/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, typeCast, Point_$type, runOn, delegateCombine, enumGetBox, fromEnum, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { FastItemCoalescingColumn } from "./FastItemCoalescingColumn";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { RadialBaseView } from "./RadialBaseView";
import { ChartSelection } from "./ChartSelection";
import { CollisionRect } from "igniteui-react-core";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let AnchoredRadialBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = this.f.de.acb;
            let c = Math.min(a * this.b, b.count - 1);
            let d = Math.min(c + this.b - 1, b.count - 1);
            let e = NaN;
            let f = NaN;
            for (let g = c; g <= d; ++g) {
                let h = b.item(g);
                if (!isNaN_(e)) {
                    if (!isNaN_(h)) {
                        e = Math.min(e, h);
                        f = Math.max(f, h);
                    }
                }
                else {
                    e = h;
                    f = h;
                }
            }
            if (!isNaN_(e)) {
                return [0.5 * (c + d), e, f, 0];
            }
            return [0.5 * (c + d), NaN, NaN, 0];
        }
    }
    AnchoredRadialBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeries = /*@__PURE__*/ (() => {
    class AnchoredRadialSeries extends RadialBase {
        ct() {
            return new AnchoredRadialSeriesView(this);
        }
        o4() {
            super.o4();
            this.y4 = null;
            this.za = null;
        }
        mg() {
            return AnchoredRadialSeries.$$p[4];
        }
        kr(a, b) {
            let c = this.nf(b);
            if (c == AnchoredRadialSeries.$$p[4]) {
                return this.ks(a, b, this.ac0);
            }
            if (c == AnchoredRadialSeries.$$p[0]) {
                return this.ks(a, b, this.acs);
            }
            return super.kr(a, b);
        }
        mf(a) {
            let b = this.nf(a);
            if (b == AnchoredRadialSeries.$$p[4]) {
                return this.ac0;
            }
            if (b == AnchoredRadialSeries.$$p[0]) {
                return this.acs;
            }
            return super.mf(a);
        }
        jd(a) {
            if (this.y4.n6(a)) {
                return this.aac(this.acb.count - 1, this.acb.item(this.acb.count - 1));
            }
            return super.jd(a);
        }
        ku(a) {
            if (this.y4 != null && this.y4.cl) {
                if (a == this.y4.othersIndex) {
                    return this.y4.oj(true);
                }
            }
            return super.ku(a);
        }
        q3(a) {
            super.q3(a);
            this.ab5 = a;
        }
        constructor() {
            super();
            this.ab6 = null;
            this.acg = false;
            this.aca = null;
            this.adr = { $type: Point_$type, x: 0, y: 0 };
            this.ab8 = null;
            this.ab7 = null;
            this.acc = false;
            this.ab8 = new RadialFrame(3);
            this.ab6 = new CategoryLineRasterizer();
        }
        kb(a, b) {
            return this.kc(a, b, this.y4, null, this.acb);
        }
        j9(a, b) {
            return this.ka(a, b, this.y4, null, this.acb);
        }
        iq(a, b, c, d, e) {
            if (this.acb == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.ir(a, b, this.y4, d, e, this.acb.count, null);
        }
        i6(a, b, c) {
            let d = this.getEffectiveViewport1(this.cw);
            let e = this.acm(this.y4, this.cw.ca, this.cw.b9, d);
            let f = new ScalerParams(0, this.cw.ca, this.cw.b9, this.y4.ch, d);
            f.c = this.dc.wz;
            let g = this.acb;
            if (this.acg && typeCast(FastItemCoalescingColumn.$, g) !== null) {
                g = new FastItemCoalescingColumn(this.y4, g.c, false);
            }
            return this.i8(g, a, this.y4, f, e, null, b, c);
        }
        wh(a, b, c) {
            if (this.za == null || this.y4 == null || this.cw == null || this.cw.ca.isEmpty || this.cw.b9.isEmpty) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.getEffectiveViewport1(this.cw);
            let e = new ScalerParams(0, this.cw.ca, this.cw.b9, this.za.ch, d);
            e.c = this.getEffectiveViewport1(this.cw);
            let f = this.i6(a, b, c);
            f = this.za.el(f, e);
            let g = this.zb.c(a, this.cw.ca, this.cw.b9, d);
            if (!b && this.y4 != null) {
                let h = this.kb(a, c);
                let i = this.j9(a, c);
                let j = this.acm(this.y4, this.cw.ca, this.cw.b9, d);
                let k = new ScalerParams(0, this.cw.ca, this.cw.b9, this.y4.ch, d);
                k.c = this.dc.wz;
                let l = this.iq(a, h, this.y4, k, j);
                let m = this.iq(a, i, this.y4, k, j);
                if (this.y4.cl) {
                    if (m <= l) {
                        j = this.acl(i, this.y4, this.cw.ca, this.cw.b9, d);
                        if (isNaN_(j)) {
                            j = 0;
                        }
                        g = this.y4.el(i, k) + j;
                    }
                    else {
                        j = this.acl(h, this.y4, this.cw.ca, this.cw.b9, d);
                        if (isNaN_(j)) {
                            j = 0;
                        }
                        g = this.y4.el(h, k) + j;
                    }
                }
                else {
                    if (m <= l) {
                        g = this.y4.el(i, k) + j;
                    }
                    else {
                        g = this.y4.el(h, k) + j;
                    }
                }
            }
            let n = this.zb.d(g, f, this.cw.ca, this.cw.b9, this.cw.getEffectiveViewport());
            let o = this.zb.e(g, f, this.cw.ca, this.cw.b9, this.cw.getEffectiveViewport());
            return { $type: Point_$type, x: n, y: o };
        }
        gc() {
            return this.highlightedItemsSource != null || this.acs != null;
        }
        hu() {
            let a = super.hu();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "ValueMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedValueMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.ac6));
                a.add(b);
            }
            return a;
        }
        ac6(a, b) {
            if (this.acs != null) {
                b.value = this.acs;
                return;
            }
            b.value = this.ac0;
        }
        get acb() {
            return this.aca;
        }
        set acb(a) {
            if (this.aca != a) {
                let b = this.aca;
                this.aca = a;
                this.raisePropertyChanged("ValueColumn", b, this.aca);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = new DataLegendSeriesValueInfo();
            c.a = 0;
            this.acg = true;
            c.l = this.i6({ $type: Point_$type, x: a, y: b }, false, false);
            this.acg = false;
            c.q = "Value";
            c.r = this.ac0 != null ? this.ac0 : "Value";
            c.s = this.acw != null ? this.acw : "V:";
            c.t = this.acy != null ? this.acy : "";
            let d = new DataLegendSeriesContext();
            d.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(c);
                return $ret;
            })());
            d.h = this.me();
            return d;
        }
        get adn() {
            return this.c(AnchoredRadialSeries.ada);
        }
        set adn(a) {
            this.h(AnchoredRadialSeries.ada, a);
        }
        ay(a) {
            if (a != null && a == this.y4 && this.acb != null && this.acb.count > 0) {
                return new AxisRange(0, this.acb.count - 1);
            }
            if (a != null && a == this.za && this.acb != null && this.acb.count > 0) {
                return new AxisRange(this.acb.minimum, this.acb.maximum);
            }
            return null;
        }
        aac(a, b) {
            if (this.ack) {
                let c = this.acb.c;
                if (a < 0) {
                    return super.aac(a, b);
                }
                if (a > c.count - 1) {
                    if (typeCast(ProportionalCategoryAngleAxis.$, this.y4) !== null) {
                        let d = this.acb;
                        return d.f;
                    }
                    return super.aac(a, b);
                }
                return c.item(a);
            }
            else {
                return super.aac(a, b);
            }
        }
        dl(a) {
            let b = super.dl(a);
            this.acc = false;
            if (this.y4 != null && this.y4.cl) {
                this.acc = true;
                b = new FastItemCoalescingColumn(this.y4, b, this.ack);
            }
            return b;
        }
        ac4(a, b) {
            if (this.acc) {
                let c = b;
                let d = c.c;
                a.deregisterColumn(d);
            }
            else {
                a.deregisterColumn(b);
            }
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            if (this.ab5.df.g$e(a, b, c, d)) {
                this.ru(false);
                this.qn();
            }
            let e = typeCast(NumericAxisBase.$, this.za);
            switch (b) {
                case AnchoredRadialSeries.$$p[2]:
                case AnchoredRadialSeries.$$p[3]:
                    this.qh();
                    break;
                case AnchoredRadialSeries.$$p[1]:
                case RadialBase.$$p[0]:
                    if (this.acb != null) {
                        this.ac4(this.dp, this.acb);
                        this.acb = this.dl(this.ac0);
                    }
                    break;
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) !== null) {
                        this.ac4(c, this.acb);
                        this.acb = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) !== null) {
                        this.acb = this.dl(this.ac0);
                        this.ab5.da.e(this.ie);
                    }
                    if (e != null && !e.c1()) {
                        this.ab5.da.e(this.ie);
                        this.ru(this.gh && c != null);
                    }
                    break;
                case AnchoredRadialSeries.$$p[4]:
                    if (this.dp != null) {
                        this.ac4(this.dp, this.acb);
                        this.acb = this.dl(this.ac0);
                    }
                    break;
                case "ValueColumn":
                    if (e != null && !e.c1()) {
                        this.ab5.da.e(this.ie);
                        this.ru(this.gh && this.d9);
                    }
                    break;
                case "TrendLineBrush":
                    this.ri(b);
                    break;
                case "TrendLineType":
                    this.qn();
                    break;
            }
        }
        pd(a, b, c, d) {
            super.pd(a, b, c, d);
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.ab5.da.e(this.ie);
                    break;
            }
            this.ab5.df.g$i(a, b, c, d);
            if (this.ab5.aa.count > 0) {
                for (let e of fromEnum(this.ab5.aa)) {
                    e.g$i(a, b, c, d);
                }
            }
            switch (a) {
                case 4:
                    if (this.za != null && !this.za.c1()) {
                        this.ru(true);
                    }
                    break;
                case 1:
                    if (this.za != null && !this.za.c1()) {
                        this.ru(true);
                    }
                    break;
                case 0:
                    if (this.za != null && !this.za.c1()) {
                        this.ru(true);
                    }
                    break;
                case 2:
                    if (this.ac0 != null && this.ab5.da.b > 0 && this.za != null && !this.za.c1()) {
                        this.ru(true);
                    }
                    break;
                case 3:
                    if (d == this.ac0) {
                        if (this.za != null && !this.za.c1()) {
                            this.ru(true);
                        }
                    }
                    break;
            }
        }
        hf(a, b, c) {
            let d = super.hf(a, b, c);
            let e = c;
            if (this.dp == null || this.dp.count == 0 || this.y4 == null || this.acb == null || this.y4.lj == 0 || this.za == null || isInfinity(this.za.l4) || isInfinity(this.za.l3) || e.da.b < 1) {
                d = false;
            }
            return d;
        }
        getOffsetValue() {
            return this.acm(this.y4, this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
        }
        getCategoryWidth() {
            return this.y4.getCategorySize(this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
        }
        get_ach() {
            return false;
        }
        get ach() {
            return this.get_ach();
        }
        get_em() {
            return true;
        }
        get_f6() {
            return this.za != null && this.za.ch;
        }
        acm(a, b, c, d) {
            let e = 0;
            let f = this.preferredCategoryMode(a);
            if (f == 0 && a.categoryMode != 0) {
                f = 1;
            }
            switch (f) {
                case 0:
                    e = 0;
                    break;
                case 1:
                    e = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    e = a.getGroupCenter(this.aab(), b, c, d);
                    break;
            }
            if (a.ch) {
                e = -e;
            }
            return e;
        }
        acl(a, b, c, d, e) {
            let f = 0;
            let g = this.preferredCategoryMode(b);
            if (g == 0 && b.categoryMode != 0) {
                g = 1;
            }
            switch (g) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * b.m7(a, c, d, e);
                    break;
                case 2:
                    f = b.m6(a, this.aab(), c, d, e);
                    break;
            }
            if (b.ch) {
                f = -f;
            }
            return f;
        }
        ac5(a, b, c, d) {
            if (d == 0) {
                this.p6(a, b, c);
                return;
            }
            let e = this.cw.ca;
            let f = this.cw.b9;
            let g = this.getEffectiveViewport1(this.cw);
            let h = this.dc.wp(this.wx, this.getEffectiveViewport(), e);
            let i = this.za.k5(f, e, g, h);
            let j = this.y4 != null && this.y4.cl;
            let k = new CollisionRect(0, this.dc.wm(a));
            for (let l = 0; l < this.dp.count; l++) {
                let m = typeCast(RadialBaseView.$, this.cw);
                let n = m.da.getBucket(l);
                let o = this.acm(this.y4, e, f, g);
                if (j) {
                    o = this.acl(l, this.y4, e, f, g);
                    if (isNaN_(o)) {
                        o = 0;
                    }
                }
                n[0] = this.y4.getScaledAngle(n[0]) + o;
                let p = Math.min(this.zb.b.od(n[2]), i.maxLength);
                let q = this.zb.d(n[0], p, e, f, g);
                let r = this.zb.e(n[0], p, e, f, g);
                if (k.containsLocation(q, r)) {
                    if (c == 7 || c == 6) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.series = this;
                            return $ret;
                        })()));
                        return;
                    }
                    else if (c == 2 || c == 1) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.item = this.dp.item(l);
                            return $ret;
                        })()));
                    }
                    else {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.item = this.dp.item(l);
                            $ret.series = this;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        get_acj() {
            return false;
        }
        get acj() {
            return this.get_acj();
        }
        get_acd() {
            return false;
        }
        get acd() {
            return this.get_acd();
        }
        abc(a, b) {
            let c = b.ca;
            let d = b.b9;
            let e = this.getEffectiveViewport1(b);
            let f = this.y4;
            let g = this.za;
            let h = g.l4;
            let i = g.l3;
            a.h.clear();
            a.p.clear();
            a.s.clear();
            let j = this.xl();
            let k = 0;
            let l = b;
            let m = f.cl;
            let n = new CollisionAvoider();
            let o = 0;
            let p = 0;
            let q = b.da.d;
            o = this.acm(f, c, d, e);
            l.df.k = this.za.n7;
            l.df.j = this.za.n6;
            l.df.l = (r, s) => this.acn(r, s, c, d, e);
            l.df.m = (r, s) => this.aco(r, s, c, d, e);
            let r = ((() => {
                let $ret = new Clipper(0, d, false);
                $ret.i = a.s;
                return $ret;
            })());
            let s = ((() => {
                let $ret = new TrendResolutionParams();
                $ret.e = b.da.b;
                $ret.f = b.da.c;
                $ret.g = q;
                $ret.a = o;
                $ret.d = this.ie;
                $ret.i = d;
                $ret.h = e;
                $ret.j = c;
                return $ret;
            })());
            l.df.n(a.s, this.ab9, this.acb, this.acq, (t) => this.y4.getScaledAngle(t), (t) => this.za.od(t), s, r);
            a.f.clear();
            for (let t = 0; t < b.aa.count; t++) {
                a.f.add(new List$1(Point_$type, 0));
                let u = b.aa._inner[t];
                u.k = this.za.n7;
                u.j = this.za.n6;
                u.l = (v, w) => this.acn(v, w, c, d, e);
                u.m = (v, w) => this.aco(v, w, c, d, e);
                u.n(a.f._inner[t], u.g$b, this.acb, u.g$f, (v) => this.y4.getScaledAngle(v), (v) => this.za.od(v), s, r);
            }
            let v = true;
            if (this.aci(b)) {
                q--;
            }
            for (let w = b.da.c; w <= q; ++w) {
                let x = w;
                if (x * b.da.b >= this.y4.lj) {
                    x -= intDivide((this.y4.lj), b.da.b);
                }
                let y = b.da.getBucket(x);
                p = 0;
                if (m) {
                    p = this.z3(x, c, d, e);
                }
                y[3] = p;
                if (!isNaN_(y[0])) {
                    let z = false;
                    if (m) {
                        o = this.acl(x, f, c, d, e);
                        if (isNaN_(o)) {
                            o = 0;
                            z = true;
                        }
                    }
                    y[0] = f.getScaledAngle(y[0]) + o;
                    if (y[1] < h || y[1] > i) {
                        if (this.acj) {
                            if (y[1] > i && this.acd) {
                            }
                            else {
                                z = true;
                            }
                        }
                        else {
                            if (y[1] > i && this.acd) {
                            }
                            else {
                                continue;
                            }
                        }
                    }
                    if (z) {
                        y[1] = NaN;
                        y[2] = NaN;
                    }
                    y[1] = g.od(y[1]);
                    if (b.da.b > 1) {
                        if (y[2] < h || y[2] > i) {
                            continue;
                        }
                        y[2] = g.od(y[2]);
                    }
                    else {
                        y[2] = y[1];
                    }
                    if ((isNaN_(y[1]) || isNaN_(y[2])) && v && this.ach && this.acf()) {
                        q++;
                    }
                    else {
                        v = false;
                    }
                    a.h.add(y);
                    if (j) {
                        let aa = Math.min(x * b.da.b, this.dp.count - 1);
                        let ab = false;
                        if (this.y4.cl) {
                            let ac = this.y4;
                            let ad = ac.hasOthersCategory && (x * b.da.b) == this.y4.lj - 1;
                            ab = ad;
                        }
                        let ae = this.zb.d(y[0], y[1], c, d, e);
                        let af = this.zb.e(y[0], y[1], c, d, e);
                        let ag = new Rect(0, ae - 5, af - 5, 11, 11);
                        if (!isNaN_(ae) && !isNaN_(af) && !isInfinity(ae) && !isInfinity(af) && n.tryAdd(ag)) {
                            a.p.add({ $type: Point_$type, x: y[0], y: y[1] });
                            let ah = b.db.item(k);
                            ah.al = x;
                            ah.ak = aa;
                            ah.content.item = this.dp.item(aa);
                            if (ab) {
                                ah.ak = this.dp.count;
                                let ai = this.y4;
                                ah.content.item = this.y4.oj(true);
                            }
                            ++k;
                        }
                    }
                }
                else {
                    if (v && this.ach && this.acf()) {
                        q++;
                    }
                }
            }
            b.db.count = k;
            return;
        }
        acn(a, b, c, d, e) {
            return this.zb.d(a, b, c, d, e);
        }
        aco(a, b, c, d, e) {
            return this.zb.e(a, b, c, d, e);
        }
        aci(a) {
            let b = a;
            return !this.ach && b.da.c == 0 && b.da.d == this.y4.lj;
        }
        ab4(a, b, c) {
            let d = null;
            let e = c.ca;
            let f = c.b9;
            if (b > -1 && !e.isEmpty && !f.isEmpty) {
                let g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
                let h = f.bottom + 10;
                let i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
                let j = f.top - 10;
                d = new Clipper(1, g, h, i, j, false);
            }
            return d;
        }
        ac9(a, b, c, d, e) {
            if (a.count > 0 && d.count > 0) {
                if (!e || this.ace()) {
                    a.add(this.adr);
                    a.add(a._inner[0]);
                    d.add(this.adr);
                    d.add(d._inner[0]);
                }
            }
        }
        acf() {
            return !this.ace();
        }
        ace() {
            let a = this.cw.ca;
            return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
        }
        o7(a, b) {
            super.o7(a, b);
            let c = b;
            if (a) {
                c.db.clear();
            }
            c.df.g$h();
        }
        abf(a, b) {
            this.qz();
            let c = b.ca;
            let d = b.b9;
            let e = this.getEffectiveViewport1(b);
            let f = this.wo(b);
            let g = b;
            g.df.g$k(a.s);
            for (let h = 0; h < b.aa.count; h++) {
                let i = b.aa._inner[h];
                i.g$k(a.f._inner[h]);
            }
            let j = new List$1(Point_$type, 0);
            for (let k = 0; k < a.p.count; k++) {
                let l = a.p._inner[k];
                let m = this.zb.d(l.x, l.y, c, d, e);
                let n = this.zb.e(l.x, l.y, c, d, e);
                let o = { $type: Point_$type, x: m, y: n };
                j.add(o);
            }
            CategoryMarkerManager.e(this, j, g.db, this.xn);
            this.ac3(b, a);
            g.c4();
            this.ac2(d, c, e, f, g);
        }
        ab3(a, b, c) {
            if (b < a || a < 0 || a > this.acb.count || b < 0 || b > this.acb.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cn;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.dp.item(g);
            }
            return d;
        }
        ac7(a, b, c, d, e, f) {
            let g = this.by != 1;
            let h = this.cq != 1;
            let i = this.cp != 1;
            let j = this.d3;
            this.zj.a3(this.zj.d, d.cn, a, b, c, d, e, f, true);
            this.zj.aa(this.ic);
            let k = this.zj.ax;
            let l = null;
            let m = null;
            let n = null;
            let o = this.dp;
            let p = null;
            let q = null;
            let r = null;
            if (j && this.dc != null && !k.e) {
                let s = this.vt(k.z);
                let t = this.vu(k.z);
                this.zj.ag = s;
                this.zj.ah = t;
                k.aa = s;
                k.ab = t;
            }
            if (g && this.dc != null) {
                l = this.dc.dk.getHighlightingInfo(this, o, k.z, k.y, true);
                if (this.dc.dk.isCrossContextHighlight(this)) {
                    p = this.dc.dk.getHighlightingInfo(this, o, k.z, k.y, true);
                }
                k.c = l;
            }
            if (h && this.dc != null) {
                m = this.dc.dl.getHighlightingInfo(this, o, k.z, k.y, true);
                if (m == null && this.bo != null) {
                    m = this.dc.dl.getHighlightingInfo(this.bo, this.bo.dp, k.z, k.y, true);
                }
                if (this.dc.dl.isCrossContextHighlight(this)) {
                    q = this.dc.dl.getHighlightingInfo(this, o, k.z, k.y, true);
                }
                k.d = m;
            }
            if (i && this.dc != null) {
                n = this.dc.dj.getHighlightingInfo(this, o, k.z, k.y, true);
                if (this.dc.dj.isCrossContextHighlight(this)) {
                    r = this.dc.dj.getHighlightingInfo(this, o, k.z, k.y, true);
                }
                k.b = n;
            }
            k.h = f;
            this.abd(k);
            this.zj.y(this, l, m, n, f, g, h, i, k.v, this.dc.dk.totalHighWaterMark, k.x, this.dc.dl.totalHighWaterMark, k.t, this.dc.dj.totalHighWaterMark);
        }
        ac8(a, b, c, d, e, f) {
            let g = this.by != 1;
            let h = this.cq != 1;
            let i = this.cq != 1;
            let j = this.d3;
            this.zj.a3(this.zj.b, d.cn, a, b, c, d, e, f, false);
            this.zj.ab(this.ic);
            let k = this.zj.ay;
            let l = null;
            let m = null;
            let n = null;
            let o = this.dp;
            if (j && this.dc != null && !k.e) {
                let p = this.vs(k.z);
                let q = this.vv(k.z);
                this.zj.ag = p;
                this.zj.ah = q;
                k.aa = p;
                k.ab = q;
            }
            if (g && this.dc != null) {
                l = this.dc.dk.getHighlightingInfo(this, o, k.z, k.y, false);
                k.c = l;
            }
            if (h && this.dc != null) {
                m = this.dc.dl.getHighlightingInfo(this, o, k.z, k.y, false);
                if (m == null && this.bo != null) {
                    m = this.dc.dl.getHighlightingInfo(this.bo, this.bo.dp, k.z, k.y, false);
                }
                k.d = m;
            }
            k.h = f;
            this.abe(k);
            this.zj.z(this, l, m, n, f, g, h, i, b < 0);
        }
        ac3(a, b) {
            a.ck = true;
            this.zj.a1(this, this.zz(), runOn(this, this.ys), this.z9(a), this.aaa(a));
            let c = this.zj.d;
            let d = c != null;
            let e = this.y4;
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.ca, a.b9, e.ch, f);
            let h = this.dp == null ? 0 : this.dp.count;
            let i = a;
            let j = b.h;
            let k = i.da.c;
            let l = i.da.d;
            let m = i.da.b;
            let n = k * m;
            for (let o = 0; o < a.db.count; o++) {
                let p = a.db.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.ac7(j, r, h, e, g, a.t);
                }
                this.zj.ac(p, q);
            }
        }
        ac2(a, b, c, d, e) {
            e.dg(a, b, c, d);
        }
        sl() {
            super.sl();
            if (this.index < 0) {
                return;
            }
            this.ab5.dh();
        }
        ky(a, b) {
            if (a == this.ab5.df.g$n) {
                return null;
            }
            return super.ky(a, b);
        }
        ge(a) {
            let b = this.cw.ca;
            b = b.copy();
            let c = this.cw.b9;
            let d = !b.isEmpty && !c.isEmpty && this.dp != null ? this.dp.indexOf(a) : -1;
            if (this.y4 == null || this.acb == null || this.za == null) {
                return false;
            }
            if (d < 0 || d > this.acb.count - 1) {
                return false;
            }
            let e = this.y4.getScaledAngle(d);
            let f = this.za.od(this.acb.item(d));
            if (isNaN_(f)) {
                f = (this.za.n6 + this.za.n7) / 2;
            }
            let g = 0.5 + (Math.cos(e) * f);
            let h = 0.5 + (Math.sin(e) * f);
            if (!isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.c4 != null) {
                this.c4.au(this.dc, b, true);
            }
            return d >= 0;
        }
        rw(a, b) {
            super.rw(a, b);
            if (!this.g1) {
                this.cw.be(b);
                return;
            }
            this.cw.be(b);
            let c = typeCast(AnchoredRadialSeriesView.$, this.cv);
            c.da.e(this.ie);
            if (this.d7(this.cv)) {
                return;
            }
            this.rx();
            this.g1 = false;
        }
        rx() {
            super.rx();
            let a = typeCast(AnchoredRadialSeriesView.$, this.cv);
            if (!this.gt) {
                this.ab8 = new RadialFrame(3);
                this.abc(this.ab8, a);
            }
            this.gt = false;
            this.abf(this.ab8, a);
        }
        rt(a, b, c, d, e) {
            super.rt(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            let g = f;
            g.da.e(this.ie);
            f.bd(c);
            if (this.d7(g)) {
                return;
            }
            if (this.ab7 == null) {
                this.ab7 = new RadialFrame(3);
            }
            this.ab7.x();
            this.abc(this.ab7, g);
            this.abf(this.ab7, g);
        }
        p1(a) {
            super.p1(a);
            this.bc.exportTrendlineData(this, a, this.ab5.df.g$n);
        }
        bd() {
            return new RadialTrendLineManager();
        }
    }
    AnchoredRadialSeries.$t = /*@__PURE__*/ markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.ada = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredRadialSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['HighlightedValueMemberPath:acs:adb', [2, null], 'UseCategoryNormalizedValues:ack:adj', [0, false], 'ValueMemberAsLegendLabel:acw:adk', [2, null], 'ValueMemberAsLegendUnit:acy:adl', [2, null], 'ValueMemberPath:ac0:adm', [2, null], 'TrendLineType:ab9:adh', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:acp:adg', [1, 1.5], 'TrendLinePeriod:acq:adf', [1, 7], 'TrendLineZIndex:acr:adi', [1, 1], 'TrendLineBrush:ado:adc', [Brush.$, null], 'TrendLineDashArray:adp:add', [DoubleCollection.$], 'TrendLineDashCap:adq:ade', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeriesView = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesView extends RadialBaseView {
        constructor(a) {
            super(a);
            this.de = null;
            this.df = null;
            this.da = new AnchoredRadialBucketCalculator(this);
            this.de = a;
            this.df = new RadialTrendLineManager();
        }
        dg(a, b, c, d) {
        }
        dh() {
            this.de.adn = null;
            if (this.de.ado != null) {
                this.de.adn = this.de.ado;
            }
            else {
                this.de.adn = this.de.ve;
            }
        }
        bi(a, b) {
            if (a.d) {
                if (!b) {
                }
                if (this.de.ab9 != 0 && !b) {
                    let c = this.df.g$n;
                    c.ad = this.de.acp;
                    c._stroke = this.de.adn;
                    c.ai = this.de.adp;
                    c.aj = this.de.adq;
                    a.v(c);
                }
            }
            super.bi(a, b);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.de.y4.f2 != null) {
                a += "<span>${item." + this.de.y4.f2 + "}</span><br/>";
            }
            a += "<span";
            let b = this.f.ba.a$u(this.f);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.de.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.de.ac0 + "}</span></div>";
            return a;
        }
    }
    AnchoredRadialSeriesView.$t = /*@__PURE__*/ markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
})();
