/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-react-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-react-core";
import { IChartScaleLegend_$type } from "igniteui-react-core";
import { ContentControl } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { FastItemsSource } from "igniteui-react-core";
import { FastItemColumn } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, isInfinity, logBase } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let BubbleSeries = /*@__PURE__*/ (() => {
    class BubbleSeries extends ScatterBase {
        bk() {
            return new BubbleSeries();
        }
        get_ek() {
            return true;
        }
        ct() {
            return new BubbleSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.acv = a;
        }
        jm() {
            return 0.7;
        }
        w6() {
            if (this.w5 == 0) {
                return 2;
            }
            return super.w6();
        }
        constructor() {
            super();
            this.aem = null;
            this.ael = null;
            this.ac9 = null;
            this.ac0 = null;
            this.acz = null;
            this.acy = null;
            this.acw = null;
            this.ab = BubbleSeries.$;
            this.y7 = new ScatterFrame();
            this.y9 = new ScatterFrame();
            this.y5 = new ScatterFrame();
        }
        isAttachedTo(a) {
            return this.a5 == a;
        }
        ej() {
            return true;
        }
        p4(a) {
            super.p4(a);
            if (this.ac4 != null && this.ac9 != null && this.ac9.count > 0) {
                for (let b = 0; b < this.ac9.count; b++) {
                    a(this.ac9._inner[b]);
                }
            }
        }
        get ac3() {
            return this.ac5;
        }
        get_isColoredItemwise() {
            return this.ac1 != null && this.ac1.count > 0;
        }
        aek(a) {
            let b = typeCast(CustomPaletteBrushScale.$, this.acu);
            let c = typeCast(ValueBrushScale.$, this.acu);
            let d = this.acu;
            if (b != null && this.dp != null) {
                return b.getBrush1(a, this.dp.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.ac1);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        }
        get legendReady() {
            return this.ac5 != null && this.ac5.count != 0;
        }
        get minScaleText() {
            let a = this.act(this.acx).b;
            return (Math.round(a * 1000) / 1000).toString();
        }
        get maxScaleText() {
            let a = this.act(this.acx).a;
            return (Math.round(a * 1000) / 1000).toString();
        }
        forScaleColors(a) {
            for (let b = 0; b < this.ac5.count; b++) {
                if (this.acu == null || !this.acu.isReady) {
                    return false;
                }
                let c = NaN;
                if (this.ac1 != null) {
                    c = (this.ac1.item(b) - this.ac1.minimum) / (this.ac1.maximum - this.ac1.minimum);
                }
                let d = (this.ac5.item(b) - this.ac5.minimum) / (this.ac5.maximum - this.ac5.minimum);
                if (isNaN_(c)) {
                    c = 0;
                }
                if (isNaN_(d)) {
                    d = c;
                }
                let e = this.ym;
                let f = this.aek(b);
                let g = f != null ? f : e;
                a(g, d);
            }
            return true;
        }
        kr(a, b) {
            let c = this.nf(b);
            if (c == BubbleSeries.$$p[5]) {
                return this.ks(a, b, this.ado);
            }
            if (c == BubbleSeries.$$p[11]) {
                return this.ks(a, b, this.ady);
            }
            if (c == ScatterBase.$$p[12]) {
                return this.ks(a, b, this.aay);
            }
            if (c == ScatterBase.$$p[16]) {
                return this.ks(a, b, this.aa6);
            }
            if (c == BubbleSeries.$$p[2]) {
                return this.ks(a, b, this.adj);
            }
            return super.kr(a, b);
        }
        mf(a) {
            let b = this.nf(a);
            if (b == BubbleSeries.$$p[5]) {
                return this.ado;
            }
            if (b == BubbleSeries.$$p[11]) {
                return this.ady;
            }
            if (b == ScatterBase.$$p[12]) {
                return this.aay;
            }
            if (b == ScatterBase.$$p[16]) {
                return this.aa6;
            }
            if (b == BubbleSeries.$$p[2]) {
                return this.adj;
            }
            return super.mf(a);
        }
        get ac5() {
            return this.ac0;
        }
        set ac5(a) {
            if (this.ac0 != a) {
                let b = this.ac5;
                this.ac0 = a;
                this.raisePropertyChanged("RadiusColumn", b, this.ac5);
            }
        }
        get ac4() {
            return this.acz;
        }
        set ac4(a) {
            if (this.acz != a) {
                let b = this.ac4;
                this.acz = a;
                this.raisePropertyChanged("LabelColumn", b, this.ac4);
            }
        }
        get ac1() {
            return this.acy;
        }
        set ac1(a) {
            if (this.acy != a) {
                let b = this.ac1;
                this.acy = a;
                this.raisePropertyChanged("FillColumn", b, this.ac1);
            }
        }
        aa9(a, b, c, d, e) {
            if (c <= this.aae) {
                b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            }
            let f = this.aae;
            let g = this.dp;
            let h;
            let i;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(0, d, e, this.y1.d, j);
            let l = new ScalerParams(0, d, e, this.y1.e, j);
            let m = false;
            let n = 0;
            if (this.dc != null) {
                if (this.dc.f4()) {
                    let o = this.dc.nd(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            for (let p = 0; p < c; p++) {
                h = this.zm.item(p);
                i = this.zn.item(p);
                let q = { $type: Point_$type, x: this.y1.a.el(h, k), y: this.y1.b.el(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!isInfinity(q.x) && !isInfinity(q.y)) {
                    let r = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r)) {
                            let s = { $type: Point_$type, x: h, y: i };
                            b.g.addItem(r, ((() => {
                                let $ret = new OwnedPoint();
                                $ret.a = r;
                                $ret.b = s;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            }
        }
        abk(a, b) {
            let c = typeCast(BubbleSeriesView.$, b);
            let d = c.dd;
            d.m = this.ac5;
            super.abk(a, b);
            let e = Math.min(this.zm != null ? this.zm.count : 0, this.zn != null ? this.zn.count : 0);
            if (e < 1) {
                return;
            }
            c.d0();
            c.d1();
        }
        ad3() {
            if (this.dc == null) {
                return;
            }
            if (this.a5 == null) {
                return;
            }
            if (this.a5.isItemwise) {
                let a = this.a5;
                this.a5.clearLegendItemsForSeries(this);
                this.ad2();
                a.renderItemwiseContent(this);
            }
            if (this.a5.isScale) {
                let b = this.a5;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        }
        static ada(a, b, c, d, e) {
            if (e <= a || isNaN_(e) || isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            let f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        }
        static adb(a, b, c, d, logBase_, e) {
            let f = logBase(e, logBase_);
            let g = logBase(a, logBase_);
            let h = logBase(b, logBase_);
            return BubbleSeries.ada(g, h, c, d, f);
        }
        hf(a, b, c) {
            let d = super.hf(a, b, c);
            if (this.ac5 == null || this.dp == null || this.ac5.count == 0 || this.dp.count != this.ac5.count) {
                d = false;
            }
            return d;
        }
        zw(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.aay == a || this.aa6 == a || this.ady == a) {
                return true;
            }
            return false;
        }
        ad2() {
            let a = typeCast(IChartLegend_$type, this.a5);
            if (a == null || this.dp == null) {
                return;
            }
            this.ac9 = new List$1(UIElement.$, 0);
            let b = typeCast(CustomPaletteBrushScale.$, this.acu);
            let c = typeCast(ValueBrushScale.$, this.acu);
            let d = this.acu;
            let e = this.acs();
            let f = e.b;
            let g = e.a;
            let h = this.dp;
            for (let i = 0; i < h.count; i++) {
                let j = null;
                if (c != null && this.ac1 != null) {
                    let k = this.ac1.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                let l = new ContentControl();
                let m = this.ac4 != null && this.ac4.item(i) != null ? this.ac4.item(i).toString() : "";
                l.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    $ret.legendLabel = m;
                    return $ret;
                })());
                let n = this.s1;
                if (n == null) {
                    n = this.cw.bz(this.c1);
                }
                l.ah = n;
                this.ac9.add(l);
            }
        }
        pd(a, b, c, d) {
            super.pd(a, b, c, d);
            if (this.acx != null) {
                this.acx.aa();
            }
            if (this.acu != null) {
                this.acu.x();
            }
            this.ad3();
        }
        qf() {
            super.qf();
            this.ad3();
        }
        qm() {
            super.qm();
            this.ad3();
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case ScatterBase.$$p[10]:
                case ScatterBase.$$p[14]:
                case ScatterBase.$$p[11]:
                case ScatterBase.$$p[15]:
                case BubbleSeries.$$p[9]:
                case BubbleSeries.$$p[10]:
                    this.qh();
                    break;
                case "FastItemsSource":
                    if (this.acx != null) {
                        this.acx.aa();
                    }
                    if (this.acu != null) {
                        this.acu.x();
                    }
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.ac5);
                        c.deregisterColumn(this.ac1);
                        c.deregisterColumn(this.ac4);
                        this.ac5 = null;
                        this.ac1 = null;
                        this.ac4 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.ac5 = this.dl(this.ady);
                        if (!stringIsNullOrEmpty(this.adj)) {
                            this.ac1 = this.dl(this.adj);
                        }
                        this.ac4 = this.dn(this.ado);
                    }
                    this.ru(false);
                    this.ad3();
                    break;
                case BubbleSeries.$$p[11]:
                    if (this.acx != null) {
                        this.acx.aa();
                    }
                    if (this.dp != null) {
                        this.dp.deregisterColumn(this.ac5);
                        this.ac5 = this.dl(this.ady);
                        this.ad3();
                    }
                    break;
                case "RadiusColumn":
                    if (this.acx != null) {
                        this.acx.aa();
                    }
                    this.y2.df.g$m();
                    this.ru(this.gh && this.d9);
                    this.qo();
                    break;
                case BubbleSeries.$$p[12]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.ru(false);
                    this.qn();
                    break;
                case BubbleSeries.$$p[13]:
                    this.ru(false);
                    this.qn();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.ad3();
                    break;
                case BubbleSeries.$$p[3]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.ru(false);
                    this.ad3();
                    this.qn();
                    break;
                case BubbleSeries.$$p[4]:
                case BubbleSeries.$$p[8]:
                case BubbleSeries.$$p[7]:
                case BubbleSeries.$$p[6]:
                    this.ru(false);
                    this.ad3();
                    this.qn();
                    break;
                case "FillColumn":
                    this.ru(this.gh && this.d9);
                    this.qn();
                    break;
                case BubbleSeries.$$p[2]:
                    if (this.acu != null) {
                        this.acu.x();
                    }
                    if (this.dp != null) {
                        this.dp.deregisterColumn(this.ac1);
                        this.ac1 = this.dl(this.adj);
                        this.ad3();
                    }
                    break;
                case BubbleSeries.$$p[5]:
                    if (this.dp != null) {
                        this.dp.deregisterColumn(this.ac4);
                        this.ac4 = this.dn(this.ado);
                        this.ad3();
                    }
                    break;
                case "ActualLegend":
                    let e = typeCast(IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        let f = typeCast(IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        let g = typeCast(IChartScaleLegend_$type, e);
                        let h = true;
                        let i = null;
                        if (this.dc != null) {
                            for (let j of fromEnum(this.dc.series)) {
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                        }
                    }
                    this.ad3();
                    break;
                case "SeriesViewer":
                    this.ad3();
                    break;
            }
        }
        updateSizeScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.ac5 != null) {
                a.b = this.ac5.minimum;
                a.a = this.ac5.maximum;
            }
            if (this.acx != null) {
                this.acx.ab(a.b, a.a);
            }
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.ac1 != null) {
                a.b = this.ac1.minimum;
                a.a = this.ac1.maximum;
            }
            if (this.acu != null) {
                this.acu.z(a.b, a.a);
            }
        }
        act(a) {
            let b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.ac5 != null) {
                b.b = this.ac5.minimum;
                b.a = this.ac5.maximum;
            }
            if (a != null) {
                a.x();
                if (this.ac8) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        }
        acs() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.ac1 != null) {
                a.b = this.ac1.minimum;
                a.a = this.ac1.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.acu);
            if (b != null) {
                b.s();
                if (this.ac6 && this.acu.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        ad5(a, b, c, d) {
            let e = c.width;
            if (!this.cw.b9.isEmpty) {
                e = this.cw.b9.width;
            }
            else if (this.dc != null && !this.dc.wz.isEmpty) {
                e = this.dc.wz.width;
            }
            let f = DeviceUtils.c(e);
            this.acw = this.acx || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (this.acw != null) {
                let g = this.acw.minimumValue;
                let h = this.acw.maximumValue;
                let i = this.acw.logarithmBase;
                let j = this.act(this.acw);
                let k = j.b;
                let l = j.a;
                if (this.acw.isLogarithmic) {
                    for (let m = 0; m < b.count; m++) {
                        b._inner[m] = BubbleSeries.adb(k, l, g, h, i, b._inner[m]);
                    }
                }
                else {
                    for (let n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.ada(k, l, g, h, b._inner[n]);
                    }
                }
            }
            let o = 1;
            o = DeviceUtils.d();
            let p = this.acx == null;
            if (d) {
                let q = c.width / e;
                for (let r = 0; r < b.count; r++) {
                    if (p) {
                        b._inner[r] = b._inner[r] / o;
                    }
                    b._inner[r] = b._inner[r] * q;
                }
            }
            for (let s = 0; s < a.count; s++) {
                let t = a._inner[s];
                if (p && !d) {
                    t.width = Math.max(0, b._inner[s] / o);
                    t.height = Math.max(0, b._inner[s] / o);
                }
                else {
                    t.width = Math.max(0, b._inner[s]);
                    t.height = Math.max(0, b._inner[s]);
                }
            }
        }
        ad4(a) {
            let b = typeCast(BubbleSeriesView.$, this.cv);
            this.acv.ck = false;
            if (b != null) {
                b.ck = false;
            }
            let c = typeCast(CustomPaletteBrushScale.$, this.acu);
            let d = typeCast(ValueBrushScale.$, this.acu);
            let e = this.acu;
            let f = this.acs();
            let g = f.b;
            let h = f.a;
            let i = this.acu == null || !this.acu.isReady || (d != null && this.adj == null);
            if (i) {
                this.acv.dz();
                if (b != null) {
                    b.dz();
                }
                return;
            }
            this.acv.ck = true;
            if (b != null) {
                b.ck = true;
            }
            let j = a.count;
            let k = this.dp;
            for (let l = 0; l < j; l++) {
                let m = a._inner[l];
                let n = typeCast(DataContext.$, m.content);
                if (n != null) {
                    let o = null;
                    let p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.ac1 != null) {
                        let q = this.ac1.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.yo == null) {
                            o = this.ym;
                        }
                        else {
                            o = this.yo;
                        }
                    }
                    let r = null;
                    if (this.yp == null) {
                        r = this.yn;
                    }
                    else {
                        r = this.yp;
                    }
                    if (this.ac7 && o != null) {
                        r = o;
                    }
                    if (r != null && !isNaN_(this.add)) {
                        r = BrushUtil.o(r, this.add);
                    }
                    if (o != null && !isNaN_(this.adc)) {
                        o = BrushUtil.o(o, this.adc);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.p6(a, c, b);
            return c.toArray();
        }
        p6(a, b, c) {
            let d = 1;
            if (d == 1) {
                let e = this.ac2();
                this.abc(a, b, c, d, e);
            }
            else {
                super.p6(a, b, c);
            }
        }
        ac2() {
            let a = new FastItemColumn(typeCast(FastItemsSource.$, this.dp), "RadiusColumn", null, false);
            let b = this.cw.b9;
            let c = b.width;
            if (!this.cw.b9.isEmpty) {
                c = this.cw.b9.width;
            }
            else if (this.dc != null && !this.dc.wz.isEmpty) {
                c = this.dc.wz.width;
            }
            let d = DeviceUtils.c(c);
            this.acw = this.acx || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = d / 10;
                $ret.maximumValue = d / 5;
                return $ret;
            })());
            if (this.acw != null) {
                let e = this.acw.minimumValue;
                let f = this.acw.maximumValue;
                let g = this.acw.logarithmBase;
                let h = this.act(this.acw);
                let i = h.b;
                let j = h.a;
                if (this.acw.isLogarithmic) {
                    for (let k = 0; k < a.count; k++) {
                        a.item(k, BubbleSeries.adb(i, j, e, f, g, a.item(k)));
                    }
                }
                else {
                    for (let l = 0; l < a.count; l++) {
                        a.item(l, BubbleSeries.ada(i, j, e, f, a.item(l)));
                    }
                }
            }
            let m = DeviceUtils.d();
            let n = this.acx == null;
            let o = this.cw == this.cv;
            if (o) {
                let p = b.width / c;
                for (let q = 0; q < a.count; q++) {
                    if (n) {
                        a.item(q, a.item(q) / m);
                    }
                    a.item(q, a.item(q) * p);
                }
            }
            for (let r = 0; r < a.count; r++) {
                let s;
                if (n && !o) {
                    a.item(r, Math.max(0, a.item(r) / m));
                }
                else {
                    a.item(r, Math.max(0, a.item(r)));
                }
            }
            return a;
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ko(c);
            let e = d == null ? NaN : this.iy(d, "XMemberPath");
            let f = d == null ? NaN : this.iy(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.a = 13;
            g.l = e;
            g.q = "X";
            g.r = this.aay != null ? this.aay : "X";
            g.s = this.aau != null ? this.aau : "X:";
            g.t = this.aaw != null ? this.aaw : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.q = "Y";
            h.r = this.aa6 != null ? this.aa6 : "Y";
            h.s = this.aa2 != null ? this.aa2 : "Y:";
            h.t = this.aa4 != null ? this.aa4 : "";
            let i = new DataLegendSeriesContext();
            i.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.h = this.me();
            if (!stringIsNullOrEmpty(this.ady)) {
                let j = d == null ? NaN : this.iy(d, "RadiusMemberPath");
                let k = new DataLegendSeriesValueInfo();
                k.l = j;
                k.a = 11;
                k.q = "Radius";
                k.r = this.ady != null ? this.ady : "Radius";
                k.s = this.adu != null ? this.adu : "R:";
                k.t = this.adw != null ? this.adw : "";
                i.e.add(k);
            }
            else if (this.acw != null) {
                let l = new DataLegendSeriesValueInfo();
                l.l = this.acw.maximumValue;
                l.a = 11;
                l.q = "Radius";
                l.r = this.ady != null ? this.ady : "Radius";
                l.s = this.adu != null ? this.adu : "R:";
                l.t = this.adw != null ? this.adw : "";
                i.e.add(l);
            }
            if (!stringIsNullOrEmpty(this.adj)) {
                let m = d == null ? NaN : this.iy(d, "FillMemberPath");
                let n = new DataLegendSeriesValueInfo();
                n.l = m;
                n.a = 12;
                n.q = "Fill";
                n.r = this.adj != null ? this.adj : "Fill";
                n.s = this.adf != null ? this.adf : "F:";
                n.t = this.adh != null ? this.adh : "";
                i.e.add(n);
            }
            return i;
        }
        get actualMarkerBrush() {
            return this.ym;
        }
    }
    BubbleSeries.$t = /*@__PURE__*/ markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:adf:ad6', [2, null], 'FillMemberAsLegendUnit:adh:ad7', [2, null], 'FillMemberPath:adj:ad8', [2], 'FillScale:acu:ad9', [BrushScale.$], 'FillScaleUseGlobalValues:ac6:aea', [0, false], 'LabelMemberPath:ado:aeb', [2], 'MarkerBrushBrightness:adc:aec', [1, NaN], 'MarkerOutlineBrightness:add:aed', [1, NaN], 'MarkerOutlineUsesFillScale:ac7:aee', [0, false], 'RadiusMemberAsLegendLabel:adu:aef', [2, null], 'RadiusMemberAsLegendUnit:adw:aeg', [2, null], 'RadiusMemberPath:ady:aeh', [2, null], 'RadiusScale:acx:aei', [SizeScale.$], 'RadiusScaleUseGlobalValues:ac8:aej', [0, false]]);
    return BubbleSeries;
})();
/**
 * @hidden
 */
export let CustomPaletteBrushScale = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScale extends BrushScale {
        constructor() {
            super();
        }
        getBrush1(a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return super.getBrush(a % this.brushes.count);
            }
            let c = BubbleSeries.ada(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        }
        get_isReady() {
            return this.brushes != null && this.brushes.count > 0;
        }
    }
    CustomPaletteBrushScale.$t = /*@__PURE__*/ markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, /*@__PURE__*/ enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
})();
/**
 * @hidden
 */
export let BubbleSeriesView = /*@__PURE__*/ (() => {
    class BubbleSeriesView extends ScatterBaseView {
        constructor(a) {
            super(a);
            this.dy = null;
            this.dy = a;
            this.df = new ScatterTrendLineManager();
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.ch.xf = Defaults.e;
            }
        }
        dc() {
            return new BubbleMarkerManager((a) => this.dg.item(a), (a) => this.de.y1.c.item(a), runOn(this, this.ds), runOn(this, this.c9), runOn(this, this.dh));
        }
        d0() {
            let a = this.dd;
            this.dy.ad5(a.n, a.o, this.b9, this == this.f.cv);
            this.a2();
        }
        d1() {
            let a = this.dd;
            this.dy.ad4(a.n);
        }
        dz() {
            let a = this.dd;
            for (let b of fromEnum(a.n)) {
                let c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.f.ba.a$u(this.f);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dy.title + "</span><br/><span>" + "(${item." + this.dy.aay + "}, ${item." + this.dy.aa6 + "})</span>";
            if (!stringIsNullOrEmpty(this.dy.ady)) {
                a += "<span>, Radius: ${item." + this.dy.ady + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    BubbleSeriesView.$t = /*@__PURE__*/ markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
})();
