/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
export let FinancialChart = /*@__PURE__*/ (() => {
    class FinancialChart extends XYChart {
        wi(a, b, c) {
            super.wi(a, b, c);
            switch (a) {
                case "ToolbarTemplate":
                case "RangeSelectorTemplate":
                    this.aik = new FinancialChartToolbar(this, this.am1);
                    break;
                case "Toolbar":
                    let d = b;
                    if (d != null) {
                        d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.apv));
                        d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.apy));
                        d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.apz));
                        d.l(null);
                    }
                    if (this.aik != null) {
                        this.aik.ac = this.air;
                        this.aik.ai = this.ec;
                        this.aik.y = this.aim;
                        this.aik.al = this.akk;
                        if (this.al8 != null) {
                            this.aik.l(this.al8);
                        }
                        let e = this.aik;
                        e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.apv));
                        ;
                        let f = this.aik;
                        f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.apy));
                        let g = this.aik;
                        g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.apz));
                    }
                    break;
                case "ChartType":
                    if (this.aik != null) {
                        this.aik.y = this.aim;
                    }
                    break;
                case "VolumeType":
                    if (this.aik != null) {
                        this.aik.ac = this.air;
                    }
                    break;
                case "TrendLineType":
                    if (this.aik != null) {
                        this.aik.ai = this.ec;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.aik == null) {
                        break;
                    }
                    this.aik.al = this.akk;
                    this.setGridRows();
                    break;
            }
        }
        apz(a, b) {
            this.air = this.aik.ac;
        }
        apy(a, b) {
            this.ec = this.aik.ai;
        }
        apv(a, b) {
            this.aim = this.aik.y;
        }
        ap8() {
            this.ajd = new IndicatorPane();
            this.ai4 = TypeRegistrar.create("FinancialLegend");
        }
        provideGrid(a) {
            this.amb = a;
            this.aqt();
            this.setGridRows();
            if (this.aik != null) {
                this.aik.bg(a);
            }
        }
        onDocumentClick(a) {
            if (this.aik != null) {
                this.aik.bl(a);
            }
        }
        getContext() {
            let a = this.aik.v();
            let b = new FinancialChartContext();
            b.vm = new FinancialChartViewModel();
            b.vm.toolbar = a;
            b.container = this.l4;
            b.toolbarContainer = this.al8;
            b.legendContainer = this.al7;
            b.indicatorsContainer = this.al6;
            b.volumeContainer = this.al9;
            b.zoomContainer = this.ama;
            return b;
        }
        provideContainer(a) {
            let b = a;
            if (b != null) {
                let c = "financialChartMainGrid";
                let d = b.createElement("div");
                d.setStyleProperty("width", "100%");
                d.setStyleProperty("height", "100%");
                if (this.aik == null) {
                    this.aik = new FinancialChartToolbar(this, this.am1);
                }
                this.aik.w.isIndicatorMenuVisible = this.akb && this.akc;
                this.al8 = b.getSubRenderer(d);
                this.aik.l(this.al8);
                let e = b.createElement("div");
                e.setStyleProperty("width", "100%");
                e.setStyleProperty("height", "100%");
                let f = b.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                this.al7 = b.getSubRenderer(f);
                let g = b.createElement("div");
                g.setStyleProperty("width", "100%");
                g.setStyleProperty("height", "100%");
                this.al6 = b.getSubRenderer(g);
                let h = b.createElement("div");
                h.setStyleProperty("width", "100%");
                h.setStyleProperty("height", "100%");
                this.al9 = b.getSubRenderer(h);
                let i = b.createElement("div");
                i.setStyleProperty("width", "100%");
                i.setStyleProperty("height", "100%");
                this.ama = b.getSubRenderer(i);
                a = b.getSubRenderer(e);
            }
            else {
                this.al8 = null;
                if (this.aik != null) {
                    this.aik.l(null);
                }
                if (this.aj2 != null) {
                    this.aj2.provideContainer(null);
                    this.aj2 = null;
                }
                if (this.ai4 != null) {
                    this.ai4.provideContainer(null);
                }
            }
            super.provideContainer(a);
            if (b != null) {
                if (this.volumeChart != null) {
                    this.volumeChart.c9.b4(this.al9);
                }
                if (this.ajd != null) {
                    this.ajd.h(this.al6);
                }
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.c9.b4(this.ama);
                    if (a != null) {
                        this.apf();
                    }
                    else {
                        this.aj2 = null;
                    }
                }
                if (this.ai4 != null) {
                    this.ai4.provideContainer(this.al7);
                }
                this.setGridRows();
            }
        }
        aqj(a, b, c) {
            if (a != null) {
                a.provideContainer(null);
            }
            if (b != null) {
                b.c9.b4(c);
            }
            this.setGridRows();
        }
        aqx(a, b) {
            this.aqj(a, b, this.ama);
            if (b == null) {
                return;
            }
            this.apf();
        }
        apf() {
            if (this.ama == null) {
                return;
            }
            if (this.aj2 != null) {
                this.aj2.provideContainer(null);
            }
            this.aj2 = TypeRegistrar.create("ZoomSlider");
            this.aj2.provideContainer(this.ama);
            let a = this.aj2;
            a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
                if (this.dataChart != null) {
                    this.dataChart.w0 = new Rect(0, this.aj2.windowRect.left, this.dataChart.wh.top, this.aj2.windowRect.width, this.dataChart.wh.height);
                }
            });
            this.apg();
        }
        aqv(a, b) {
            this.aqj(a, b, this.al9);
        }
        setGridRows() {
            if (this.amb == null) {
                return;
            }
            let a = new Array(6);
            a[0] = (this.akk ? this.als : 0) + "px";
            a[1] = this.akg ? "min-content" : "0px";
            a[2] = "auto";
            a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
            a[4] = this.volumeChart == null ? "0px" : "100px";
            a[5] = this.zoomSliderChart == null ? "0px" : "100px";
            if (this.aj2 != null) {
                if (a[5] == "0px") {
                    this.aj2.hide();
                }
                else {
                    this.aj2.show();
                }
            }
            this.amb.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
            this.amb.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
            if (this.l4 == null) {
                return;
            }
            if (this.dataChart != null) {
                this.dataChart.notifyContainerResized();
            }
            if (this.ajd != null) {
                this.ajd.f();
            }
            if (this.volumeChart != null) {
                this.volumeChart.notifyContainerResized();
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.notifyContainerResized();
            }
            if (this.aj2 != null) {
                this.aj2.notifySizeChanged();
            }
        }
        vm() {
            super.vm();
            this.aaz = 1;
            this.age = 0;
            this.acw = 0;
            this.ag8 = null;
            this.ag1 = AxisDefaults.axis_LineBrush;
            this.acg = AxisDefaults.axis_TickStroke;
            this.acf = AxisDefaults.categoryAxis_TickLength;
            this.ag2 = AxisDefaults.axis_TickBrush;
            this.agy = null;
            this.aqz = AxisDefaults.axis_MajorBrush;
            this.al5 = AxisDefaults.axis_MajorStroke;
            this.finalValueAnnotationsVisible = true;
            this.crosshairsAnnotationEnabled = true;
            this.gq = false;
            this.crosshairsDisplayMode = 0;
            this.jq = Defaults.crosshairLineThickness;
            this.yy = Defaults.crosshairLineBrush;
            this.yt = Defaults.crosshairXAxisAnnotationBackground;
            this.yu = Defaults.crosshairXAxisAnnotationTextColor;
            this.ka = NaN;
            this.j2 = 40;
            this.g6 = true;
            this.he = false;
            if (this.dataChart != null) {
                let a = this.dataChart.c9.j.e();
                this.ahv = a.d;
                this.ahw = a.e;
                this.ahu = a.d;
                this.aqz = this.dataChart.aa5;
            }
            let b = new BrushCollection();
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8BDC5C";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8961A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#6DB1FF";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#82E9D9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#EA3C63";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#735656";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#F8CE4F";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#A8A8B7";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#E051A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#FF903B";
                return $ret;
            })()));
            let c = new BrushCollection();
            for (let d of fromEnum(b)) {
                c.add(BrushUtil.p(d, 0.3));
            }
            this.ahx = c;
            this.ahy = b;
        }
        aqf() {
            if (this.ajd != null) {
                this.ajd.b = null;
                this.ajd.b = this.indicatorCharts;
            }
            this.setGridRows();
        }
        aqg() {
            this.setGridRows();
        }
        aqp() {
            this.aqf();
        }
        ape() {
            if (this.aj2 == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
                return;
            }
            let a = this.l4.rootWrapper.width();
            let b = this.dataChart.wz.left + this.dataChart.wz.width;
            let c = this.dataChart.wz.left;
            let d = a - b;
            this.aj2.startInset = c - this.aj2.trackStartInset;
            this.aj2.endInset = d - this.aj2.trackEndInset;
            if (this.aj2.endInset < 0) {
                let e = this.aj2.endInset;
                this.aj2.endInset = 0;
                this.dataChart.h9 += (e * -1);
            }
            if (this.aj2.startInset < 0) {
                let f = this.aj2.startInset;
                this.aj2.startInset = 0;
                this.dataChart.h4 += (f * -1);
            }
            this.zoomSliderChart.h4 = c;
            this.zoomSliderChart.h9 = d;
            this.zoomSliderChart.hr = this.aj2.barExtent;
        }
        ap5() {
            this.ape();
        }
        vj(a) {
            super.vj(a);
            if (a != null) {
                a.hq = 0;
            }
        }
        aq0(a) {
            return a.wa();
        }
        aq3() {
            return this.al7 == null ? null : this.aq2(this.al7.rootWrapper);
        }
        aq1(a) {
            if (a == null || a.d == null) {
                return null;
            }
            return this.aq2(a.d.rootWrapper);
        }
        aq2(a) {
            if (a == null) {
                return null;
            }
            let b = a.getOffset();
            return new Rect(0, b.left, b.top, a.width(), a.height());
        }
        aln() {
            if (this.amb == null) {
                return NaN;
            }
            let a = this.amb.getOffset();
            return this.amb.width() + (a == null ? 0 : a.left);
        }
        vv(source_, a, b) {
            super.vv(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.on(source_, a, b);
            }
        }
        vw(source_, a, b) {
            super.vw(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.oo(source_, a, b);
            }
        }
        vu(source_) {
            super.vu(source_);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.og(source_);
            }
        }
        vy(source_, a, b, c) {
            super.vy(source_, a, b, c);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.op(source_, a, b, c);
            }
        }
        vp(a, b) {
            super.vp(a, b);
            if (this.akh(a)) {
                a.toolTip = null;
            }
        }
        get aik() {
            return this.aij;
        }
        set aik(a) {
            let b = this.aik;
            if (a != b) {
                this.aij = a;
                this.wd("Toolbar", b, this.aik);
            }
        }
        get am0() {
            return this.amt;
        }
        set am0(a) {
            let b = this.am0;
            if (a != b) {
                this.amt = a;
                this.wd("RangeSelectorTemplate", b, this.am0);
            }
        }
        get am1() {
            return this.amu;
        }
        set am1(a) {
            let b = this.am1;
            if (a != b) {
                this.amu = a;
                this.wd("ToolbarTemplate", b, this.am1);
            }
        }
        get amx() {
            return this.amq;
        }
        set amx(a) {
            let b = this.amx;
            if (a != b) {
                this.amq = a;
                this.wd("ChartTypePickerTemplate", b, this.amx);
            }
        }
        get am2() {
            return this.amv;
        }
        set am2(a) {
            let b = this.am2;
            if (a != b) {
                this.amv = a;
                this.wd("TrendLineTypePickerTemplate", b, this.am2);
            }
        }
        get am3() {
            return this.amw;
        }
        set am3(a) {
            let b = this.am3;
            if (a != b) {
                this.amw = a;
                this.wd("VolumeTypePickerTemplate", b, this.am3);
            }
        }
        get amy() {
            return this.amr;
        }
        set amy(a) {
            let b = this.amy;
            if (a != b) {
                this.amr = a;
                this.wd("IndicatorMenuTemplate", b, this.amy);
            }
        }
        get amz() {
            return this.ams;
        }
        set amz(a) {
            let b = this.amz;
            if (a != b) {
                this.ams = a;
                this.wd("OverlayPickerTemplate", b, this.amz);
            }
        }
        get aj2() {
            return this.aj1;
        }
        set aj2(a) {
            let b = this.aj2;
            if (a != b) {
                this.aj1 = a;
                this.wd("ZoomSlider", b, this.aj2);
            }
        }
        get_j2() {
            return super.get_j2();
        }
        set_j2(a) {
            super.set_j2(a);
        }
        get_g6() {
            return super.get_g6();
        }
        set_g6(a) {
            super.set_g6(a);
        }
        get als() {
            return this.alb;
        }
        set als(a) {
            let b = this.als;
            if (a != b) {
                this.alb = a;
                this.wd("ToolbarHeight", b, this.als);
            }
        }
        constructor() {
            super();
            this.ajd = null;
            this.amb = null;
            this.al9 = null;
            this.al6 = null;
            this.al8 = null;
            this.ama = null;
            this.al7 = null;
            this.aij = null;
            this.amt = null;
            this.amu = null;
            this.amq = null;
            this.amv = null;
            this.amw = null;
            this.amr = null;
            this.ams = null;
            this.aj1 = null;
            this.alb = 40;
            this.ai7 = null;
            this.ai5 = null;
            this.ai9 = null;
            this.aje = null;
            this.am4 = null;
            this.ajx = null;
            this.akn = false;
            this.akm = false;
            this.aku = false;
            this.aj9 = false;
            this.amh = 10;
            this.ali = NaN;
            this.alk = NaN;
            this.alj = NaN;
            this.all = 0;
            this.aip = 0;
            this.ais = 0;
            this.ald = 3;
            this.alg = NaN;
            this.ale = NaN;
            this.alf = NaN;
            this.alh = NaN;
            this.aiu = 0;
            this.aj4 = true;
            this.ail = 0;
            this.aj5 = false;
            this.aiz = null;
            this.ai1 = null;
            this.akw = null;
            this.aj7 = true;
            this.aj6 = false;
            this.aj8 = false;
            this.ajy = null;
            this.aiw = 1;
            this.ahn = null;
            this.aho = null;
            this.ahp = null;
            this.ahq = null;
            this.ahs = null;
            this.ahr = null;
            this.ahm = null;
            this.ahl = null;
            this.alc = 1;
            this.ala = 1;
            this.ak9 = 2;
            this.ak8 = 1;
            this.ajb = null;
            this.amd = -2147483648;
            this.ak7 = 2;
            this.amg = 3;
            this.ame = 10;
            this.amc = 30;
            this.amf = 9;
            this.aig = null;
            this.aih = null;
            this.aic = null;
            this.applyCustomIndicators = null;
            this.aqy = null;
            this.alm = 1;
            this.aj3 = false;
            this.ai3 = null;
            this.ak4 = dateMinValue();
            this.ak3 = dateMaxValue();
            this.ak1 = null;
            this.u2();
            this.ak1 = new ObservableCollection$1(Base.$, 0);
            if (this.xAxisBreaks != null) {
                let a = this.xAxisBreaks;
                a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.aqn());
            }
            this.ap8();
        }
        aao() {
            return this.xAxis;
        }
        aap() {
            return this.yAxis;
        }
        onAttachedToUI() {
            super.onAttachedToUI();
            if (this.aj2 != null) {
                this.aj2.onAttachedToUI();
            }
        }
        onDetachedFromUI() {
            super.onDetachedFromUI();
            if (this.aj2 != null) {
                this.aj2.onDetachedFromUI();
            }
        }
        be(a) {
            return 20;
        }
        get_h2() {
            return ((() => {
                let $ret = new List$1(DataSeriesType_$type, 0);
                $ret.add(20);
                return $ret;
            })());
        }
        get h2() {
            return this.get_h2();
        }
        get_h1() {
            return ((() => {
                let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
                $ret.add(new SimpleFinancialPriceSeriesRule());
                $ret.add(new SubCollectionsRule());
                return $ret;
            })());
        }
        get h1() {
            return this.get_h1();
        }
        ah6(a) {
            return this.ah7(a);
        }
        ajk(a) {
            return this.ajl(a);
        }
        ah5(a) {
            let b = this.ah6(0);
            b.name = a;
            return b;
        }
        ux() {
            this.xAxis = this.ah5("xAxis");
            this.yAxis = this.ajk(0);
            this.yAxis.name = "yAxis";
            this.volumeAxis = this.ajk(0);
            this.volumeAxis.name = "volumeAxis";
            this.volumeXAxis = this.ah5("volumeXAxis");
            this.aky = new List$1(NumericYAxis.$, 0);
            this.ak0 = new List$1(CategoryAxisBase.$, 0);
            this.indicatorAxis = this.ajk(0);
            this.indicatorAxis.name = "indicatorAxis";
            this.indicatorXAxis = this.ah5("indicatorXAxis_0");
            this.aky.add(this.indicatorAxis);
            this.ak0.add(this.indicatorXAxis);
            if (this.xAxis.az == null) {
                this.xAxis.az = new AxisLabelSettings();
            }
            if (this.yAxis.az == null) {
                this.yAxis.az = new AxisLabelSettings();
            }
            if (this.volumeAxis.az == null) {
                this.volumeAxis.az = new AxisLabelSettings();
            }
            if (this.volumeXAxis.az == null) {
                this.volumeAxis.az = new AxisLabelSettings();
            }
            if (this.indicatorAxis.az == null) {
                this.indicatorAxis.az = new AxisLabelSettings();
            }
            if (this.indicatorXAxis.az == null) {
                this.indicatorXAxis.az = new AxisLabelSettings();
            }
            this.zoomSliderAxis = this.ajk(0);
            this.zoomSliderAxis.name = "zoomSliderAxis";
            this.zoomSliderXAxis = this.ah5("zoomSliderXAxis");
            if (this.zoomSliderAxis.az == null) {
                this.zoomSliderAxis.az = new AxisLabelSettings();
            }
            if (this.zoomSliderXAxis.az == null) {
                this.zoomSliderXAxis.az = new AxisLabelSettings();
            }
        }
        ur(a, b) {
            let c = typeCast(MarkerSeries.$, a);
            if (c != null) {
                c.xf = this.c2(a, b);
            }
        }
        c1(a) {
            if (a != null) {
                return 1;
            }
            return super.c1(a);
        }
        w8(a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.lo = true;
                this.yAxis.mm = 10;
            }
        }
        xb() {
            this.yAxis.lo = this.akr;
            this.yAxis.mm = this.amp;
        }
        aio(a) {
            let b;
            if (this.aim == 0) {
                if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                    b = 4;
                }
                else {
                    b = 2;
                }
            }
            else {
                b = this.aim;
            }
            b = this.ain(b);
            return b;
        }
        ain(a) {
            if ((a == 1 || a == 2)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        aix(a) {
            if ((a == 2 || a == 3)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 5;
            }
            if (a == 5) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 6;
            }
            if (a == 6) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        aiq(a) {
            if (a == 2) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 1;
            }
            if (a == 1) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        anc(a) {
            let b = a.getMemberPathFor(14);
            if (stringIsNullOrEmpty(b)) {
                b = a.getMemberPathFor(11);
            }
            return b;
        }
        ah7(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createXAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        ajl(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createYAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        ajr() {
            return this.df(1);
        }
        ajs() {
            return this.df(0);
        }
        ajq() {
            return this.df(2);
        }
        ajt() {
            return this.df(20);
        }
        get aka() {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        }
        get ai8() {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        }
        get akd() {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        }
        get ai6() {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get akb() {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        }
        get aja() {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get akc() {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        }
        get ajf() {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        }
        dc(a, b) {
            let c = this.anc(a);
            switch (this.aio(a)) {
                case 3:
                    let d = this.ajr();
                    this.ai8.setValueMemberPath(d, c);
                    this.ai8.setXAxis(d, this.xAxis);
                    this.ai8.setYAxis(d, this.yAxis);
                    this.ai8.setCategoryMode(d, 1);
                    return d;
                case 4:
                    let e = this.ajs();
                    this.ai8.setValueMemberPath(e, c);
                    this.ai8.setXAxis(e, this.xAxis);
                    this.ai8.setYAxis(e, this.yAxis);
                    this.ai8.setCategoryMode(e, 1);
                    return e;
                default:
                case 1:
                case 2:
                    let f = this.ajt();
                    this.ai6.setOpenMemberPath(f, a.getMemberPathFor(11));
                    this.ai6.setHighMemberPath(f, a.getMemberPathFor(12));
                    this.ai6.setLowMemberPath(f, a.getMemberPathFor(13));
                    this.ai6.setCloseMemberPath(f, a.getMemberPathFor(14));
                    this.ai6.setVolumeMemberPath(f, a.getMemberPathFor(15));
                    this.ai6.setXAxis(f, this.xAxis);
                    this.ai6.setYAxis(f, this.yAxis);
                    this.ai6.setDisplayType(f, this.aim == 1 ? 1 : 0);
                    this.ai6.setCategoryMode(f, 1);
                    return f;
            }
        }
        xa() {
            super.xa();
            this.ap3(this.xAxis);
            this.aqr(false);
            if (this.air != 0 && this.volumeChart != null) {
                this.aqa();
            }
            this.ap3(this.volumeXAxis);
            this.ap3(this.indicatorXAxis);
            this.aqo();
            this.aqq();
            if (this.aiy != 0) {
                this.aqb();
                this.ap3(this.zoomSliderXAxis);
            }
        }
        af0(a, b) {
            super.af0(a, b);
            a(this.volumeXAxis);
            if (this.ak0 != null) {
                for (let c of fromEnum(this.ak0)) {
                    a(c);
                }
            }
            let d = true;
            switch (b) {
                case "XAxisMajorStroke":
                case "XAxisMajorStrokeThickness":
                    d = false;
                    break;
            }
            if (d) {
                a(this.zoomSliderXAxis);
            }
        }
        af5(a, b) {
            super.af5(a, b);
            if (b) {
                a(this.volumeAxis);
                if (this.aky != null) {
                    for (let c of fromEnum(this.aky)) {
                        a(c);
                    }
                }
                a(this.zoomSliderAxis);
            }
        }
        ap7(a) {
            let b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
            if (b != null) {
                a(b);
            }
        }
        af3(a) {
            super.af3(a);
            this.afu(this.volumeXAxis, a);
            this.afu(this.indicatorXAxis, a);
            this.afu(this.zoomSliderXAxis, a);
        }
        af8(a) {
            super.af8(a);
            this.afu(this.volumeAxis, a);
            this.afu(this.indicatorAxis, a);
            this.afu(this.zoomSliderAxis, a);
        }
        af6(a) {
            super.af6(a);
            this.aft(this.volumeAxis, a);
            this.aft(this.indicatorAxis, a);
            this.aft(this.zoomSliderAxis, a);
        }
        af1(a) {
            super.af1(a);
            this.aft(this.volumeXAxis, a);
            this.aft(this.indicatorXAxis, a);
            this.aft(this.zoomSliderXAxis, a);
        }
        vi(a) {
            super.vi(a);
            if (a == null) {
                return;
            }
            if (a == this.zoomSliderChart) {
                a.xv = a.xy = false;
                a.legend = null;
                if (this.dataChart != null) {
                    a.ag = this.dataChart.ag;
                    a.aj = this.dataChart.aj;
                }
            }
            else {
                SyncManager.d(a, ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = this.an7();
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })()));
                SyncManager.c(a);
            }
            a.cw = 2;
        }
        an7() {
            if (this.am4 == null) {
                FinancialChart.amo++;
                this.am4 = FinancialChart.amo.toString();
            }
            return this.am4;
        }
        app(a, b) {
            this.apb();
            this.ap5();
        }
        apb() {
            if (this.yAxis.b8()) {
                return;
            }
            let a = this.yAxis.aw.bd;
            if (this.air != 0) {
                a = Math.max(a, this.volumeAxis.aw.bd);
            }
            for (let b of fromEnum(this.aky)) {
                a = Math.max(a, b.aw.bd);
            }
            this.apc(a);
        }
        apc(a) {
            if (this.yAxis.b8()) {
                return;
            }
            this.yAxis.eu = this.volumeAxis.eu = a;
            for (let b of fromEnum(this.aky)) {
                b.eu = a;
            }
            this.zoomSliderAxis.eu = this.yAxis.eu;
        }
        aph(a) {
            if (this.indicatorCharts == null) {
                return;
            }
            for (let b = 0; b < this.indicatorCharts.count; b++) {
                let c = this.indicatorCharts._inner[b];
                for (let d = 0; d < c.series.count; d++) {
                    let e = c.series._inner[d];
                    if (!(this.akf(e))) {
                        continue;
                    }
                    a(c.series._inner[d], b);
                }
            }
        }
        apk(a) {
            if (this.volumeChart == null) {
                return;
            }
            for (let b = 0; b < this.volumeChart.series.count; b++) {
                let c = this.volumeChart.series._inner[b];
                if (c.eu) {
                    continue;
                }
                a(this.volumeChart.series._inner[b], b);
            }
        }
        api(a) {
            if (this.dataChart == null) {
                return;
            }
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (!this.akh(c)) {
                    continue;
                }
                a(c, b);
            }
        }
        apj(a, b) {
            if (this.dataChart == null) {
                return;
            }
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.akh(d)) {
                    continue;
                }
                let e = this.ami(d, c);
                a(d, e);
            }
            if (b) {
                this.apl(a);
            }
        }
        apl(a) {
            if (this.zoomSliderChart == null) {
                return;
            }
            for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
                let c = this.zoomSliderChart.series._inner[b];
                if (c.eu) {
                    continue;
                }
                a(this.zoomSliderChart.series._inner[b], b);
            }
        }
        ami(a, b) {
            if (a.da != this.dataChart) {
                return b;
            }
            let c = this.bf == null || this.bf.dataSeries == null ? 0 : this.bf.dataSeries.count;
            let d = this.ai2 == null ? 0 : this.ai2.count;
            return b - (c * d);
        }
        u7(a) {
            super.u7(a);
            this.apk(a);
            this.aph(a);
            this.apl(a);
        }
        get volumeChart() {
            return this.ajx;
        }
        set volumeChart(a) {
            let b = this.volumeChart;
            if (a != b) {
                this.ajx = a;
                this.wd("VolumeChart", b, this.volumeChart);
            }
        }
        aqa() {
            if (this.dataChart == null) {
                return;
            }
            this.volumeChart.series.clear();
            let a = new List$1(Series.$, 0);
            let b = -1;
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.akh(d) || d.eu) {
                    continue;
                }
                b++;
                let e;
                let f = this.air;
                f = this.aiq(f);
                switch (f) {
                    case 2:
                        e = this.ajs();
                        break;
                    case 3:
                        e = this.ajq();
                        break;
                    default:
                    case 1:
                        e = this.ajr();
                        break;
                }
                this.ai8.setCategoryMode(e, 1);
                e.name = "volumeSeries_" + b;
                e.itemsSource = d.itemsSource;
                this.ai8.setXAxis(e, this.volumeXAxis);
                this.ai8.setYAxis(e, this.volumeAxis);
                this.ai8.setValueMemberPath(e, this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > b ? this.bf.dataSeries._inner[b].getMemberPathFor(15) : null);
                e.title = d.title + " Volume";
                e.vk = ArrayExtension.getModulus$1(Brush.$, this.ahz, b);
                e.v0 = ArrayExtension.getModulus$1(Brush.$, this.ah0, b);
                e.jq = this.alt;
                a.add(e);
            }
            let g = this.hy("volume", false);
            if (g != null) {
                a.o(g);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.volumeChart.series.add(i);
                this.vn(i, h);
            }
        }
        ake(a) {
            if (!this.aka) {
                return false;
            }
            return this.ai8.matchesType(a);
        }
        aki(a) {
            if (!this.akd) {
                return false;
            }
            return this.ai6.matchesType(a);
        }
        akf(a) {
            if (!this.akb) {
                return false;
            }
            return this.aja.matchesType(a);
        }
        akh(a) {
            if (!this.akc) {
                return false;
            }
            return this.ajf.matchesType(a);
        }
        ap9() {
            if (this.dataChart == null) {
                return;
            }
            let a = 0;
            let b = this.ai0 == null ? 0 : this.ai0.count;
            let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let d = b + c;
            for (let e = 0; e < d; e++) {
                let f = new List$1(Series.$, 0);
                let g = this.indicatorCharts._inner[e];
                let h = e >= b;
                let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ai0._inner[e]);
                let j = -1;
                for (let k = 0; k < this.dataChart.series.count; k++) {
                    let l = this.dataChart.series._inner[k];
                    if (this.akh(l) || l.eu) {
                        continue;
                    }
                    j++;
                    let m;
                    if (h) {
                        let n = this.aju("Custom");
                        this.aja.handleCustomIndicatorEvent(n, runOn(this, this.apn));
                        m = n;
                    }
                    else {
                        m = this.ajw(this.ai0._inner[e]);
                    }
                    if (m == null) {
                        continue;
                    }
                    m.name = "indicator_" + a++;
                    this.aja.setXAxis(m, this.ak0._inner[e]);
                    this.aja.setYAxis(m, this.aky._inner[e]);
                    m.itemsSource = l.itemsSource;
                    this.aja.setOpenMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(11));
                    this.aja.setHighMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(12));
                    this.aja.setLowMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(13));
                    this.aja.setCloseMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(14));
                    this.aja.setVolumeMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(15));
                    m.title = l.title + " " + i;
                    m.vk = ArrayExtension.getModulus$1(Brush.$, this.aht, e);
                    m.jq = this.alp;
                    if (this.akf(m)) {
                        this.aja.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ahu, e));
                        this.aja.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ajc, e));
                    }
                    if (this.amk != -2147483648 && this.akf(m)) {
                        this.aja.setPeriodOverride(m, this.amk);
                    }
                    if (this.akf(m)) {
                        this.aja.setSmoothingPeriod(m, this.amn);
                    }
                    if (this.akf(m)) {
                        this.aja.setSignalPeriod(m, this.amm);
                    }
                    if (this.akf(m)) {
                        this.aja.setShortPeriod(m, this.aml);
                        this.aja.setLongPeriod(m, this.amj);
                    }
                    this.vn(m, e);
                    f.add(m);
                }
                let o = this.hy(i, false);
                for (let p = 0; p < f.count; p++) {
                    let q = f._inner[p];
                    g.series.add(q);
                }
                if (o != null) {
                    for (let r = 0; r < o.count; r++) {
                        let s = o._inner[r];
                        g.series.add(s);
                        this.vn(s, r);
                    }
                }
            }
        }
        aju(indicatorName_) {
            return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
        }
        ajw(a) {
            return this.aju(EnumUtil.getName(FinancialIndicatorType_$type, a));
        }
        aqr(a) {
            if (this.aik == null) {
                return;
            }
            let b = this.xAxis;
            if (b.actualMinimumValue > b.actualMaximumValue) {
                return;
            }
            this.aik.as = b.actualMinimumValue;
            this.aik.ar = b.actualMaximumValue;
            if (a) {
                this.aik.au = b.visibleMinimum;
                this.aik.at = b.visibleMaximum;
            }
            this.aik.bn();
        }
        l5() {
            let a = ((() => {
                let $ret = new FinancialChartVisualData();
                $ret.mainChart = super.l5();
                $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.y7();
                $ret.toolbar = this.aik == null ? null : this.aik.aj();
                $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.y7();
                return $ret;
            })());
            if (this.indicatorCharts != null) {
                a.indicatorCharts = new List$1(Base.$, 0);
                for (let b of fromEnum(this.indicatorCharts)) {
                    a.indicatorCharts.add1(b.y7());
                }
            }
            if (this.dataChart != null) {
                a.mainChartLeft = this.aq0(this.dataChart).x;
                a.mainChartTop = this.aq0(this.dataChart).y;
            }
            if (this.volumeChart != null) {
                a.volumeChartLeft = this.aq0(this.volumeChart).x;
                a.volumeChartTop = this.aq0(this.volumeChart).y;
            }
            if (this.zoomSliderChart != null) {
                a.zoomChartLeft = this.aq0(this.zoomSliderChart).x;
                a.zoomChartTop = this.aq0(this.zoomSliderChart).y;
            }
            if (this.aik != null) {
                let c = this.aq1(this.aik);
                a.toolbarLeft = c.left;
                a.toolbarTop = c.top;
                a.toolbarWidth = c.width;
                a.toolbarHeight = c.height;
            }
            if (this.indicatorCharts != null) {
                a.indicatorChartLefts = new List$1(Number_$type, 0);
                a.indicatorChartTops = new List$1(Number_$type, 0);
                for (let d of fromEnum(this.indicatorCharts)) {
                    a.indicatorChartLefts.add(this.aq0(d).x);
                    a.indicatorChartTops.add(this.aq0(d).y);
                }
            }
            let e = this.aq3();
            a.legendLeft = e.left;
            a.legendTop = e.top;
            a.legendWidth = e.width;
            a.legendHeight = e.height;
            a.legend = this.ai4 == null ? null : this.ai4.exportVisualData();
            return a;
        }
        am9() {
            let a = this.l5();
            a.scaleByViewport();
            return a.serialize();
        }
        ajv(overlayName_) {
            return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
        }
        aqq() {
            if (this.dataChart == null) {
                return;
            }
            let a = new List$1(Series.$, 0);
            for (let b of fromEnum(this.dataChart.series)) {
                if (this.akh(b)) {
                    a.add(b);
                }
            }
            for (let c of fromEnum(a)) {
                this.dataChart.series.remove(c);
            }
            if (this.ai2 == null) {
                return;
            }
            let d = new List$1(Series.$, 0);
            let e = -1;
            for (let f = 0; f < this.dataChart.series.count; f++) {
                let g = this.dataChart.series._inner[f];
                if (this.akh(g) || g.eu) {
                    continue;
                }
                e++;
                for (let h = 0; h < this.ai2.count; h++) {
                    let i = this.ai2._inner[h];
                    let j;
                    switch (i) {
                        case 1:
                            j = this.ajv(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                        default:
                        case 0:
                            j = this.ajv(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                    }
                    j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                    this.ajf.setXAxis(j, this.xAxis);
                    this.ajf.setYAxis(j, this.yAxis);
                    j.itemsSource = g.itemsSource;
                    let k = e * this.ai2.count + h;
                    j.vk = ArrayExtension.getModulus$1(Brush.$, this.ahx, k);
                    j.v0 = ArrayExtension.getModulus$1(Brush.$, this.ahy, k);
                    j.jq = this.alr;
                    j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                    let l = g;
                    if (l == null) {
                        continue;
                    }
                    let m = this.bf.dataSeries._inner[e];
                    this.ajf.setOpenMemberPath(j, m.getMemberPathFor(11));
                    this.ajf.setHighMemberPath(j, m.getMemberPathFor(12));
                    this.ajf.setLowMemberPath(j, m.getMemberPathFor(13));
                    this.ajf.setCloseMemberPath(j, m.getMemberPathFor(14));
                    this.ajf.setVolumeMemberPath(j, m.getMemberPathFor(15));
                    d.add(j);
                }
            }
            let n = new Array(this.dataChart.series.count);
            this.dataChart.series.copyTo(n, 0);
            this.dataChart.skipDataCleanup = true;
            this.dataChart.series.clear();
            this.dataChart.skipDataCleanup = false;
            for (let o = 0; o < n.length; o++) {
                n[o].index = -1;
            }
            d.o(n);
            for (let p = 0; p < d.count; p++) {
                let q = d._inner[p];
                this.dataChart.series.add(q);
                this.vn(q, p);
            }
        }
        aqo() {
            if (this.akn) {
                return;
            }
            this.akn = true;
            if (this.indicatorCharts != null) {
                let a = this.indicatorCharts;
                this.indicatorCharts = null;
                for (let b of fromEnum(a)) {
                    this.ap4(b);
                }
            }
            if ((this.ai0 == null || this.ai0.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
                this.indicatorCharts = null;
                if (this.aky != null) {
                    this.aky.clear();
                }
                if (this.ak0 != null) {
                    this.ak0.clear();
                }
                this.aqf();
                this.aqp();
                this.akn = false;
                return;
            }
            if (this.indicatorCharts == null) {
                this.indicatorCharts = new List$1(XamDataChart.$, 0);
            }
            this.indicatorCharts.clear();
            this.aky.clear();
            this.ak0.clear();
            let c = this.ai0 == null ? 0 : this.ai0.count;
            let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let e = c + d;
            for (let f = 0; f < e; f++) {
                let g = new XamDataChart();
                this.indicatorCharts.add(g);
                this.ap2(g, null);
                let h = f >= c;
                if (h) {
                    g.mc = this.customIndicatorNames._inner[f - c];
                }
                else {
                    g.mc = this.anb(this.ai0._inner[f]);
                }
                if (this.indicatorAxis != null) {
                    let i;
                    let j;
                    if (f == 0) {
                        i = this.indicatorAxis;
                        j = this.indicatorXAxis;
                    }
                    else {
                        i = new NumericYAxis();
                        if (!this.indicatorXAxis.ce) {
                            j = this.ah6(0);
                        }
                        else {
                            j = this.ah6(1);
                        }
                    }
                    j.name = "indicatorXAxis_" + f;
                    i.name = "indicatorAxis_" + f;
                    g.axes.add(i);
                    g.axes.add(j);
                    this.aky.add(i);
                    this.ak0.add(j);
                    if (this.gk) {
                        this.afx(i);
                    }
                    if (this.gk) {
                        this.afv(j);
                    }
                }
            }
            this.aqf();
            this.ap9();
            if (this.aik != null) {
                this.aik.ae = this.ai0;
            }
            this.apd();
            this.aqp();
            this.akn = false;
        }
        vf() {
            super.vf();
            this.afv(this.xAxis);
            this.afv(this.volumeXAxis);
            if (this.ak0 != null) {
                for (let a of fromEnum(this.ak0)) {
                    this.afv(a);
                }
            }
            this.afx(this.yAxis);
            this.afx(this.volumeAxis);
            if (this.aky != null) {
                for (let b of fromEnum(this.aky)) {
                    this.afx(b);
                }
            }
            this.afv(this.zoomSliderXAxis);
            this.afx(this.zoomSliderAxis);
        }
        get_hd() {
            return !this.akl;
        }
        get akt() {
            return (this.externalObject._dynamicContent);
        }
        aqw(a, b) {
            this.aqi(a, b, this.ama);
            this.apd();
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
            }
            this.aqb();
            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
            this.aqg();
            this.aqx(a, b);
        }
        aqb() {
            if (this.dataChart == null || this.zoomSliderChart == null) {
                return;
            }
            this.zoomSliderChart.series.clear();
            let a = new List$1(Series.$, 0);
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (this.akh(c) || c.eu) {
                    continue;
                }
                let d;
                let e = this.aiy;
                e = this.aix(e);
                let f = this.ami(c, b);
                if (e == 1) {
                    switch (this.aio(this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null)) {
                        case 1:
                            e = 2;
                            break;
                        case 2:
                            e = 3;
                            break;
                        case 3:
                            e = 4;
                            break;
                        case 4:
                            e = 5;
                            break;
                    }
                }
                switch (e) {
                    case 2:
                        d = this.ajt();
                        this.ai6.setDisplayType(d, 1);
                        break;
                    case 3:
                        d = this.ajt();
                        this.ai6.setDisplayType(d, 0);
                        break;
                    case 5:
                        d = this.ajs();
                        break;
                    case 6:
                        d = this.ajq();
                        break;
                    default:
                    case 4:
                        d = this.ajr();
                        break;
                }
                let g = this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null;
                if (d.e0 && !d.e8) {
                    this.ai8.setCategoryMode(d, 1);
                    this.ai8.setXAxis(d, this.zoomSliderXAxis);
                    this.ai8.setYAxis(d, this.zoomSliderAxis);
                    this.ai8.setValueMemberPath(d, g == null ? null : this.anc(g));
                }
                else if (d.e8) {
                    this.ai6.setCategoryMode(d, 1);
                    this.ai6.setXAxis(d, this.zoomSliderXAxis);
                    this.ai6.setYAxis(d, this.zoomSliderAxis);
                    if (g != null) {
                        this.ai6.setOpenMemberPath(d, g.getMemberPathFor(11));
                        this.ai6.setHighMemberPath(d, g.getMemberPathFor(12));
                        this.ai6.setLowMemberPath(d, g.getMemberPathFor(13));
                        this.ai6.setCloseMemberPath(d, g.getMemberPathFor(14));
                        this.ai6.setVolumeMemberPath(d, g.getMemberPathFor(15));
                    }
                }
                d.name = "zoomSliderSeries_" + f;
                d.itemsSource = c.itemsSource;
                d.title = c.title;
                d.jq = this.kg;
                a.add(d);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.zoomSliderChart.series.add(i);
                this.vn(i, h);
            }
        }
        v3(a, b, c) {
            super.v3(a, b, c);
            if (a == null || !b) {
                return;
            }
            let d = true;
            let e = true;
            switch (c) {
                case "Brushes":
                case "Outlines":
                    d = e = false;
                    break;
            }
            if (this.indicatorCharts != null && d) {
                for (let f of fromEnum(this.indicatorCharts)) {
                    a(f);
                }
            }
            if (this.volumeChart != null && e) {
                a(this.volumeChart);
            }
            if (this.zoomSliderChart != null) {
                a(this.zoomSliderChart);
            }
        }
        apn(a, b) {
            let c = b;
            let d = a;
            let e = -1;
            if (this.indicatorCharts != null) {
                e = this.indicatorCharts.indexOf(d.da);
            }
            e -= this.ai0 == null ? 0 : this.ai0.count;
            if (this.applyCustomIndicators != null) {
                this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
            }
        }
        aqk(a, b, c) {
            if (a != null) {
                if (b != null) {
                    a.axes.remove(b);
                }
                a.axes.add(c);
            }
            if (this.gk) {
                this.afv(c);
            }
        }
        get aks() {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        }
        apo(a, b) {
            this.aqo();
        }
        akj(a, b) {
            if (b <= (0)) {
                return false;
            }
            switch (a) {
                case 5: return true;
                case 4:
                case 3: return b >= timeSpanFromDays(365);
                case 2: return b >= timeSpanFromDays(180);
                case 1: return b >= timeSpanFromDays(90);
                case 0: return b >= timeSpanFromDays(30);
            }
            return false;
        }
        aqe() {
            let a = this.aii != null ? this.aii : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
            let b = new FinancialChartRangeSelectorOptionCollection(0);
            let c = this.xAxis;
            let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
            for (let e of fromEnum(a)) {
                if (this.akj(e, d)) {
                    b.add(e);
                }
            }
            this.aih = b;
            if (this.aik != null) {
                this.aik.u = this.aih;
            }
        }
        aps(a, b) {
            this.aqe();
        }
        apx(a, b) {
            this.ai2 = this.aik.ag;
        }
        apw(a, b) {
            this.ai0 = this.aik.ae;
        }
        apq(a, b) {
            this.aqo();
        }
        apr(a, b) {
            this.aqq();
        }
        ap1(a, b) {
            let c = a;
            if (c.bg == null) {
                return;
            }
            if (this.akl) {
                this.aqd(c.bg);
            }
        }
        ap4(a) {
            SyncManager.e(a);
            a.axes.clear();
            a.series.clear();
            a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.app));
            a.provideContainer(null);
            if (this.volumeChart == null && this.indicatorCharts == null) {
                this.yAxis.eu = this.volumeAxis.eu = this.indicatorAxis.eu = 0;
                this.xAxis.az.visibility = this.ahj;
            }
        }
        ap2(a, b) {
            let c = a != this.zoomSliderChart;
            if (c) {
                if (this.dataChart != null) {
                    a.w0 = new Rect(0, this.dataChart.wh.x, a.w0.y, this.dataChart.wh.width, a.w0.height);
                }
                let d = ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = "one";
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })());
                SyncManager.d(a, d);
                SyncManager.c(a);
            }
            a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.app));
            this.vh(a, b);
        }
        apd() {
            if (this.indicatorCharts != null || this.volumeChart != null) {
                this.aft(this.xAxis, (a) => a.visibility = 1);
            }
            for (let a = 0; a < this.ak0.count; a++) {
                let b = this.ak0._inner[a];
                let c = a < this.ak0.count - 1 || this.volumeChart != null;
                this.aft(b, (d) => d.visibility = c ? 1 : 0);
            }
        }
        aqi(a, b, c) {
            if (a != null) {
                this.ap4(a);
            }
            if (b != null) {
                this.ap2(b, c);
            }
        }
        aqu(a, b) {
            this.aqi(a, b, this.al9);
            this.apd();
            if (this.volumeChart != null) {
                if (this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.volumeChart.axes.add(this.volumeXAxis);
                }
                this.aqa();
                this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
            }
            this.aqv(a, b);
        }
        apt(a, b) {
            this.aqs();
        }
        aqs() {
            if (this.aik == null || +(this.aik.au) == +(dateMaxValue()) || +(this.aik.at) == +(dateMinValue()) || this.dataChart == null) {
                return;
            }
            let a = this.xAxis;
            let b = a.getWindowRectForSelection(this.aik.au, this.aik.at);
            if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
                return;
            }
            this.akm = true;
            this.dataChart.w0 = new Rect(0, b.left, this.dataChart.w0.top, b.width, this.dataChart.w0.height);
            if (this.aj2 != null) {
                this.aj2.windowRect = this.dataChart.wh;
            }
            if (this.akl) {
                this.aqd(this.dataChart);
            }
            this.akm = false;
        }
        ap0(a, b) {
            this.aqe();
            this.aqr(!this.akm);
        }
        apm(a, b) {
            if (!this.akm) {
                if (this.akl) {
                    this.aqd(a);
                }
                let c = false;
                let d = this.wm(() => this.aqr(true), c);
                c = d.p1;
                if (this.aj2 != null) {
                    this.aj2.windowRect = this.dataChart.wh;
                }
            }
        }
        aqm(a, b, c, d) {
            if (a == null || b == null) {
                return;
            }
            if (c != -1) {
                this.akm = true;
                a.w0 = new Rect(0, d, a.wh.top, c, a.wh.height);
                this.akm = false;
            }
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(0, g, g, this.yAxis.ch, a.wl);
            for (let i of fromEnum(a.series)) {
                h.b = i.iz();
                let j = i.az(a.wh);
                let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                let l = b.el(j.c, h);
                let m = b.el(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
            let n = a.wh.width;
            if (c != -1) {
                n = c;
            }
            let o = a.wh.left;
            if (d != -1) {
                o = d;
            }
            if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
                return;
            }
            this.akm = true;
            let p = new Rect(0, o, e, n, f - e);
            a.w0 = p;
            this.akm = false;
        }
        aql(a) {
            if (a == null) {
                return;
            }
            if (a == this.dataChart) {
                this.aqm(this.dataChart, this.yAxis, -1, -1);
                if (this.volumeChart != null) {
                    this.aqm(this.volumeChart, this.volumeAxis, this.dataChart.wh.width, this.dataChart.wh.left);
                }
            }
            else if (a == this.volumeChart) {
                this.aqm(this.volumeChart, this.volumeAxis, -1, -1);
                this.aqm(this.dataChart, this.yAxis, this.volumeChart.wh.width, this.volumeChart.wh.left);
            }
        }
        aqd(a) {
            this.wl(() => this.aql(a));
        }
        apu(a, b) {
            if (this.akl) {
                this.aqd(a);
            }
        }
        aqt() {
            if (!this.akt) {
                return;
            }
            this.apg();
            if (this.aiy == 0) {
                this.resetZoom();
                this.zoomSliderChart = null;
                this.ama.rootWrapper.removeChildren();
            }
            else if (this.zoomSliderChart == null) {
                this.zoomSliderChart = ((() => {
                    let $ret = new XamDataChart();
                    $ret.name = "ZoomSliderChart";
                    return $ret;
                })());
                this.aqg();
            }
            else {
                this.aqb();
            }
        }
        apg() {
            let container_ = this.ama.rootWrapper.getNativeElement();
            let containerParent_ = container_.parentElement;
            if (this.aj2 != null && containerParent_ != null && !this.aku) {
                this.aku = true;
                if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                    let z_ = this.aj2;
                    let f_ = this.externalObject;
                    let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                    let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                    sliderInstance_._implementation = z_;
                    sliderComponent_._staticStyling(container_, sliderInstance_, f_);
                }
            }
        }
        aqn() {
            if (this.ait != 1) {
                return;
            }
            this.afz((a) => {
                let b;
                b = a.breaks;
                b.clear();
                if (this.xAxisBreaks == null) {
                    return;
                }
                for (let c of fromEnum(this.xAxisBreaks)) {
                    b.add(c);
                }
            });
        }
        xf(a, b, c) {
            super.xf(a, b, c);
            if (this.bf.dataSeries.count > 0) {
                if (this.ait == 1 && stringIsNullOrEmpty(this.nz)) {
                    this.ce.setXMemberPath(a, c.getMemberPathFor(17));
                }
                if (stringIsNullOrEmpty(this.n1)) {
                    this.ce.setYMemberPath(a, this.anc(c));
                }
                if (stringIsNullOrEmpty(this.nm)) {
                    this.ce.setLabelMemberPath(a, this.anc(c));
                }
                if (stringIsNullOrEmpty(this.ni)) {
                    this.ce.setContentMemberPath(a, this.anc(c));
                }
            }
        }
        anb(a) {
            switch (a) {
                case 0: return "Absolute Volume Oscillator";
                case 1: return "Accumulation/Distribution Indicator";
                case 2: return "Average Directional Index";
                case 3: return "Average True Range Indicator";
                case 4: return "Bollinger Bandwidth";
                case 5: return "Chaikin Oscillator";
                case 6: return "Chaikin Volatility Indicator";
                case 7: return "Commodity Channel Index";
                case 8: return "Detrended Price Oscillator";
                case 9: return "Ease of Movement Indicator";
                case 10: return "Fast Stochastic Oscillator";
                case 11: return "Force Index Indicator";
                case 12: return "Full Stochastic Oscillator";
                case 13: return "Market Facilitation Index";
                case 14: return "Mass Index Indicator";
                case 15: return "Median Price Indicator";
                case 16: return "Money Flow Index";
                case 17: return "MACD Indicator";
                case 18: return "Negative Volume Index";
                case 19: return "On Balance Volume Indicator";
                case 20: return "Percentage Price Oscillator";
                case 21: return "Percentage Volume Oscillator";
                case 22: return "Positive Volume Index";
                case 23: return "Price Volume Trend";
                case 24: return "ROC - Rate of Change Indicator";
                case 25: return "RSI - Relative Strength Index";
                case 26: return "Slow Stochastic Oscillator";
                case 27: return "Standard Deviation Indicator";
                case 28: return "Stoch RSI";
                case 29: return "TRIX Indicator";
                case 30: return "Typical Price Indicator";
                case 31: return "Ultimate Oscillator";
                case 32: return "Weighted Close Indicator";
                case 33: return "Williams %R Indicator";
                default: return "Unknown";
            }
        }
        afv(a) {
            super.afv(a);
            let b = a;
            this.ap3(b);
            if (a.bg != null) {
                for (let c of fromEnum(a.bg.series)) {
                    if (this.ake(c)) {
                        this.ai8.setXAxis(c, b);
                    }
                    else if (this.aki(c)) {
                        this.ai6.setXAxis(c, b);
                    }
                    else if (this.akf(c)) {
                        this.aja.setXAxis(c, b);
                    }
                    else if (this.akh(c)) {
                        this.ajf.setXAxis(c, b);
                    }
                }
            }
            this.ap7((d) => {
                d.zoomMaximumCategoryRange = this.alu;
                d.zoomMaximumItemSpan = this.alv;
                d.zoomToCategoryRange = this.alw;
                d.zoomToCategoryStart = this.alx;
                d.zoomToItemSpan = this.aly;
            });
            let d = a == this.zoomSliderXAxis;
            if (d) {
                a.jz = this.aqz;
                a.et = this.al5;
                this.aft(a, (e) => e.visibility = 1);
            }
            let e = a;
            e.minimumValue = this.ak6;
            e.maximumValue = this.ak5;
            a.b1 = this.ako;
        }
        afx(a) {
            super.afx(a);
            if (a.bg != null && a == this.yAxis) {
                for (let b of fromEnum(a.bg.series)) {
                    if (this.ake(b)) {
                        this.ai8.setYAxis(b, this.yAxis);
                    }
                    else if (this.aki(b)) {
                        this.ai6.setYAxis(b, this.yAxis);
                    }
                    else if (this.akf(b)) {
                        this.aja.setYAxis(b, this.yAxis);
                    }
                    else if (this.akh(b)) {
                        this.ajf.setYAxis(b, this.yAxis);
                    }
                }
            }
            a.lf = this.akp;
            a.mc = this.al3;
            a.mb = this.al2;
            if (a == this.yAxis) {
                a.l8 = this.al1;
            }
            let c = a == this.zoomSliderAxis;
            if (c) {
                this.aft(a, (d) => d.visibility = 1);
            }
            a.b1 = this.akq;
        }
        ap3(a) {
            a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
            a.f2 = XYChart.adi(a, this.bf.dataSeries);
            if (this.bf.dataSeries.count > 0) {
                let b = this.bf.dataSeries._inner[0].getMemberPathFor(17);
                a.h1(b);
            }
        }
        vn(a, b) {
            if (a == null) {
                return;
            }
            let c = this.zoomSliderChart == a.da;
            let d = this.dataChart != null && this.dataChart.series.contains(a);
            if (d && !a.eu && !this.akh(a)) {
                a.l5 = "Financial Series";
            }
            super.vn(a, b);
            if ((d || c) && a.fn) {
                a.r7(this.ahv != null ? ArrayExtension.getModulus$1(Brush.$, this.ahv, b) : null, this.ahw != null ? ArrayExtension.getModulus$1(Brush.$, this.ahw, b) : null);
            }
            let e = this.akf(a);
            if (this.akh(a)) {
                a.vk = this.ahx != null ? ArrayExtension.getModulus$1(Brush.$, this.ahx, b) : null;
                a.v0 = this.ahy != null ? ArrayExtension.getModulus$1(Brush.$, this.ahy, b) : null;
                a.jq = this.alr;
            }
            else if (e) {
                a.vk = this.aht != null ? ArrayExtension.getModulus$1(Brush.$, this.aht, b) : null;
                a.jq = this.alp;
            }
            else if (!a.eu && (d || c)) {
                a.vk = this.z != null ? ArrayExtension.getModulus$1(Brush.$, this.z, b) : null;
                a.v0 = this.ad != null ? ArrayExtension.getModulus$1(Brush.$, this.ad, b) : null;
            }
            let f = this.volumeChart != null && this.volumeChart == a.da;
            if (f) {
                a.jq = this.alt;
            }
            a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.akg ? this.ai4 : null;
        }
        vo(a, b) {
            super.vo(a, b);
            if (a == null) {
                return;
            }
        }
        wd(a, b, c) {
            super.wd(a, b, c);
            switch (a) {
                case "YAxisIsLogarithmic":
                    this.yAxis.lo = this.akr;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.lo = this.akr;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.lo = this.akr;
                    }
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.mm = this.amp;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.mm = this.amp;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.mm = this.amp;
                    }
                    break;
                case "VolumeType":
                    let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                    if (this.air == 0) {
                        this.volumeChart = null;
                    }
                    else if (this.volumeChart == null) {
                        this.volumeChart = ((() => {
                            let $ret = new XamDataChart();
                            $ret.name = "VolumeChart";
                            return $ret;
                        })());
                    }
                    else {
                        this.aqa();
                    }
                    break;
                case "VolumeChart":
                    this.aqu(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "DataChart":
                    if (typeCast(XamDataChart.$, b) !== null) {
                        let e = b;
                        e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.app));
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.apm));
                        e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.apu));
                    }
                    if (this.dataChart != null) {
                        let f = this.dataChart;
                        f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.app));
                        let g = this.dataChart;
                        g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.apm));
                        let h = this.dataChart;
                        h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.apu));
                    }
                    this.aqt();
                    break;
                case "XAxisMode":
                    this.xAxis = this.ah6(this.ait);
                    this.xAxis.name = "xAxis";
                    this.volumeXAxis = this.ah6(this.ait);
                    this.volumeXAxis.name = "volumeXAxis";
                    this.indicatorXAxis = this.ah6(this.ait);
                    this.indicatorXAxis.name = "indicatorXAxis_0";
                    this.zoomSliderXAxis = this.ah6(this.ait);
                    this.zoomSliderXAxis.name = "zoomSliderXAxis";
                    this.aft(this.zoomSliderXAxis, (i) => i.visibility = 1);
                    this.apd();
                    if (this.ait == 1) {
                        this.aqn();
                    }
                    break;
                case "YAxisMode":
                    this.yAxis = this.ajk(this.aiv);
                    this.yAxis.name = "yAxis";
                    this.zoomSliderAxis = this.ajk(this.aiv);
                    this.zoomSliderAxis.name = "zoomSliderAxis";
                    this.volumeAxis = this.ajk(this.aiv);
                    this.volumeAxis.name = "volumeAxis";
                    break;
                case "Toolbar":
                    let i = typeCast(FinancialChartToolbar.$, b);
                    if (i != null) {
                        i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.apt));
                        i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.apw));
                        i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.apx));
                    }
                    if (this.aik != null) {
                        this.aik.ae = this.ai0;
                        this.aik.ag = this.ai2;
                        this.aik.u = this.aih;
                        this.aqr(true);
                        let j = this.aik;
                        j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.apt));
                        let k = this.aik;
                        k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.apw));
                        let l = this.aik;
                        l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.apx));
                    }
                    break;
                case "XAxis":
                    let m = typeCast(CategoryAxisBase.$, b);
                    if (m != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(m);
                        }
                    }
                    let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                    if (n != null) {
                        n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.ap0));
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.xAxis);
                    }
                    if (this.gk) {
                        this.afv(this.xAxis);
                        this.u4();
                    }
                    this.aqr(false);
                    this.aqs();
                    this.aqe();
                    let o = this.xAxis;
                    o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.ap0));
                    break;
                case "XAxisZoomMaximumCategoryRange":
                    this.ap7((p) => p.zoomMaximumCategoryRange = this.alu);
                    break;
                case "XAxisZoomMaximumItemSpan":
                    this.ap7((p) => p.zoomMaximumItemSpan = this.alv);
                    break;
                case "XAxisZoomToCategoryRange":
                    this.ap7((p) => p.zoomToCategoryRange = this.alw);
                    break;
                case "XAxisZoomToCategoryStart":
                    this.ap7((p) => p.zoomToCategoryStart = this.alx);
                    break;
                case "XAxisZoomToItemSpan":
                    this.ap7((p) => p.zoomToItemSpan = this.aly);
                    break;
                case "ChartType":
                    this.u8();
                    break;
                case "VolumeXAxis":
                    this.aqk(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                    break;
                case "ZoomSliderXAxis":
                    this.aqk(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                    break;
                case "IndicatorXAxis":
                    this.aqo();
                    break;
                case "YAxis":
                    let p = typeCast(NumericYAxis.$, b);
                    if (p != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(p);
                        }
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.yAxis);
                    }
                    if (this.gk) {
                        this.afx(this.yAxis);
                        this.afx(this.yAxis);
                    }
                    let q = this.yAxis;
                    q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.ap1));
                    break;
                case "VolumeAxis":
                    let r = typeCast(Axis.$, b);
                    if (this.volumeChart != null && r != null) {
                        this.volumeChart.axes.remove(r);
                    }
                    if (this.volumeChart != null && this.volumeAxis != null) {
                        this.volumeChart.axes.add(this.volumeAxis);
                        this.aqa();
                    }
                    if (this.gk) {
                        this.afx(this.volumeAxis);
                    }
                    let s = this.volumeAxis;
                    s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.ap1));
                    break;
                case "IndicatorAxis":
                    if (this.indicatorCharts != null) {
                        for (let t = 0; t < this.indicatorCharts.count; t++) {
                            let u = this.indicatorCharts._inner[t];
                            let v = new List$1(Axis.$, 0);
                            for (let w of fromEnum(u.axes)) {
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                            for (let x of fromEnum(v)) {
                                u.axes.remove(x);
                            }
                            let y = null;
                            if (t == 0) {
                                y = this.indicatorAxis;
                            }
                            else if (this.aiv == 1) {
                                y = this.ajk(this.aiv);
                            }
                            else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                                y = new NumericYAxis();
                            }
                            if (y != null) {
                                u.axes.add(y);
                            }
                            if (this.gk) {
                                this.afx(y);
                            }
                        }
                    }
                    break;
                case "IsWindowSyncedToVisibleRange":
                    if (this.dataChart != null) {
                        this.dataChart.xy = this.he && this.hd;
                    }
                    if (this.volumeChart != null) {
                        this.volumeChart.xy = this.he && this.hd;
                    }
                    if (this.akl) {
                        this.aql(this.dataChart);
                    }
                    else {
                        this.volumeChart.y5 = 1;
                    }
                    break;
                case "IndicatorTypes":
                    let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                    if (z != null) {
                        z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.apq));
                    }
                    let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                    if (aa != null) {
                        aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.apq));
                    }
                    this.aqo();
                    break;
                case "OverlayTypes":
                    let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                    if (ab != null) {
                        ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.apr));
                    }
                    let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                    if (ac != null) {
                        ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.apr));
                    }
                    this.aqq();
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.af4((ad) => ad.lf = this.akp);
                    break;
                case "YAxisMinimumValue":
                    this.af5((ad) => ad.mc = this.al3, false);
                    break;
                case "YAxisMaximumValue":
                    this.af5((ad) => ad.mb = this.al2, false);
                    break;
                case "YAxisInterval":
                    this.af5((ad) => ad.l8 = this.al1, false);
                    break;
                case "Thickness":
                case "ZoomSliderType":
                    this.aqt();
                    break;
                case "ZoomSliderChart":
                    if (!this.aks) {
                        return;
                    }
                    this.aqw(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.apj((ad, ae) => {
                        if (ad.fn) {
                            ad.r7(this.ahv != null ? ArrayExtension.getModulus$1(Brush.$, this.ahv, ae) : null, this.ahw != null ? ArrayExtension.getModulus$1(Brush.$, this.ahw, ae) : null);
                        }
                    }, true);
                    break;
                case "OverlayBrushes":
                    this.api((ad, ae) => ad.vk = this.ahx != null ? ArrayExtension.getModulus$1(Brush.$, this.ahx, ae) : null);
                    break;
                case "OverlayOutlines":
                    this.api((ad, ae) => ad.v0 = this.ahy != null ? ArrayExtension.getModulus$1(Brush.$, this.ahy, ae) : null);
                    break;
                case "OverlayThickness":
                    this.api((ad, ae) => ad.jq = this.alr);
                    break;
                case "OverlayMultiplier":
                    this.api((ad, ae) => this.ajf.setMultiplier(ad, this.alq));
                    break;
                case "VolumeBrushes":
                    this.apk((ad, ae) => ad.vk = ArrayExtension.getModulus$1(Brush.$, this.ahz, ae));
                    break;
                case "VolumeOutlines":
                    this.apk((ad, ae) => ad.v0 = ArrayExtension.getModulus$1(Brush.$, this.ah0, ae));
                    break;
                case "VolumeThickness":
                    this.apk((ad, ae) => ad.jq = this.alt);
                    break;
                case "IndicatorNegativeBrushes":
                    this.aph((ad, ae) => this.aja.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.ahu, ae)));
                    break;
                case "IndicatorBrushes":
                    this.aph((ad, ae) => ad.vk = ArrayExtension.getModulus$1(Brush.$, this.aht, ae));
                    break;
                case "IndicatorThickness":
                    this.aph((ad, ae) => ad.jq = this.alp);
                    break;
                case "IndicatorDisplayTypes":
                    this.aph((ad, ae) => this.aja.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ajc, ae)));
                    break;
                case "IndicatorPeriod":
                    this.aph((ad, ae) => {
                        if (this.amk == -2147483648) {
                            return;
                        }
                        this.aja.setPeriodOverride(ad, this.amk);
                    });
                    break;
                case "IndicatorMultiplier":
                    this.aph((ad, ae) => this.aja.setMultiplier(ad, this.alo));
                    break;
                case "IndicatorSmoothingPeriod":
                    this.aph((ad, ae) => this.aja.setSmoothingPeriod(ad, this.amn));
                    break;
                case "IndicatorShortPeriod":
                    this.aph((ad, ae) => this.aja.setShortPeriod(ad, this.aml));
                    break;
                case "IndicatorLongPeriod":
                    this.aph((ad, ae) => this.aja.setLongPeriod(ad, this.amj));
                    break;
                case "IndicatorSignalPeriod":
                    this.aph((ad, ae) => this.aja.setSignalPeriod(ad, this.amm));
                    break;
                case "RangeSelectorOptions":
                    let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                    if (ad != null) {
                        ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.aps));
                    }
                    if (this.aii != null) {
                        let ae = this.aii;
                        ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.aps));
                    }
                    this.aqe();
                    break;
                case "CustomIndicatorNames":
                    let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                    if (af != null) {
                        af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.apo));
                    }
                    if (this.customIndicatorNames != null) {
                        let ag = this.customIndicatorNames;
                        ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.apo));
                    }
                    this.aqo();
                    break;
                case "Legend":
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.legend = null;
                    }
                    break;
                case "Brushes":
                    this.apj((ah, ai) => ah.vk = this.z != null ? ArrayExtension.getModulus$1(Brush.$, this.z, ai) : null, true);
                    break;
                case "Outlines":
                    this.apj((ah, ai) => ah.v0 = this.ad != null ? ArrayExtension.getModulus$1(Brush.$, this.ad, ai) : null, true);
                    break;
                case "XAxisLabelVisibility":
                    if (this.ahj == 0 && this.zoomSliderXAxis != null) {
                        this.aft(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                    }
                    this.apd();
                    break;
                case "YAxisLabelVisibility":
                    if (this.ahk != 0 || this.zoomSliderAxis == null) {
                        break;
                    }
                    this.aft(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                    break;
                case "ZoomSliderXAxisMajorStroke":
                    this.zoomSliderXAxis.jz = this.aqz;
                    break;
                case "ZoomSliderXAxisMajorStrokeThickness":
                    this.zoomSliderXAxis.et = this.al5;
                    break;
                case "FinancialChartLegend":
                case "IsLegendVisible":
                    let ah = this.akg && this.legend == null;
                    {
                        let ai = (aj, ak) => {
                            if (aj.isUsableInLegend) {
                                aj.legend = ah ? this.ai4 : null;
                            }
                        };
                        this.apj(ai, false);
                        this.api(ai);
                    }
                    break;
                case "ZoomSliderAxis":
                    let aj = typeCast(Axis.$, b);
                    if (aj != null && this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.remove(aj);
                    }
                    if (this.zoomSliderAxis != null) {
                        if (this.zoomSliderChart != null) {
                            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                            this.aqb();
                            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                        }
                        if (this.gk) {
                            this.afx(this.zoomSliderAxis);
                        }
                        this.aft(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                    }
                    break;
                case "XAxisMinimumValue":
                    this.afz((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.minimumValue = this.ak6;
                        }
                    });
                    break;
                case "XAxisMaximumValue":
                    this.afz((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.maximumValue = this.ak5;
                        }
                    });
                    break;
                case FinancialChart.aok:
                    this.af0((ak) => ak.b1 = this.ako, a);
                    break;
                case FinancialChart.aov:
                    this.af4((ak) => ak.b1 = this.akq);
                    break;
            }
        }
        get_cb() {
            return 1;
        }
        get cb() {
            return this.get_cb();
        }
        get akr() {
            return this.aj9;
        }
        set akr(a) {
            let b = this.akr;
            if (a != b) {
                this.aj9 = a;
                this.wd("YAxisIsLogarithmic", b, this.akr);
            }
        }
        get amp() {
            return this.amh;
        }
        set amp(a) {
            let b = this.amp;
            if (a != b) {
                this.amh = a;
                this.wd("YAxisLogarithmBase", b, this.amp);
            }
        }
        get al1() {
            return this.ali;
        }
        set al1(a) {
            let b = this.al1;
            if (a != b) {
                this.ali = a;
                this.wd("YAxisInterval", b, this.al1);
            }
        }
        get al3() {
            return this.alk;
        }
        set al3(a) {
            let b = this.al3;
            if (a != b) {
                this.alk = a;
                this.wd("YAxisMinimumValue", b, this.al3);
            }
        }
        get al2() {
            return this.alj;
        }
        set al2(a) {
            let b = this.al2;
            if (a != b) {
                this.alj = a;
                this.wd("YAxisMaximumValue", b, this.al2);
            }
        }
        get al4() {
            return this.all;
        }
        set al4(a) {
            let b = this.al4;
            if (a != b) {
                this.all = a;
                this.wd("YAxisMinorInterval", b, this.al4);
            }
        }
        get al0() {
            return this.yAxis.l4;
        }
        get alz() {
            return this.yAxis.l3;
        }
        get air() {
            return this.aip;
        }
        set air(a) {
            let b = this.air;
            if (a != b) {
                this.aip = a;
                this.wd("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.air));
            }
        }
        get ait() {
            return this.ais;
        }
        set ait(a) {
            let b = this.ait;
            if (a != b) {
                this.ais = a;
                this.wd("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ait));
            }
        }
        get alu() {
            return this.ald;
        }
        set alu(a) {
            let b = this.alu;
            if (a != b) {
                this.ald = a;
                this.wd("XAxisZoomMaximumCategoryRange", b, this.alu);
            }
        }
        get alx() {
            return this.alg;
        }
        set alx(a) {
            let b = this.alx;
            if (a != b) {
                this.alg = a;
                this.wd("XAxisZoomToCategoryStart", b, this.alx);
            }
        }
        get alv() {
            return this.ale;
        }
        set alv(a) {
            let b = this.alv;
            if (a != b) {
                this.ale = a;
                this.wd("XAxisZoomMaximumItemSpan", b, this.alv);
            }
        }
        get alw() {
            return this.alf;
        }
        set alw(a) {
            let b = this.alw;
            if (a != b) {
                this.alf = a;
                this.wd("XAxisZoomToCategoryRange", b, this.alw);
            }
        }
        get aly() {
            return this.alh;
        }
        set aly(a) {
            let b = this.aly;
            if (a != b) {
                this.alh = a;
                this.wd("XAxisZoomToItemSpan", b, this.aly);
            }
        }
        get aiv() {
            return this.aiu;
        }
        set aiv(a) {
            let b = this.aiv;
            if (a != b) {
                this.aiu = a;
                this.wd("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.aiv));
            }
        }
        get akk() {
            return this.aj4;
        }
        set akk(a) {
            let b = this.akk;
            if (a != b) {
                this.aj4 = a;
                this.wd("IsToolbarVisible", b, this.akk);
            }
        }
        get aim() {
            return this.ail;
        }
        set aim(a) {
            let b = this.aim;
            if (a != b) {
                this.ail = a;
                this.wd("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.aim));
            }
        }
        get_age() {
            return super.get_age();
        }
        set_age(a) {
            super.set_age(a);
        }
        get akl() {
            return this.aj5;
        }
        set akl(a) {
            let b = this.akl;
            if (a != b) {
                this.aj5 = a;
                this.wd("IsWindowSyncedToVisibleRange", b, this.akl);
            }
        }
        get ai0() {
            return this.aiz;
        }
        set ai0(a) {
            let b = this.ai0;
            if (a != b) {
                this.aiz = a;
                this.wd("IndicatorTypes", b, this.ai0);
            }
        }
        get ai2() {
            return this.ai1;
        }
        set ai2(a) {
            let b = this.ai2;
            if (a != b) {
                this.ai1 = a;
                this.wd("OverlayTypes", b, this.ai2);
            }
        }
        get indicatorCharts() {
            return this.akw;
        }
        set indicatorCharts(a) {
            let b = this.indicatorCharts;
            if (a != b) {
                this.akw = a;
                this.wd("IndicatorCharts", b, this.indicatorCharts);
            }
        }
        get akp() {
            return this.aj7;
        }
        set akp(a) {
            let b = this.akp;
            if (a != b) {
                this.aj7 = a;
                this.wd("YAxisAbbreviateLargeNumbers", b, this.akp);
            }
        }
        get_ka() {
            return super.get_ka();
        }
        set_ka(a) {
            super.set_ka(a);
        }
        get ako() {
            return this.aj6;
        }
        set ako(a) {
            let b = this.ako;
            if (a != b) {
                this.aj6 = a;
                this.wd(FinancialChart.aok, b, this.ako);
            }
        }
        get akq() {
            return this.aj8;
        }
        set akq(a) {
            let b = this.akq;
            if (a != b) {
                this.aj8 = a;
                this.wd(FinancialChart.aov, b, this.akq);
            }
        }
        get zoomSliderChart() {
            return this.ajy;
        }
        set zoomSliderChart(a) {
            let b = this.zoomSliderChart;
            if (a != b) {
                this.ajy = a;
                this.wd("ZoomSliderChart", b, this.zoomSliderChart);
            }
        }
        get zoomSliderAxis() {
            return this.ajj;
        }
        set zoomSliderAxis(a) {
            let b = this.zoomSliderAxis;
            if (a != b) {
                this.ajj = a;
                this.wd("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        }
        get zoomSliderXAxis() {
            return this.ah4;
        }
        set zoomSliderXAxis(a) {
            let b = this.zoomSliderXAxis;
            if (a != b) {
                this.ah4 = a;
                this.wd("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        }
        get aiy() {
            return this.aiw;
        }
        set aiy(a) {
            let b = this.aiy;
            if (a != b) {
                this.aiw = a;
                this.wd("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.aiy));
            }
        }
        get ahv() {
            return this.ahn;
        }
        set ahv(a) {
            let b = this.ahv;
            if (a != b) {
                this.ahn = a;
                this.wd("NegativeBrushes", b, this.ahv);
            }
        }
        get ahw() {
            return this.aho;
        }
        set ahw(a) {
            let b = this.ahw;
            if (a != b) {
                this.aho = a;
                this.wd("NegativeOutlines", b, this.ahw);
            }
        }
        get ahx() {
            return this.ahp;
        }
        set ahx(a) {
            let b = this.ahx;
            if (a != b) {
                this.ahp = a;
                this.wd("OverlayBrushes", b, this.ahx);
            }
        }
        get ahy() {
            return this.ahq;
        }
        set ahy(a) {
            let b = this.ahy;
            if (a != b) {
                this.ahq = a;
                this.wd("OverlayOutlines", b, this.ahy);
            }
        }
        get ah0() {
            return this.ahs;
        }
        set ah0(a) {
            let b = this.ah0;
            if (a != b) {
                this.ahs = a;
                this.wd("VolumeOutlines", b, this.ah0);
            }
        }
        get ahz() {
            return this.ahr;
        }
        set ahz(a) {
            let b = this.ahz;
            if (a != b) {
                this.ahr = a;
                this.wd("VolumeBrushes", b, this.ahz);
            }
        }
        get ahu() {
            return this.ahm;
        }
        set ahu(a) {
            let b = this.ahu;
            if (a != b) {
                this.ahm = a;
                this.wd("IndicatorNegativeBrushes", b, this.ahu);
            }
        }
        get aht() {
            return this.ahl;
        }
        set aht(a) {
            let b = this.aht;
            if (a != b) {
                this.ahl = a;
                this.wd("IndicatorBrushes", b, this.aht);
            }
        }
        get alt() {
            return this.alc;
        }
        set alt(a) {
            let b = this.alt;
            if (a != b) {
                this.alc = a;
                this.wd("VolumeThickness", b, this.alt);
            }
        }
        get alr() {
            return this.ala;
        }
        set alr(a) {
            let b = this.alr;
            if (a != b) {
                this.ala = a;
                this.wd("OverlayThickness", b, this.alr);
            }
        }
        get alq() {
            return this.ak9;
        }
        set alq(a) {
            let b = this.alq;
            if (a != b) {
                this.ak9 = a;
                this.wd("OverlayMultiplier", b, this.alq);
            }
        }
        get alp() {
            return this.ak8;
        }
        set alp(a) {
            let b = this.alp;
            if (a != b) {
                this.ak8 = a;
                this.wd("IndicatorThickness", b, this.alp);
            }
        }
        get ajc() {
            return this.ajb;
        }
        set ajc(a) {
            let b = this.ajc;
            if (a != b) {
                this.ajb = a;
                this.wd("IndicatorDisplayTypes", b, this.ajc);
            }
        }
        get amk() {
            return this.amd;
        }
        set amk(a) {
            let b = this.amk;
            if (a != b) {
                this.amd = a;
                this.wd("IndicatorPeriod", b, this.amk);
            }
        }
        get alo() {
            return this.ak7;
        }
        set alo(a) {
            let b = this.alo;
            if (a != b) {
                this.ak7 = a;
                this.wd("IndicatorMultiplier", b, this.alo);
            }
        }
        get amn() {
            return this.amg;
        }
        set amn(a) {
            let b = this.amn;
            if (a != b) {
                this.amg = a;
                this.wd("IndicatorSmoothingPeriod", b, this.amn);
            }
        }
        get aml() {
            return this.ame;
        }
        set aml(a) {
            let b = this.aml;
            if (a != b) {
                this.ame = a;
                this.wd("IndicatorShortPeriod", b, this.aml);
            }
        }
        get amj() {
            return this.amc;
        }
        set amj(a) {
            let b = this.amj;
            if (a != b) {
                this.amc = a;
                this.wd("IndicatorLongPeriod", b, this.amj);
            }
        }
        get amm() {
            return this.amf;
        }
        set amm(a) {
            let b = this.amm;
            if (a != b) {
                this.amf = a;
                this.wd("IndicatorSignalPeriod", b, this.amm);
            }
        }
        get aii() {
            return this.aig;
        }
        set aii(a) {
            let b = this.aii;
            if (a != b) {
                this.aig = a;
                this.wd("RangeSelectorOptions", b, this.aii);
            }
        }
        get customIndicatorNames() {
            return this.aic;
        }
        set customIndicatorNames(a) {
            let b = this.aic;
            if (a != b) {
                this.aic = a;
                this.wd("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        }
        get_he() {
            return super.get_he();
        }
        set_he(a) {
            super.set_he(a);
        }
        get aqz() {
            return this.aqy;
        }
        set aqz(a) {
            let b = this.aqz;
            if (a != b) {
                this.aqy = a;
                this.wd("ZoomSliderXAxisMajorStroke", b, this.aqz);
            }
        }
        get al5() {
            return this.alm;
        }
        set al5(a) {
            let b = this.al5;
            if (a != b) {
                this.alm = a;
                this.wd("ZoomSliderXAxisMajorStrokeThickness", b, this.al5);
            }
        }
        get akg() {
            return this.aj3;
        }
        set akg(a) {
            let b = this.akg;
            if (a != b) {
                this.aj3 = a;
                this.wd("IsLegendVisible", b, this.akg);
            }
        }
        get ai4() {
            return this.ai3;
        }
        set ai4(a) {
            let b = this.ai4;
            if (a != b) {
                this.ai3 = a;
                this.wd("FinancialChartLegend", b, this.ai4);
            }
        }
        get xAxis() {
            return this.ah3;
        }
        set xAxis(a) {
            let b = this.xAxis;
            if (a != b) {
                this.ah3 = a;
                this.wd("XAxis", b, this.xAxis);
            }
        }
        get yAxis() {
            return this.aji;
        }
        set yAxis(a) {
            let b = this.yAxis;
            if (a != b) {
                this.aji = a;
                this.wd("YAxis", b, this.yAxis);
            }
        }
        get volumeAxis() {
            return this.ajh;
        }
        set volumeAxis(a) {
            let b = this.volumeAxis;
            if (a != b) {
                this.ajh = a;
                this.wd("VolumeAxis", b, this.volumeAxis);
            }
        }
        get volumeXAxis() {
            return this.ah2;
        }
        set volumeXAxis(a) {
            let b = this.volumeXAxis;
            if (a != b) {
                this.ah2 = a;
                this.wd("VolumeXAxis", b, this.volumeXAxis);
            }
        }
        get indicatorAxis() {
            return this.ajg;
        }
        set indicatorAxis(a) {
            let b = this.indicatorAxis;
            if (a != b) {
                this.ajg = a;
                this.wd("IndicatorAxis", b, this.indicatorAxis);
            }
        }
        get indicatorXAxis() {
            return this.ah1;
        }
        set indicatorXAxis(a) {
            let b = this.indicatorXAxis;
            if (a != b) {
                this.ah1 = a;
                this.wd("IndicatorXAxis", b, this.indicatorXAxis);
            }
        }
        get aky() {
            return this.akv;
        }
        set aky(a) {
            let b = this.aky;
            if (a != b) {
                this.akv = a;
                this.wd("IndicatorAxes", b, this.aky);
            }
        }
        get ak0() {
            return this.akx;
        }
        set ak0(a) {
            let b = this.ak0;
            if (a != b) {
                this.akx = a;
                this.wd("IndicatorXAxes", b, this.ak0);
            }
        }
        get ak6() {
            return this.ak4;
        }
        set ak6(a) {
            let b = this.ak6;
            if (+a != +b) {
                this.ak4 = a;
                this.wd("XAxisMinimumValue", b, this.ak6);
            }
        }
        get ak5() {
            return this.ak3;
        }
        set ak5(a) {
            let b = this.ak5;
            if (+a != +b) {
                this.ak3 = a;
                this.wd("XAxisMaximumValue", b, this.ak5);
            }
        }
        get xAxisBreaks() {
            return this.ak1;
        }
    }
    FinancialChart.$t = /*@__PURE__*/ markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.amo = 0;
    FinancialChart.aok = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.aov = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
})();
/**
 * @hidden
 */
export let FinancialChartToolbar = /*@__PURE__*/ (() => {
    class FinancialChartToolbar extends TemplatedHtmlControl {
        bg(a) {
            let b = a.querySelectorAll(".financialChartToolbarArea");
            if (b != null && b.length > 0) {
                this.g = b[0];
                if (!this.al) {
                    this.g.hide();
                }
            }
            let c = a.querySelectorAll(".financialChartIndicatorMenu");
            if (c != null && c.length > 0) {
                this.q.g = c[0];
            }
            let d = a.querySelectorAll(".financialChartRangeSelector");
            if (d != null && d.length > 0) {
                this.s.g = d[0];
            }
            let e = a.querySelectorAll(".financialChartTypePicker");
            if (e != null && e.length > 0) {
                this.aa.g = e[0];
            }
        }
        bl(a) {
            this.q.u(a);
            this.aa.u(a);
        }
        constructor(a, b) {
            super("financialChartToolbar", b, "");
            this.o = null;
            this.r = null;
            this.z = null;
            this.p = null;
            this.w = null;
            this.aq = dateMaxValue();
            this.ap = dateMinValue();
            this.ao = dateMaxValue();
            this.an = dateMinValue();
            this.rangeChanged = null;
            this.chartTypeChanged = null;
            this.trendLineTypeChanged = null;
            this.volumeTypeChanged = null;
            this.indicatorTypesChanged = null;
            this.overlayTypesChanged = null;
            this.x = 0;
            this.ah = 0;
            this.ab = 0;
            this.ad = null;
            this.af = null;
            this.t = null;
            this.ak = false;
            this.o = a;
            this.w = new FinancialChartToolbarViewModel();
            this.s = new FinancialChartRangeSelector(a != null ? a.am0 : null);
            this.aa = new FinancialChartTypePicker(a != null ? a.amx : null);
            this.q = new FinancialChartIndicatorMenu(1, a != null ? a.amy : null);
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        }
        bm(a, b, c) {
            switch (a) {
                case "RangeStart":
                    if (this.s != null) {
                        this.s.t = this.as;
                    }
                    break;
                case "RangeEnd":
                    if (this.s != null) {
                        this.s.s = this.ar;
                    }
                    break;
                case "SelectionStart":
                    if (this.s != null) {
                        this.s.v = this.au;
                    }
                    break;
                case "SelectionEnd":
                    if (this.s != null) {
                        this.s.u = this.at;
                    }
                    break;
                case "RangeSelector":
                    let d = b;
                    if (d != null) {
                        d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                    }
                    if (this.s != null) {
                        this.s.t = this.as;
                        this.s.s = this.ar;
                        this.s.o = this.u;
                        this.s.v = this.au;
                        this.s.u = this.at;
                        let e = this.s;
                        e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                    }
                    break;
                case "ChartTypePicker":
                    let f = b;
                    if (f != null) {
                        f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                    }
                    if (this.aa != null) {
                        this.aa.w = this.y;
                        let g = this.aa;
                        g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                    }
                    break;
                case "ChartType":
                    if (this.aa != null) {
                        this.aa.w = this.y;
                    }
                    break;
                case "RangeSelectorOptions":
                    if (this.s != null) {
                        this.s.o = this.u;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.g == null) {
                        break;
                    }
                    if (this.al) {
                        this.g.show();
                    }
                    else {
                        this.g.hide();
                    }
                    break;
                case "IndicatorMenu":
                    let h = typeCast(FinancialChartIndicatorMenu.$, b);
                    if (h != null) {
                        h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                    }
                    if (this.q != null) {
                        let i = this.q;
                        i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                    }
                    break;
                case "IndicatorTypes":
                    if (this.indicatorTypesChanged != null) {
                        this.indicatorTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "OverlayTypes":
                    if (this.overlayTypesChanged != null) {
                        this.overlayTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "TrendLineType":
                    if (this.trendLineTypeChanged != null) {
                        this.trendLineTypeChanged(this, EventArgs.empty);
                    }
                    break;
                case "VolumeType":
                    if (this.volumeTypeChanged != null) {
                        this.volumeTypeChanged(this, EventArgs.empty);
                    }
                    break;
            }
        }
        bh(a, b) {
            this.ag = this.q.z;
            this.ae = this.q.y;
            this.ai = this.q.aa;
            this.ac = this.q.x;
        }
        bi(a, b) {
            this.y = this.aa.w;
            if (this.chartTypeChanged != null) {
                this.chartTypeChanged(this, b);
            }
        }
        bj(a, b) {
            this.au = this.s.v;
            this.at = this.s.u;
            if (this.rangeChanged != null) {
                this.rangeChanged(this, b);
            }
        }
        v() {
            let a = new FinancialChartToolbarContext();
            a.container = this.d;
            a.vm = this.w;
            a.vm.financialChartIndicatorMenu = ((() => {
                let $ret = new FinancialChartIndicatorMenuContext();
                $ret.vm = this.q.p;
                return $ret;
            })());
            a.vm.financialChartTypePicker = ((() => {
                let $ret = new FinancialChartTypePickerContext();
                $ret.vm = this.aa.p;
                return $ret;
            })());
            a.vm.financialChartRangeSelector = ((() => {
                let $ret = new FinancialChartRangeSelectorContext();
                $ret.vm = this.s.q;
                return $ret;
            })());
            return a;
        }
        l(a) {
            super.l(a);
            if (a == null) {
                return;
            }
            this.s.l(a);
            this.aa.l(a);
            this.q.l(a);
            this.bk();
        }
        bk() {
        }
        get au() {
            return this.aq;
        }
        set au(a) {
            let b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        }
        get at() {
            return this.ap;
        }
        set at(a) {
            let b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        }
        get as() {
            return this.ao;
        }
        set as(a) {
            let b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        }
        get ar() {
            return this.an;
        }
        set ar(a) {
            let b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        }
        bn() {
            if (this.s != null) {
                this.s.ab();
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        }
        get ai() {
            return this.ah;
        }
        set ai(a) {
            let b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            let b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        }
        get ae() {
            return this.ad;
        }
        set ae(a) {
            let b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        }
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        }
        static am(a, b) {
            if (a == b) {
                return true;
            }
            if ((a == null && b != null) || (a != null && b == null)) {
                return false;
            }
            if (a.count != b.count) {
                return false;
            }
            for (let c of fromEn(a)) {
                if (!b.contains(c)) {
                    return false;
                }
            }
            return true;
        }
        aj() {
            return ((() => {
                let $ret = new FinancialChartToolbarVisualData();
                $ret.rangeSelector = this.s == null ? null : this.s.r();
                return $ret;
            })());
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        }
    }
    FinancialChartToolbar.$t = /*@__PURE__*/ markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
})();
/**
 * @hidden
 */
export let FinancialChartRangeSelector = /*@__PURE__*/ (() => {
    class FinancialChartRangeSelector extends TemplatedHtmlControl {
        get v() {
            return this.q.selectionStart;
        }
        set v(a) {
            this.q.selectionStart = a;
        }
        get u() {
            return this.q.selectionEnd;
        }
        set u(a) {
            this.q.selectionEnd = a;
        }
        get t() {
            return this.q.rangeStart;
        }
        set t(a) {
            this.q.rangeStart = a;
        }
        get s() {
            return this.q.rangeEnd;
        }
        set s(a) {
            this.q.rangeEnd = a;
        }
        ab() {
            if (this.q.onPropertiesChanged()) {
                this.p.g(this.q);
            }
        }
        constructor(a) {
            super("financialChartRangeSelector", a, "");
            this.q = null;
            this.rangeChanged = null;
            this.p = null;
            this.p = new FinancialChartRangeSelectorView();
            this.q = new FinancialChartRangeSelectorViewModel();
            this.q.onRangeChanged = runOn(this, this.z);
            this.p.c = this.q;
        }
        l(a) {
            super.l(a);
            this.p.f(this.d, this.q);
        }
        z() {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, EventArgs.empty);
            }
        }
        r() {
            return this.p.d(this.g);
        }
        get o() {
            return this.q.options;
        }
        set o(a) {
            let b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        }
        aa() {
            let a = false;
            if (this.q != null) {
                a = this.q.p();
            }
            if (this.p != null) {
                this.p.i(this.o);
                if (a) {
                    if (this.q.notifyChanged != null) {
                        this.q.notifyChanged();
                    }
                }
            }
        }
    }
    FinancialChartRangeSelector.$t = /*@__PURE__*/ markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
})();
