/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { TrendLineType_$type } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PriceDisplayType_$type } from "./PriceDisplayType";
import { CategoryCollisionMode_$type } from "./CategoryCollisionMode";
import { Series } from "./Series";
import { Defaults } from "./Defaults";
import { enumGetBox, EnumUtil, Number_$type, typeCast, fromEnum, Point_$type, runOn, markType, markDep } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { RectUtil } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { AxisRange } from "./AxisRange";
import { ScalerParams } from "./ScalerParams";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { RectangleGeometry } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
import { FinancialPriceBucketCalculator } from "./FinancialPriceBucketCalculator";
import { Extensions } from "igniteui-react-core";
/**
 * @hidden
 */
export let FinancialPriceSeries = /*@__PURE__*/ (() => {
    class FinancialPriceSeries extends FinancialSeries {
        bk() {
            return new FinancialPriceSeries();
        }
        get_fb() {
            return true;
        }
        jl() {
            if (!isNaN_(this.jk)) {
                return super.jl();
            }
            return Defaults.financialSeries_Resolution;
        }
        ct() {
            return new FinancialPriceSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.aa7 = a;
        }
        constructor() {
            super();
            this.aa9 = true;
            this.aba = 0;
            this.abb = 0;
            this.ab = FinancialPriceSeries.$;
            this.xf = new CategoryFrame(5);
            this.xh = new CategoryFrame(5);
            this.xd = new CategoryFrame(5);
        }
        get acq() {
            return this.c(FinancialPriceSeries.ab7);
        }
        set acq(a) {
            this.h(FinancialPriceSeries.ab7, a);
        }
        pd(a, b, c, d) {
            super.pd(a, b, c, d);
            if (this.xb != null && typeCast(ISortingAxis_$type, this.xb) !== null) {
                this.xb.i$i();
            }
            this.aa7.cd.e(this.ie);
            if (this.aa7.cn) {
                this.aa7.cl.g$i(a, b, c, d);
            }
            if (this.aa7.aa.count > 0) {
                for (let e of fromEnum(this.aa7.aa)) {
                    e.g$i(a, b, c, d);
                }
            }
            if (this.xu != null) {
                this.xu.c1();
            }
            this.ru(true);
            if (a == 0 || a == 2 || a == 3 || a == 4) {
                this.aa9 = true;
            }
            else if (a == 1) {
                for (let f = b; f < b + c; f++) {
                    let g = 0;
                    g += this.x5.item(f);
                    g += this.x6.item(f);
                    g += this.x4.item(f);
                    this.aba += g / 3;
                }
                this.abb = this.aba / this.x5.count;
            }
        }
        b3() {
            if (this.b4 == 0) {
                return 1;
            }
            else {
                return super.b3();
            }
        }
        ws(a) {
            if (this.xd == null || this.xd.h.count == 0) {
                return Rect.empty;
            }
            let b = this.wc(a);
            let c = this.cw.ca;
            let d = this.cw.b9;
            let e = this.getEffectiveViewport1(this.cw);
            let f = this.an(this.xb, this.xd.h, this.y8(this.cw), this.za(this.cw), a, true);
            let g = f[0];
            let h = f[1];
            let i = Math.abs(b.x - g[0]);
            let j = Math.abs(b.x - h[0]);
            let k = this.abc(this.xs, e);
            k = Math.max(k, 3);
            let l = (k - 1) / 2;
            if (i < j) {
                let m = g[0] - l;
                let n = g[0];
                let o = g[0] + l;
                let p = g[1];
                let q = g[2];
                let r = g[3];
                let s = g[4];
                let t = Math.min(Math.min(Math.min(p, q), r), s);
                let u = Math.max(Math.max(Math.max(p, q), r), s);
                return new Rect(0, m, t, Math.abs(o - m), u - t);
            }
            else {
                let v = h[0] - l;
                let w = h[0];
                let x = h[0] + l;
                let y = h[1];
                let z = h[2];
                let aa = h[3];
                let ab = h[4];
                let ac = Math.min(Math.min(Math.min(y, z), aa), ab);
                let ad = Math.max(Math.max(Math.max(y, z), aa), ab);
                return new Rect(0, v, ac, Math.abs(x - v), ad - ac);
            }
        }
        aa5(a, b) {
            let c = a[0] - b;
            let d = a[0];
            let e = a[0] + b;
            let f = a[1];
            let g = a[2];
            let h = a[3];
            let i = a[4];
            let j = Math.min(Math.min(Math.min(f, g), h), i);
            let k = Math.max(Math.max(Math.max(f, g), h), i);
            let l = Math.min(g, h);
            let m = Math.max(g, h);
            let n = Math.min(f, i);
            let o = Math.max(f, i);
            if (this.aa8 == 1) {
                let p = new Array(3);
                let q = new Rect(0, c, f, b, 0);
                let r = new Rect(0, d, i, b, 0);
                let s = new Rect(0, d, l, 0, m - l);
                p[0] = q;
                p[1] = r;
                p[2] = s;
                return p;
            }
            else {
                let t = new Array(2);
                let u = new Rect(0, d, l, 0, m - l);
                let v = new Rect(0, c, n, b * 2, o - n);
                t[0] = u;
                t[1] = v;
                return t;
            }
        }
        ao(a) {
            let b = new List$1(Rect.$, 0);
            let c = this.wc(a);
            let d = this.cw.ca;
            let e = this.cw.b9;
            let f = this.getEffectiveViewport1(this.cw);
            let g = this.an(this.xb, this.xd.h, this.y8(this.cw), this.za(this.cw), a, true);
            let h = g[0];
            let i = g[1];
            let j = Math.abs(c.x - h[0]);
            let k = Math.abs(c.x - i[0]);
            let l = this.abc(this.xs, f);
            l = Math.max(l, 3);
            let m = (l - 1) / 2;
            if (j < k) {
                return this.aa5(h, m);
            }
            else {
                return this.aa5(i, m);
            }
        }
        gx(a, b) {
            if (this.g0(a, b)) {
                return true;
            }
            return false;
        }
        g0(a, b) {
            let c = this.wt(a);
            if (c.isEmpty) {
                return false;
            }
            let d = RectUtil.r(c, (this.ig / 2) + this.iv(b));
            if (d.containsPoint(a)) {
                let e = this.ap(a);
                if (e != null) {
                    for (let f = 0; f < e.length; f++) {
                        let g = e[f];
                        let h = RectUtil.r(g, (this.ig / 2) + this.iv(b));
                        if (h.containsPoint(a)) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        rc(a, b, c, d) {
            switch (b) {
                case FinancialPriceSeries.$$p[4]:
                case FinancialPriceSeries.$$p[5]:
                case FinancialPriceSeries.$$p[6]:
                case FinancialPriceSeries.$$p[7]:
                case FinancialPriceSeries.$$p[1]:
                case FinancialPriceSeries.$$p[2]:
                case FinancialPriceSeries.$$p[9]:
                case FinancialPriceSeries.$$p[10]:
                    this.qh();
                    break;
                case FinancialSeries.$$p[14]:
                    this.aa7.ct();
                    if (this.dc != null) {
                        this.dc.ob();
                    }
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.aa7.cl = CategoryTrendLineManagerFactory.a(this.aa7.cl, this.xb, this.sz, this, this.ds);
                    }
                    break;
            }
            super.rc(a, b, c, d);
            if (this.aa7.cn && this.aa7.cl != null && this.aa7.cl.g$e(a, b, c, d)) {
                this.ru(false);
                this.qn();
            }
            switch (b) {
                case FinancialPriceSeries.$$p[3]:
                    if (this.sz != null) {
                        this.ab6();
                        this.sm();
                        this.xd.z();
                        this.aaj(this.xd, this.aa7);
                    }
                    this.qn();
                    break;
                case "ActualHighlightingMode":
                case "ActualSelectionMode":
                case "ActualFocusMode":
                    this.ru(true);
                    break;
                case "TrendLineBrush":
                    this.ri(b);
                    break;
                case "TrendLineType":
                    this.qn();
                    break;
                case FinancialSeries.$$p[10]:
                case FinancialPriceSeries.$$p[8]:
                    this.q5();
                    break;
            }
        }
        ab6() {
            this.aa7.cx();
            if (this.cv != null) {
                this.cv.cx();
            }
        }
        ay(a) {
            if (a != null && a == this.xu && this.x6 != null && !isNaN_(this.x6.minimum) && this.x5 != null && !isNaN_(this.x5.maximum)) {
                return new AxisRange(this.x6.minimum, this.x5.maximum);
            }
            return null;
        }
        az(a) {
            if (a.isEmpty && this.dc != null) {
                a = this.dc.wh;
            }
            if (this.x6 == null || this.x5 == null) {
                return null;
            }
            let b = this.wo(this.cw);
            let c = new ScalerParams(0, a, this.dc.wz, this.xb.ch, this.getEffectiveViewport());
            let d = (this.xb.eo(b.left, c));
            let e = (this.xb.eo(b.right, c));
            if (this.xb.ch) {
                let f = d;
                d = e;
                e = f;
            }
            let g = null;
            if (this.xb.cn) {
                g = this.xb;
                d = g.i$f(d);
                e = g.i$f(e);
            }
            else {
                d = Math.floor(d);
                e = Math.ceil(e);
            }
            d = Math.max(0, Math.min(this.x6.count - 1, d));
            e = Math.max(0, Math.min(this.x6.count - 1, e));
            let h = 1.7976931348623157E+308;
            let i = -1.7976931348623157E+308;
            for (let j = truncate(d); j <= truncate(e); j++) {
                let k = j;
                if (g != null) {
                    k = g.i$b._inner[j];
                }
                let l = this.x6.item(k);
                if (this.x6.mayContainUnknowns) {
                    if (isInfinity(l) || isNaN_(l)) {
                        continue;
                    }
                }
                let m = this.x5.item(k);
                if (this.x5.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                h = Math.min(h, l);
                i = Math.max(i, m);
            }
            let n = new AxisRange(h, i);
            n = this.ax(n, this.xu, a);
            return n;
        }
        iz() {
            return Series.i0(this.x7, typeCast(ISortingAxis_$type, this.xb));
        }
        ge(a) {
            let b = this.dp != null ? this.dp.indexOf(a) : -1;
            let c = this.cw.ca;
            c = c.copy();
            let d = this.cw.b9;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.wq(this.cw);
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.xb != null) {
                    let g = new ScalerParams(0, e, e, this.xb.ch, f);
                    let h = this.xb.el(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.xu != null && this.x6 != null && this.x5 != null && b < this.x6.count && b < this.x5.count) {
                    let i = new ScalerParams(0, e, e, this.xu.ch, f);
                    i.b = this.iz();
                    let j = this.xu.el(this.x6.item(b), i);
                    let k = this.xu.el(this.x5.item(b), i);
                    if (!isNaN_(j) && !isNaN_(k)) {
                        let l = Math.abs(j - k);
                        if (c.height < l) {
                            c.height = l;
                            c.y = Math.min(j, k);
                        }
                        else {
                            if (j < c.top + 0.1 * c.height) {
                                j = j + 0.4 * c.height;
                            }
                            if (j > c.bottom - 0.1 * c.height) {
                                j = j - 0.4 * c.height;
                            }
                            c.y = j - 0.5 * c.height;
                        }
                    }
                }
                this.c4.au(this.dc, c, true);
            }
            return b >= 0;
        }
        hf(a, b, c) {
            let d = super.hf(a, b, c);
            if (this.x7 == null || this.x4 == null || this.x5 == null || this.x6 == null) {
                d = false;
            }
            return d;
        }
        aah(a, b) {
            super.aah(a, b);
            let c = b.ca;
            let d = b.b9;
            let e = this.getEffectiveViewport1(b);
            let f = this.xb;
            let g = this.xu;
            let h = new ScalerParams(0, c, d, f.ch, e);
            let i = ((() => {
                let $ret = new ScalerParams(0, c, d, g.ch, e);
                $ret.b = this.iz();
                return $ret;
            })());
            let j = this.xb.ag();
            let k = j[0];
            let l = j[1];
            a.h.clear();
            if (a.o != null) {
                a.o.clear();
            }
            a.p.clear();
            a.s.clear();
            let m = 0;
            let n = typeCast(ISortingAxis_$type, this.xb);
            if (n != null && (n.i$b == null || n.i$b.count != this.dp.count)) {
                return;
            }
            m = this.y2(c, d, e);
            let o = typeCast(FinancialPriceSeriesView.$, b);
            let p = this.ie;
            let q = b.cd.b;
            if (this.trendLineType != 0) {
                let r = new Array(this.dp.count);
                let s = 0;
                for (let t of fromEnum(this.yt)) {
                    r[s] = t;
                    s++;
                }
                if (this.aa7.cn) {
                    this.aa7.cl.prepareLineCore(a.s, this.trendLineType, boxArray$1(r), this.trendLinePeriod, (u) => this.xb.el(u, h), (u) => this.xu.el(u, i), ((() => {
                        let $ret = new TrendResolutionParams();
                        $ret.e = b.cd.b;
                        $ret.f = b.cd.c;
                        $ret.g = b.cd.d;
                        $ret.a = m;
                        $ret.d = p;
                        $ret.i = d;
                        $ret.h = e;
                        $ret.c = k;
                        $ret.b = l;
                        return $ret;
                    })()));
                }
            }
            if (b.aa.count > 0) {
                let u = new Array(this.dp.count);
                let v = 0;
                for (let w of fromEnum(this.yt)) {
                    u[v] = w;
                    v++;
                }
                a.f.clear();
                for (let x = 0; x < b.aa.count; x++) {
                    a.f.add(new List$1(Point_$type, 0));
                    let y = b.aa._inner[x];
                    y.prepareLineCore(a.f._inner[x], y.g$b, boxArray$1(u), y.g$f, (z) => this.xb.el(z, h), (z) => this.xu.el(z, i), ((() => {
                        let $ret = new TrendResolutionParams();
                        $ret.e = b.cd.b;
                        $ret.f = b.cd.c;
                        $ret.g = b.cd.d;
                        $ret.a = m;
                        $ret.d = p;
                        $ret.i = d;
                        $ret.h = e;
                        $ret.c = k;
                        $ret.b = l;
                        return $ret;
                    })()));
                }
            }
            let z = this.xb.eo(2, h) - this.xb.eo(1, h);
            for (let aa = b.cd.c; aa <= b.cd.d; ++aa) {
                let ab;
                let ac = aa * q;
                if (n == null) {
                    ab = b.cd.getBucket(aa);
                }
                else {
                    let ad = n.i$b._inner[aa];
                    ac = ad;
                    let ae = n.i$d(ad);
                    let af = this.x7.item(ad);
                    let ag = this.x5.item(ad);
                    let ah = this.x6.item(ad);
                    let ai = this.x4.item(ad);
                    let aj = af;
                    let ak = ag;
                    let al = ah;
                    let am = ai;
                    let an = ae;
                    while (aa < b.cd.d) {
                        ad = n.i$b._inner[aa + 1];
                        an = n.i$d(ad);
                        if (an - ae > z * p) {
                            break;
                        }
                        ac = ad;
                        aa++;
                        ak = Math.max(ak, this.x5.item(ad));
                        al = Math.min(al, this.x6.item(ad));
                        am = this.x4.item(ad);
                    }
                    let ao = NaN;
                    if (!isNaN_(ae)) {
                        ao = this.xb.el(ae, h);
                    }
                    ab = [ao, aj, ak, al, am];
                }
                if (!isNaN_(ab[0])) {
                    if (n != null) {
                        ab[0] = ab[0] + m;
                    }
                    else {
                        ab[0] = f.el(ab[0], h) + m;
                    }
                    ab[1] = g.el(ab[1], i);
                    ab[2] = g.el(ab[2], i);
                    ab[3] = g.el(ab[3], i);
                    ab[4] = g.el(ab[4], i);
                    if (n != null) {
                        if (a.o == null) {
                            a.o = new List$1(Number_$type, 0);
                        }
                        a.o.add(ac);
                    }
                    a.h.add(ab);
                }
            }
            return;
        }
        o7(a, b) {
            super.o7(a, b);
            let c = typeCast(FinancialPriceSeriesView.$, b);
            c.cr();
            if (a) {
                c.cm.count = 0;
            }
            if (c.cn && c.cl != null) {
                c.cl.g$h();
            }
        }
        su(a, b) {
            super.su(a, b);
            if (this.dc != null) {
                this.dc.ob();
            }
        }
        w0(a, b) {
            if (this.xb != null && this.xb.categoryMode == 0) {
                let c = this.getEffectiveViewport1(this.cw);
                let d = this.abc(this.xs, c) / 2;
                return new Thickness(1, d, 0, d, 0);
            }
            return super.w0(a, b);
        }
        get_ef() {
            return true;
        }
        aaj(a, b) {
            super.aaj(a, b);
            if (this.xb == null || this.xu == null) {
                return;
            }
            let c = false;
            if (b.cg(a)) {
                c = true;
                b.ci(a);
            }
            this.xk.a2(this, this.yj(), runOn(this, this.w3), this.y8(b), this.za(b));
            let d = false;
            let e = this.xk.b;
            if (e != null) {
                d = true;
            }
            let f = typeCast(FinancialPriceSeriesView.$, b);
            f.cq();
            f.co = false;
            if (f.cn) {
                f.cl.g$h();
            }
            if (this.trendLineType != 0) {
                f.cl.g$k(a.s);
            }
            if (b.aa.count > 0) {
                for (let g = 0; g < b.aa.count; g++) {
                    let h = b.aa._inner[g];
                    h.g$k(a.f._inner[g]);
                }
            }
            if (d) {
                this.ab4(a, b, c);
            }
            else {
                f.cm.count = 0;
                this.ab3(a, b);
            }
        }
        ix() {
            let a = this.getEffectiveViewport1(this.cw);
            return this.abc(this.xs, a);
        }
        ab4(a, b, c) {
            let d = this.aa8;
            let e = this.getEffectiveViewport1(b);
            let f = this.abc(b, e);
            let g = (f - 1) / 2;
            let h = typeCast(ISortingAxis_$type, this.xb) !== null;
            let i = typeCast(FinancialPriceSeriesView.$, b);
            i.co = true;
            let j = a.h;
            let k = 0;
            let l = this.dp.count;
            let m = this.xb;
            let n = new ScalerParams(0, b.ca, b.b9, m.ch, e);
            let o = this.ve;
            let p = this.aa1;
            if (p == null) {
                p = o;
            }
            let q = this.vi;
            let r = this.acr;
            if (r == null) {
                r = q;
            }
            for (let s = 0; s < j.count; ++s) {
                let t = j._inner[s][0] - g;
                let u = j._inner[s][0];
                let v = j._inner[s][0] + g;
                let w = j._inner[s][1];
                let x = j._inner[s][2];
                let y = j._inner[s][3];
                let z = j._inner[s][4];
                if (isNaN_(w) || isNaN_(x) || isNaN_(y) || isNaN_(z)) {
                    continue;
                }
                let aa = i.cm.item(k);
                k++;
                let ab = w < z;
                let ac = new PathGeometry();
                if (c) {
                    switch (d) {
                        case 0:
                            if (ab) {
                                let ad = w;
                                w = z;
                                z = ad;
                            }
                            let ae = new PathFigure();
                            ae._startPoint = { $type: Point_$type, x: u, y: y };
                            ae._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: w };
                                return $ret;
                            })()));
                            let af = new PathFigure();
                            af._startPoint = { $type: Point_$type, x: t, y: z };
                            af._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: v, y: z };
                                return $ret;
                            })()));
                            af._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: v, y: w };
                                return $ret;
                            })()));
                            af._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: t, y: w };
                                return $ret;
                            })()));
                            af._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: t, y: z };
                                return $ret;
                            })()));
                            let ag = new PathFigure();
                            ag._startPoint = { $type: Point_$type, x: u, y: z };
                            ag._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: x };
                                return $ret;
                            })()));
                            ac.c.add(ae);
                            ac.c.add(af);
                            ac.c.add(ag);
                            break;
                        case 1:
                            let ah = new PathFigure();
                            ah._startPoint = { $type: Point_$type, x: t, y: w };
                            ah._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: w };
                                return $ret;
                            })()));
                            let ai = new PathFigure();
                            ai._startPoint = { $type: Point_$type, x: u, y: y };
                            ai._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: u, y: x };
                                return $ret;
                            })()));
                            let aj = new PathFigure();
                            aj._startPoint = { $type: Point_$type, x: u, y: z };
                            aj._segments.add(((() => {
                                let $ret = new LineSegment(1);
                                $ret.c = { $type: Point_$type, x: v, y: z };
                                return $ret;
                            })()));
                            ac.c.add(ah);
                            ac.c.add(ai);
                            ac.c.add(aj);
                            break;
                    }
                }
                if (ab) {
                    this.xk.ak = p;
                    this.xk.ag = p;
                    this.xk.ah = r;
                    this.xk.al = r;
                    this.xk.f = true;
                }
                else {
                    this.xk.ak = o;
                    this.xk.ag = o;
                    this.xk.ah = q;
                    this.xk.al = q;
                    this.xk.f = false;
                }
                let ak = this.xk.aw(l, s)[0];
                if (h && a.o != null && s >= 0 && s < a.o.count) {
                    ak = truncate(Math.round(a.o._inner[s]));
                }
                this.aag(j, s, l, m, n, b.t, ak);
                if (d == 1) {
                    this.xk.ad(aa, true, false, false, false);
                }
                else {
                    this.xk.ad(aa, false, false, false, false);
                }
                if (c) {
                    aa.an = ac;
                }
            }
            i.cm.count = k;
            i.cs();
        }
        abc(a, b) {
            let c = this.xb.k8(a.ca, a.b9, b);
            c = Math.max(c, this.ie * 0.9);
            c = Math.max(c, 3);
            return c;
        }
        ab3(a, b) {
            let c = this.aa8;
            let d = this.getEffectiveViewport1(b);
            let e = this.abc(b, d);
            let f = (e - 1) / 2;
            let g = typeCast(FinancialPriceSeriesView.$, b);
            let h = g.c0();
            let i = g.cz();
            let j = a.h;
            for (let k = 0; k < j.count; ++k) {
                let l = j._inner[k][0] - f;
                let m = j._inner[k][0];
                let n = j._inner[k][0] + f;
                let o = j._inner[k][1];
                let p = j._inner[k][2];
                let q = j._inner[k][3];
                let r = j._inner[k][4];
                if (isNaN_(o) || isNaN_(p) || isNaN_(q) || isNaN_(r)) {
                    continue;
                }
                let s = o < r;
                let t = s ? i : h;
                switch (c) {
                    case 0:
                        if (s) {
                            let u = o;
                            o = r;
                            r = u;
                        }
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: q };
                            $ret.c = { $type: Point_$type, x: m, y: o };
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new RectangleGeometry();
                            $ret.e = new Rect(0, l, r, n - l, o - r);
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: r };
                            $ret.c = { $type: Point_$type, x: m, y: p };
                            return $ret;
                        })()));
                        break;
                    case 1:
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: l, y: o };
                            $ret.c = { $type: Point_$type, x: m, y: o };
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: q };
                            $ret.c = { $type: Point_$type, x: m, y: p };
                            return $ret;
                        })()));
                        t.d.add(((() => {
                            let $ret = new LineGeometry();
                            $ret.d = { $type: Point_$type, x: m, y: r };
                            $ret.c = { $type: Point_$type, x: n, y: r };
                            return $ret;
                        })()));
                        break;
                }
            }
        }
        ky(a, b) {
            if (this.aa7.cn && a == this.aa7.cl.g$n) {
                return null;
            }
            return super.ky(a, b);
        }
        sl() {
            super.sl();
            if (this.index < 0) {
                return;
            }
            this.aa7.cy();
        }
        p1(a) {
            super.p1(a);
            if (this.aa7.cn) {
                this.bc.exportTrendlineData(this, a, this.aa7.cl.g$n);
            }
        }
        v2() {
            return this.acr;
        }
        r7(a, b) {
            super.r7(a, b);
            this.acr = b;
        }
        bf(a) {
            if (this.aa8 == 0) {
                return 3;
            }
            else if (this.aa8 == 1) {
                if (this.be == 1) {
                    return 3;
                }
                return 2;
            }
            return a;
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.i4(c, false, false);
            let e = this.i2(c, false, false);
            let f = new DataLegendSeriesValueInfo();
            f.a = 4;
            f.l = this.y3(c, false, false);
            f.q = "Close";
            f.r = this.zf != null ? this.zf : "Close";
            f.s = this.abg != null ? this.abg : "C:";
            f.t = this.abi != null ? this.abi : "";
            let g = new DataLegendSeriesValueInfo();
            g.l = this.y4(c, false, false);
            g.a = 3;
            g.q = "Open";
            g.r = this.z1 != null ? this.z1 : "Open";
            g.s = this.abu != null ? this.abu : "O:";
            g.t = this.abw != null ? this.abw : "";
            g.k = true;
            let h = new DataLegendSeriesValueInfo();
            h.l = (f.l - g.l) / g.l * 100;
            h.l = round10N(h.l, 1);
            h.a = 9;
            h.q = "Change";
            h.r = "Change";
            h.s = "";
            h.v = "";
            h.x = "+";
            h.w = "%";
            h.y = "%";
            h.t = null;
            h.c = false;
            h.k = true;
            h.e = false;
            h.f = true;
            h.h = false;
            h.g = false;
            h.d = false;
            h.n = 1;
            h.m = 1;
            g.z = h.l >= 0 ? this.ve : this.aa1;
            f.z = h.l >= 0 ? this.ve : this.aa1;
            h.z = h.l >= 0 ? this.ve : this.aa1;
            let i = new DataLegendSeriesValueInfo();
            i.l = e > d ? d : e;
            i.a = 1;
            i.q = "Low";
            i.r = this.zx != null ? this.zx : "Low";
            i.s = this.abp != null ? this.abp : "L:";
            i.t = this.abr != null ? this.abr : "";
            i.k = true;
            let j = new DataLegendSeriesValueInfo();
            j.l = e > d ? e : d;
            j.a = 2;
            j.q = "High";
            j.r = this.zs != null ? this.zs : "High";
            j.s = this.abl != null ? this.abl : "H:";
            j.t = this.abn != null ? this.abn : "";
            j.k = true;
            let k = new DataLegendSeriesValueInfo();
            k.l = (j.l + i.l + f.l) / 3;
            k.l = round10N(k.l, 2);
            k.a = 5;
            k.q = "TypicalPrice";
            k.r = "TypicalPrice";
            k.s = "TP:";
            k.t = "";
            k.k = true;
            let l = new DataLegendSeriesValueInfo();
            l.l = this.y5(c, false, false);
            l.a = 8;
            l.q = "Volume";
            l.r = this.z5 != null ? this.z5 : "Volume";
            l.s = "VOL:";
            l.t = "";
            l.k = true;
            l.n = 0;
            l.m = 0;
            l.e = false;
            l.f = false;
            l.h = false;
            let m = new List$1(DataLegendSeriesValueInfo.$, 0);
            m.add(g);
            m.add(j);
            m.add(i);
            m.add(f);
            m.add(k);
            m.add(h);
            m.add(l);
            let n = new DataLegendSeriesContext();
            n.h = this.me();
            n.e = m;
            return n;
        }
        ab5() {
            if (this.aa9) {
                this.aba = 0;
                for (let a = 0; a < this.x5.count; a++) {
                    let b = 0;
                    b += this.x5.item(a);
                    b += this.x6.item(a);
                    b += this.x4.item(a);
                    this.aba += b / 3;
                }
                this.abb = this.aba / this.x5.count;
                this.aa9 = false;
            }
        }
        aq(a) {
            let b = NaN;
            switch (a) {
                case 2:
                    b = this.x5.maximum;
                    break;
                case 1:
                    b = this.x6.minimum;
                    break;
                case 3:
                    if (this.aa9) {
                        this.ab5();
                    }
                    b = this.abb;
                    break;
            }
            let c = this.xu;
            if (c.cp) {
                return [NaN, b];
            }
            else {
                return [b, NaN];
            }
        }
        wk(a) {
            let b = NaN;
            switch (a) {
                case 2:
                    b = this.x5.maximum;
                    break;
                case 1:
                    b = this.x6.minimum;
                    break;
                case 3:
                    if (this.aa9) {
                        this.ab5();
                    }
                    b = this.abb;
                    break;
            }
            if (isNaN_(b)) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let c = this.xu;
            let d = this.getEffectiveViewport1(this.cw);
            let e = new ScalerParams(0, this.cw.ca, this.cw.b9, c.ch, d);
            if (c.cp) {
                e.b = this.iz();
            }
            e.c = d;
            if (c.cp) {
                return { $type: Point_$type, x: NaN, y: c.el(b, e) };
            }
            else {
                return { $type: Point_$type, x: c.el(b, e), y: NaN };
            }
        }
        wl(a) {
            let b = this.xu;
            let c = this.getEffectiveViewport1(this.cw);
            let d = new ScalerParams(0, this.cw.ca, this.cw.b9, b.ch, c);
            if (b.cp) {
                d.b = this.iz();
            }
            d.c = c;
            if (b.cp) {
                return { $type: Point_$type, x: NaN, y: b.el(a[1], d) };
            }
            else {
                return { $type: Point_$type, x: b.el(a[0], d), y: NaN };
            }
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.p6(a, c, b);
            return c.toArray();
        }
        p6(a, b, c) {
            let d = this.dc.ww(this.dc.wm(a));
            let e = this.xu;
            let f = this.xb;
            let g = this.dc.wp(this.wx, this.getEffectiveViewport(), d);
            let h, i;
            let j = this.ab0(d, f, true, g, h, i);
            h = j.p4;
            i = j.p5;
            if (this.aa6 == 0) {
                this.ab2(b, h, i, c);
            }
            else {
                let k, l;
                let m = this.abz(d, e, true, g, k, l);
                k = m.p4;
                l = m.p5;
                this.ab1(1, b, h, i, k, l, c);
            }
        }
        ab0(a, b, c, d, e, f) {
            let g = new ScalerParams(0, a, this.dc.wz, this.xb.ch, this.getEffectiveViewport());
            let h = (this.xb.eo(d.left, g));
            let i = (this.xb.eo(d.right, g));
            if (this.xb.ch) {
                let j = h;
                h = i;
                i = j;
            }
            if (this.xb.cn) {
                let k = this.xb;
                h = k.i$f(h);
                i = k.i$f(i);
            }
            else {
                h = Math.floor(h);
                i = Math.ceil(i);
            }
            e = truncate(Math.max(0, Math.min(this.x6.count - 1, h)));
            f = truncate(Math.max(0, Math.min(this.x6.count - 1, i)));
            return {
                p4: e,
                p5: f
            };
        }
        abz(a, b, c, d, e, f) {
            let g = new ScalerParams(0, a, this.dc.wz, b.ch, this.getEffectiveViewport());
            let h = c ? (b.ch ? d.top : d.bottom) : (b.ch ? d.left : d.right);
            let i = c ? (b.ch ? d.bottom : d.top) : (b.ch ? d.right : d.left);
            e = b.eo(h, g);
            f = b.eo(i, g);
            return {
                p4: e,
                p5: f
            };
        }
        aby(a, b, c) {
            if (c == 2 || c == 1) {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.item = this.dp.item(b);
                    return $ret;
                })()));
            }
            else {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.item = this.dp.item(b);
                    $ret.series = this;
                    return $ret;
                })()));
            }
        }
        ab2(a, b, c, d) {
            if (b == -1 || c == -1) {
                return;
            }
            if (d == 7 || d == 6) {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.series = this;
                    return $ret;
                })()));
                return;
            }
            for (let e = b; e <= c; e++) {
                this.aby(a, e, d);
            }
        }
        ab1(a, b, c, d, e, f, g) {
            if (c == -1 || d == -1) {
                return;
            }
            for (let h = c; h <= d; h++) {
                let i = Math.min(this.x7.item(h), this.x6.item(h));
                let j = Math.max(this.x4.item(h), this.x5.item(h));
                let k = Math.min(i, j);
                let l = Math.max(i, j);
                if (k < f && e < l) {
                    if (g == 7 || g == 6) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.series = this;
                            return $ret;
                        })()));
                        return;
                    }
                    this.aby(b, h, g);
                }
            }
        }
        bd() {
            return CategoryTrendLineManagerFactory.a(null, this.xb, null, null, this.ds);
        }
    }
    FinancialPriceSeries.$t = /*@__PURE__*/ markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialPriceSeries.ab7 = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialPriceSeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    FinancialPriceSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['CategoryCollisionMode:aa6:ab8', [CategoryCollisionMode_$type, /*@__PURE__*/ enumGetBox(CategoryCollisionMode_$type, 0)], 'CloseMemberAsLegendLabel:abg:ab9', [2, null], 'CloseMemberAsLegendUnit:abi:aca', [2, null], 'DisplayType:aa8:acb', [PriceDisplayType_$type, /*@__PURE__*/ enumGetBox(PriceDisplayType_$type, 0)], 'HighMemberAsLegendLabel:abl:acc', [2, null], 'HighMemberAsLegendUnit:abn:acd', [2, null], 'LowMemberAsLegendLabel:abp:ace', [2, null], 'LowMemberAsLegendUnit:abr:acf', [2, null], 'NegativeOutline:acr:acg', [Brush.$, null], 'OpenMemberAsLegendLabel:abu:ach', [2, null], 'OpenMemberAsLegendUnit:abw:aci', [2, null], 'TrendLineType::aco', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::acn', [1, 1.5], 'TrendLinePeriod::acm', [1, 7], 'TrendLineBrush::acj', [Brush.$, null], 'TrendLineZIndex:abe:acp', [1, 1001], 'TrendLineDashArray:acs:ack', [DoubleCollection.$], 'TrendLineDashCap:act:acl', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialPriceSeries;
})();
/**
 * @hidden
 */
export let FinancialPriceSeriesView = /*@__PURE__*/ (() => {
    class FinancialPriceSeriesView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.cj = null;
            this.cm = null;
            this.cp = null;
            this.c3 = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.c2 = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.ck = null;
            this.c1 = new Path();
            this.co = false;
            this.cj = a;
            this.cp = new List$1(Path.$, 0);
            this.cm = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.c4);
                $ret.activate = runOn(this, this.cu);
                $ret.disactivate = runOn(this, this.cw);
                $ret.destroy = runOn(this, this.cv);
                return $ret;
            })());
        }
        c4() {
            let a = new Path();
            this.cp.add(a);
            a._visibility = 1;
            return a;
        }
        cu(a) {
            a._visibility = 0;
        }
        cw(a) {
            a._visibility = 1;
        }
        cv(a) {
            this.cp.remove(a);
        }
        ce() {
            return new FinancialPriceBucketCalculator(this);
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.cj.aa8 = Defaults.g;
                this.cj.aa1 = Defaults.financialSeries_NegativeBrush;
                this.cj.acr = Defaults.financialSeries_NegativeOutline;
                this.cj.jq = Defaults.financialSeries_Thickness;
                this.cj.v0 = this.cj.vi;
            }
        }
        get cl() {
            if (this.ck == null) {
                this.ck = CategoryTrendLineManagerFactory.a(this.ck, this.f.a0(), this.f.sz, this.f, this.f.ds);
            }
            return this.ck;
        }
        set cl(a) {
            this.ck = a;
        }
        get cn() {
            return this.ck != null;
        }
        cx() {
            if (this.cj.aa8 == 1) {
                this.c3._stroke = this.f.ve;
            }
            else {
                this.c3._stroke = this.f.vi;
            }
            if (this.cj.aa8 == 1) {
                this.c2._stroke = this.cf.aa1;
            }
            else {
                this.c2._stroke = this.cj.acr;
            }
        }
        cr() {
            this.a2();
            this.cm.count = 0;
            this.cq();
        }
        cq() {
            let a = typeCast(GeometryGroup.$, this.c3.an);
            let b = typeCast(GeometryGroup.$, this.c2.an);
            Extensions.d(a);
            Extensions.d(b);
        }
        c0() {
            this.a2();
            return typeCast(GeometryGroup.$, this.c3.an);
        }
        cz() {
            this.a2();
            return typeCast(GeometryGroup.$, this.c2.an);
        }
        cy() {
            this.cj.acq = null;
            if (this.cj.trendLineBrush != null) {
                this.cj.acq = this.cj.trendLineBrush;
            }
            else {
                this.cj.acq = this.cj.ve;
            }
        }
        bp() {
            super.bp();
            this.c3.ad = this.f.ig;
            this.c3.ai = this.f.v7;
            this.c3.aj = this.f.v8;
            if (this.cj.aa8 == 1) {
                this.c3._stroke = this.f.ve;
            }
            else {
                this.c3._stroke = this.f.vi;
                this.c3._fill = this.f.ve;
            }
            this.c2.ad = this.f.ig;
            this.c2.ai = this.f.v7;
            this.c2.aj = this.f.v8;
            if (this.cj.aa8 == 1) {
                this.c2._stroke = this.cf.aa1;
            }
            else {
                this.c2._stroke = this.cj.acr;
                this.c2._fill = this.cf.aa1;
            }
        }
        bq() {
            super.bq();
            let a = this.b3();
            this.c3.ad = this.f.ig + 3;
            if (this.cj.aa8 == 1) {
                this.c3._stroke = a;
            }
            else {
                this.c3._stroke = a;
                this.c3._fill = a;
            }
            this.c2.ad = this.f.ig + 3;
            if (this.cj.aa8 == 1) {
                this.c2._stroke = a;
            }
            else {
                this.c2._stroke = a;
                this.c2._fill = a;
            }
        }
        ak(a) {
            return this.cp._inner[a];
        }
        aj(a) {
            let b = this.cp._inner[a];
            this.c1._visibility = b._visibility;
            this.c1.an = b.an;
            let c = this.b4(a);
            this.c1._fill = c;
            this.c1._stroke = c;
            this.c1.ad = this.f.ig + 3;
            return this.c1;
        }
        bj(a, b) {
            super.bj(a, b);
            if (a.d) {
                if (this.co) {
                    for (let c = 0; c < this.cp.count; c++) {
                        let d = this.ai(c, b);
                        if (d._visibility == 0) {
                            a.t(d);
                        }
                    }
                }
                else {
                    a.t(this.c3);
                    a.t(this.c2);
                }
            }
        }
        bi(a, b) {
            if (a.d) {
                if (this.cj.trendLineType != 0 && !b) {
                    let c = this.cl.g$n;
                    c.ad = this.cj.trendLineThickness;
                    c._stroke = this.cj.acq;
                    c.ai = this.cj.acs;
                    c.aj = this.cj.act;
                    a.v(c);
                }
            }
            super.bi(a, b);
        }
        ax(a) {
            super.ax(a);
            if (this.cj.yj()) {
                for (let b = 0; b < this.cp.count; b++) {
                    let c = this.cp._inner[b];
                    if (c._fill == this.cj.aa1) {
                        this.f.bc.exportPathData(a, c, "negativePathShape" + b, ["Negative"]);
                    }
                    else {
                        this.f.bc.exportPathData(a, c, "positivePathShape" + b, ["Positive", "Main"]);
                    }
                }
            }
            else {
                this.f.bc.exportPathData(a, this.c3, "positivePathShape", ["Positive", "Main"]);
                this.f.bc.exportPathData(a, this.c2, "negativePathShape", ["Negative"]);
            }
        }
        cs() {
            this.a2();
        }
        ct() {
            if (this.cn) {
                this.ck = CategoryTrendLineManagerFactory.a(this.ck, this.f.a0(), this.f.sz, this.f, this.f.ds);
            }
        }
    }
    FinancialPriceSeriesView.$t = /*@__PURE__*/ markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);
    return FinancialPriceSeriesView;
})();
