/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let RadialBaseChart = /*@__PURE__*/ (() => {
    class RadialBaseChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.aas = null;
            this.aat = null;
            this.aa7 = 0;
            this.aa9 = 5;
            this.aa8 = 0;
            this.aa6 = 5;
            this.abo = 5;
            this.abq = 0;
            this.abp = 5;
            this.abn = 0;
            this.agh = null;
            this.ago = null;
            this.agf = null;
            this.agg = null;
            this.abi = 0;
            this.abz = 0;
            this.abh = NaN;
            this.aby = NaN;
            this.abk = NaN;
            this.ab1 = NaN;
            this.abj = NaN;
            this.ab0 = NaN;
            this.abg = NaN;
            this.abx = NaN;
            this.agn = null;
            this.agu = null;
            this.ac9 = null;
            this.add = null;
            this.adb = null;
            this.adf = null;
            this.ac4 = null;
            this.ac5 = null;
            this.agi = null;
            this.agp = null;
            this.aba = DeviceUtils.g(1);
            this.abr = DeviceUtils.g(1);
            this.abb = DeviceUtils.g(1);
            this.abs = DeviceUtils.g(1);
            this.agk = null;
            this.agr = null;
            this.agl = null;
            this.ags = null;
            this.abc = DeviceUtils.g(1);
            this.abt = DeviceUtils.g(1);
            this.abd = DeviceUtils.g(8);
            this.abu = 0;
            this.agm = null;
            this.agt = null;
            this.abe = DeviceUtils.g(1);
            this.abv = DeviceUtils.g(1);
            this.ada = null;
            this.ade = null;
            this.agj = null;
            this.agq = null;
            this.aa5 = 0;
            this.abm = 0;
            this.aa4 = NaN;
            this.abl = NaN;
            this.abf = 0;
            this.abw = -90;
            this.aa0 = false;
            this.aa1 = false;
            this.aga = 1;
            this.ahd = 1;
            this.af9 = 1;
            this.agb = 2;
            this.ahb = 0;
            this.ahc = 1;
            this.ahh = 0;
            this.ahi = 0;
            this.aay = 4;
            this.aao = 4;
            this.ac8 = null;
            this.aak = null;
            this.adc = null;
            this.aal = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.aaq();
                let c = this.aar();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        vm() {
            super.vm();
            let a = this.aaq();
            let b = this.aar();
            if (a != null && a.az != null) {
                this.agx = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.ag4 = b.az.textColor;
            }
            this.ag2 = AxisDefaults.axis_TickBrush;
            this.ag9 = AxisDefaults.axis_TickBrush;
            this.agy = AxisDefaults.axis_MajorBrush;
            this.ag5 = AxisDefaults.axis_MajorBrush;
            this.ag1 = AxisDefaults.axis_LineBrush;
            this.ag8 = AxisDefaults.axis_LineBrush;
        }
        wh(a, b, c) {
            super.wh(a, b, c);
            switch (a) {
                case "AngleAxisLabelLeftMargin":
                    this.af1((d) => d.leftMargin = this.ab5);
                    break;
                case "AngleAxisLabelTopMargin":
                    this.af1((d) => d.topMargin = this.ab7);
                    break;
                case "AngleAxisLabelRightMargin":
                    this.af1((d) => d.rightMargin = this.ab6);
                    break;
                case "AngleAxisLabelBottomMargin":
                    this.af1((d) => d.bottomMargin = this.ab4);
                    break;
                case "ValueAxisLabelLeftMargin":
                    this.af6((d) => d.leftMargin = this.acq);
                    break;
                case "ValueAxisLabelTopMargin":
                    this.af6((d) => d.topMargin = this.acs);
                    break;
                case "ValueAxisLabelRightMargin":
                    this.af6((d) => d.rightMargin = this.acr);
                    break;
                case "ValueAxisLabelBottomMargin":
                    this.af6((d) => d.bottomMargin = this.acp);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.agv = this.zi(this.agx);
                    this.agw = this.zi(this.ag4);
                    break;
                case "AngleAxisLabelTextColor":
                    this.agv = this.zi(this.agx);
                    break;
                case "ValueAxisLabelTextColor":
                    this.agw = this.zi(this.ag4);
                    break;
                case "ActualAngleAxisLabelTextColor":
                    this.af1((d) => d.textColor = this.agv);
                    break;
                case "ActualValueAxisLabelTextColor":
                    this.af6((d) => d.textColor = this.agw);
                    break;
                case "AngleAxisTitleMargin":
                    this.af3((d) => d.margin = this.acg);
                    break;
                case "ValueAxisTitleMargin":
                    this.af8((d) => d.margin = this.ac1);
                    break;
                case "AngleAxisTitleLeftMargin":
                    this.af3((d) => d.leftMargin = this.acf);
                    break;
                case "ValueAxisTitleLeftMargin":
                    this.af8((d) => d.leftMargin = this.ac0);
                    break;
                case "AngleAxisTitleTopMargin":
                    this.af3((d) => d.topMargin = this.aci);
                    break;
                case "ValueAxisTitleTopMargin":
                    this.af8((d) => d.topMargin = this.ac3);
                    break;
                case "AngleAxisTitleRightMargin":
                    this.af3((d) => d.rightMargin = this.ach);
                    break;
                case "ValueAxisTitleRightMargin":
                    this.af8((d) => d.rightMargin = this.ac2);
                    break;
                case "AngleAxisTitleBottomMargin":
                    this.af3((d) => d.bottomMargin = this.ace);
                    break;
                case "ValueAxisTitleBottomMargin":
                    this.af8((d) => d.bottomMargin = this.acz);
                    break;
                case "AngleAxisTitleTextColor":
                    this.af3((d) => d.textColor = this.ag3);
                    break;
                case "ValueAxisTitleTextColor":
                    this.af8((d) => d.textColor = this.aha);
                    break;
                case "AngleAxisFormatLabel":
                    this.afz((d) => d.au = this.aau);
                    break;
                case "ValueAxisFormatLabel":
                    this.af4((d) => d.au = this.aav);
                    break;
            }
        }
        get aau() {
            return this.aas;
        }
        set aau(a) {
            let b = this.aau;
            if (a != b) {
                this.aas = a;
                this.wd("AngleAxisFormatLabel", b, this.aau);
            }
        }
        get aav() {
            return this.aat;
        }
        set aav(a) {
            let b = this.aav;
            if (a != b) {
                this.aat = a;
                this.wd("ValueAxisFormatLabel", b, this.aav);
            }
        }
        get ab5() {
            return this.aa7;
        }
        set ab5(a) {
            let b = this.ab5;
            if (a != b) {
                this.aa7 = a;
                this.wd("AngleAxisLabelLeftMargin", b, this.ab5);
            }
        }
        get ab7() {
            return this.aa9;
        }
        set ab7(a) {
            let b = this.ab7;
            if (a != b) {
                this.aa9 = a;
                this.wd("AngleAxisLabelTopMargin", b, this.ab7);
            }
        }
        get ab6() {
            return this.aa8;
        }
        set ab6(a) {
            let b = this.ab6;
            if (a != b) {
                this.aa8 = a;
                this.wd("AngleAxisLabelRightMargin", b, this.ab6);
            }
        }
        get ab4() {
            return this.aa6;
        }
        set ab4(a) {
            let b = this.ab4;
            if (a != b) {
                this.aa6 = a;
                this.wd("AngleAxisLabelBottomMargin", b, this.ab4);
            }
        }
        get acq() {
            return this.abo;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.abo = a;
                this.wd("ValueAxisLabelLeftMargin", b, this.acq);
            }
        }
        get acs() {
            return this.abq;
        }
        set acs(a) {
            let b = this.acs;
            if (a != b) {
                this.abq = a;
                this.wd("ValueAxisLabelTopMargin", b, this.acs);
            }
        }
        get acr() {
            return this.abp;
        }
        set acr(a) {
            let b = this.acr;
            if (a != b) {
                this.abp = a;
                this.wd("ValueAxisLabelRightMargin", b, this.acr);
            }
        }
        get acp() {
            return this.abn;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.abn = a;
                this.wd("ValueAxisLabelBottomMargin", b, this.acp);
            }
        }
        get agx() {
            return this.agh;
        }
        set agx(a) {
            let b = this.agx;
            if (a != b) {
                this.agh = a;
                this.wd("AngleAxisLabelTextColor", b, this.agx);
            }
        }
        get ag4() {
            return this.ago;
        }
        set ag4(a) {
            let b = this.ag4;
            if (a != b) {
                this.ago = a;
                this.wd("ValueAxisLabelTextColor", b, this.ag4);
            }
        }
        get agv() {
            return this.agf;
        }
        set agv(a) {
            let b = this.agf;
            if (a != b) {
                this.agf = a;
                this.wd("ActualAngleAxisLabelTextColor", b, this.agv);
            }
        }
        get agw() {
            return this.agg;
        }
        set agw(a) {
            let b = this.agg;
            if (a != b) {
                this.agg = a;
                this.wd("ActualValueAxisLabelTextColor", b, this.agw);
            }
        }
        get acg() {
            return this.abi;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.abi = a;
                this.wd("AngleAxisTitleMargin", b, this.acg);
            }
        }
        get ac1() {
            return this.abz;
        }
        set ac1(a) {
            let b = this.ac1;
            if (a != b) {
                this.abz = a;
                this.wd("ValueAxisTitleMargin", b, this.ac1);
            }
        }
        get acf() {
            return this.abh;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.abh = a;
                this.wd("AngleAxisTitleLeftMargin", b, this.acf);
            }
        }
        get ac0() {
            return this.aby;
        }
        set ac0(a) {
            let b = this.ac0;
            if (a != b) {
                this.aby = a;
                this.wd("ValueAxisTitleLeftMargin", b, this.ac0);
            }
        }
        get aci() {
            return this.abk;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.abk = a;
                this.wd("AngleAxisTitleTopMargin", b, this.aci);
            }
        }
        get ac3() {
            return this.ab1;
        }
        set ac3(a) {
            let b = this.ac3;
            if (a != b) {
                this.ab1 = a;
                this.wd("ValueAxisTitleTopMargin", b, this.ac3);
            }
        }
        get ach() {
            return this.abj;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.abj = a;
                this.wd("AngleAxisTitleRightMargin", b, this.ach);
            }
        }
        get ac2() {
            return this.ab0;
        }
        set ac2(a) {
            let b = this.ac2;
            if (a != b) {
                this.ab0 = a;
                this.wd("ValueAxisTitleRightMargin", b, this.ac2);
            }
        }
        get ace() {
            return this.abg;
        }
        set ace(a) {
            let b = this.ace;
            if (a != b) {
                this.abg = a;
                this.wd("AngleAxisTitleBottomMargin", b, this.ace);
            }
        }
        get acz() {
            return this.abx;
        }
        set acz(a) {
            let b = this.acz;
            if (a != b) {
                this.abx = a;
                this.wd("ValueAxisTitleBottomMargin", b, this.acz);
            }
        }
        get ag3() {
            return this.agn;
        }
        set ag3(a) {
            let b = this.ag3;
            if (a != b) {
                this.agn = a;
                this.wd("AngleAxisTitleTextColor", b, this.ag3);
            }
        }
        get aha() {
            return this.agu;
        }
        set aha(a) {
            let b = this.aha;
            if (a != b) {
                this.agu = a;
                this.wd("ValueAxisTitleTextColor", b, this.aha);
            }
        }
        wi(a, b, c) {
            super.wi(a, b, c);
            switch (a) {
                case "AngleAxisLabelTextStyle":
                    this.af1((d) => d.textStyle = this.adw);
                    break;
                case "ValueAxisLabelTextStyle":
                    this.af6((d) => d.textStyle = this.ae2);
                    break;
                case "AngleAxisTitleTextStyle":
                    this.af3((d) => d.textStyle = this.aek);
                    break;
                case "ValueAxisTitleTextStyle":
                    this.af8((d) => d.textStyle = this.afq);
                    break;
            }
        }
        get adw() {
            return this.ac9;
        }
        set adw(a) {
            let b = this.adw;
            if (a != b) {
                this.ac9 = a;
                this.wd("AngleAxisLabelTextStyle", b, this.adw);
            }
        }
        get ae2() {
            return this.add;
        }
        set ae2(a) {
            let b = this.ae2;
            if (a != b) {
                this.add = a;
                this.wd("ValueAxisLabelTextStyle", b, this.ae2);
            }
        }
        get aek() {
            return this.adb;
        }
        set aek(a) {
            let b = this.aek;
            if (a != b) {
                this.adb = a;
                this.wd("AngleAxisTitleTextStyle", b, this.aek);
            }
        }
        get afq() {
            return this.adf;
        }
        set afq(a) {
            let b = this.afq;
            if (a != b) {
                this.adf = a;
                this.wd("ValueAxisTitleTextStyle", b, this.afq);
            }
        }
        afw(a) {
            this.aft(a, (b) => b.leftMargin = this.ab5);
            this.aft(a, (b) => b.topMargin = this.ab7);
            this.aft(a, (b) => b.rightMargin = this.ab6);
            this.aft(a, (b) => b.bottomMargin = this.ab4);
            this.aft(a, (b) => b.textColor = this.agv);
            this.afu(a, (b) => b.textColor = this.ag3);
            this.afu(a, (b) => b.leftMargin = this.acf);
            this.afu(a, (b) => b.topMargin = this.aci);
            this.afu(a, (b) => b.rightMargin = this.ach);
            this.afu(a, (b) => b.bottomMargin = this.ace);
            this.aft(a, (b) => b.textStyle = this.adw);
            this.afu(a, (b) => b.textStyle = this.aek);
        }
        afy(a) {
            this.aft(a, (b) => b.leftMargin = this.acq);
            this.aft(a, (b) => b.topMargin = this.acs);
            this.aft(a, (b) => b.rightMargin = this.acr);
            this.aft(a, (b) => b.bottomMargin = this.acp);
            this.aft(a, (b) => b.textColor = this.agw);
            this.afu(a, (b) => b.textColor = this.aha);
            this.afu(a, (b) => b.leftMargin = this.ac0);
            this.afu(a, (b) => b.topMargin = this.ac3);
            this.afu(a, (b) => b.rightMargin = this.ac2);
            this.afu(a, (b) => b.bottomMargin = this.acz);
            this.aft(a, (b) => b.textStyle = this.ae2);
            this.afu(a, (b) => b.textStyle = this.afq);
        }
        w9(a) {
            let b = this.be(a);
            let c = this.dc(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = this.h6(a);
            if (a.highlightedData != null) {
                c.highlightedItemsSource = this.h7(a);
            }
            c.name = this.q0(a);
            c.title = this.q1(a, b);
            this.dataChart.series.add(c);
        }
        afz(a) {
            this.af0(a, null);
        }
        af0(a, b) {
            a(this.aaq());
        }
        af5(a, b) {
            a(this.aar());
        }
        af4(a) {
            this.af5(a, true);
        }
        u5(a, b) {
            this.afz(a);
            this.af5(a, b);
        }
        af3(a) {
            this.afu(this.aaq(), a);
        }
        af8(a) {
            this.afu(this.aar(), a);
        }
        af6(a) {
            this.aft(this.aar(), a);
        }
        af1(a) {
            this.aft(this.aaq(), a);
        }
        acj(a) {
            let b = this.aaq();
            return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        acl(a) {
            let b = this.aaq();
            return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        ack(a) {
            let b = this.aar();
            return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        acm(a) {
            let b = this.aar();
            return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
        }
        w6(a) {
            super.w6(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.aaq();
                let c = this.aar();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static aen(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        vh(a, b) {
            super.vh(a, b);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.aaq());
                this.dataChart.axes.add(this.aar());
            }
        }
        afv(a) {
            if (a != null && this.l4 != null && a.fn == null) {
                a.provideRenderer(this.l4);
            }
            a.jz = this.agy;
            a.et = this.ab8;
            a.j0 = this.agz;
            a.ew = this.ab9;
            a.j2 = this.ag1;
            a.fi = this.aca;
            a.j1 = this.ag0;
            a.fj = this.acb;
            a.j3 = this.ag2;
            a.fk = this.acc;
            a.c4 = true;
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            let b = a == this.aaq();
            if (b) {
                a.g8 = this.aeb;
            }
            a.f2 = this.ac6;
            a.gi = this.adn;
            a.ah = this.aam;
            this.aft(a, (c) => c.angle = this.ab3);
            this.aft(a, (c) => {
                if (c.extent != this.ab2) {
                    c.extent = this.ab2;
                }
            });
            this.aft(a, (c) => c.horizontalAlignment = this.agc);
            this.aft(a, (c) => c.verticalAlignment = this.ahe);
            this.aft(a, (c) => c.visibility = this.ahj);
            this.aft(a, (c) => c.location = this.aaw(this.aap));
            this.afu(a, (c) => c.horizontalAlignment = this.agd);
            this.afu(a, (c) => c.angle = this.acd);
            this.afw(a);
        }
        afx(a) {
            if (a == null) {
                return;
            }
            if (this.l4 != null && a.fn == null) {
                a.provideRenderer(this.l4);
            }
            a.cu = this.shouldAvoidAxisAnnotationCollisions;
            a.cw = this.shouldAvoidAxisAnnotationCollisions;
            this.aft(a, (b) => b.angle = this.aco);
            this.aft(a, (b) => {
                if (b.extent != this.acn) {
                    b.extent = this.acn;
                }
            });
            this.aft(a, (b) => b.horizontalAlignment = this.age);
            this.aft(a, (b) => b.verticalAlignment = this.ahf);
            this.aft(a, (b) => b.visibility = this.ahk);
            this.aft(a, (b) => b.location = this.aax(this.aaz));
            this.afu(a, (b) => b.verticalAlignment = this.ahg);
            this.afu(a, (b) => b.angle = this.acy);
            a.jz = this.ag5;
            a.et = this.act;
            a.j0 = this.ag6;
            a.ew = this.acu;
            a.j2 = this.ag8;
            a.fi = this.acv;
            a.j1 = this.ag7;
            a.fj = this.acw;
            a.j3 = this.ag9;
            a.fk = this.acx;
            let b = a == this.aar();
            if (b) {
                a.g8 = this.afh;
            }
            a.gi = this.aet;
            a.ah = this.aan;
            this.afy(a);
        }
        ve() {
            super.ve();
            this.afv(this.aaq());
            this.afx(this.aar());
        }
        aft(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d7();
                a.az.bottomMargin = a.d8();
                a.az.leftMargin = a.d9();
                a.az.rightMargin = a.ea();
                a.az.topMargin = a.eb();
                a.az.horizontalAlignment = a.ju();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.ko();
            }
            b(a.az);
        }
        afu(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.ed();
                a.bf.leftMargin = a.ee();
                a.bf.rightMargin = a.ef();
                a.bf.topMargin = a.eg();
                a.bf.location = a.a1();
                a.bf.angle = a.ec();
                a.bf.horizontalAlignment = a.jv();
                a.bf.verticalAlignment = a.kp();
            }
            b(a.bf);
        }
        wd(a, b, c) {
            super.wd(a, b, c);
            switch (a) {
                case "AngleAxisLabelAngle":
                    this.af1((d) => d.angle = this.ab3);
                    break;
                case "ValueAxisLabelAngle":
                    this.af6((d) => d.angle = this.aco);
                    break;
                case "AngleAxisLabelHorizontalAlignment":
                    this.af1((d) => d.horizontalAlignment = this.agc);
                    break;
                case "ValueAxisLabelHorizontalAlignment":
                    this.af6((d) => d.horizontalAlignment = this.age);
                    break;
                case "AngleAxisLabelVerticalAlignment":
                    this.af1((d) => d.verticalAlignment = this.ahe);
                    break;
                case "ValueAxisLabelVerticalAlignment":
                    this.af6((d) => d.verticalAlignment = this.ahf);
                    break;
                case "AngleAxisLabelVisibility":
                    this.af1((d) => d.visibility = this.ahj);
                    break;
                case "ValueAxisLabelVisibility":
                    this.af6((d) => d.visibility = this.ahk);
                    break;
                case "AngleAxisLabel":
                    this.afz((d) => d.f2 = this.ac6);
                    break;
                case "ValueAxisLabel":
                    this.af4((d) => d.f2 = this.ac7);
                    break;
                case "AngleAxisLabelFormat":
                    this.afz((d) => d.gi = this.adn);
                    break;
                case "AngleAxisLabelFormatSpecifiers":
                    this.afz((d) => d.ah = this.aam);
                    break;
                case "ValueAxisLabelFormat":
                    this.af4((d) => d.gi = this.aet);
                    break;
                case "ValueAxisLabelFormatSpecifiers":
                    this.af4((d) => d.ah = this.aan);
                    break;
                case "AngleAxisTitleAngle":
                    this.af3((d) => d.angle = this.acd);
                    break;
                case "ValueAxisTitleAngle":
                    this.af8((d) => d.angle = this.acy);
                    break;
                case "AngleAxisTitleAlignment":
                    this.af3((d) => d.horizontalAlignment = this.agd);
                    break;
                case "ValueAxisTitleAlignment":
                    this.af8((d) => d.verticalAlignment = this.ahg);
                    break;
                case "AngleAxisTitle":
                    this.afz((d) => d.g8 = this.aeb);
                    break;
                case "ValueAxisTitle":
                    this.af5((d) => d.g8 = this.afh, false);
                    break;
                case "AngleAxisMajorStroke":
                    this.af0((d) => d.jz = this.agy, a);
                    break;
                case "ValueAxisMajorStroke":
                    this.af4((d) => d.jz = this.ag5);
                    break;
                case "AngleAxisMajorStrokeThickness":
                    this.af0((d) => d.et = this.ab8, a);
                    break;
                case "ValueAxisMajorStrokeThickness":
                    this.af4((d) => d.et = this.act);
                    break;
                case "AngleAxisMinorStroke":
                    this.afz((d) => d.j0 = this.agz);
                    break;
                case "ValueAxisMinorStroke":
                    this.af4((d) => d.j0 = this.ag6);
                    break;
                case "AngleAxisMinorStrokeThickness":
                    this.afz((d) => d.ew = this.ab9);
                    break;
                case "ValueAxisMinorStrokeThickness":
                    this.af4((d) => d.ew = this.acu);
                    break;
                case "AngleAxisTickLength":
                    this.afz((d) => d.fj = this.acb);
                    break;
                case "ValueAxisTickLength":
                    this.af4((d) => d.fj = this.acw);
                    break;
                case "AngleAxisTickStroke":
                    this.afz((d) => d.j3 = this.ag2);
                    break;
                case "ValueAxisTickStroke":
                    this.af4((d) => d.j3 = this.ag9);
                    break;
                case "AngleAxisTickStrokeThickness":
                    this.afz((d) => d.fk = this.acc);
                    break;
                case "ValueAxisTickStrokeThickness":
                    this.af4((d) => d.fk = this.acx);
                    break;
                case "AngleAxisStroke":
                    this.afz((d) => d.j2 = this.ag1);
                    break;
                case "ValueAxisStroke":
                    this.af4((d) => d.j2 = this.ag8);
                    break;
                case "AngleAxisStrokeThickness":
                    this.afz((d) => d.fi = this.aca);
                    break;
                case "ValueAxisStrokeThickness":
                    this.af4((d) => d.fi = this.acv);
                    break;
                case "AngleAxisExtent":
                    this.af1((d) => d.extent = this.ab2);
                    break;
                case "ValueAxisExtent":
                    this.af6((d) => d.extent = this.acn);
                    break;
                case "AngleAxisStrip":
                    this.afz((d) => d.j1 = this.ag0);
                    break;
                case "ValueAxisStrip":
                    this.af4((d) => d.j1 = this.ag7);
                    break;
                case "AngleAxisInverted":
                    this.afz((d) => d.ch = this.aa2);
                    break;
                case "ValueAxisInverted":
                    this.af4((d) => d.ch = this.aa3);
                    break;
                case "ValueAxisLabelLocation":
                    this.af7();
                    break;
                case "AngleAxisLabelLocation":
                    this.af2();
                    break;
            }
        }
        af7() {
            let a = this.aax(this.aaz);
            if (a == 2 || a == 7) {
                this.age = 2;
            }
            else {
                this.age = 0;
            }
            this.af6((b) => b.location = a);
        }
        af2() {
            let a = this.aaw(this.aap);
            if (a == 1 || a == 5) {
                this.ahe = 0;
            }
            else {
                this.ahe = 2;
            }
            this.af1((b) => b.location = a);
        }
        aax(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.cb == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        aaw(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get ac6() {
            return this.ac4;
        }
        set ac6(a) {
            let b = this.ac6;
            if (a != b) {
                this.ac4 = a;
                this.wd("AngleAxisLabel", b, this.ac6);
            }
        }
        get ac7() {
            return this.ac5;
        }
        set ac7(a) {
            let b = this.ac7;
            if (a != b) {
                this.ac5 = a;
                this.wd("ValueAxisLabel", b, this.ac7);
            }
        }
        get agy() {
            return this.agi;
        }
        set agy(a) {
            let b = this.agy;
            if (a != b) {
                this.agi = a;
                this.wd("AngleAxisMajorStroke", b, this.agy);
            }
        }
        get ag5() {
            return this.agp;
        }
        set ag5(a) {
            let b = this.ag5;
            if (a != b) {
                this.agp = a;
                this.wd("ValueAxisMajorStroke", b, this.ag5);
            }
        }
        get ab8() {
            return this.aba;
        }
        set ab8(a) {
            let b = this.ab8;
            if (a != b) {
                this.aba = a;
                this.wd("AngleAxisMajorStrokeThickness", b, this.ab8);
            }
        }
        get act() {
            return this.abr;
        }
        set act(a) {
            let b = this.act;
            if (a != b) {
                this.abr = a;
                this.wd("ValueAxisMajorStrokeThickness", b, this.act);
            }
        }
        get ab9() {
            return this.abb;
        }
        set ab9(a) {
            let b = this.ab9;
            if (a != b) {
                this.abb = a;
                this.wd("AngleAxisMinorStrokeThickness", b, this.ab9);
            }
        }
        get acu() {
            return this.abs;
        }
        set acu(a) {
            let b = this.acu;
            if (a != b) {
                this.abs = a;
                this.wd("ValueAxisMinorStrokeThickness", b, this.acu);
            }
        }
        get ag0() {
            return this.agk;
        }
        set ag0(a) {
            let b = this.ag0;
            if (a != b) {
                this.agk = a;
                this.wd("AngleAxisStrip", b, this.ag0);
            }
        }
        get ag7() {
            return this.agr;
        }
        set ag7(a) {
            let b = this.ag7;
            if (a != b) {
                this.agr = a;
                this.wd("ValueAxisStrip", b, this.ag7);
            }
        }
        get ag1() {
            return this.agl;
        }
        set ag1(a) {
            let b = this.ag1;
            if (a != b) {
                this.agl = a;
                this.wd("AngleAxisStroke", b, this.ag1);
            }
        }
        get ag8() {
            return this.ags;
        }
        set ag8(a) {
            let b = this.ag8;
            if (a != b) {
                this.ags = a;
                this.wd("ValueAxisStroke", b, this.ag8);
            }
        }
        get aca() {
            return this.abc;
        }
        set aca(a) {
            let b = this.aca;
            if (a != b) {
                this.abc = a;
                this.wd("AngleAxisStrokeThickness", b, this.aca);
            }
        }
        get acv() {
            return this.abt;
        }
        set acv(a) {
            let b = this.acv;
            if (a != b) {
                this.abt = a;
                this.wd("ValueAxisStrokeThickness", b, this.acv);
            }
        }
        get acb() {
            return this.abd;
        }
        set acb(a) {
            let b = this.acb;
            if (a != b) {
                this.abd = a;
                this.wd("AngleAxisTickLength", b, this.acb);
            }
        }
        get acw() {
            return this.abu;
        }
        set acw(a) {
            let b = this.acw;
            if (a != b) {
                this.abu = a;
                this.wd("ValueAxisTickLength", b, this.acw);
            }
        }
        get ag2() {
            return this.agm;
        }
        set ag2(a) {
            let b = this.ag2;
            if (a != b) {
                this.agm = a;
                this.wd("AngleAxisTickStroke", b, this.ag2);
            }
        }
        get ag9() {
            return this.agt;
        }
        set ag9(a) {
            let b = this.ag9;
            if (a != b) {
                this.agt = a;
                this.wd("ValueAxisTickStroke", b, this.ag9);
            }
        }
        get acc() {
            return this.abe;
        }
        set acc(a) {
            let b = this.acc;
            if (a != b) {
                this.abe = a;
                this.wd("AngleAxisTickStrokeThickness", b, this.acc);
            }
        }
        get acx() {
            return this.abv;
        }
        set acx(a) {
            let b = this.acx;
            if (a != b) {
                this.abv = a;
                this.wd("ValueAxisTickStrokeThickness", b, this.acx);
            }
        }
        get aeb() {
            return this.ada;
        }
        set aeb(a) {
            let b = this.aeb;
            if (a != b) {
                this.ada = a;
                this.wd("AngleAxisTitle", b, this.aeb);
            }
        }
        get afh() {
            return this.ade;
        }
        set afh(a) {
            let b = this.afh;
            if (a != b) {
                this.ade = a;
                this.wd("ValueAxisTitle", b, this.afh);
            }
        }
        get agz() {
            return this.agj;
        }
        set agz(a) {
            let b = this.agz;
            if (a != b) {
                this.agj = a;
                this.wd("AngleAxisMinorStroke", b, this.agz);
            }
        }
        get ag6() {
            return this.agq;
        }
        set ag6(a) {
            let b = this.ag6;
            if (a != b) {
                this.agq = a;
                this.wd("ValueAxisMinorStroke", b, this.ag6);
            }
        }
        get ab3() {
            return this.aa5;
        }
        set ab3(a) {
            let b = this.ab3;
            if (a != b) {
                this.aa5 = a;
                this.wd("AngleAxisLabelAngle", b, this.ab3);
            }
        }
        get aco() {
            return this.abm;
        }
        set aco(a) {
            let b = this.aco;
            if (a != b) {
                this.abm = a;
                this.wd("ValueAxisLabelAngle", b, this.aco);
            }
        }
        get ab2() {
            return this.aa4;
        }
        set ab2(a) {
            let b = this.ab2;
            if (a != b) {
                this.aa4 = a;
                this.wd("AngleAxisExtent", b, this.ab2);
            }
        }
        get acn() {
            return this.abl;
        }
        set acn(a) {
            let b = this.acn;
            if (a != b) {
                this.abl = a;
                this.wd("ValueAxisExtent", b, this.acn);
            }
        }
        get acd() {
            return this.abf;
        }
        set acd(a) {
            let b = this.acd;
            if (a != b) {
                this.abf = a;
                this.wd("AngleAxisTitleAngle", b, this.acd);
            }
        }
        get acy() {
            return this.abw;
        }
        set acy(a) {
            let b = this.acy;
            if (a != b) {
                this.abw = a;
                this.wd("ValueAxisTitleAngle", b, this.acy);
            }
        }
        get aa2() {
            return this.aa0;
        }
        set aa2(a) {
            let b = this.aa2;
            if (a != b) {
                this.aa0 = a;
                this.wd("AngleAxisInverted", b, this.aa2);
            }
        }
        get aa3() {
            return this.aa1;
        }
        set aa3(a) {
            let b = this.aa3;
            if (a != b) {
                this.aa1 = a;
                this.wd("ValueAxisInverted", b, this.aa3);
            }
        }
        get agd() {
            return this.aga;
        }
        set agd(a) {
            let b = this.agd;
            if (a != b) {
                this.aga = a;
                this.wd("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agd));
            }
        }
        get ahg() {
            return this.ahd;
        }
        set ahg(a) {
            let b = this.ahg;
            if (a != b) {
                this.ahd = a;
                this.wd("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahg));
            }
        }
        get agc() {
            return this.af9;
        }
        set agc(a) {
            let b = this.agc;
            if (a != b) {
                this.af9 = a;
                this.wd("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agc));
            }
        }
        get_age() {
            return this.agb;
        }
        set_age(a) {
            let b = this.age;
            if (a != b) {
                this.agb = a;
                this.wd("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.age));
            }
        }
        get age() {
            return this.get_age();
        }
        set age(a) {
            this.set_age(a);
        }
        get ahe() {
            return this.ahb;
        }
        set ahe(a) {
            let b = this.ahe;
            if (a != b) {
                this.ahb = a;
                this.wd("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahe));
            }
        }
        get ahf() {
            return this.ahc;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.ahc = a;
                this.wd("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahf));
            }
        }
        get ahj() {
            return this.ahh;
        }
        set ahj(a) {
            let b = this.ahj;
            if (a != b) {
                this.ahh = a;
                this.wd("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahj));
            }
        }
        get ahk() {
            return this.ahi;
        }
        set ahk(a) {
            let b = this.ahk;
            if (a != b) {
                this.ahi = a;
                this.wd("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahk));
            }
        }
        get_aaz() {
            return this.aay;
        }
        set_aaz(a) {
            let b = this.aaz;
            if (a != b) {
                this.aay = a;
                this.wd("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.aaz));
            }
        }
        get aaz() {
            return this.get_aaz();
        }
        set aaz(a) {
            this.set_aaz(a);
        }
        get_aap() {
            return this.aao;
        }
        set_aap(a) {
            let b = this.aap;
            if (a != b) {
                this.aao = a;
                this.wd("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.aap));
            }
        }
        get aap() {
            return this.get_aap();
        }
        set aap(a) {
            this.set_aap(a);
        }
        get adn() {
            return this.ac8;
        }
        set adn(a) {
            let b = this.ac8;
            if (a != b) {
                this.ac8 = a;
                this.wd("AngleAxisLabelFormat", b, this.ac8);
            }
        }
        get aam() {
            return this.aak;
        }
        set aam(a) {
            let b = this.aak;
            if (a != b) {
                this.aak = a;
                this.wd("AngleAxisLabelFormatSpecifiers", b, this.aak);
            }
        }
        get aet() {
            return this.adc;
        }
        set aet(a) {
            let b = this.adc;
            if (a != b) {
                this.adc = a;
                this.wd("ValueAxisLabelFormat", b, this.adc);
            }
        }
        get aan() {
            return this.aal;
        }
        set aan(a) {
            let b = this.aal;
            if (a != b) {
                this.aal = a;
                this.wd("ValueAxisLabelFormatSpecifiers", b, this.aal);
            }
        }
    }
    RadialBaseChart.$t = /*@__PURE__*/ markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
})();
