/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { DependencyProperty } from "igniteui-react-core";
import { enumGetBox, Point_$type, runOn, typeCast, markType, markDep, fromEnum } from "igniteui-react-core";
import { LegendEmptyValuesMode_$type } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { ScalerParams } from "./ScalerParams";
import { PathGeometry } from "igniteui-react-core";
import { ViewportUtils } from "./ViewportUtils";
import { SliceCoords } from "./SliceCoords";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { ArcSegment } from "igniteui-react-core";
import { PieSliceCollisionGeometry } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { GeometryUtil } from "igniteui-react-core";
import { MathUtil } from "igniteui-react-core";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { DataContext } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { CollisionRect } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { intDivide, isNaN_ } from "igniteui-react-core";
import { AnchoredRadialSeriesView } from "./AnchoredRadialSeriesView";
/**
 * @hidden
 */
export let RadialPieSeries = /*@__PURE__*/ (() => {
    class RadialPieSeries extends AnchoredRadialSeries {
        bk() {
            return new RadialPieSeries();
        }
        get_fo() {
            return true;
        }
        get_fm() {
            return true;
        }
        jl() {
            if (!isNaN_(this.jk)) {
                return super.jl();
            }
            return Defaults.h;
        }
        ct() {
            return new RadialPieSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.adu = a;
        }
        constructor() {
            super();
            this.adv = null;
            this.ad0 = null;
            this.ads = 0;
            this.ab = RadialPieSeries.$;
        }
        get adw() {
            return this.adv;
        }
        set adw(a) {
            if (this.adv != a) {
                let b = this.adw;
                this.adv = a;
                this.raisePropertyChanged("LegendLabelColumn", b, this.adw);
            }
        }
        get ad3() {
            return this.ad0;
        }
        set ad3(a) {
            if (this.ad0 != a) {
                let b = this.ad0;
                this.ad0 = a;
                this.raisePropertyChanged("LegendLabelMemberPath", b, this.ad0);
            }
        }
        get adt() {
            return this.ads;
        }
        set adt(a) {
            if (this.ads != a) {
                let b = this.ads;
                this.ads = a;
                this.raisePropertyChanged("LegendEmptyValuesMode", enumGetBox(LegendEmptyValuesMode_$type, b), enumGetBox(LegendEmptyValuesMode_$type, this.ads));
            }
        }
        preferredCategoryMode(a) {
            return a != null && a == this.y4 ? 2 : 0;
        }
        o7(a, b) {
            super.o7(a, b);
            let c = b;
            if (a && c.dj != null) {
                c.dj.count = 0;
            }
        }
        ix() {
            return this.y4.k8(this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
        }
        ar(a, b) {
            let c = new List$1(Rect.$, 0);
            let d = this.cw.ca;
            let e = this.cw.b9;
            let f = this.getEffectiveViewport1(this.cw);
            let g = this.wo(this.cw);
            let h = this.za.k5(e, d, f, g);
            let i = { $type: Point_$type, x: 0.5, y: 0.5 };
            let j = this.za;
            let k = Math.max(0, 0.5 * j.n6);
            let l = k;
            l = Math.max(l, h.minLength);
            let m = this.y4.k8(d, e, f);
            let n = this.y4 != null && this.y4.cl;
            let o = this.zd;
            if (this.d4()) {
                o = this.zg;
            }
            {
                if (n) {
                    m = this.z3(a, d, e, f);
                }
                if (b < 0 || b > o.h.count - 1) {
                    return null;
                }
                let p = o.h._inner[b][0];
                let q = Math.min(o.h._inner[b][2], h.maxLength);
                return this.adx(d, e, f, p - (m * 0.5), p + (m * 0.5), l, q, i);
            }
        }
        get_ef() {
            return true;
        }
        get_acj() {
            return true;
        }
        get_acd() {
            return true;
        }
        abf(a, b) {
            super.abf(a, b);
            let c = b;
            let d = b.ca;
            let e = b.b9;
            let f = this.getEffectiveViewport1(b);
            let g = this.wo(b);
            let h = this.za.k5(e, d, f, g);
            let i = a.h;
            let j = this.za;
            let k = Math.max(0, 0.5 * j.n6);
            let l = k;
            l = Math.max(l, h.minLength);
            let m = this.y4.k8(d, e, f);
            let n = this.y4.cl;
            let o = { $type: Point_$type, x: 0.5, y: 0.5 };
            let p = this.ady;
            let q = this.adz;
            let r = (p > 0 && q > 0);
            let s = this.acb.count;
            this.zj.a2(this, this.z0(), runOn(this, this.ys), this.z9(b), this.aaa(b));
            this.zj.r = this.ady;
            this.zj.s = this.adz;
            this.zj.k = this.ady;
            this.zj.l = this.adz;
            let t = false;
            let u = this.zj.b;
            if (u != null) {
                t = true;
            }
            let v = this.y4;
            let w = new ScalerParams(1, b.ca, b.b9, v.ch);
            w.c = this.getEffectiveViewport();
            let x = 0;
            let y = 0;
            for (let z = 0; z < i.count; ++z) {
                let aa = i._inner[z][0];
                let ab = Math.min(i._inner[z][2], h.maxLength);
                let ac = i._inner[z][1];
                let ad = i._inner[z][2];
                let ae = i._inner[z][3];
                if (t) {
                    this.ac8(i, z, s, v, w, b.t);
                }
                if (n) {
                    if (isNaN_(aa) || isNaN_(ac) || isNaN_(ad)) {
                        continue;
                    }
                    let af = (b.da.c + z) * b.da.b;
                    if ((b.da.c + z) * b.da.b > this.y4.lk - 1) {
                        if ((af) * b.da.b >= this.y4.lj) {
                            af = (af) - (intDivide((this.y4.lj), b.da.b));
                        }
                    }
                    m = ae;
                    if (isNaN_(m)) {
                        continue;
                    }
                }
                let ag = c.dj.item(x);
                x++;
                let ah = this.zj.k;
                let ai = this.zj.l;
                r = (ah > 0 && ai > 0);
                let aj = null;
                if (r) {
                    aj = this.ad9(d, e, f, aa - (m * 0.5), aa + (m * 0.5), l, ab, o, ah, ai);
                }
                else {
                    aj = this.aea(d, e, f, aa - (m * 0.5), aa + (m * 0.5), l, ab, o);
                }
                ag.an = aj;
                this.zj.ad(ag, false, false, false, false);
                let ak = i._inner[z][2];
                if (ak > y) {
                    y = ak;
                }
            }
            c.dc = ViewportUtils.f(y, d, e);
            c.dd = { $type: Point_$type, x: ViewportUtils.e(o.x, d, e, f), y: ViewportUtils.i(o.y, d, e, f) };
            c.dj.count = x;
            c.dp();
        }
        aea(a, b, c, d, e, f, g, h) {
            let i = SliceCoords.b(a, b, c, d, e, f, g, h);
            let j = new PathFigure();
            j._startPoint = i.d;
            j._isClosed = true;
            j._segments.add(((() => {
                let $ret = new LineSegment(1);
                $ret.c = i.f;
                return $ret;
            })()));
            j._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = i.h;
                $ret.f = i.n;
                $ret.d = 1;
                $ret.b = i.c;
                return $ret;
            })()));
            j._segments.add(((() => {
                let $ret = new LineSegment(1);
                $ret.c = i.j;
                return $ret;
            })()));
            j._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = i.d;
                $ret.f = i.m;
                $ret.d = 0;
                $ret.b = i.c;
                return $ret;
            })()));
            let k = new PathGeometry();
            k.c.add(j);
            return k;
        }
        adx(a, b, c, d, e, f, g, h) {
            let i = SliceCoords.b(a, b, c, d, e, f, g, h);
            if (isNaN_(i.n.width) || isNaN_(d) || isNaN_(e)) {
                return null;
            }
            let j = ViewportUtils.e(0.5, a, b, c);
            let k = ViewportUtils.i(0.5, a, b, c);
            return new PieSliceCollisionGeometry(j, k, i.n.width, i.m.width, d, e);
        }
        ad9(a, b, c, d, e, f, g, h, i, j) {
            let k = SliceCoords.a(a, b, c, d, e, f, g, h, i, j);
            if (k == null) {
                return this.aea(a, b, c, d, e, f, g, h);
            }
            let l = new PathFigure();
            l._startPoint = k.d;
            l._isClosed = true;
            let m = ((d + ((e - d) * 0.5)) * 180 / Math.PI) + 90;
            let n = new Size(1, k.l.width * (f / g), k.l.height * (f / g));
            l._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = k.e;
                $ret.f = n;
                $ret.c = m;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new LineSegment(1);
                $ret.c = k.f;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = k.g;
                $ret.f = k.l;
                $ret.c = m;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = k.h;
                $ret.f = k.n;
                $ret.d = 1;
                $ret.b = k.c;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = k.i;
                $ret.f = k.l;
                $ret.c = m;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new LineSegment(1);
                $ret.c = k.j;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = k.k;
                $ret.f = n;
                $ret.c = m;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            l._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.e = k.d;
                $ret.f = k.m;
                $ret.d = 0;
                $ret.b = k.c;
                return $ret;
            })()));
            let o = new PathGeometry();
            o.c.add(l);
            return o;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case RadialPieSeries.$$p[0]:
                case RadialPieSeries.$$p[1]:
                    this.q5();
                    break;
                case "FastItemsSource":
                    if (c != null) {
                        if (this.adw != null) {
                            c.deregisterColumn(this.adw);
                        }
                    }
                    if (d != null) {
                        if (this.ad3 != null) {
                            this.adw = this.dn(this.ad3);
                        }
                    }
                    break;
                case "LegendLabelMemberPath":
                    if (this.dp != null) {
                        this.dp.deregisterColumn(this.adw);
                        this.adw = this.dn(this.ad3);
                        this.pg();
                        this.pv();
                    }
                    break;
            }
        }
        ws(a) {
            let b = this.adu.ca;
            let c = this.adu.b9;
            let d = this.getEffectiveViewport1(this.adu);
            let e = this.wo(this.adu);
            let f = this.za.k5(c, b, d, e);
            let g = { $type: Point_$type, x: 0.5, y: 0.5 };
            let h = GeometryUtil.j(g, a);
            let i = this.zd.h;
            let j = 0;
            for (let k = 0; k < i.count; k++) {
                let l = i._inner[k][0];
                let m = Math.min(i._inner[k][2], f.maxLength);
                let n = i._inner[k][3];
                if (isNaN_(n)) {
                    continue;
                }
                l = l % 6.28318531;
                if (l < 0) {
                    l += 6.28318531;
                }
                if (h >= l - (n * 0.5) && h <= l + (n * 0.5)) {
                    let o = Math.max(0, 0.5 * this.za.n6);
                    let p = o;
                    p = Math.max(p, f.minLength);
                    let q = SliceCoords.b(b, c, d, l - (n * 0.5), l + (n * 0.5), p, m, g);
                    let r = GeometryUtil.u({ $type: Point_$type, x: ViewportUtils.e(g.x, b, c, d), y: ViewportUtils.i(g.y, b, c, d) }, MathUtil.f(l), q.n.width);
                    let s = 1.7976931348623157E+308;
                    let t = 1.7976931348623157E+308;
                    let u = -1.7976931348623157E+308;
                    let v = -1.7976931348623157E+308;
                    s = Math.min(s, q.d.x);
                    s = Math.min(s, q.f.x);
                    s = Math.min(s, q.h.x);
                    s = Math.min(s, q.j.x);
                    s = Math.min(s, r.x);
                    t = Math.min(t, q.d.y);
                    t = Math.min(t, q.f.y);
                    t = Math.min(t, q.h.y);
                    t = Math.min(t, q.j.y);
                    t = Math.min(t, r.y);
                    u = Math.max(u, q.d.x);
                    u = Math.max(u, q.f.x);
                    u = Math.max(u, q.h.x);
                    u = Math.max(u, q.j.x);
                    u = Math.max(u, r.x);
                    v = Math.max(v, q.d.y);
                    v = Math.max(v, q.f.y);
                    v = Math.max(v, q.h.y);
                    v = Math.max(v, q.j.y);
                    v = Math.max(v, r.y);
                    return new Rect(0, s, t, u - s, v - t);
                }
                j++;
            }
            return new Rect(0, 0, 0, 0, 0);
        }
        kv(a) {
            if (this.y4 != null && this.y4.cl && a == this.y4.othersIndex) {
                return null;
            }
            if (this.adw != null) {
                return this.adw.item(a);
            }
            return null;
        }
        ed(a, b, c, d, e) {
            if (super.ed(a, b, c, d, e)) {
                let f = typeCast(ProportionalCategoryAngleAxis.$, this.y4) !== null && this.y4.hasOthersCategory;
                if (e && (this.adt == 1 || (this.adt == 2 && !f))) {
                    let g = this.y4;
                    let h = new ScalerParams(1, this.dc.wh, this.wx, g.ch);
                    h.c = this.getEffectiveViewport1(this.cw);
                    let i = this.za;
                    let j = new ScalerParams(1, this.dc.wh, this.wx, i.ch);
                    j.c = this.getEffectiveViewport1(this.cw);
                    let k = this.z8;
                    for (let l = 0; l < this.dp.count; l++) {
                        let m = this.dp.item(l);
                        let n = NaN;
                        if (m != null) {
                            n = this.jd(m);
                        }
                        if (n == 0) {
                            let o = new SeriesPointOfInterest();
                            o.f = this.aa8(n, m, l, d, k, c, b, false);
                            o.b = ((() => {
                                let $ret = new DataContext();
                                $ret.item = m;
                                $ret.series = this;
                                return $ret;
                            })());
                            o.g = this.vl;
                            o.c = l;
                            if (this.ha) {
                                o.g = this.vs(l);
                            }
                            let p = false;
                            for (let q = 0; q < a.count; q++) {
                                if (o.c < a._inner[q].c) {
                                    a.insert(q, o);
                                    p = true;
                                    break;
                                }
                            }
                            if (!p) {
                                a.add(o);
                            }
                        }
                    }
                }
                return true;
            }
            return false;
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.p6(a, c, b);
            return c.toArray();
        }
        p6(a, b, c) {
            if (this.y5 == 0) {
                super.p6(a, b, c);
                return;
            }
            let d = this.cw.ca;
            let e = this.cw.b9;
            let f = this.getEffectiveViewport1(this.cw);
            let g = this.dc.wp(this.wx, this.getEffectiveViewport(), d);
            let h = this.za.k5(e, d, f, g);
            let i = { $type: Point_$type, x: 0.5, y: 0.5 };
            let j = this.za;
            let k = Math.max(0, 0.5 * j.n6);
            let l = k;
            l = Math.max(l, h.minLength);
            let m = this.y4.k8(d, e, f);
            let n = this.y4 != null && this.y4.cl;
            let o = new CollisionRect(0, this.dc.wm(a));
            for (let p = 0; p < this.y4.lk; p++) {
                let q = typeCast(RadialBaseView.$, this.cw);
                let r = q.da.getBucket(p);
                let s = this.acm(this.y4, d, e, f);
                if (n) {
                    m = this.z3(p, d, e, f);
                    s = this.acl(p, this.y4, d, e, f);
                    if (isNaN_(s)) {
                        s = 0;
                    }
                }
                r[0] = this.y4.getScaledAngle(r[0]) + s;
                let t = r[0];
                let u = Math.min(this.zb.b.od(r[2]), h.maxLength);
                let v = this.adx(d, e, f, t - (m * 0.5), t + (m * 0.5), l, u, i);
                if (v.collidesWithHeavy(o)) {
                    if (c == 7 || c == 6) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.series = this;
                            return $ret;
                        })()));
                        return;
                    }
                    if (c == 2 || c == 1) {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.item = this.dp.item(p);
                            return $ret;
                        })()));
                    }
                    else {
                        b.add(((() => {
                            let $ret = new ChartSelection();
                            $ret.item = this.dp.item(p);
                            $ret.series = this;
                            return $ret;
                        })()));
                    }
                }
            }
        }
    }
    RadialPieSeries.$t = /*@__PURE__*/ markType(RadialPieSeries, 'RadialPieSeries', AnchoredRadialSeries.$);
    RadialPieSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, RadialPieSeries, 'raisePropertyChanged', ['RadiusX:ady:ad7', [1, 2], 'RadiusY:adz:ad8', [1, 2]]);
    return RadialPieSeries;
})();
/**
 * @hidden
 */
export let RadialPieSeriesView = /*@__PURE__*/ (() => {
    class RadialPieSeriesView extends AnchoredRadialSeriesView {
        constructor(a) {
            super(a);
            this.di = null;
            this.dj = null;
            this.dk = null;
            this.dq = new Path();
            this.di = a;
            this.dj = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.dr);
                $ret.activate = runOn(this, this.dl);
                $ret.disactivate = runOn(this, this.dn);
                $ret.destroy = runOn(this, this.dm);
                return $ret;
            })());
        }
        a4() {
            super.a4();
            this.dk = new List$1(Path.$, 0);
            if (!this.t) {
                this.c9.xf = Defaults.c;
                this.c9.jq = Defaults.i;
            }
        }
        dr() {
            let a = ((() => {
                let $ret = new Path();
                $ret.dataContext = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this.f;
                    return $ret;
                })());
                return $ret;
            })());
            this.dk.add(a);
            a._visibility = 1;
            return a;
        }
        dl(a) {
            a._visibility = 0;
        }
        dn(a) {
            a._visibility = 1;
        }
        dm(a) {
            this.dk.remove(a);
        }
        bs(a, b) {
            super.bs(a, b);
            let c = a;
        }
        ak(a) {
            return this.dk._inner[a];
        }
        aj(a) {
            let b = this.dk._inner[a];
            this.dq._visibility = b._visibility;
            this.dq.an = b.an;
            let c = this.b4(a);
            this.dq._fill = c;
            this.dq._stroke = c;
            this.dq.ad = this.f.ig;
            return this.dq;
        }
        bj(a, b) {
            super.bj(a, b);
            if (a.d) {
                for (let c = 0; c < this.dk.count; c++) {
                    let d = this.ai(c, b);
                    a.t(d);
                }
            }
        }
        dp() {
            this.a2();
        }
        ax(a) {
            super.ax(a);
            let b = 0;
            for (let c of fromEnum(this.dj.a)) {
                this.f.bc.exportPathData(a, c, "slice" + b, ["Main", "Fill"]);
                b++;
            }
        }
    }
    RadialPieSeriesView.$t = /*@__PURE__*/ markType(RadialPieSeriesView, 'RadialPieSeriesView', AnchoredRadialSeriesView.$);
    return RadialPieSeriesView;
})();
