/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { ValueOverlay } from "./ValueOverlay";
import { Base, enumGetBox, typeCast, fromEnum, markType, markDep } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { DoubleCollection } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let TrendLineLayer = /*@__PURE__*/ (() => {
    class TrendLineLayer extends AnnotationLayer {
        bk() {
            return new ValueOverlay();
        }
        constructor() {
            super();
            this.aat = null;
            this.aau = null;
            this.ab = TrendLineLayer.$;
        }
        ac() {
            super.ac();
        }
        ct() {
            return new TrendLineLayerView(this);
        }
        q3(a) {
            super.q3(a);
            this.aac = a;
        }
        get_eu() {
            return true;
        }
        get_fl() {
            return true;
        }
        get_isUsableInLegend() {
            return this.xq && this.aaa != null;
        }
        yw(a, b) {
            if (this.aaa == null || this.aaa == a) {
                if (!this.a1.c) {
                    this.ru(b);
                }
            }
        }
        xn(a) {
            if (a == null) {
                return false;
            }
            if (a == this) {
                return false;
            }
            if (a.dc != this.dc) {
                return false;
            }
            if (a.eu || a.isStacked) {
                return false;
            }
            return true;
        }
        rw(a, b) {
            super.rw(a, b);
            if (this.aaa != null && this.aaa.cv == null) {
                this.aaa.rx();
            }
            this.cw.be(b);
            let c = typeCast(TrendLineLayerView.$, this.cv);
            if (this.aaa != null && c.cp) {
                this.aaa.rx();
                c.cp = false;
            }
        }
        rt(a, b, c, d, e) {
            super.rt(a, b, c, d, e);
            let f = typeCast(TrendLineLayerView.$, this.cv);
            if (this.aaa != null) {
                this.aaa.rt(a, b, c, d, e);
            }
            this.cw.bd(c);
        }
        yx(a) {
            super.yx(a);
            if (this.aaa == null) {
                this.aan();
            }
            else {
                if (a.oldItems != null && a.oldItems.contains(this.aaa)) {
                    this.aaa = null;
                }
            }
        }
        aag() {
            switch (this.aad) {
                case 3: return "TrendLineLayer_CubicFit";
                case 12: return "TrendLineLayer_CumulativeAverage";
                case 10: return "TrendLineLayer_ExponentialAverage";
                case 7: return "TrendLineLayer_ExponentialAverage";
                case 1: return "TrendLineLayer_LinearFit";
                case 6: return "TrendLineLayer_LogarithmicFit";
                case 11: return "TrendLineLayer_ModifiedAverage";
                case 8: return "TrendLineLayer_PowerLawFit";
                case 2: return "TrendLineLayer_QuadraticFit";
                case 4: return "TrendLineLayer_QuarticFit";
                case 5: return "TrendLineLayer_QuinticFit";
                case 9: return "TrendLineLayer_SimpleAverage";
                case 13: return "TrendLineLayer_WeightedAverage";
            }
            return null;
        }
        aan() {
            if (this.aab != null && this.xn(this.aab)) {
                this.aaa = this.aab;
                return;
            }
            if (this.aah != null && this.dc != null) {
                for (let a of fromEnum(this.dc.series)) {
                    if (!this.xn(a)) {
                        continue;
                    }
                    if (Base.equalsStatic(this.aah, a.name)) {
                        this.aaa = a;
                        break;
                    }
                }
            }
        }
        aak(a, b) {
            this.aac.ct(a, b);
            if (b != null) {
                b.ru(true);
            }
            this.oy(this.a5, this.a5);
        }
        aam() {
            if (this.aaa != null && this.aac.cn != null) {
                this.aac.cn.g$b = this.aad;
                this.aaa.ru(true);
            }
        }
        aal() {
            if (this.aaa != null && this.aac.cn != null) {
                this.aac.cn.g$f = this.aae;
                this.aaa.ru(true);
            }
        }
        sl() {
            super.sl();
            this.qn();
            this.y6();
        }
        y6() {
            super.y6();
            let a = this.ve;
            if (!this.xp) {
                if (this.aaa != null) {
                    a = this.vk != null ? this.vk : this.aaa.ve;
                    if (this.aat == null) {
                        this.aat = this.ve;
                    }
                }
                else {
                    if (this.aat != null) {
                        a = this.aat;
                    }
                }
            }
            switch (this.w3) {
                case 0:
                case 1:
                    a = this.aac.ck(a, this.xs);
                    break;
                case 2:
                    a = this.aac.cm(a, this.xs);
                    break;
                case 4:
                    a = this.aac.cl(a, this.xs);
                    break;
            }
            this.ve = a;
        }
        w7() {
            return 3;
        }
        xu() {
            return 0.3;
        }
        xx() {
            return -0.4;
        }
        xw() {
            return 0.5;
        }
        zy() {
            return this.w3 == 3 ? this.aav() : null;
        }
        aav() {
            if (this.aau == null) {
                this.aau = new DoubleCollection();
                this.aau.add(DeviceUtils.g(5));
                this.aau.add(DeviceUtils.g(5));
            }
            return this.aau;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.aan();
                    break;
                case "TrendLineType":
                    this.aam();
                    break;
                case "TrendLinePeriod":
                    this.aal();
                    break;
                case TrendLineLayer.$$p[0]:
                    this.aak(c, d);
                    this.y6();
                    this.aac.cs();
                    break;
                case TrendLineLayer.$$p[2]:
                case TrendLineLayer.$$p[1]:
                    this.aan();
                    break;
                case "ActualBrush":
                case "ActualThickness":
                case AnnotationLayer.$$p[1]:
                case "DashCap":
                    this.aac.cs();
                    break;
                case "UseItemWiseColors":
                    this.y6();
                    break;
            }
        }
        p1(a) {
            super.p1(a);
            this.aac.ax(a);
        }
    }
    TrendLineLayer.$t = /*@__PURE__*/ markType(TrendLineLayer, 'TrendLineLayer', AnnotationLayer.$);
    TrendLineLayer.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, TrendLineLayer, 'raisePropertyChanged', ['ActualTargetSeries:aaa:aao', [Series.$, null], 'TargetSeriesName:aah:aap', [2, null], 'TargetSeries:aab:aaq', [Series.$, null], 'TrendLineType:aad:aas', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLinePeriod:aae:aar', [1, 7]]);
    return TrendLineLayer;
})();
/**
 * @hidden
 */
export let TrendLineLayerView = /*@__PURE__*/ (() => {
    class TrendLineLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.cq = 0;
            this.co = null;
            this.cn = null;
            this.cp = false;
            this.co = a;
            this.cq = TrendLineLayerView.cr++;
        }
        cu() {
            if (this.cn == null && this.co.aaa != null) {
                if (this.t) {
                    let a = this.co.aaa.cv;
                    this.cn = a.e();
                    this.cp = true;
                }
                else if (this.s) {
                    let b = this.co.aaa.ba.a$j.item(this.al);
                    this.cn = b.e();
                }
                else {
                    let c = this.co.aaa.cw;
                    this.cn = c.e();
                }
                if (this.cn != null) {
                    this.cn.g$b = this.co.aad;
                    this.cn.g$f = this.co.aae;
                    this.cs();
                }
            }
        }
        bj(a, b) {
            super.bj(a, b);
            if (this.cn != null && a.d) {
                if (this.co.aad != 0 && !b) {
                    let c = this.cn.g$n;
                    c.ad = this.co.ig;
                    c._stroke = this.co.ve;
                    c.ai = this.co.zv;
                    c.aj = this.co.v8;
                    a.v(c);
                }
            }
        }
        ct(a, b) {
            if (a != null) {
                let c = null;
                if (this.t) {
                    c = a.cv;
                }
                else if (this.s) {
                    c = a.ba.a$j.item(this.al);
                }
                else {
                    c = a.cw;
                }
                if (this.cn != null) {
                    c.bf(this.cn);
                    this.cn = null;
                }
            }
            this.cu();
        }
        cs() {
            if (this.cn != null) {
                this.cn.g$n.ad = this.co.ig;
                this.cn.g$n._stroke = this.co.ve;
                this.cn.g$n.ai = this.co.zv;
                this.cn.g$n.aj = this.co.v8;
            }
        }
        ax(a) {
            super.ax(a);
            if (this.cn != null) {
                this.co.bc.exportTrendlineData(this.co, a, this.cn.g$n);
            }
        }
    }
    TrendLineLayerView.$t = /*@__PURE__*/ markType(TrendLineLayerView, 'TrendLineLayerView', AnnotationLayerView.$);
    TrendLineLayerView.cr = 0;
    return TrendLineLayerView;
})();
