import { IgrDataAnnotationPointLayer } from "./igr-data-annotation-point-layer";
import { DataAnnotationBandLayer } from "./DataAnnotationBandLayer";
/**
 * Represents an annotation layer that renders bands (line with breadth) at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
 * AnnotationBreadthMemberPath
*/
export class IgrDataAnnotationBandLayer extends IgrDataAnnotationPointLayer {
    createImplementation() {
        return new DataAnnotationBandLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets name of data column with breath/size of shape annotations.
    */
    get annotationBreadthMemberPath() {
        return this.i.aii;
    }
    set annotationBreadthMemberPath(v) {
        this.i.aii = v;
    }
}
