import { IgrDataAnnotationShapeLayer } from "./igr-data-annotation-shape-layer";
import { DataAnnotationSliceLayer } from "./DataAnnotationSliceLayer";
/**
 * Represents an annotation layer that renders vertical or horizontal slices/lines at values mapped to AnnotationValueMemberPath property
 * horizontal slices/lines when TargetAxis is set to Y-axis
 * vertical slices/lines when TargetAxis is set to X-axis
*/
export class IgrDataAnnotationSliceLayer extends IgrDataAnnotationShapeLayer {
    createImplementation() {
        return new DataAnnotationSliceLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets name of data column with values used to position annotations.
    */
    get annotationValueMemberPath() {
        return this.i.afr;
    }
    set annotationValueMemberPath(v) {
        this.i.afr = v;
    }
    /**
     * Gets or sets mapping custom label on axis annotations.
    */
    get annotationLabelMemberPath() {
        return this.i.afo;
    }
    set annotationLabelMemberPath(v) {
        this.i.afo = v;
    }
}
