/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, typeCast, Point_$type, runOn, delegateCombine, enumGetBox, fromEnum, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { FastItemCoalescingColumn } from "./FastItemCoalescingColumn";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { RadialBaseView } from "./RadialBaseView";
import { ChartSelection } from "./ChartSelection";
import { CollisionRect } from "igniteui-react-core";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.de.acb;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f, 0];
        }
        return [0.5 * (c + d), NaN, NaN, 0];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.ab6 = null;
        _this.acg = false;
        _this.aca = null;
        _this.adr = { $type: Point_$type, x: 0, y: 0 };
        _this.ab8 = null;
        _this.ab7 = null;
        _this.acc = false;
        _this.ab8 = new RadialFrame(3);
        _this.ab6 = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.ct = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.o4 = function () {
        _super.prototype.o4.call(this);
        this.y4 = null;
        this.za = null;
    };
    AnchoredRadialSeries.prototype.mg = function () {
        return AnchoredRadialSeries.$$p[4];
    };
    AnchoredRadialSeries.prototype.kr = function (a, b) {
        var c = this.nf(b);
        if (c == AnchoredRadialSeries.$$p[4]) {
            return this.ks(a, b, this.ac0);
        }
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.ks(a, b, this.acs);
        }
        return _super.prototype.kr.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.mf = function (a) {
        var b = this.nf(a);
        if (b == AnchoredRadialSeries.$$p[4]) {
            return this.ac0;
        }
        if (b == AnchoredRadialSeries.$$p[0]) {
            return this.acs;
        }
        return _super.prototype.mf.call(this, a);
    };
    AnchoredRadialSeries.prototype.jd = function (a) {
        if (this.y4.n6(a)) {
            return this.aac(this.acb.count - 1, this.acb.item(this.acb.count - 1));
        }
        return _super.prototype.jd.call(this, a);
    };
    AnchoredRadialSeries.prototype.ku = function (a) {
        if (this.y4 != null && this.y4.cl) {
            if (a == this.y4.othersIndex) {
                return this.y4.oj(true);
            }
        }
        return _super.prototype.ku.call(this, a);
    };
    AnchoredRadialSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.ab5 = a;
    };
    AnchoredRadialSeries.prototype.kb = function (a, b) {
        return this.kc(a, b, this.y4, null, this.acb);
    };
    AnchoredRadialSeries.prototype.j9 = function (a, b) {
        return this.ka(a, b, this.y4, null, this.acb);
    };
    AnchoredRadialSeries.prototype.iq = function (a, b, c, d, e) {
        if (this.acb == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ir(a, b, this.y4, d, e, this.acb.count, null);
    };
    AnchoredRadialSeries.prototype.i6 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.cw);
        var e = this.acm(this.y4, this.cw.ca, this.cw.b9, d);
        var f = new ScalerParams(0, this.cw.ca, this.cw.b9, this.y4.ch, d);
        f.c = this.dc.wz;
        var g = this.acb;
        if (this.acg && typeCast(FastItemCoalescingColumn.$, g) !== null) {
            g = new FastItemCoalescingColumn(this.y4, g.c, false);
        }
        return this.i8(g, a, this.y4, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.wh = function (a, b, c) {
        if (this.za == null || this.y4 == null || this.cw == null || this.cw.ca.isEmpty || this.cw.b9.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.cw);
        var e = new ScalerParams(0, this.cw.ca, this.cw.b9, this.za.ch, d);
        e.c = this.getEffectiveViewport1(this.cw);
        var f = this.i6(a, b, c);
        f = this.za.el(f, e);
        var g = this.zb.c(a, this.cw.ca, this.cw.b9, d);
        if (!b && this.y4 != null) {
            var h = this.kb(a, c);
            var i = this.j9(a, c);
            var j = this.acm(this.y4, this.cw.ca, this.cw.b9, d);
            var k = new ScalerParams(0, this.cw.ca, this.cw.b9, this.y4.ch, d);
            k.c = this.dc.wz;
            var l = this.iq(a, h, this.y4, k, j);
            var m = this.iq(a, i, this.y4, k, j);
            if (this.y4.cl) {
                if (m <= l) {
                    j = this.acl(i, this.y4, this.cw.ca, this.cw.b9, d);
                    if (isNaN_(j)) {
                        j = 0;
                    }
                    g = this.y4.el(i, k) + j;
                }
                else {
                    j = this.acl(h, this.y4, this.cw.ca, this.cw.b9, d);
                    if (isNaN_(j)) {
                        j = 0;
                    }
                    g = this.y4.el(h, k) + j;
                }
            }
            else {
                if (m <= l) {
                    g = this.y4.el(i, k) + j;
                }
                else {
                    g = this.y4.el(h, k) + j;
                }
            }
        }
        var n = this.zb.d(g, f, this.cw.ca, this.cw.b9, this.cw.getEffectiveViewport());
        var o = this.zb.e(g, f, this.cw.ca, this.cw.b9, this.cw.getEffectiveViewport());
        return { $type: Point_$type, x: n, y: o };
    };
    AnchoredRadialSeries.prototype.gc = function () {
        return this.highlightedItemsSource != null || this.acs != null;
    };
    AnchoredRadialSeries.prototype.hu = function () {
        var a = _super.prototype.hu.call(this);
        {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.ad = "ValueMemberPath";
                $ret.p = true;
                $ret.y = "HighlightedValueMemberPath";
                $ret.q = true;
                return $ret;
            })());
            b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.ac6));
            a.add(b);
        }
        return a;
    };
    AnchoredRadialSeries.prototype.ac6 = function (a, b) {
        if (this.acs != null) {
            b.value = this.acs;
            return;
        }
        b.value = this.ac0;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "acb", {
        get: function () {
            return this.aca;
        },
        set: function (a) {
            if (this.aca != a) {
                var b = this.aca;
                this.aca = a;
                this.raisePropertyChanged("ValueColumn", b, this.aca);
            }
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = new DataLegendSeriesValueInfo();
        c.a = 0;
        this.acg = true;
        c.l = this.i6({ $type: Point_$type, x: a, y: b }, false, false);
        this.acg = false;
        c.q = "Value";
        c.r = this.ac0 != null ? this.ac0 : "Value";
        c.s = this.acw != null ? this.acw : "V:";
        c.t = this.acy != null ? this.acy : "";
        var d = new DataLegendSeriesContext();
        d.e = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(c);
            return $ret;
        })());
        d.h = this.me();
        return d;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "adn", {
        get: function () {
            return this.c(AnchoredRadialSeries.ada);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.ada, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.ay = function (a) {
        if (a != null && a == this.y4 && this.acb != null && this.acb.count > 0) {
            return new AxisRange(0, this.acb.count - 1);
        }
        if (a != null && a == this.za && this.acb != null && this.acb.count > 0) {
            return new AxisRange(this.acb.minimum, this.acb.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.aac = function (a, b) {
        if (this.ack) {
            var c = this.acb.c;
            if (a < 0) {
                return _super.prototype.aac.call(this, a, b);
            }
            if (a > c.count - 1) {
                if (typeCast(ProportionalCategoryAngleAxis.$, this.y4) !== null) {
                    var d = this.acb;
                    return d.f;
                }
                return _super.prototype.aac.call(this, a, b);
            }
            return c.item(a);
        }
        else {
            return _super.prototype.aac.call(this, a, b);
        }
    };
    AnchoredRadialSeries.prototype.dl = function (a) {
        var b = _super.prototype.dl.call(this, a);
        this.acc = false;
        if (this.y4 != null && this.y4.cl) {
            this.acc = true;
            b = new FastItemCoalescingColumn(this.y4, b, this.ack);
        }
        return b;
    };
    AnchoredRadialSeries.prototype.ac4 = function (a, b) {
        if (this.acc) {
            var c = b;
            var d = c.c;
            a.deregisterColumn(d);
        }
        else {
            a.deregisterColumn(b);
        }
    };
    AnchoredRadialSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        if (this.ab5.df.g$e(a, b, c, d)) {
            this.ru(false);
            this.qn();
        }
        var e = typeCast(NumericAxisBase.$, this.za);
        switch (b) {
            case AnchoredRadialSeries.$$p[2]:
            case AnchoredRadialSeries.$$p[3]:
                this.qh();
                break;
            case AnchoredRadialSeries.$$p[1]:
            case RadialBase.$$p[0]:
                if (this.acb != null) {
                    this.ac4(this.dp, this.acb);
                    this.acb = this.dl(this.ac0);
                }
                break;
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    this.ac4(c, this.acb);
                    this.acb = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.acb = this.dl(this.ac0);
                    this.ab5.da.e(this.ie);
                }
                if (e != null && !e.c1()) {
                    this.ab5.da.e(this.ie);
                    this.ru(this.gh && c != null);
                }
                break;
            case AnchoredRadialSeries.$$p[4]:
                if (this.dp != null) {
                    this.ac4(this.dp, this.acb);
                    this.acb = this.dl(this.ac0);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.c1()) {
                    this.ab5.da.e(this.ie);
                    this.ru(this.gh && this.d9);
                }
                break;
            case "TrendLineBrush":
                this.ri(b);
                break;
            case "TrendLineType":
                this.qn();
                break;
        }
    };
    AnchoredRadialSeries.prototype.pd = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.pd.call(this, a, b, c, d);
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.ab5.da.e(this.ie);
                break;
        }
        this.ab5.df.g$i(a, b, c, d);
        if (this.ab5.aa.count > 0) {
            try {
                for (var _b = __values(fromEnum(this.ab5.aa)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    e.g$i(a, b, c, d);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        switch (a) {
            case 4:
                if (this.za != null && !this.za.c1()) {
                    this.ru(true);
                }
                break;
            case 1:
                if (this.za != null && !this.za.c1()) {
                    this.ru(true);
                }
                break;
            case 0:
                if (this.za != null && !this.za.c1()) {
                    this.ru(true);
                }
                break;
            case 2:
                if (this.ac0 != null && this.ab5.da.b > 0 && this.za != null && !this.za.c1()) {
                    this.ru(true);
                }
                break;
            case 3:
                if (d == this.ac0) {
                    if (this.za != null && !this.za.c1()) {
                        this.ru(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.hf = function (a, b, c) {
        var d = _super.prototype.hf.call(this, a, b, c);
        var e = c;
        if (this.dp == null || this.dp.count == 0 || this.y4 == null || this.acb == null || this.y4.lj == 0 || this.za == null || isInfinity(this.za.l4) || isInfinity(this.za.l3) || e.da.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.acm(this.y4, this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.y4.getCategorySize(this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
    };
    AnchoredRadialSeries.prototype.get_ach = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "ach", {
        get: function () {
            return this.get_ach();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.get_em = function () {
        return true;
    };
    AnchoredRadialSeries.prototype.get_f6 = function () {
        return this.za != null && this.za.ch;
    };
    AnchoredRadialSeries.prototype.acm = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.aab(), b, c, d);
                break;
        }
        if (a.ch) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.acl = function (a, b, c, d, e) {
        var f = 0;
        var g = this.preferredCategoryMode(b);
        if (g == 0 && b.categoryMode != 0) {
            g = 1;
        }
        switch (g) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * b.m7(a, c, d, e);
                break;
            case 2:
                f = b.m6(a, this.aab(), c, d, e);
                break;
        }
        if (b.ch) {
            f = -f;
        }
        return f;
    };
    AnchoredRadialSeries.prototype.ac5 = function (a, b, c, d) {
        var _this = this;
        if (d == 0) {
            this.p6(a, b, c);
            return;
        }
        var e = this.cw.ca;
        var f = this.cw.b9;
        var g = this.getEffectiveViewport1(this.cw);
        var h = this.dc.wp(this.wx, this.getEffectiveViewport(), e);
        var i = this.za.k5(f, e, g, h);
        var j = this.y4 != null && this.y4.cl;
        var k = new CollisionRect(0, this.dc.wm(a));
        var _loop_1 = function (l) {
            var m = typeCast(RadialBaseView.$, this_1.cw);
            var n = m.da.getBucket(l);
            var o = this_1.acm(this_1.y4, e, f, g);
            if (j) {
                o = this_1.acl(l, this_1.y4, e, f, g);
                if (isNaN_(o)) {
                    o = 0;
                }
            }
            n[0] = this_1.y4.getScaledAngle(n[0]) + o;
            var p = Math.min(this_1.zb.b.od(n[2]), i.maxLength);
            var q = this_1.zb.d(n[0], p, e, f, g);
            var r = this_1.zb.e(n[0], p, e, f, g);
            if (k.containsLocation(q, r)) {
                if (c == 7 || c == 6) {
                    b.add(((function () {
                        var $ret = new ChartSelection();
                        $ret.series = _this;
                        return $ret;
                    })()));
                    return { value: void 0 };
                }
                else if (c == 2 || c == 1) {
                    b.add(((function () {
                        var $ret = new ChartSelection();
                        $ret.item = _this.dp.item(l);
                        return $ret;
                    })()));
                }
                else {
                    b.add(((function () {
                        var $ret = new ChartSelection();
                        $ret.item = _this.dp.item(l);
                        $ret.series = _this;
                        return $ret;
                    })()));
                }
            }
        };
        var this_1 = this;
        for (var l = 0; l < this.dp.count; l++) {
            var state_1 = _loop_1(l);
            if (typeof state_1 === "object")
                return state_1.value;
        }
    };
    AnchoredRadialSeries.prototype.get_acj = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "acj", {
        get: function () {
            return this.get_acj();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.get_acd = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "acd", {
        get: function () {
            return this.get_acd();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.abc = function (a, b) {
        var _this = this;
        var c = b.ca;
        var d = b.b9;
        var e = this.getEffectiveViewport1(b);
        var f = this.y4;
        var g = this.za;
        var h = g.l4;
        var i = g.l3;
        a.h.clear();
        a.p.clear();
        a.s.clear();
        var j = this.xl();
        var k = 0;
        var l = b;
        var m = f.cl;
        var n = new CollisionAvoider();
        var o = 0;
        var p = 0;
        var q = b.da.d;
        o = this.acm(f, c, d, e);
        l.df.k = this.za.n7;
        l.df.j = this.za.n6;
        l.df.l = function (r, s) { return _this.acn(r, s, c, d, e); };
        l.df.m = function (r, s) { return _this.aco(r, s, c, d, e); };
        var r = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.s;
            return $ret;
        })());
        var s = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.e = b.da.b;
            $ret.f = b.da.c;
            $ret.g = q;
            $ret.a = o;
            $ret.d = _this.ie;
            $ret.i = d;
            $ret.h = e;
            $ret.j = c;
            return $ret;
        })());
        l.df.n(a.s, this.ab9, this.acb, this.acq, function (t) { return _this.y4.getScaledAngle(t); }, function (t) { return _this.za.od(t); }, s, r);
        a.f.clear();
        for (var t = 0; t < b.aa.count; t++) {
            a.f.add(new List$1(Point_$type, 0));
            var u = b.aa._inner[t];
            u.k = this.za.n7;
            u.j = this.za.n6;
            u.l = function (v, w) { return _this.acn(v, w, c, d, e); };
            u.m = function (v, w) { return _this.aco(v, w, c, d, e); };
            u.n(a.f._inner[t], u.g$b, this.acb, u.g$f, function (v) { return _this.y4.getScaledAngle(v); }, function (v) { return _this.za.od(v); }, s, r);
        }
        var v = true;
        if (this.aci(b)) {
            q--;
        }
        for (var w = b.da.c; w <= q; ++w) {
            var x = w;
            if (x * b.da.b >= this.y4.lj) {
                x -= intDivide((this.y4.lj), b.da.b);
            }
            var y = b.da.getBucket(x);
            p = 0;
            if (m) {
                p = this.z3(x, c, d, e);
            }
            y[3] = p;
            if (!isNaN_(y[0])) {
                var z = false;
                if (m) {
                    o = this.acl(x, f, c, d, e);
                    if (isNaN_(o)) {
                        o = 0;
                        z = true;
                    }
                }
                y[0] = f.getScaledAngle(y[0]) + o;
                if (y[1] < h || y[1] > i) {
                    if (this.acj) {
                        if (y[1] > i && this.acd) {
                        }
                        else {
                            z = true;
                        }
                    }
                    else {
                        if (y[1] > i && this.acd) {
                        }
                        else {
                            continue;
                        }
                    }
                }
                if (z) {
                    y[1] = NaN;
                    y[2] = NaN;
                }
                y[1] = g.od(y[1]);
                if (b.da.b > 1) {
                    if (y[2] < h || y[2] > i) {
                        continue;
                    }
                    y[2] = g.od(y[2]);
                }
                else {
                    y[2] = y[1];
                }
                if ((isNaN_(y[1]) || isNaN_(y[2])) && v && this.ach && this.acf()) {
                    q++;
                }
                else {
                    v = false;
                }
                a.h.add(y);
                if (j) {
                    var aa = Math.min(x * b.da.b, this.dp.count - 1);
                    var ab = false;
                    if (this.y4.cl) {
                        var ac = this.y4;
                        var ad = ac.hasOthersCategory && (x * b.da.b) == this.y4.lj - 1;
                        ab = ad;
                    }
                    var ae = this.zb.d(y[0], y[1], c, d, e);
                    var af = this.zb.e(y[0], y[1], c, d, e);
                    var ag = new Rect(0, ae - 5, af - 5, 11, 11);
                    if (!isNaN_(ae) && !isNaN_(af) && !isInfinity(ae) && !isInfinity(af) && n.tryAdd(ag)) {
                        a.p.add({ $type: Point_$type, x: y[0], y: y[1] });
                        var ah = b.db.item(k);
                        ah.al = x;
                        ah.ak = aa;
                        ah.content.item = this.dp.item(aa);
                        if (ab) {
                            ah.ak = this.dp.count;
                            var ai = this.y4;
                            ah.content.item = this.y4.oj(true);
                        }
                        ++k;
                    }
                }
            }
            else {
                if (v && this.ach && this.acf()) {
                    q++;
                }
            }
        }
        b.db.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.acn = function (a, b, c, d, e) {
        return this.zb.d(a, b, c, d, e);
    };
    AnchoredRadialSeries.prototype.aco = function (a, b, c, d, e) {
        return this.zb.e(a, b, c, d, e);
    };
    AnchoredRadialSeries.prototype.aci = function (a) {
        var b = a;
        return !this.ach && b.da.c == 0 && b.da.d == this.y4.lj;
    };
    AnchoredRadialSeries.prototype.ab4 = function (a, b, c) {
        var d = null;
        var e = c.ca;
        var f = c.b9;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.ac9 = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.ace()) {
                a.add(this.adr);
                a.add(a._inner[0]);
                d.add(this.adr);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.acf = function () {
        return !this.ace();
    };
    AnchoredRadialSeries.prototype.ace = function () {
        var a = this.cw.ca;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.o7 = function (a, b) {
        _super.prototype.o7.call(this, a, b);
        var c = b;
        if (a) {
            c.db.clear();
        }
        c.df.g$h();
    };
    AnchoredRadialSeries.prototype.abf = function (a, b) {
        this.qz();
        var c = b.ca;
        var d = b.b9;
        var e = this.getEffectiveViewport1(b);
        var f = this.wo(b);
        var g = b;
        g.df.g$k(a.s);
        for (var h = 0; h < b.aa.count; h++) {
            var i = b.aa._inner[h];
            i.g$k(a.f._inner[h]);
        }
        var j = new List$1(Point_$type, 0);
        for (var k = 0; k < a.p.count; k++) {
            var l = a.p._inner[k];
            var m = this.zb.d(l.x, l.y, c, d, e);
            var n = this.zb.e(l.x, l.y, c, d, e);
            var o = { $type: Point_$type, x: m, y: n };
            j.add(o);
        }
        CategoryMarkerManager.e(this, j, g.db, this.xn);
        this.ac3(b, a);
        g.c4();
        this.ac2(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.ab3 = function (a, b, c) {
        if (b < a || a < 0 || a > this.acb.count || b < 0 || b > this.acb.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cn;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.dp.item(g);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.ac7 = function (a, b, c, d, e, f) {
        var g = this.by != 1;
        var h = this.cq != 1;
        var i = this.cp != 1;
        var j = this.d3;
        this.zj.a3(this.zj.d, d.cn, a, b, c, d, e, f, true);
        this.zj.aa(this.ic);
        var k = this.zj.ax;
        var l = null;
        var m = null;
        var n = null;
        var o = this.dp;
        var p = null;
        var q = null;
        var r = null;
        if (j && this.dc != null && !k.e) {
            var s = this.vt(k.z);
            var t = this.vu(k.z);
            this.zj.ag = s;
            this.zj.ah = t;
            k.aa = s;
            k.ab = t;
        }
        if (g && this.dc != null) {
            l = this.dc.dk.getHighlightingInfo(this, o, k.z, k.y, true);
            if (this.dc.dk.isCrossContextHighlight(this)) {
                p = this.dc.dk.getHighlightingInfo(this, o, k.z, k.y, true);
            }
            k.c = l;
        }
        if (h && this.dc != null) {
            m = this.dc.dl.getHighlightingInfo(this, o, k.z, k.y, true);
            if (m == null && this.bo != null) {
                m = this.dc.dl.getHighlightingInfo(this.bo, this.bo.dp, k.z, k.y, true);
            }
            if (this.dc.dl.isCrossContextHighlight(this)) {
                q = this.dc.dl.getHighlightingInfo(this, o, k.z, k.y, true);
            }
            k.d = m;
        }
        if (i && this.dc != null) {
            n = this.dc.dj.getHighlightingInfo(this, o, k.z, k.y, true);
            if (this.dc.dj.isCrossContextHighlight(this)) {
                r = this.dc.dj.getHighlightingInfo(this, o, k.z, k.y, true);
            }
            k.b = n;
        }
        k.h = f;
        this.abd(k);
        this.zj.y(this, l, m, n, f, g, h, i, k.v, this.dc.dk.totalHighWaterMark, k.x, this.dc.dl.totalHighWaterMark, k.t, this.dc.dj.totalHighWaterMark);
    };
    AnchoredRadialSeries.prototype.ac8 = function (a, b, c, d, e, f) {
        var g = this.by != 1;
        var h = this.cq != 1;
        var i = this.cq != 1;
        var j = this.d3;
        this.zj.a3(this.zj.b, d.cn, a, b, c, d, e, f, false);
        this.zj.ab(this.ic);
        var k = this.zj.ay;
        var l = null;
        var m = null;
        var n = null;
        var o = this.dp;
        if (j && this.dc != null && !k.e) {
            var p = this.vs(k.z);
            var q = this.vv(k.z);
            this.zj.ag = p;
            this.zj.ah = q;
            k.aa = p;
            k.ab = q;
        }
        if (g && this.dc != null) {
            l = this.dc.dk.getHighlightingInfo(this, o, k.z, k.y, false);
            k.c = l;
        }
        if (h && this.dc != null) {
            m = this.dc.dl.getHighlightingInfo(this, o, k.z, k.y, false);
            if (m == null && this.bo != null) {
                m = this.dc.dl.getHighlightingInfo(this.bo, this.bo.dp, k.z, k.y, false);
            }
            k.d = m;
        }
        k.h = f;
        this.abe(k);
        this.zj.z(this, l, m, n, f, g, h, i, b < 0);
    };
    AnchoredRadialSeries.prototype.ac3 = function (a, b) {
        a.ck = true;
        this.zj.a1(this, this.zz(), runOn(this, this.ys), this.z9(a), this.aaa(a));
        var c = this.zj.d;
        var d = c != null;
        var e = this.y4;
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.ca, a.b9, e.ch, f);
        var h = this.dp == null ? 0 : this.dp.count;
        var i = a;
        var j = b.h;
        var k = i.da.c;
        var l = i.da.d;
        var m = i.da.b;
        var n = k * m;
        for (var o = 0; o < a.db.count; o++) {
            var p = a.db.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.ac7(j, r, h, e, g, a.t);
            }
            this.zj.ac(p, q);
        }
    };
    AnchoredRadialSeries.prototype.ac2 = function (a, b, c, d, e) {
        e.dg(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.sl = function () {
        _super.prototype.sl.call(this);
        if (this.index < 0) {
            return;
        }
        this.ab5.dh();
    };
    AnchoredRadialSeries.prototype.ky = function (a, b) {
        if (a == this.ab5.df.g$n) {
            return null;
        }
        return _super.prototype.ky.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.ge = function (a) {
        var b = this.cw.ca;
        b = b.copy();
        var c = this.cw.b9;
        var d = !b.isEmpty && !c.isEmpty && this.dp != null ? this.dp.indexOf(a) : -1;
        if (this.y4 == null || this.acb == null || this.za == null) {
            return false;
        }
        if (d < 0 || d > this.acb.count - 1) {
            return false;
        }
        var e = this.y4.getScaledAngle(d);
        var f = this.za.od(this.acb.item(d));
        if (isNaN_(f)) {
            f = (this.za.n6 + this.za.n7) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.c4 != null) {
            this.c4.au(this.dc, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.rw = function (a, b) {
        _super.prototype.rw.call(this, a, b);
        if (!this.g1) {
            this.cw.be(b);
            return;
        }
        this.cw.be(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.cv);
        c.da.e(this.ie);
        if (this.d7(this.cv)) {
            return;
        }
        this.rx();
        this.g1 = false;
    };
    AnchoredRadialSeries.prototype.rx = function () {
        _super.prototype.rx.call(this);
        var a = typeCast(AnchoredRadialSeriesView.$, this.cv);
        if (!this.gt) {
            this.ab8 = new RadialFrame(3);
            this.abc(this.ab8, a);
        }
        this.gt = false;
        this.abf(this.ab8, a);
    };
    AnchoredRadialSeries.prototype.rt = function (a, b, c, d, e) {
        _super.prototype.rt.call(this, a, b, c, d, e);
        var f = this.ba.a$j.item(d);
        var g = f;
        g.da.e(this.ie);
        f.bd(c);
        if (this.d7(g)) {
            return;
        }
        if (this.ab7 == null) {
            this.ab7 = new RadialFrame(3);
        }
        this.ab7.x();
        this.abc(this.ab7, g);
        this.abf(this.ab7, g);
    };
    AnchoredRadialSeries.prototype.p1 = function (a) {
        _super.prototype.p1.call(this, a);
        this.bc.exportTrendlineData(this, a, this.ab5.df.g$n);
    };
    AnchoredRadialSeries.prototype.bd = function () {
        return new RadialTrendLineManager();
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.ada = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['HighlightedValueMemberPath:acs:adb', [2, null], 'UseCategoryNormalizedValues:ack:adj', [0, false], 'ValueMemberAsLegendLabel:acw:adk', [2, null], 'ValueMemberAsLegendUnit:acy:adl', [2, null], 'ValueMemberPath:ac0:adm', [2, null], 'TrendLineType:ab9:adh', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:acp:adg', [1, 1.5], 'TrendLinePeriod:acq:adf', [1, 7], 'TrendLineZIndex:acr:adi', [1, 1], 'TrendLineBrush:ado:adc', [Brush.$, null], 'TrendLineDashArray:adp:add', [DoubleCollection.$], 'TrendLineDashCap:adq:ade', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.de = null;
        _this.df = null;
        _this.da = new AnchoredRadialBucketCalculator(_this);
        _this.de = a;
        _this.df = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.dg = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.dh = function () {
        this.de.adn = null;
        if (this.de.ado != null) {
            this.de.adn = this.de.ado;
        }
        else {
            this.de.adn = this.de.ve;
        }
    };
    AnchoredRadialSeriesView.prototype.bi = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.de.ab9 != 0 && !b) {
                var c = this.df.g$n;
                c.ad = this.de.acp;
                c._stroke = this.de.adn;
                c.ai = this.de.adp;
                c.aj = this.de.adq;
                a.v(c);
            }
        }
        _super.prototype.bi.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.de.y4.f2 != null) {
            a += "<span>${item." + this.de.y4.f2 + "}</span><br/>";
        }
        a += "<span";
        var b = this.f.ba.a$u(this.f);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.de.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.de.ac0 + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
