/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Describes mode for displaying content of axis annotation
 */
export var DataAnnotationDisplayMode = /*@__PURE__*/ (function (DataAnnotationDisplayMode) {
    /**
     * Indicates a mode that automatically selects content dsiaplyed on axis, based on type of data annotation layer
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["Auto"] = 0] = "Auto";
    /**
     * Displays data value in axis annotation that represents a value mapped via ValueMemberPath
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["DataValue"] = 1] = "DataValue";
    /**
     * Displays a label in axis annotation that represents a value mapped via LabelMemberPath
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["DataLabel"] = 2] = "DataLabel";
    /**
     * Displays axis value in axis annotation that is between axis minimum and maximum
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["AxisValue"] = 3] = "AxisValue";
    /**
     * Displays pixel value in axis annotation that is between start and end size of plot area
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["PixelValue"] = 4] = "PixelValue";
    /**
     * Displays window value in axis annotation in relative coordinates (0.0 - 1.0) to start and end size of plot area
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["WindowValue"] = 5] = "WindowValue";
    /**
     * Hides axis annotation
     */
    DataAnnotationDisplayMode[DataAnnotationDisplayMode["Hidden"] = 6] = "Hidden";
    return DataAnnotationDisplayMode;
})({});
/**
 * @hidden
 */
export var DataAnnotationDisplayMode_$type = /*@__PURE__*/ markEnum('DataAnnotationDisplayMode', 'Auto,0|DataValue,1|DataLabel,2|AxisValue,3|PixelValue,4|WindowValue,5|Hidden,6');
