/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Describes available axis modes for targeting by the data annotation layers
 */
export var DataAnnotationTargetMode = /*@__PURE__*/ (function (DataAnnotationTargetMode) {
    /**
     * Indicate default target mode that automatically targets Category-based Axes or NumericXAxis.
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["Auto"] = 0] = "Auto";
    /**
     * Indicate to target axes with data source such as CategoryX, CategoryY, CategoryDateTimeXAxis, TimeXAxis, OrdinalTimeXAxis.
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["DataSourceAxes"] = 1] = "DataSourceAxes";
    /**
     * Indicate to target all horizontal axes, e.g. CategoryX, NumericX
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["HorizontalAxes"] = 2] = "HorizontalAxes";
    /**
     * Indicate to target all vertical axes, e.g. CategoryY, NumericY
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["VerticalAxes"] = 3] = "VerticalAxes";
    /**
     * Indicate to target all category axes, e.g. CategoryX, CategoryY, CategoryDateTimeXAxis
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["CategoryAxes"] = 4] = "CategoryAxes";
    /**
     * Indicate to target all time axes, e.g. CategoryDateTimeXAxis, TimeXAxis, OrdinalTimeXAxis
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["TimeAxes"] = 5] = "TimeAxes";
    /**
     * Indicate to target all numeric x-axes, e.g. NumericX
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["NumericXAxes"] = 6] = "NumericXAxes";
    /**
     * Indicate to target all numeric y-axes, e.g. NumericY
     */
    DataAnnotationTargetMode[DataAnnotationTargetMode["NumericYAxes"] = 7] = "NumericYAxes";
    return DataAnnotationTargetMode;
})({});
/**
 * @hidden
 */
export var DataAnnotationTargetMode_$type = /*@__PURE__*/ markEnum('DataAnnotationTargetMode', 'Auto,0|DataSourceAxes,1|HorizontalAxes,2|VerticalAxes,3|CategoryAxes,4|TimeAxes,5|NumericXAxes,6|NumericYAxes,7');
