/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.ajd = null;
        _this.amb = null;
        _this.al9 = null;
        _this.al6 = null;
        _this.al8 = null;
        _this.ama = null;
        _this.al7 = null;
        _this.aij = null;
        _this.amt = null;
        _this.amu = null;
        _this.amq = null;
        _this.amv = null;
        _this.amw = null;
        _this.amr = null;
        _this.ams = null;
        _this.aj1 = null;
        _this.alb = 40;
        _this.ai7 = null;
        _this.ai5 = null;
        _this.ai9 = null;
        _this.aje = null;
        _this.am4 = null;
        _this.ajx = null;
        _this.akn = false;
        _this.akm = false;
        _this.aku = false;
        _this.aj9 = false;
        _this.amh = 10;
        _this.ali = NaN;
        _this.alk = NaN;
        _this.alj = NaN;
        _this.all = 0;
        _this.aip = 0;
        _this.ais = 0;
        _this.ald = 3;
        _this.alg = NaN;
        _this.ale = NaN;
        _this.alf = NaN;
        _this.alh = NaN;
        _this.aiu = 0;
        _this.aj4 = true;
        _this.ail = 0;
        _this.aj5 = false;
        _this.aiz = null;
        _this.ai1 = null;
        _this.akw = null;
        _this.aj7 = true;
        _this.aj6 = false;
        _this.aj8 = false;
        _this.ajy = null;
        _this.aiw = 1;
        _this.ahn = null;
        _this.aho = null;
        _this.ahp = null;
        _this.ahq = null;
        _this.ahs = null;
        _this.ahr = null;
        _this.ahm = null;
        _this.ahl = null;
        _this.alc = 1;
        _this.ala = 1;
        _this.ak9 = 2;
        _this.ak8 = 1;
        _this.ajb = null;
        _this.amd = -2147483648;
        _this.ak7 = 2;
        _this.amg = 3;
        _this.ame = 10;
        _this.amc = 30;
        _this.amf = 9;
        _this.aig = null;
        _this.aih = null;
        _this.aic = null;
        _this.applyCustomIndicators = null;
        _this.aqy = null;
        _this.alm = 1;
        _this.aj3 = false;
        _this.ai3 = null;
        _this.ak4 = dateMinValue();
        _this.ak3 = dateMaxValue();
        _this.ak1 = null;
        _this.u2();
        _this.ak1 = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.aqn(); });
        }
        _this.ap8();
        return _this;
    }
    FinancialChart.prototype.wi = function (a, b, c) {
        _super.prototype.wi.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.aik = new FinancialChartToolbar(this, this.am1);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.apv));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.apy));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.apz));
                    d.l(null);
                }
                if (this.aik != null) {
                    this.aik.ac = this.air;
                    this.aik.ai = this.ec;
                    this.aik.y = this.aim;
                    this.aik.al = this.akk;
                    if (this.al8 != null) {
                        this.aik.l(this.al8);
                    }
                    var e = this.aik;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.apv));
                    ;
                    var f = this.aik;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.apy));
                    var g = this.aik;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.apz));
                }
                break;
            case "ChartType":
                if (this.aik != null) {
                    this.aik.y = this.aim;
                }
                break;
            case "VolumeType":
                if (this.aik != null) {
                    this.aik.ac = this.air;
                }
                break;
            case "TrendLineType":
                if (this.aik != null) {
                    this.aik.ai = this.ec;
                }
                break;
            case "IsToolbarVisible":
                if (this.aik == null) {
                    break;
                }
                this.aik.al = this.akk;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.apz = function (a, b) {
        this.air = this.aik.ac;
    };
    FinancialChart.prototype.apy = function (a, b) {
        this.ec = this.aik.ai;
    };
    FinancialChart.prototype.apv = function (a, b) {
        this.aim = this.aik.y;
    };
    FinancialChart.prototype.ap8 = function () {
        this.ajd = new IndicatorPane();
        this.ai4 = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.amb = a;
        this.aqt();
        this.setGridRows();
        if (this.aik != null) {
            this.aik.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.aik != null) {
            this.aik.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.aik.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.l4;
        b.toolbarContainer = this.al8;
        b.legendContainer = this.al7;
        b.indicatorsContainer = this.al6;
        b.volumeContainer = this.al9;
        b.zoomContainer = this.ama;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.aik == null) {
                this.aik = new FinancialChartToolbar(this, this.am1);
            }
            this.aik.w.isIndicatorMenuVisible = this.akb && this.akc;
            this.al8 = b.getSubRenderer(d);
            this.aik.l(this.al8);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.al7 = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.al6 = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.al9 = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ama = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.al8 = null;
            if (this.aik != null) {
                this.aik.l(null);
            }
            if (this.aj2 != null) {
                this.aj2.provideContainer(null);
                this.aj2 = null;
            }
            if (this.ai4 != null) {
                this.ai4.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.c9.b4(this.al9);
            }
            if (this.ajd != null) {
                this.ajd.h(this.al6);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.c9.b4(this.ama);
                if (a != null) {
                    this.apf();
                }
                else {
                    this.aj2 = null;
                }
            }
            if (this.ai4 != null) {
                this.ai4.provideContainer(this.al7);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.aqj = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.c9.b4(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.aqx = function (a, b) {
        this.aqj(a, b, this.ama);
        if (b == null) {
            return;
        }
        this.apf();
    };
    FinancialChart.prototype.apf = function () {
        var _this = this;
        if (this.ama == null) {
            return;
        }
        if (this.aj2 != null) {
            this.aj2.provideContainer(null);
        }
        this.aj2 = TypeRegistrar.create("ZoomSlider");
        this.aj2.provideContainer(this.ama);
        var a = this.aj2;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.w0 = new Rect(0, _this.aj2.windowRect.left, _this.dataChart.wh.top, _this.aj2.windowRect.width, _this.dataChart.wh.height);
            }
        });
        this.apg();
    };
    FinancialChart.prototype.aqv = function (a, b) {
        this.aqj(a, b, this.al9);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.amb == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.akk ? this.als : 0) + "px";
        a[1] = this.akg ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.aj2 != null) {
            if (a[5] == "0px") {
                this.aj2.hide();
            }
            else {
                this.aj2.show();
            }
        }
        this.amb.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)), "auto", "1fr"));
        this.amb.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)));
        if (this.l4 == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.ajd != null) {
            this.ajd.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.aj2 != null) {
            this.aj2.notifySizeChanged();
        }
    };
    FinancialChart.prototype.vm = function () {
        var e_1, _a;
        _super.prototype.vm.call(this);
        this.aaz = 1;
        this.age = 0;
        this.acw = 0;
        this.ag8 = null;
        this.ag1 = AxisDefaults.axis_LineBrush;
        this.acg = AxisDefaults.axis_TickStroke;
        this.acf = AxisDefaults.categoryAxis_TickLength;
        this.ag2 = AxisDefaults.axis_TickBrush;
        this.agy = null;
        this.aqz = AxisDefaults.axis_MajorBrush;
        this.al5 = AxisDefaults.axis_MajorStroke;
        this.finalValueAnnotationsVisible = true;
        this.crosshairsAnnotationEnabled = true;
        this.gq = false;
        this.crosshairsDisplayMode = 0;
        this.jq = Defaults.crosshairLineThickness;
        this.yy = Defaults.crosshairLineBrush;
        this.yt = Defaults.crosshairXAxisAnnotationBackground;
        this.yu = Defaults.crosshairXAxisAnnotationTextColor;
        this.ka = NaN;
        this.j2 = 40;
        this.g6 = true;
        this.he = false;
        if (this.dataChart != null) {
            var a = this.dataChart.c9.j.e();
            this.ahv = a.d;
            this.ahw = a.e;
            this.ahu = a.d;
            this.aqz = this.dataChart.aa5;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8BDC5C";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8961A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6DB1FF";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#82E9D9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#EA3C63";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#F8CE4F";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#A8A8B7";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#E051A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#FF903B";
            return $ret;
        })()));
        var c = new BrushCollection();
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(BrushUtil.p(d, 0.3));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.ahx = c;
        this.ahy = b;
    };
    FinancialChart.prototype.aqf = function () {
        if (this.ajd != null) {
            this.ajd.b = null;
            this.ajd.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.aqg = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.aqp = function () {
        this.aqf();
    };
    FinancialChart.prototype.ape = function () {
        if (this.aj2 == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.l4.rootWrapper.width();
        var b = this.dataChart.wz.left + this.dataChart.wz.width;
        var c = this.dataChart.wz.left;
        var d = a - b;
        this.aj2.startInset = c - this.aj2.trackStartInset;
        this.aj2.endInset = d - this.aj2.trackEndInset;
        if (this.aj2.endInset < 0) {
            var e = this.aj2.endInset;
            this.aj2.endInset = 0;
            this.dataChart.h9 += (e * -1);
        }
        if (this.aj2.startInset < 0) {
            var f = this.aj2.startInset;
            this.aj2.startInset = 0;
            this.dataChart.h4 += (f * -1);
        }
        this.zoomSliderChart.h4 = c;
        this.zoomSliderChart.h9 = d;
        this.zoomSliderChart.hr = this.aj2.barExtent;
    };
    FinancialChart.prototype.ap5 = function () {
        this.ape();
    };
    FinancialChart.prototype.vj = function (a) {
        _super.prototype.vj.call(this, a);
        if (a != null) {
            a.hq = 0;
        }
    };
    FinancialChart.prototype.aq0 = function (a) {
        return a.wa();
    };
    FinancialChart.prototype.aq3 = function () {
        return this.al7 == null ? null : this.aq2(this.al7.rootWrapper);
    };
    FinancialChart.prototype.aq1 = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.aq2(a.d.rootWrapper);
    };
    FinancialChart.prototype.aq2 = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.aln = function () {
        if (this.amb == null) {
            return NaN;
        }
        var a = this.amb.getOffset();
        return this.amb.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.vv = function (source_, a, b) {
        _super.prototype.vv.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.on(source_, a, b);
        }
    };
    FinancialChart.prototype.vw = function (source_, a, b) {
        _super.prototype.vw.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.oo(source_, a, b);
        }
    };
    FinancialChart.prototype.vu = function (source_) {
        _super.prototype.vu.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.og(source_);
        }
    };
    FinancialChart.prototype.vy = function (source_, a, b, c) {
        _super.prototype.vy.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.op(source_, a, b, c);
        }
    };
    FinancialChart.prototype.vp = function (a, b) {
        _super.prototype.vp.call(this, a, b);
        if (this.akh(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "aik", {
        get: function () {
            return this.aij;
        },
        set: function (a) {
            var b = this.aik;
            if (a != b) {
                this.aij = a;
                this.wd("Toolbar", b, this.aik);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am0", {
        get: function () {
            return this.amt;
        },
        set: function (a) {
            var b = this.am0;
            if (a != b) {
                this.amt = a;
                this.wd("RangeSelectorTemplate", b, this.am0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am1", {
        get: function () {
            return this.amu;
        },
        set: function (a) {
            var b = this.am1;
            if (a != b) {
                this.amu = a;
                this.wd("ToolbarTemplate", b, this.am1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amx", {
        get: function () {
            return this.amq;
        },
        set: function (a) {
            var b = this.amx;
            if (a != b) {
                this.amq = a;
                this.wd("ChartTypePickerTemplate", b, this.amx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am2", {
        get: function () {
            return this.amv;
        },
        set: function (a) {
            var b = this.am2;
            if (a != b) {
                this.amv = a;
                this.wd("TrendLineTypePickerTemplate", b, this.am2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "am3", {
        get: function () {
            return this.amw;
        },
        set: function (a) {
            var b = this.am3;
            if (a != b) {
                this.amw = a;
                this.wd("VolumeTypePickerTemplate", b, this.am3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amy", {
        get: function () {
            return this.amr;
        },
        set: function (a) {
            var b = this.amy;
            if (a != b) {
                this.amr = a;
                this.wd("IndicatorMenuTemplate", b, this.amy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amz", {
        get: function () {
            return this.ams;
        },
        set: function (a) {
            var b = this.amz;
            if (a != b) {
                this.ams = a;
                this.wd("OverlayPickerTemplate", b, this.amz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aj2", {
        get: function () {
            return this.aj1;
        },
        set: function (a) {
            var b = this.aj2;
            if (a != b) {
                this.aj1 = a;
                this.wd("ZoomSlider", b, this.aj2);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_j2 = function () {
        return _super.prototype.get_j2.call(this);
    };
    FinancialChart.prototype.set_j2 = function (a) {
        _super.prototype.set_j2.call(this, a);
    };
    FinancialChart.prototype.get_g6 = function () {
        return _super.prototype.get_g6.call(this);
    };
    FinancialChart.prototype.set_g6 = function (a) {
        _super.prototype.set_g6.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "als", {
        get: function () {
            return this.alb;
        },
        set: function (a) {
            var b = this.als;
            if (a != b) {
                this.alb = a;
                this.wd("ToolbarHeight", b, this.als);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aao = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.aap = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.aj2 != null) {
            this.aj2.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.aj2 != null) {
            this.aj2.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.be = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_h2 = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "h2", {
        get: function () {
            return this.get_h2();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_h1 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "h1", {
        get: function () {
            return this.get_h1();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ah6 = function (a) {
        return this.ah7(a);
    };
    FinancialChart.prototype.ajk = function (a) {
        return this.ajl(a);
    };
    FinancialChart.prototype.ah5 = function (a) {
        var b = this.ah6(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.ux = function () {
        this.xAxis = this.ah5("xAxis");
        this.yAxis = this.ajk(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ajk(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.ah5("volumeXAxis");
        this.aky = new List$1(NumericYAxis.$, 0);
        this.ak0 = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.ajk(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.ah5("indicatorXAxis_0");
        this.aky.add(this.indicatorAxis);
        this.ak0.add(this.indicatorXAxis);
        if (this.xAxis.az == null) {
            this.xAxis.az = new AxisLabelSettings();
        }
        if (this.yAxis.az == null) {
            this.yAxis.az = new AxisLabelSettings();
        }
        if (this.volumeAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.volumeXAxis.az == null) {
            this.volumeAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorAxis.az == null) {
            this.indicatorAxis.az = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.az == null) {
            this.indicatorXAxis.az = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ajk(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.ah5("zoomSliderXAxis");
        if (this.zoomSliderAxis.az == null) {
            this.zoomSliderAxis.az = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.az == null) {
            this.zoomSliderXAxis.az = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.ur = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.xf = this.c2(a, b);
        }
    };
    FinancialChart.prototype.c1 = function (a) {
        if (a != null) {
            return 1;
        }
        return _super.prototype.c1.call(this, a);
    };
    FinancialChart.prototype.w8 = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.lo = true;
            this.yAxis.mm = 10;
        }
    };
    FinancialChart.prototype.xb = function () {
        this.yAxis.lo = this.akr;
        this.yAxis.mm = this.amp;
    };
    FinancialChart.prototype.aio = function (a) {
        var b;
        if (this.aim == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.aim;
        }
        b = this.ain(b);
        return b;
    };
    FinancialChart.prototype.ain = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.aix = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.aiq = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.anc = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.ah7 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ajl = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ajr = function () {
        return this.df(1);
    };
    FinancialChart.prototype.ajs = function () {
        return this.df(0);
    };
    FinancialChart.prototype.ajq = function () {
        return this.df(2);
    };
    FinancialChart.prototype.ajt = function () {
        return this.df(20);
    };
    Object.defineProperty(FinancialChart.prototype, "aka", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai8", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akd", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai6", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akb", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aja", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akc", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajf", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.dc = function (a, b) {
        var c = this.anc(a);
        switch (this.aio(a)) {
            case 3:
                var d = this.ajr();
                this.ai8.setValueMemberPath(d, c);
                this.ai8.setXAxis(d, this.xAxis);
                this.ai8.setYAxis(d, this.yAxis);
                this.ai8.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.ajs();
                this.ai8.setValueMemberPath(e, c);
                this.ai8.setXAxis(e, this.xAxis);
                this.ai8.setYAxis(e, this.yAxis);
                this.ai8.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.ajt();
                this.ai6.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.ai6.setHighMemberPath(f, a.getMemberPathFor(12));
                this.ai6.setLowMemberPath(f, a.getMemberPathFor(13));
                this.ai6.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.ai6.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.ai6.setXAxis(f, this.xAxis);
                this.ai6.setYAxis(f, this.yAxis);
                this.ai6.setDisplayType(f, this.aim == 1 ? 1 : 0);
                this.ai6.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.xa = function () {
        _super.prototype.xa.call(this);
        this.ap3(this.xAxis);
        this.aqr(false);
        if (this.air != 0 && this.volumeChart != null) {
            this.aqa();
        }
        this.ap3(this.volumeXAxis);
        this.ap3(this.indicatorXAxis);
        this.aqo();
        this.aqq();
        if (this.aiy != 0) {
            this.aqb();
            this.ap3(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.af0 = function (a, b) {
        var e_2, _a;
        _super.prototype.af0.call(this, a, b);
        a(this.volumeXAxis);
        if (this.ak0 != null) {
            try {
                for (var _b = __values(fromEnum(this.ak0)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.af5 = function (a, b) {
        var e_3, _a;
        _super.prototype.af5.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.aky != null) {
                try {
                    for (var _b = __values(fromEnum(this.aky)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.ap7 = function (a) {
        var b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
        if (b != null) {
            a(b);
        }
    };
    FinancialChart.prototype.af3 = function (a) {
        _super.prototype.af3.call(this, a);
        this.afu(this.volumeXAxis, a);
        this.afu(this.indicatorXAxis, a);
        this.afu(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.af8 = function (a) {
        _super.prototype.af8.call(this, a);
        this.afu(this.volumeAxis, a);
        this.afu(this.indicatorAxis, a);
        this.afu(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.af6 = function (a) {
        _super.prototype.af6.call(this, a);
        this.aft(this.volumeAxis, a);
        this.aft(this.indicatorAxis, a);
        this.aft(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.af1 = function (a) {
        _super.prototype.af1.call(this, a);
        this.aft(this.volumeXAxis, a);
        this.aft(this.indicatorXAxis, a);
        this.aft(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.vi = function (a) {
        var _this = this;
        _super.prototype.vi.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.xv = a.xy = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.ag = this.dataChart.ag;
                a.aj = this.dataChart.aj;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.an7();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.cw = 2;
    };
    FinancialChart.prototype.an7 = function () {
        if (this.am4 == null) {
            FinancialChart.amo++;
            this.am4 = FinancialChart.amo.toString();
        }
        return this.am4;
    };
    FinancialChart.prototype.app = function (a, b) {
        this.apb();
        this.ap5();
    };
    FinancialChart.prototype.apb = function () {
        var e_4, _a;
        if (this.yAxis.b8()) {
            return;
        }
        var a = this.yAxis.aw.bd;
        if (this.air != 0) {
            a = Math.max(a, this.volumeAxis.aw.bd);
        }
        try {
            for (var _b = __values(fromEnum(this.aky)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.aw.bd);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.apc(a);
    };
    FinancialChart.prototype.apc = function (a) {
        var e_5, _a;
        if (this.yAxis.b8()) {
            return;
        }
        this.yAxis.eu = this.volumeAxis.eu = a;
        try {
            for (var _b = __values(fromEnum(this.aky)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.eu = a;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.zoomSliderAxis.eu = this.yAxis.eu;
    };
    FinancialChart.prototype.aph = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                var e = c.series._inner[d];
                if (!(this.akf(e))) {
                    continue;
                }
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.apk = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            var c = this.volumeChart.series._inner[b];
            if (c.eu) {
                continue;
            }
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.api = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.akh(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.apj = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.akh(d)) {
                continue;
            }
            var e = this.ami(d, c);
            a(d, e);
        }
        if (b) {
            this.apl(a);
        }
    };
    FinancialChart.prototype.apl = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            var c = this.zoomSliderChart.series._inner[b];
            if (c.eu) {
                continue;
            }
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.ami = function (a, b) {
        if (a.da != this.dataChart) {
            return b;
        }
        var c = this.bf == null || this.bf.dataSeries == null ? 0 : this.bf.dataSeries.count;
        var d = this.ai2 == null ? 0 : this.ai2.count;
        return b - (c * d);
    };
    FinancialChart.prototype.u7 = function (a) {
        _super.prototype.u7.call(this, a);
        this.apk(a);
        this.aph(a);
        this.apl(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.ajx;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.ajx = a;
                this.wd("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aqa = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.akh(d) || d.eu) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.air;
            f = this.aiq(f);
            switch (f) {
                case 2:
                    e = this.ajs();
                    break;
                case 3:
                    e = this.ajq();
                    break;
                default:
                case 1:
                    e = this.ajr();
                    break;
            }
            this.ai8.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.ai8.setXAxis(e, this.volumeXAxis);
            this.ai8.setYAxis(e, this.volumeAxis);
            this.ai8.setValueMemberPath(e, this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > b ? this.bf.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.title = d.title + " Volume";
            e.vk = ArrayExtension.getModulus$1(Brush.$, this.ahz, b);
            e.v0 = ArrayExtension.getModulus$1(Brush.$, this.ah0, b);
            e.jq = this.alt;
            a.add(e);
        }
        var g = this.hy("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.vn(i, h);
        }
    };
    FinancialChart.prototype.ake = function (a) {
        if (!this.aka) {
            return false;
        }
        return this.ai8.matchesType(a);
    };
    FinancialChart.prototype.aki = function (a) {
        if (!this.akd) {
            return false;
        }
        return this.ai6.matchesType(a);
    };
    FinancialChart.prototype.akf = function (a) {
        if (!this.akb) {
            return false;
        }
        return this.aja.matchesType(a);
    };
    FinancialChart.prototype.akh = function (a) {
        if (!this.akc) {
            return false;
        }
        return this.ajf.matchesType(a);
    };
    FinancialChart.prototype.ap9 = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.ai0 == null ? 0 : this.ai0.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ai0._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.akh(l) || l.eu) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.aju("Custom");
                    this.aja.handleCustomIndicatorEvent(n, runOn(this, this.apn));
                    m = n;
                }
                else {
                    m = this.ajw(this.ai0._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.aja.setXAxis(m, this.ak0._inner[e]);
                this.aja.setYAxis(m, this.aky._inner[e]);
                m.itemsSource = l.itemsSource;
                this.aja.setOpenMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(11));
                this.aja.setHighMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(12));
                this.aja.setLowMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(13));
                this.aja.setCloseMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(14));
                this.aja.setVolumeMemberPath(m, this.bf.dataSeries._inner[j].getMemberPathFor(15));
                m.title = l.title + " " + i;
                m.vk = ArrayExtension.getModulus$1(Brush.$, this.aht, e);
                m.jq = this.alp;
                if (this.akf(m)) {
                    this.aja.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ahu, e));
                    this.aja.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ajc, e));
                }
                if (this.amk != -2147483648 && this.akf(m)) {
                    this.aja.setPeriodOverride(m, this.amk);
                }
                if (this.akf(m)) {
                    this.aja.setSmoothingPeriod(m, this.amn);
                }
                if (this.akf(m)) {
                    this.aja.setSignalPeriod(m, this.amm);
                }
                if (this.akf(m)) {
                    this.aja.setShortPeriod(m, this.aml);
                    this.aja.setLongPeriod(m, this.amj);
                }
                this.vn(m, e);
                f.add(m);
            }
            var o = this.hy(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.vn(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.aju = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.ajw = function (a) {
        return this.aju(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.aqr = function (a) {
        if (this.aik == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.aik.as = b.actualMinimumValue;
        this.aik.ar = b.actualMaximumValue;
        if (a) {
            this.aik.au = b.visibleMinimum;
            this.aik.at = b.visibleMaximum;
        }
        this.aik.bn();
    };
    FinancialChart.prototype.l5 = function () {
        var e_6, _a, e_7, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.l5.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.y7();
            $ret.toolbar = _this.aik == null ? null : _this.aik.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.y7();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.y7());
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.aq0(this.dataChart).x;
            a.mainChartTop = this.aq0(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.aq0(this.volumeChart).x;
            a.volumeChartTop = this.aq0(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.aq0(this.zoomSliderChart).x;
            a.zoomChartTop = this.aq0(this.zoomSliderChart).y;
        }
        if (this.aik != null) {
            var c = this.aq1(this.aik);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.aq0(d).x);
                    a.indicatorChartTops.add(this.aq0(d).y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        var e = this.aq3();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.ai4 == null ? null : this.ai4.exportVisualData();
        return a;
    };
    FinancialChart.prototype.am9 = function () {
        var a = this.l5();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.ajv = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.aqq = function () {
        var e_8, _a, e_9, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.akh(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        if (this.ai2 == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.akh(g) || g.eu) {
                continue;
            }
            e++;
            for (var h = 0; h < this.ai2.count; h++) {
                var i = this.ai2._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.ajv(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.ajv(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.ajf.setXAxis(j, this.xAxis);
                this.ajf.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.ai2.count + h;
                j.vk = ArrayExtension.getModulus$1(Brush.$, this.ahx, k);
                j.v0 = ArrayExtension.getModulus$1(Brush.$, this.ahy, k);
                j.jq = this.alr;
                j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.bf.dataSeries._inner[e];
                this.ajf.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.ajf.setHighMemberPath(j, m.getMemberPathFor(12));
                this.ajf.setLowMemberPath(j, m.getMemberPathFor(13));
                this.ajf.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.ajf.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].index = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.vn(q, p);
        }
    };
    FinancialChart.prototype.aqo = function () {
        var e_10, _a;
        if (this.akn) {
            return;
        }
        this.akn = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.ap4(b);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        if ((this.ai0 == null || this.ai0.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.aky != null) {
                this.aky.clear();
            }
            if (this.ak0 != null) {
                this.ak0.clear();
            }
            this.aqf();
            this.aqp();
            this.akn = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.aky.clear();
        this.ak0.clear();
        var c = this.ai0 == null ? 0 : this.ai0.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.ap2(g, null);
            var h = f >= c;
            if (h) {
                g.mc = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.mc = this.anb(this.ai0._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.ce) {
                        j = this.ah6(0);
                    }
                    else {
                        j = this.ah6(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.aky.add(i);
                this.ak0.add(j);
                if (this.gk) {
                    this.afx(i);
                }
                if (this.gk) {
                    this.afv(j);
                }
            }
        }
        this.aqf();
        this.ap9();
        if (this.aik != null) {
            this.aik.ae = this.ai0;
        }
        this.apd();
        this.aqp();
        this.akn = false;
    };
    FinancialChart.prototype.vf = function () {
        var e_11, _a, e_12, _b;
        _super.prototype.vf.call(this);
        this.afv(this.xAxis);
        this.afv(this.volumeXAxis);
        if (this.ak0 != null) {
            try {
                for (var _c = __values(fromEnum(this.ak0)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.afv(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.afx(this.yAxis);
        this.afx(this.volumeAxis);
        if (this.aky != null) {
            try {
                for (var _e = __values(fromEnum(this.aky)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.afx(b);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.afv(this.zoomSliderXAxis);
        this.afx(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_hd = function () {
        return !this.akl;
    };
    Object.defineProperty(FinancialChart.prototype, "akt", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aqw = function (a, b) {
        this.aqi(a, b, this.ama);
        this.apd();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.aqb();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.aqg();
        this.aqx(a, b);
    };
    FinancialChart.prototype.aqb = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.akh(c) || c.eu) {
                continue;
            }
            var d = void 0;
            var e = this.aiy;
            e = this.aix(e);
            var f = this.ami(c, b);
            if (e == 1) {
                switch (this.aio(this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.ajt();
                    this.ai6.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.ajt();
                    this.ai6.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.ajs();
                    break;
                case 6:
                    d = this.ajq();
                    break;
                default:
                case 4:
                    d = this.ajr();
                    break;
            }
            var g = this.bf != null && this.bf.dataSeries != null && this.bf.dataSeries.count > f ? this.bf.dataSeries._inner[f] : null;
            if (d.e0 && !d.e8) {
                this.ai8.setCategoryMode(d, 1);
                this.ai8.setXAxis(d, this.zoomSliderXAxis);
                this.ai8.setYAxis(d, this.zoomSliderAxis);
                this.ai8.setValueMemberPath(d, g == null ? null : this.anc(g));
            }
            else if (d.e8) {
                this.ai6.setCategoryMode(d, 1);
                this.ai6.setXAxis(d, this.zoomSliderXAxis);
                this.ai6.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.ai6.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.ai6.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.ai6.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.ai6.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.ai6.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.title = c.title;
            d.jq = this.kg;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.vn(i, h);
        }
    };
    FinancialChart.prototype.v3 = function (a, b, c) {
        var e_13, _a;
        _super.prototype.v3.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.apn = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.da);
        }
        e -= this.ai0 == null ? 0 : this.ai0.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.aqk = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.gk) {
            this.afv(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "aks", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.apo = function (a, b) {
        this.aqo();
    };
    FinancialChart.prototype.akj = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.aqe = function () {
        var e_14, _a;
        var a = this.aii != null ? this.aii : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.akj(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.aih = b;
        if (this.aik != null) {
            this.aik.u = this.aih;
        }
    };
    FinancialChart.prototype.aps = function (a, b) {
        this.aqe();
    };
    FinancialChart.prototype.apx = function (a, b) {
        this.ai2 = this.aik.ag;
    };
    FinancialChart.prototype.apw = function (a, b) {
        this.ai0 = this.aik.ae;
    };
    FinancialChart.prototype.apq = function (a, b) {
        this.aqo();
    };
    FinancialChart.prototype.apr = function (a, b) {
        this.aqq();
    };
    FinancialChart.prototype.ap1 = function (a, b) {
        var c = a;
        if (c.bg == null) {
            return;
        }
        if (this.akl) {
            this.aqd(c.bg);
        }
    };
    FinancialChart.prototype.ap4 = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.app));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.eu = this.volumeAxis.eu = this.indicatorAxis.eu = 0;
            this.xAxis.az.visibility = this.ahj;
        }
    };
    FinancialChart.prototype.ap2 = function (a, b) {
        var c = a != this.zoomSliderChart;
        if (c) {
            if (this.dataChart != null) {
                a.w0 = new Rect(0, this.dataChart.wh.x, a.w0.y, this.dataChart.wh.width, a.w0.height);
            }
            var d = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, d);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.app));
        this.vh(a, b);
    };
    FinancialChart.prototype.apd = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.aft(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.ak0._inner[a];
            var c = a < this_1.ak0.count - 1 || this_1.volumeChart != null;
            this_1.aft(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.ak0.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.aqi = function (a, b, c) {
        if (a != null) {
            this.ap4(a);
        }
        if (b != null) {
            this.ap2(b, c);
        }
    };
    FinancialChart.prototype.aqu = function (a, b) {
        this.aqi(a, b, this.al9);
        this.apd();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.aqa();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.aqv(a, b);
    };
    FinancialChart.prototype.apt = function (a, b) {
        this.aqs();
    };
    FinancialChart.prototype.aqs = function () {
        if (this.aik == null || +(this.aik.au) == +(dateMaxValue()) || +(this.aik.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.aik.au, this.aik.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.akm = true;
        this.dataChart.w0 = new Rect(0, b.left, this.dataChart.w0.top, b.width, this.dataChart.w0.height);
        if (this.aj2 != null) {
            this.aj2.windowRect = this.dataChart.wh;
        }
        if (this.akl) {
            this.aqd(this.dataChart);
        }
        this.akm = false;
    };
    FinancialChart.prototype.ap0 = function (a, b) {
        this.aqe();
        this.aqr(!this.akm);
    };
    FinancialChart.prototype.apm = function (a, b) {
        var _this = this;
        if (!this.akm) {
            if (this.akl) {
                this.aqd(a);
            }
            var c = false;
            var d = this.wm(function () { return _this.aqr(true); }, c);
            c = d.p1;
            if (this.aj2 != null) {
                this.aj2.windowRect = this.dataChart.wh;
            }
        }
    };
    FinancialChart.prototype.aqm = function (a, b, c, d) {
        var e_15, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.akm = true;
            a.w0 = new Rect(0, d, a.wh.top, c, a.wh.height);
            this.akm = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.ch, a.wl);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.iz();
                var j = i.az(a.wh);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.el(j.c, h);
                var m = b.el(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        var n = a.wh.width;
        if (c != -1) {
            n = c;
        }
        var o = a.wh.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.akm = true;
        var p = new Rect(0, o, e, n, f - e);
        a.w0 = p;
        this.akm = false;
    };
    FinancialChart.prototype.aql = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.aqm(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.aqm(this.volumeChart, this.volumeAxis, this.dataChart.wh.width, this.dataChart.wh.left);
            }
        }
        else if (a == this.volumeChart) {
            this.aqm(this.volumeChart, this.volumeAxis, -1, -1);
            this.aqm(this.dataChart, this.yAxis, this.volumeChart.wh.width, this.volumeChart.wh.left);
        }
    };
    FinancialChart.prototype.aqd = function (a) {
        var _this = this;
        this.wl(function () { return _this.aql(a); });
    };
    FinancialChart.prototype.apu = function (a, b) {
        if (this.akl) {
            this.aqd(a);
        }
    };
    FinancialChart.prototype.aqt = function () {
        if (!this.akt) {
            return;
        }
        this.apg();
        if (this.aiy == 0) {
            this.resetZoom();
            this.zoomSliderChart = null;
            this.ama.rootWrapper.removeChildren();
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
            this.aqg();
        }
        else {
            this.aqb();
        }
    };
    FinancialChart.prototype.apg = function () {
        var container_ = this.ama.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.aj2 != null && containerParent_ != null && !this.aku) {
            this.aku = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.aj2;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.aqn = function () {
        var _this = this;
        if (this.ait != 1) {
            return;
        }
        this.afz(function (a) {
            var e_16, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        });
    };
    FinancialChart.prototype.xf = function (a, b, c) {
        _super.prototype.xf.call(this, a, b, c);
        if (this.bf.dataSeries.count > 0) {
            if (this.ait == 1 && stringIsNullOrEmpty(this.nz)) {
                this.ce.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.n1)) {
                this.ce.setYMemberPath(a, this.anc(c));
            }
            if (stringIsNullOrEmpty(this.nm)) {
                this.ce.setLabelMemberPath(a, this.anc(c));
            }
            if (stringIsNullOrEmpty(this.ni)) {
                this.ce.setContentMemberPath(a, this.anc(c));
            }
        }
    };
    FinancialChart.prototype.anb = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.afv = function (a) {
        var e_17, _a;
        var _this = this;
        _super.prototype.afv.call(this, a);
        var b = a;
        this.ap3(b);
        if (a.bg != null) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.ake(c)) {
                        this.ai8.setXAxis(c, b);
                    }
                    else if (this.aki(c)) {
                        this.ai6.setXAxis(c, b);
                    }
                    else if (this.akf(c)) {
                        this.aja.setXAxis(c, b);
                    }
                    else if (this.akh(c)) {
                        this.ajf.setXAxis(c, b);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        this.ap7(function (d) {
            d.zoomMaximumCategoryRange = _this.alu;
            d.zoomMaximumItemSpan = _this.alv;
            d.zoomToCategoryRange = _this.alw;
            d.zoomToCategoryStart = _this.alx;
            d.zoomToItemSpan = _this.aly;
        });
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.jz = this.aqz;
            a.et = this.al5;
            this.aft(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.ak6;
        e.maximumValue = this.ak5;
        a.b1 = this.ako;
    };
    FinancialChart.prototype.afx = function (a) {
        var e_18, _a;
        _super.prototype.afx.call(this, a);
        if (a.bg != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bg.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.ake(b)) {
                        this.ai8.setYAxis(b, this.yAxis);
                    }
                    else if (this.aki(b)) {
                        this.ai6.setYAxis(b, this.yAxis);
                    }
                    else if (this.akf(b)) {
                        this.aja.setYAxis(b, this.yAxis);
                    }
                    else if (this.akh(b)) {
                        this.ajf.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        a.lf = this.akp;
        a.mc = this.al3;
        a.mb = this.al2;
        if (a == this.yAxis) {
            a.l8 = this.al1;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.aft(a, function (d) { return d.visibility = 1; });
        }
        a.b1 = this.akq;
    };
    FinancialChart.prototype.ap3 = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.f2 = XYChart.adi(a, this.bf.dataSeries);
        if (this.bf.dataSeries.count > 0) {
            var b = this.bf.dataSeries._inner[0].getMemberPathFor(17);
            a.h1(b);
        }
    };
    FinancialChart.prototype.vn = function (a, b) {
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.da;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if (d && !a.eu && !this.akh(a)) {
            a.l5 = "Financial Series";
        }
        _super.prototype.vn.call(this, a, b);
        if ((d || c) && a.fn) {
            a.r7(this.ahv != null ? ArrayExtension.getModulus$1(Brush.$, this.ahv, b) : null, this.ahw != null ? ArrayExtension.getModulus$1(Brush.$, this.ahw, b) : null);
        }
        var e = this.akf(a);
        if (this.akh(a)) {
            a.vk = this.ahx != null ? ArrayExtension.getModulus$1(Brush.$, this.ahx, b) : null;
            a.v0 = this.ahy != null ? ArrayExtension.getModulus$1(Brush.$, this.ahy, b) : null;
            a.jq = this.alr;
        }
        else if (e) {
            a.vk = this.aht != null ? ArrayExtension.getModulus$1(Brush.$, this.aht, b) : null;
            a.jq = this.alp;
        }
        else if (!a.eu && (d || c)) {
            a.vk = this.z != null ? ArrayExtension.getModulus$1(Brush.$, this.z, b) : null;
            a.v0 = this.ad != null ? ArrayExtension.getModulus$1(Brush.$, this.ad, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.da;
        if (f) {
            a.jq = this.alt;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.akg ? this.ai4 : null;
    };
    FinancialChart.prototype.vo = function (a, b) {
        _super.prototype.vo.call(this, a, b);
        if (a == null) {
            return;
        }
    };
    FinancialChart.prototype.wd = function (a, b, c) {
        var e_19, _a, e_20, _b;
        var _this = this;
        _super.prototype.wd.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.lo = this.akr;
                if (this.volumeAxis != null) {
                    this.volumeAxis.lo = this.akr;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.lo = this.akr;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.mm = this.amp;
                if (this.volumeAxis != null) {
                    this.volumeAxis.mm = this.amp;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.mm = this.amp;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.air == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.aqa();
                }
                break;
            case "VolumeChart":
                this.aqu(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.app));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.apm));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.apu));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.app));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.apm));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.apu));
                }
                this.aqt();
                break;
            case "XAxisMode":
                this.xAxis = this.ah6(this.ait);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.ah6(this.ait);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.ah6(this.ait);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.ah6(this.ait);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.aft(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.apd();
                if (this.ait == 1) {
                    this.aqn();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.ajk(this.aiv);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.ajk(this.aiv);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.ajk(this.aiv);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.apt));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.apw));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.apx));
                }
                if (this.aik != null) {
                    this.aik.ae = this.ai0;
                    this.aik.ag = this.ai2;
                    this.aik.u = this.aih;
                    this.aqr(true);
                    var j = this.aik;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.apt));
                    var k = this.aik;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.apw));
                    var l = this.aik;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.apx));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.ap0));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.gk) {
                    this.afv(this.xAxis);
                    this.u4();
                }
                this.aqr(false);
                this.aqs();
                this.aqe();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.ap0));
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.ap7(function (p) { return p.zoomMaximumCategoryRange = _this.alu; });
                break;
            case "XAxisZoomMaximumItemSpan":
                this.ap7(function (p) { return p.zoomMaximumItemSpan = _this.alv; });
                break;
            case "XAxisZoomToCategoryRange":
                this.ap7(function (p) { return p.zoomToCategoryRange = _this.alw; });
                break;
            case "XAxisZoomToCategoryStart":
                this.ap7(function (p) { return p.zoomToCategoryStart = _this.alx; });
                break;
            case "XAxisZoomToItemSpan":
                this.ap7(function (p) { return p.zoomToItemSpan = _this.aly; });
                break;
            case "ChartType":
                this.u8();
                break;
            case "VolumeXAxis":
                this.aqk(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.aqk(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.aqo();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.gk) {
                    this.afx(this.yAxis);
                    this.afx(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.ap1));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.aqa();
                }
                if (this.gk) {
                    this.afx(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.ap1));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_19 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        try {
                            for (var _e = (e_20 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_20_1) {
                            e_20 = { error: e_20_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_20)
                                    throw e_20.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.aiv == 1) {
                            y = this.ajk(this.aiv);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.gk) {
                            this.afx(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.xy = this.he && this.hd;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.xy = this.he && this.hd;
                }
                if (this.akl) {
                    this.aql(this.dataChart);
                }
                else {
                    this.volumeChart.y5 = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.apq));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.apq));
                }
                this.aqo();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.apr));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.apr));
                }
                this.aqq();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.af4(function (ad) { return ad.lf = _this.akp; });
                break;
            case "YAxisMinimumValue":
                this.af5(function (ad) { return ad.mc = _this.al3; }, false);
                break;
            case "YAxisMaximumValue":
                this.af5(function (ad) { return ad.mb = _this.al2; }, false);
                break;
            case "YAxisInterval":
                this.af5(function (ad) { return ad.l8 = _this.al1; }, false);
                break;
            case "Thickness":
            case "ZoomSliderType":
                this.aqt();
                break;
            case "ZoomSliderChart":
                if (!this.aks) {
                    return;
                }
                this.aqw(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.apj(function (ad, ae) {
                    if (ad.fn) {
                        ad.r7(_this.ahv != null ? ArrayExtension.getModulus$1(Brush.$, _this.ahv, ae) : null, _this.ahw != null ? ArrayExtension.getModulus$1(Brush.$, _this.ahw, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.api(function (ad, ae) { return ad.vk = _this.ahx != null ? ArrayExtension.getModulus$1(Brush.$, _this.ahx, ae) : null; });
                break;
            case "OverlayOutlines":
                this.api(function (ad, ae) { return ad.v0 = _this.ahy != null ? ArrayExtension.getModulus$1(Brush.$, _this.ahy, ae) : null; });
                break;
            case "OverlayThickness":
                this.api(function (ad, ae) { return ad.jq = _this.alr; });
                break;
            case "OverlayMultiplier":
                this.api(function (ad, ae) { return _this.ajf.setMultiplier(ad, _this.alq); });
                break;
            case "VolumeBrushes":
                this.apk(function (ad, ae) { return ad.vk = ArrayExtension.getModulus$1(Brush.$, _this.ahz, ae); });
                break;
            case "VolumeOutlines":
                this.apk(function (ad, ae) { return ad.v0 = ArrayExtension.getModulus$1(Brush.$, _this.ah0, ae); });
                break;
            case "VolumeThickness":
                this.apk(function (ad, ae) { return ad.jq = _this.alt; });
                break;
            case "IndicatorNegativeBrushes":
                this.aph(function (ad, ae) { return _this.aja.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.ahu, ae)); });
                break;
            case "IndicatorBrushes":
                this.aph(function (ad, ae) { return ad.vk = ArrayExtension.getModulus$1(Brush.$, _this.aht, ae); });
                break;
            case "IndicatorThickness":
                this.aph(function (ad, ae) { return ad.jq = _this.alp; });
                break;
            case "IndicatorDisplayTypes":
                this.aph(function (ad, ae) { return _this.aja.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.ajc, ae)); });
                break;
            case "IndicatorPeriod":
                this.aph(function (ad, ae) {
                    if (_this.amk == -2147483648) {
                        return;
                    }
                    _this.aja.setPeriodOverride(ad, _this.amk);
                });
                break;
            case "IndicatorMultiplier":
                this.aph(function (ad, ae) { return _this.aja.setMultiplier(ad, _this.alo); });
                break;
            case "IndicatorSmoothingPeriod":
                this.aph(function (ad, ae) { return _this.aja.setSmoothingPeriod(ad, _this.amn); });
                break;
            case "IndicatorShortPeriod":
                this.aph(function (ad, ae) { return _this.aja.setShortPeriod(ad, _this.aml); });
                break;
            case "IndicatorLongPeriod":
                this.aph(function (ad, ae) { return _this.aja.setLongPeriod(ad, _this.amj); });
                break;
            case "IndicatorSignalPeriod":
                this.aph(function (ad, ae) { return _this.aja.setSignalPeriod(ad, _this.amm); });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.aps));
                }
                if (this.aii != null) {
                    var ae = this.aii;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.aps));
                }
                this.aqe();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.apo));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.apo));
                }
                this.aqo();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.apj(function (ah, ai) { return ah.vk = _this.z != null ? ArrayExtension.getModulus$1(Brush.$, _this.z, ai) : null; }, true);
                break;
            case "Outlines":
                this.apj(function (ah, ai) { return ah.v0 = _this.ad != null ? ArrayExtension.getModulus$1(Brush.$, _this.ad, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.ahj == 0 && this.zoomSliderXAxis != null) {
                    this.aft(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.apd();
                break;
            case "YAxisLabelVisibility":
                if (this.ahk != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.aft(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.jz = this.aqz;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.et = this.al5;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.akg && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.ai4 : null;
                        }
                    };
                    this.apj(ai, false);
                    this.api(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.aqb();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.gk) {
                        this.afx(this.zoomSliderAxis);
                    }
                    this.aft(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.afz(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.ak6;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.afz(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.ak5;
                    }
                });
                break;
            case FinancialChart.aok:
                this.af0(function (ak) { return ak.b1 = _this.ako; }, a);
                break;
            case FinancialChart.aov:
                this.af4(function (ak) { return ak.b1 = _this.akq; });
                break;
        }
    };
    FinancialChart.prototype.get_cb = function () {
        return 1;
    };
    Object.defineProperty(FinancialChart.prototype, "cb", {
        get: function () {
            return this.get_cb();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akr", {
        get: function () {
            return this.aj9;
        },
        set: function (a) {
            var b = this.akr;
            if (a != b) {
                this.aj9 = a;
                this.wd("YAxisIsLogarithmic", b, this.akr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amp", {
        get: function () {
            return this.amh;
        },
        set: function (a) {
            var b = this.amp;
            if (a != b) {
                this.amh = a;
                this.wd("YAxisLogarithmBase", b, this.amp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al1", {
        get: function () {
            return this.ali;
        },
        set: function (a) {
            var b = this.al1;
            if (a != b) {
                this.ali = a;
                this.wd("YAxisInterval", b, this.al1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al3", {
        get: function () {
            return this.alk;
        },
        set: function (a) {
            var b = this.al3;
            if (a != b) {
                this.alk = a;
                this.wd("YAxisMinimumValue", b, this.al3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al2", {
        get: function () {
            return this.alj;
        },
        set: function (a) {
            var b = this.al2;
            if (a != b) {
                this.alj = a;
                this.wd("YAxisMaximumValue", b, this.al2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al4", {
        get: function () {
            return this.all;
        },
        set: function (a) {
            var b = this.al4;
            if (a != b) {
                this.all = a;
                this.wd("YAxisMinorInterval", b, this.al4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al0", {
        get: function () {
            return this.yAxis.l4;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alz", {
        get: function () {
            return this.yAxis.l3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "air", {
        get: function () {
            return this.aip;
        },
        set: function (a) {
            var b = this.air;
            if (a != b) {
                this.aip = a;
                this.wd("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.air));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ait", {
        get: function () {
            return this.ais;
        },
        set: function (a) {
            var b = this.ait;
            if (a != b) {
                this.ais = a;
                this.wd("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ait));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alu", {
        get: function () {
            return this.ald;
        },
        set: function (a) {
            var b = this.alu;
            if (a != b) {
                this.ald = a;
                this.wd("XAxisZoomMaximumCategoryRange", b, this.alu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alx", {
        get: function () {
            return this.alg;
        },
        set: function (a) {
            var b = this.alx;
            if (a != b) {
                this.alg = a;
                this.wd("XAxisZoomToCategoryStart", b, this.alx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alv", {
        get: function () {
            return this.ale;
        },
        set: function (a) {
            var b = this.alv;
            if (a != b) {
                this.ale = a;
                this.wd("XAxisZoomMaximumItemSpan", b, this.alv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alw", {
        get: function () {
            return this.alf;
        },
        set: function (a) {
            var b = this.alw;
            if (a != b) {
                this.alf = a;
                this.wd("XAxisZoomToCategoryRange", b, this.alw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aly", {
        get: function () {
            return this.alh;
        },
        set: function (a) {
            var b = this.aly;
            if (a != b) {
                this.alh = a;
                this.wd("XAxisZoomToItemSpan", b, this.aly);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aiv", {
        get: function () {
            return this.aiu;
        },
        set: function (a) {
            var b = this.aiv;
            if (a != b) {
                this.aiu = a;
                this.wd("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.aiv));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akk", {
        get: function () {
            return this.aj4;
        },
        set: function (a) {
            var b = this.akk;
            if (a != b) {
                this.aj4 = a;
                this.wd("IsToolbarVisible", b, this.akk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aim", {
        get: function () {
            return this.ail;
        },
        set: function (a) {
            var b = this.aim;
            if (a != b) {
                this.ail = a;
                this.wd("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.aim));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_age = function () {
        return _super.prototype.get_age.call(this);
    };
    FinancialChart.prototype.set_age = function (a) {
        _super.prototype.set_age.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "akl", {
        get: function () {
            return this.aj5;
        },
        set: function (a) {
            var b = this.akl;
            if (a != b) {
                this.aj5 = a;
                this.wd("IsWindowSyncedToVisibleRange", b, this.akl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai0", {
        get: function () {
            return this.aiz;
        },
        set: function (a) {
            var b = this.ai0;
            if (a != b) {
                this.aiz = a;
                this.wd("IndicatorTypes", b, this.ai0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai2", {
        get: function () {
            return this.ai1;
        },
        set: function (a) {
            var b = this.ai2;
            if (a != b) {
                this.ai1 = a;
                this.wd("OverlayTypes", b, this.ai2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.akw;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.akw = a;
                this.wd("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akp", {
        get: function () {
            return this.aj7;
        },
        set: function (a) {
            var b = this.akp;
            if (a != b) {
                this.aj7 = a;
                this.wd("YAxisAbbreviateLargeNumbers", b, this.akp);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_ka = function () {
        return _super.prototype.get_ka.call(this);
    };
    FinancialChart.prototype.set_ka = function (a) {
        _super.prototype.set_ka.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ako", {
        get: function () {
            return this.aj6;
        },
        set: function (a) {
            var b = this.ako;
            if (a != b) {
                this.aj6 = a;
                this.wd(FinancialChart.aok, b, this.ako);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akq", {
        get: function () {
            return this.aj8;
        },
        set: function (a) {
            var b = this.akq;
            if (a != b) {
                this.aj8 = a;
                this.wd(FinancialChart.aov, b, this.akq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.ajy;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.ajy = a;
                this.wd("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.ajj;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.ajj = a;
                this.wd("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.ah4;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.ah4 = a;
                this.wd("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aiy", {
        get: function () {
            return this.aiw;
        },
        set: function (a) {
            var b = this.aiy;
            if (a != b) {
                this.aiw = a;
                this.wd("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.aiy));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahv", {
        get: function () {
            return this.ahn;
        },
        set: function (a) {
            var b = this.ahv;
            if (a != b) {
                this.ahn = a;
                this.wd("NegativeBrushes", b, this.ahv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahw", {
        get: function () {
            return this.aho;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.aho = a;
                this.wd("NegativeOutlines", b, this.ahw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahx", {
        get: function () {
            return this.ahp;
        },
        set: function (a) {
            var b = this.ahx;
            if (a != b) {
                this.ahp = a;
                this.wd("OverlayBrushes", b, this.ahx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahy", {
        get: function () {
            return this.ahq;
        },
        set: function (a) {
            var b = this.ahy;
            if (a != b) {
                this.ahq = a;
                this.wd("OverlayOutlines", b, this.ahy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah0", {
        get: function () {
            return this.ahs;
        },
        set: function (a) {
            var b = this.ah0;
            if (a != b) {
                this.ahs = a;
                this.wd("VolumeOutlines", b, this.ah0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahz", {
        get: function () {
            return this.ahr;
        },
        set: function (a) {
            var b = this.ahz;
            if (a != b) {
                this.ahr = a;
                this.wd("VolumeBrushes", b, this.ahz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahu", {
        get: function () {
            return this.ahm;
        },
        set: function (a) {
            var b = this.ahu;
            if (a != b) {
                this.ahm = a;
                this.wd("IndicatorNegativeBrushes", b, this.ahu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aht", {
        get: function () {
            return this.ahl;
        },
        set: function (a) {
            var b = this.aht;
            if (a != b) {
                this.ahl = a;
                this.wd("IndicatorBrushes", b, this.aht);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alt", {
        get: function () {
            return this.alc;
        },
        set: function (a) {
            var b = this.alt;
            if (a != b) {
                this.alc = a;
                this.wd("VolumeThickness", b, this.alt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alr", {
        get: function () {
            return this.ala;
        },
        set: function (a) {
            var b = this.alr;
            if (a != b) {
                this.ala = a;
                this.wd("OverlayThickness", b, this.alr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alq", {
        get: function () {
            return this.ak9;
        },
        set: function (a) {
            var b = this.alq;
            if (a != b) {
                this.ak9 = a;
                this.wd("OverlayMultiplier", b, this.alq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alp", {
        get: function () {
            return this.ak8;
        },
        set: function (a) {
            var b = this.alp;
            if (a != b) {
                this.ak8 = a;
                this.wd("IndicatorThickness", b, this.alp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ajc", {
        get: function () {
            return this.ajb;
        },
        set: function (a) {
            var b = this.ajc;
            if (a != b) {
                this.ajb = a;
                this.wd("IndicatorDisplayTypes", b, this.ajc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amk", {
        get: function () {
            return this.amd;
        },
        set: function (a) {
            var b = this.amk;
            if (a != b) {
                this.amd = a;
                this.wd("IndicatorPeriod", b, this.amk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "alo", {
        get: function () {
            return this.ak7;
        },
        set: function (a) {
            var b = this.alo;
            if (a != b) {
                this.ak7 = a;
                this.wd("IndicatorMultiplier", b, this.alo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amn", {
        get: function () {
            return this.amg;
        },
        set: function (a) {
            var b = this.amn;
            if (a != b) {
                this.amg = a;
                this.wd("IndicatorSmoothingPeriod", b, this.amn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aml", {
        get: function () {
            return this.ame;
        },
        set: function (a) {
            var b = this.aml;
            if (a != b) {
                this.ame = a;
                this.wd("IndicatorShortPeriod", b, this.aml);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amj", {
        get: function () {
            return this.amc;
        },
        set: function (a) {
            var b = this.amj;
            if (a != b) {
                this.amc = a;
                this.wd("IndicatorLongPeriod", b, this.amj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "amm", {
        get: function () {
            return this.amf;
        },
        set: function (a) {
            var b = this.amm;
            if (a != b) {
                this.amf = a;
                this.wd("IndicatorSignalPeriod", b, this.amm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aii", {
        get: function () {
            return this.aig;
        },
        set: function (a) {
            var b = this.aii;
            if (a != b) {
                this.aig = a;
                this.wd("RangeSelectorOptions", b, this.aii);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.aic;
        },
        set: function (a) {
            var b = this.aic;
            if (a != b) {
                this.aic = a;
                this.wd("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_he = function () {
        return _super.prototype.get_he.call(this);
    };
    FinancialChart.prototype.set_he = function (a) {
        _super.prototype.set_he.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "aqz", {
        get: function () {
            return this.aqy;
        },
        set: function (a) {
            var b = this.aqz;
            if (a != b) {
                this.aqy = a;
                this.wd("ZoomSliderXAxisMajorStroke", b, this.aqz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "al5", {
        get: function () {
            return this.alm;
        },
        set: function (a) {
            var b = this.al5;
            if (a != b) {
                this.alm = a;
                this.wd("ZoomSliderXAxisMajorStrokeThickness", b, this.al5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "akg", {
        get: function () {
            return this.aj3;
        },
        set: function (a) {
            var b = this.akg;
            if (a != b) {
                this.aj3 = a;
                this.wd("IsLegendVisible", b, this.akg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ai4", {
        get: function () {
            return this.ai3;
        },
        set: function (a) {
            var b = this.ai4;
            if (a != b) {
                this.ai3 = a;
                this.wd("FinancialChartLegend", b, this.ai4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.ah3;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.ah3 = a;
                this.wd("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.aji;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.aji = a;
                this.wd("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.ajh;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.ajh = a;
                this.wd("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.ah2;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.ah2 = a;
                this.wd("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.ajg;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.ajg = a;
                this.wd("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.ah1;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.ah1 = a;
                this.wd("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aky", {
        get: function () {
            return this.akv;
        },
        set: function (a) {
            var b = this.aky;
            if (a != b) {
                this.akv = a;
                this.wd("IndicatorAxes", b, this.aky);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak0", {
        get: function () {
            return this.akx;
        },
        set: function (a) {
            var b = this.ak0;
            if (a != b) {
                this.akx = a;
                this.wd("IndicatorXAxes", b, this.ak0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak6", {
        get: function () {
            return this.ak4;
        },
        set: function (a) {
            var b = this.ak6;
            if (+a != +b) {
                this.ak4 = a;
                this.wd("XAxisMinimumValue", b, this.ak6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ak5", {
        get: function () {
            return this.ak3;
        },
        set: function (a) {
            var b = this.ak5;
            if (+a != +b) {
                this.ak3 = a;
                this.wd("XAxisMaximumValue", b, this.ak5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.ak1;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.amo = 0;
    FinancialChart.aok = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.aov = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.am0 : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.amx : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.amy : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_21, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        var a = false;
        if (this.q != null) {
            a = this.q.p();
        }
        if (this.p != null) {
            this.p.i(this.o);
            if (a) {
                if (this.q.notifyChanged != null) {
                    this.q.notifyChanged();
                }
            }
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
