/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Describes location of the overlay text in relation to underlying shape.
 */
export var OverlayTextLocation = /*@__PURE__*/ (function (OverlayTextLocation) {
    /**
     * Let the chart automatically decide which overlay text location to use based on type of annotation layer
     */
    OverlayTextLocation[OverlayTextLocation["Auto"] = 0] = "Auto";
    /**
     * Positions the overlay text inside middle center of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideMiddleCenter"] = 1] = "InsideMiddleCenter";
    /**
     * Positions the overlay text inside middle left of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideMiddleLeft"] = 2] = "InsideMiddleLeft";
    /**
     * Positions the overlay text inside middle right of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideMiddleRight"] = 3] = "InsideMiddleRight";
    /**
     * Positions the overlay text inside top left of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideTopLeft"] = 4] = "InsideTopLeft";
    /**
     * Positions the overlay text inside top center of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideTopCenter"] = 5] = "InsideTopCenter";
    /**
     * Positions the overlay text inside top right of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideTopRight"] = 6] = "InsideTopRight";
    /**
     * Positions the overlay text inside bottom left of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideBottomLeft"] = 7] = "InsideBottomLeft";
    /**
     * Positions the overlay text inside bottom center of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideBottomCenter"] = 8] = "InsideBottomCenter";
    /**
     * Positions the overlay text inside bottom right of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["InsideBottomRight"] = 9] = "InsideBottomRight";
    /**
     * Positions the overlay text outside top left of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideTopLeft"] = 10] = "OutsideTopLeft";
    /**
     * Positions the overlay text outside top center of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideTopCenter"] = 11] = "OutsideTopCenter";
    /**
     * Positions the overlay text outside top right of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideTopRight"] = 12] = "OutsideTopRight";
    /**
     * Positions the overlay text outside middle left of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideMiddleLeft"] = 13] = "OutsideMiddleLeft";
    /**
     * Positions the overlay text outside middle right of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideMiddleRight"] = 14] = "OutsideMiddleRight";
    /**
     * Positions the overlay text outside bottom left of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideBottomLeft"] = 15] = "OutsideBottomLeft";
    /**
     * Positions the overlay text outside bottom center of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideBottomCenter"] = 16] = "OutsideBottomCenter";
    /**
     * Positions the overlay text outside bottom right of underlying shape.
     */
    OverlayTextLocation[OverlayTextLocation["OutsideBottomRight"] = 17] = "OutsideBottomRight";
    /**
     * Hides the overlay text
     */
    OverlayTextLocation[OverlayTextLocation["Hidden"] = 18] = "Hidden";
    return OverlayTextLocation;
})({});
/**
 * @hidden
 */
export var OverlayTextLocation_$type = /*@__PURE__*/ markEnum('OverlayTextLocation', 'Auto,0|InsideMiddleCenter,1|InsideMiddleLeft,2|InsideMiddleRight,3|InsideTopLeft,4|InsideTopCenter,5|InsideTopRight,6|InsideBottomLeft,7|InsideBottomCenter,8|InsideBottomRight,9|OutsideTopLeft,10|OutsideTopCenter,11|OutsideTopRight,12|OutsideMiddleLeft,13|OutsideMiddleRight,14|OutsideBottomLeft,15|OutsideBottomCenter,16|OutsideBottomRight,17|Hidden,18');
