/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { DependencyProperty } from "igniteui-react-core";
import { runOn, markType, markDep } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { PathGeometry } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { PathFigure } from "igniteui-react-core";
import { Extensions } from "igniteui-react-core";
import { Numeric } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
var PolarSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSplineSeries, _super);
    function PolarSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarSplineSeries.$;
        return _this;
    }
    PolarSplineSeries.prototype.bk = function () {
        return new PolarSplineSeries();
    };
    PolarSplineSeries.prototype.get_f1 = function () {
        return true;
    };
    PolarSplineSeries.prototype.ct = function () {
        return new PolarSplineSeriesView(this);
    };
    PolarSplineSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.acz = a;
    };
    PolarSplineSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case PolarSplineSeries.$$p[0]:
                this.ru(false);
                break;
        }
    };
    PolarSplineSeries.prototype.acx = function (a) {
        var b = a;
        b.dn();
    };
    PolarSplineSeries.prototype.acy = function (a, b) {
        this.acx(b);
        var c = b;
        c.dp(a.n, this.ac0);
        this.za.az(this, this.z2(), runOn(this, this.ys));
        var d = false;
        var e = this.za.b;
        if (e != null) {
            d = true;
        }
        if (d) {
            this.abh(-1, this.zo.count, b.t);
        }
        this.za.ad(b.dr, true, false, true, false);
    };
    PolarSplineSeries.$t = markType(PolarSplineSeries, 'PolarSplineSeries', PolarLineSeriesBase.$);
    PolarSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineSeries, 'raisePropertyChanged', ['Stiffness:ac0:ac2', [1, 0.5]]);
    return PolarSplineSeries;
}(PolarLineSeriesBase));
export { PolarSplineSeries };
/**
 * @hidden
 */
var PolarSplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSplineSeriesView, _super);
    function PolarSplineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dm = null;
        _this.dr = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.dq = ((function () {
            var $ret = new Path();
            $ret.an = new PathGeometry();
            return $ret;
        })());
        _this.dm = a;
        return _this;
    }
    PolarSplineSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.ch.xf = Defaults.e;
        }
        var a = new PathGeometry();
        a.c.add(((function () {
            var $ret = new PathFigure();
            return $ret;
        })()));
        this.dr.an = a;
    };
    PolarSplineSeriesView.prototype.dn = function () {
        Extensions.e(this.dr.an);
        Extensions.e(this.dq.an);
        this.a2();
    };
    PolarSplineSeriesView.prototype.dp = function (a, b) {
        this.dr.an.c = Numeric.h(a.count, function (c) { return a._inner[c].x; }, function (c) { return a._inner[c].y; }, b);
        this.a2();
    };
    PolarSplineSeriesView.prototype.bp = function () {
        _super.prototype.bp.call(this);
    };
    PolarSplineSeriesView.prototype.bq = function () {
        _super.prototype.bq.call(this);
        var a = this.b3();
        this.dq.an = this.dr.an;
        this.dq._stroke = a;
        this.dq.ad = this.f.ig + 3;
    };
    PolarSplineSeriesView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        if (a.d) {
            if (b) {
                a.t(this.dq);
            }
            else {
                a.t(this.dr);
            }
        }
    };
    PolarSplineSeriesView.prototype.ax = function (a) {
        _super.prototype.ax.call(this, a);
        this.f.bc.exportPathData(a, this.dr, "polarShape", ["Main"]);
    };
    PolarSplineSeriesView.prototype.an = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.f.v6 = a;
        this.f.jn = 3;
        this.f.jo = 1;
        this.f.jp = 4;
        this.f.hd = false;
    };
    PolarSplineSeriesView.$t = markType(PolarSplineSeriesView, 'PolarSplineSeriesView', PolarLineSeriesBaseView.$);
    return PolarSplineSeriesView;
}(PolarLineSeriesBaseView));
export { PolarSplineSeriesView };
