/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBaseChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseChart, _super);
    function RadialBaseChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aas = null;
        _this.aat = null;
        _this.aa7 = 0;
        _this.aa9 = 5;
        _this.aa8 = 0;
        _this.aa6 = 5;
        _this.abo = 5;
        _this.abq = 0;
        _this.abp = 5;
        _this.abn = 0;
        _this.agh = null;
        _this.ago = null;
        _this.agf = null;
        _this.agg = null;
        _this.abi = 0;
        _this.abz = 0;
        _this.abh = NaN;
        _this.aby = NaN;
        _this.abk = NaN;
        _this.ab1 = NaN;
        _this.abj = NaN;
        _this.ab0 = NaN;
        _this.abg = NaN;
        _this.abx = NaN;
        _this.agn = null;
        _this.agu = null;
        _this.ac9 = null;
        _this.add = null;
        _this.adb = null;
        _this.adf = null;
        _this.ac4 = null;
        _this.ac5 = null;
        _this.agi = null;
        _this.agp = null;
        _this.aba = DeviceUtils.g(1);
        _this.abr = DeviceUtils.g(1);
        _this.abb = DeviceUtils.g(1);
        _this.abs = DeviceUtils.g(1);
        _this.agk = null;
        _this.agr = null;
        _this.agl = null;
        _this.ags = null;
        _this.abc = DeviceUtils.g(1);
        _this.abt = DeviceUtils.g(1);
        _this.abd = DeviceUtils.g(8);
        _this.abu = 0;
        _this.agm = null;
        _this.agt = null;
        _this.abe = DeviceUtils.g(1);
        _this.abv = DeviceUtils.g(1);
        _this.ada = null;
        _this.ade = null;
        _this.agj = null;
        _this.agq = null;
        _this.aa5 = 0;
        _this.abm = 0;
        _this.aa4 = NaN;
        _this.abl = NaN;
        _this.abf = 0;
        _this.abw = -90;
        _this.aa0 = false;
        _this.aa1 = false;
        _this.aga = 1;
        _this.ahd = 1;
        _this.af9 = 1;
        _this.agb = 2;
        _this.ahb = 0;
        _this.ahc = 1;
        _this.ahh = 0;
        _this.ahi = 0;
        _this.aay = 4;
        _this.aao = 4;
        _this.ac8 = null;
        _this.aak = null;
        _this.adc = null;
        _this.aal = null;
        return _this;
    }
    RadialBaseChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.aaq();
            var c = this.aar();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    RadialBaseChart.prototype.vm = function () {
        _super.prototype.vm.call(this);
        var a = this.aaq();
        var b = this.aar();
        if (a != null && a.az != null) {
            this.agx = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ag4 = b.az.textColor;
        }
        this.ag2 = AxisDefaults.axis_TickBrush;
        this.ag9 = AxisDefaults.axis_TickBrush;
        this.agy = AxisDefaults.axis_MajorBrush;
        this.ag5 = AxisDefaults.axis_MajorBrush;
        this.ag1 = AxisDefaults.axis_LineBrush;
        this.ag8 = AxisDefaults.axis_LineBrush;
    };
    RadialBaseChart.prototype.wh = function (a, b, c) {
        var _this = this;
        _super.prototype.wh.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelLeftMargin":
                this.af1(function (d) { return d.leftMargin = _this.ab5; });
                break;
            case "AngleAxisLabelTopMargin":
                this.af1(function (d) { return d.topMargin = _this.ab7; });
                break;
            case "AngleAxisLabelRightMargin":
                this.af1(function (d) { return d.rightMargin = _this.ab6; });
                break;
            case "AngleAxisLabelBottomMargin":
                this.af1(function (d) { return d.bottomMargin = _this.ab4; });
                break;
            case "ValueAxisLabelLeftMargin":
                this.af6(function (d) { return d.leftMargin = _this.acq; });
                break;
            case "ValueAxisLabelTopMargin":
                this.af6(function (d) { return d.topMargin = _this.acs; });
                break;
            case "ValueAxisLabelRightMargin":
                this.af6(function (d) { return d.rightMargin = _this.acr; });
                break;
            case "ValueAxisLabelBottomMargin":
                this.af6(function (d) { return d.bottomMargin = _this.acp; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.agv = this.zi(this.agx);
                this.agw = this.zi(this.ag4);
                break;
            case "AngleAxisLabelTextColor":
                this.agv = this.zi(this.agx);
                break;
            case "ValueAxisLabelTextColor":
                this.agw = this.zi(this.ag4);
                break;
            case "ActualAngleAxisLabelTextColor":
                this.af1(function (d) { return d.textColor = _this.agv; });
                break;
            case "ActualValueAxisLabelTextColor":
                this.af6(function (d) { return d.textColor = _this.agw; });
                break;
            case "AngleAxisTitleMargin":
                this.af3(function (d) { return d.margin = _this.acg; });
                break;
            case "ValueAxisTitleMargin":
                this.af8(function (d) { return d.margin = _this.ac1; });
                break;
            case "AngleAxisTitleLeftMargin":
                this.af3(function (d) { return d.leftMargin = _this.acf; });
                break;
            case "ValueAxisTitleLeftMargin":
                this.af8(function (d) { return d.leftMargin = _this.ac0; });
                break;
            case "AngleAxisTitleTopMargin":
                this.af3(function (d) { return d.topMargin = _this.aci; });
                break;
            case "ValueAxisTitleTopMargin":
                this.af8(function (d) { return d.topMargin = _this.ac3; });
                break;
            case "AngleAxisTitleRightMargin":
                this.af3(function (d) { return d.rightMargin = _this.ach; });
                break;
            case "ValueAxisTitleRightMargin":
                this.af8(function (d) { return d.rightMargin = _this.ac2; });
                break;
            case "AngleAxisTitleBottomMargin":
                this.af3(function (d) { return d.bottomMargin = _this.ace; });
                break;
            case "ValueAxisTitleBottomMargin":
                this.af8(function (d) { return d.bottomMargin = _this.acz; });
                break;
            case "AngleAxisTitleTextColor":
                this.af3(function (d) { return d.textColor = _this.ag3; });
                break;
            case "ValueAxisTitleTextColor":
                this.af8(function (d) { return d.textColor = _this.aha; });
                break;
            case "AngleAxisFormatLabel":
                this.afz(function (d) { return d.au = _this.aau; });
                break;
            case "ValueAxisFormatLabel":
                this.af4(function (d) { return d.au = _this.aav; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aau", {
        get: function () {
            return this.aas;
        },
        set: function (a) {
            var b = this.aau;
            if (a != b) {
                this.aas = a;
                this.wd("AngleAxisFormatLabel", b, this.aau);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aav", {
        get: function () {
            return this.aat;
        },
        set: function (a) {
            var b = this.aav;
            if (a != b) {
                this.aat = a;
                this.wd("ValueAxisFormatLabel", b, this.aav);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab5", {
        get: function () {
            return this.aa7;
        },
        set: function (a) {
            var b = this.ab5;
            if (a != b) {
                this.aa7 = a;
                this.wd("AngleAxisLabelLeftMargin", b, this.ab5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab7", {
        get: function () {
            return this.aa9;
        },
        set: function (a) {
            var b = this.ab7;
            if (a != b) {
                this.aa9 = a;
                this.wd("AngleAxisLabelTopMargin", b, this.ab7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab6", {
        get: function () {
            return this.aa8;
        },
        set: function (a) {
            var b = this.ab6;
            if (a != b) {
                this.aa8 = a;
                this.wd("AngleAxisLabelRightMargin", b, this.ab6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab4", {
        get: function () {
            return this.aa6;
        },
        set: function (a) {
            var b = this.ab4;
            if (a != b) {
                this.aa6 = a;
                this.wd("AngleAxisLabelBottomMargin", b, this.ab4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acq", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.abo = a;
                this.wd("ValueAxisLabelLeftMargin", b, this.acq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acs", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.acs;
            if (a != b) {
                this.abq = a;
                this.wd("ValueAxisLabelTopMargin", b, this.acs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acr", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.abp = a;
                this.wd("ValueAxisLabelRightMargin", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acp", {
        get: function () {
            return this.abn;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.abn = a;
                this.wd("ValueAxisLabelBottomMargin", b, this.acp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agx", {
        get: function () {
            return this.agh;
        },
        set: function (a) {
            var b = this.agx;
            if (a != b) {
                this.agh = a;
                this.wd("AngleAxisLabelTextColor", b, this.agx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag4", {
        get: function () {
            return this.ago;
        },
        set: function (a) {
            var b = this.ag4;
            if (a != b) {
                this.ago = a;
                this.wd("ValueAxisLabelTextColor", b, this.ag4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agv", {
        get: function () {
            return this.agf;
        },
        set: function (a) {
            var b = this.agf;
            if (a != b) {
                this.agf = a;
                this.wd("ActualAngleAxisLabelTextColor", b, this.agv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agw", {
        get: function () {
            return this.agg;
        },
        set: function (a) {
            var b = this.agg;
            if (a != b) {
                this.agg = a;
                this.wd("ActualValueAxisLabelTextColor", b, this.agw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acg", {
        get: function () {
            return this.abi;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.abi = a;
                this.wd("AngleAxisTitleMargin", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac1", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.ac1;
            if (a != b) {
                this.abz = a;
                this.wd("ValueAxisTitleMargin", b, this.ac1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acf", {
        get: function () {
            return this.abh;
        },
        set: function (a) {
            var b = this.acf;
            if (a != b) {
                this.abh = a;
                this.wd("AngleAxisTitleLeftMargin", b, this.acf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac0", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.aby = a;
                this.wd("ValueAxisTitleLeftMargin", b, this.ac0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aci", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.abk = a;
                this.wd("AngleAxisTitleTopMargin", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac3", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.ab1 = a;
                this.wd("ValueAxisTitleTopMargin", b, this.ac3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ach", {
        get: function () {
            return this.abj;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.abj = a;
                this.wd("AngleAxisTitleRightMargin", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac2", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.ac2;
            if (a != b) {
                this.ab0 = a;
                this.wd("ValueAxisTitleRightMargin", b, this.ac2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ace", {
        get: function () {
            return this.abg;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.abg = a;
                this.wd("AngleAxisTitleBottomMargin", b, this.ace);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acz", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.abx = a;
                this.wd("ValueAxisTitleBottomMargin", b, this.acz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag3", {
        get: function () {
            return this.agn;
        },
        set: function (a) {
            var b = this.ag3;
            if (a != b) {
                this.agn = a;
                this.wd("AngleAxisTitleTextColor", b, this.ag3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aha", {
        get: function () {
            return this.agu;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.agu = a;
                this.wd("ValueAxisTitleTextColor", b, this.aha);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.wi = function (a, b, c) {
        var _this = this;
        _super.prototype.wi.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelTextStyle":
                this.af1(function (d) { return d.textStyle = _this.adw; });
                break;
            case "ValueAxisLabelTextStyle":
                this.af6(function (d) { return d.textStyle = _this.ae2; });
                break;
            case "AngleAxisTitleTextStyle":
                this.af3(function (d) { return d.textStyle = _this.aek; });
                break;
            case "ValueAxisTitleTextStyle":
                this.af8(function (d) { return d.textStyle = _this.afq; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "adw", {
        get: function () {
            return this.ac9;
        },
        set: function (a) {
            var b = this.adw;
            if (a != b) {
                this.ac9 = a;
                this.wd("AngleAxisLabelTextStyle", b, this.adw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ae2", {
        get: function () {
            return this.add;
        },
        set: function (a) {
            var b = this.ae2;
            if (a != b) {
                this.add = a;
                this.wd("ValueAxisLabelTextStyle", b, this.ae2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aek", {
        get: function () {
            return this.adb;
        },
        set: function (a) {
            var b = this.aek;
            if (a != b) {
                this.adb = a;
                this.wd("AngleAxisTitleTextStyle", b, this.aek);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afq", {
        get: function () {
            return this.adf;
        },
        set: function (a) {
            var b = this.afq;
            if (a != b) {
                this.adf = a;
                this.wd("ValueAxisTitleTextStyle", b, this.afq);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.afw = function (a) {
        var _this = this;
        this.aft(a, function (b) { return b.leftMargin = _this.ab5; });
        this.aft(a, function (b) { return b.topMargin = _this.ab7; });
        this.aft(a, function (b) { return b.rightMargin = _this.ab6; });
        this.aft(a, function (b) { return b.bottomMargin = _this.ab4; });
        this.aft(a, function (b) { return b.textColor = _this.agv; });
        this.afu(a, function (b) { return b.textColor = _this.ag3; });
        this.afu(a, function (b) { return b.leftMargin = _this.acf; });
        this.afu(a, function (b) { return b.topMargin = _this.aci; });
        this.afu(a, function (b) { return b.rightMargin = _this.ach; });
        this.afu(a, function (b) { return b.bottomMargin = _this.ace; });
        this.aft(a, function (b) { return b.textStyle = _this.adw; });
        this.afu(a, function (b) { return b.textStyle = _this.aek; });
    };
    RadialBaseChart.prototype.afy = function (a) {
        var _this = this;
        this.aft(a, function (b) { return b.leftMargin = _this.acq; });
        this.aft(a, function (b) { return b.topMargin = _this.acs; });
        this.aft(a, function (b) { return b.rightMargin = _this.acr; });
        this.aft(a, function (b) { return b.bottomMargin = _this.acp; });
        this.aft(a, function (b) { return b.textColor = _this.agw; });
        this.afu(a, function (b) { return b.textColor = _this.aha; });
        this.afu(a, function (b) { return b.leftMargin = _this.ac0; });
        this.afu(a, function (b) { return b.topMargin = _this.ac3; });
        this.afu(a, function (b) { return b.rightMargin = _this.ac2; });
        this.afu(a, function (b) { return b.bottomMargin = _this.acz; });
        this.aft(a, function (b) { return b.textStyle = _this.ae2; });
        this.afu(a, function (b) { return b.textStyle = _this.afq; });
    };
    RadialBaseChart.prototype.w9 = function (a) {
        var b = this.be(a);
        var c = this.dc(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.h6(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.h7(a);
        }
        c.name = this.q0(a);
        c.title = this.q1(a, b);
        this.dataChart.series.add(c);
    };
    RadialBaseChart.prototype.afz = function (a) {
        this.af0(a, null);
    };
    RadialBaseChart.prototype.af0 = function (a, b) {
        a(this.aaq());
    };
    RadialBaseChart.prototype.af5 = function (a, b) {
        a(this.aar());
    };
    RadialBaseChart.prototype.af4 = function (a) {
        this.af5(a, true);
    };
    RadialBaseChart.prototype.u5 = function (a, b) {
        this.afz(a);
        this.af5(a, b);
    };
    RadialBaseChart.prototype.af3 = function (a) {
        this.afu(this.aaq(), a);
    };
    RadialBaseChart.prototype.af8 = function (a) {
        this.afu(this.aar(), a);
    };
    RadialBaseChart.prototype.af6 = function (a) {
        this.aft(this.aar(), a);
    };
    RadialBaseChart.prototype.af1 = function (a) {
        this.aft(this.aaq(), a);
    };
    RadialBaseChart.prototype.acj = function (a) {
        var b = this.aaq();
        return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.acl = function (a) {
        var b = this.aaq();
        return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.ack = function (a) {
        var b = this.aar();
        return b.el(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.acm = function (a) {
        var b = this.aar();
        return b.eo(a, new ScalerParams(1, this.zr, this.zq, b.ch));
    };
    RadialBaseChart.prototype.w6 = function (a) {
        _super.prototype.w6.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.aaq();
            var c = this.aar();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    RadialBaseChart.aen = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    RadialBaseChart.prototype.vh = function (a, b) {
        _super.prototype.vh.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.aaq());
            this.dataChart.axes.add(this.aar());
        }
    };
    RadialBaseChart.prototype.afv = function (a) {
        var _this = this;
        if (a != null && this.l4 != null && a.fn == null) {
            a.provideRenderer(this.l4);
        }
        a.jz = this.agy;
        a.et = this.ab8;
        a.j0 = this.agz;
        a.ew = this.ab9;
        a.j2 = this.ag1;
        a.fi = this.aca;
        a.j1 = this.ag0;
        a.fj = this.acb;
        a.j3 = this.ag2;
        a.fk = this.acc;
        a.c4 = true;
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        var b = a == this.aaq();
        if (b) {
            a.g8 = this.aeb;
        }
        a.f2 = this.ac6;
        a.gi = this.adn;
        a.ah = this.aam;
        this.aft(a, function (c) { return c.angle = _this.ab3; });
        this.aft(a, function (c) {
            if (c.extent != _this.ab2) {
                c.extent = _this.ab2;
            }
        });
        this.aft(a, function (c) { return c.horizontalAlignment = _this.agc; });
        this.aft(a, function (c) { return c.verticalAlignment = _this.ahe; });
        this.aft(a, function (c) { return c.visibility = _this.ahj; });
        this.aft(a, function (c) { return c.location = _this.aaw(_this.aap); });
        this.afu(a, function (c) { return c.horizontalAlignment = _this.agd; });
        this.afu(a, function (c) { return c.angle = _this.acd; });
        this.afw(a);
    };
    RadialBaseChart.prototype.afx = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.l4 != null && a.fn == null) {
            a.provideRenderer(this.l4);
        }
        a.cu = this.shouldAvoidAxisAnnotationCollisions;
        a.cw = this.shouldAvoidAxisAnnotationCollisions;
        this.aft(a, function (b) { return b.angle = _this.aco; });
        this.aft(a, function (b) {
            if (b.extent != _this.acn) {
                b.extent = _this.acn;
            }
        });
        this.aft(a, function (b) { return b.horizontalAlignment = _this.age; });
        this.aft(a, function (b) { return b.verticalAlignment = _this.ahf; });
        this.aft(a, function (b) { return b.visibility = _this.ahk; });
        this.aft(a, function (b) { return b.location = _this.aax(_this.aaz); });
        this.afu(a, function (b) { return b.verticalAlignment = _this.ahg; });
        this.afu(a, function (b) { return b.angle = _this.acy; });
        a.jz = this.ag5;
        a.et = this.act;
        a.j0 = this.ag6;
        a.ew = this.acu;
        a.j2 = this.ag8;
        a.fi = this.acv;
        a.j1 = this.ag7;
        a.fj = this.acw;
        a.j3 = this.ag9;
        a.fk = this.acx;
        var b = a == this.aar();
        if (b) {
            a.g8 = this.afh;
        }
        a.gi = this.aet;
        a.ah = this.aan;
        this.afy(a);
    };
    RadialBaseChart.prototype.ve = function () {
        _super.prototype.ve.call(this);
        this.afv(this.aaq());
        this.afx(this.aar());
    };
    RadialBaseChart.prototype.aft = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d7();
            a.az.bottomMargin = a.d8();
            a.az.leftMargin = a.d9();
            a.az.rightMargin = a.ea();
            a.az.topMargin = a.eb();
            a.az.horizontalAlignment = a.ju();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.ko();
        }
        b(a.az);
    };
    RadialBaseChart.prototype.afu = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ed();
            a.bf.leftMargin = a.ee();
            a.bf.rightMargin = a.ef();
            a.bf.topMargin = a.eg();
            a.bf.location = a.a1();
            a.bf.angle = a.ec();
            a.bf.horizontalAlignment = a.jv();
            a.bf.verticalAlignment = a.kp();
        }
        b(a.bf);
    };
    RadialBaseChart.prototype.wd = function (a, b, c) {
        var _this = this;
        _super.prototype.wd.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelAngle":
                this.af1(function (d) { return d.angle = _this.ab3; });
                break;
            case "ValueAxisLabelAngle":
                this.af6(function (d) { return d.angle = _this.aco; });
                break;
            case "AngleAxisLabelHorizontalAlignment":
                this.af1(function (d) { return d.horizontalAlignment = _this.agc; });
                break;
            case "ValueAxisLabelHorizontalAlignment":
                this.af6(function (d) { return d.horizontalAlignment = _this.age; });
                break;
            case "AngleAxisLabelVerticalAlignment":
                this.af1(function (d) { return d.verticalAlignment = _this.ahe; });
                break;
            case "ValueAxisLabelVerticalAlignment":
                this.af6(function (d) { return d.verticalAlignment = _this.ahf; });
                break;
            case "AngleAxisLabelVisibility":
                this.af1(function (d) { return d.visibility = _this.ahj; });
                break;
            case "ValueAxisLabelVisibility":
                this.af6(function (d) { return d.visibility = _this.ahk; });
                break;
            case "AngleAxisLabel":
                this.afz(function (d) { return d.f2 = _this.ac6; });
                break;
            case "ValueAxisLabel":
                this.af4(function (d) { return d.f2 = _this.ac7; });
                break;
            case "AngleAxisLabelFormat":
                this.afz(function (d) { return d.gi = _this.adn; });
                break;
            case "AngleAxisLabelFormatSpecifiers":
                this.afz(function (d) { return d.ah = _this.aam; });
                break;
            case "ValueAxisLabelFormat":
                this.af4(function (d) { return d.gi = _this.aet; });
                break;
            case "ValueAxisLabelFormatSpecifiers":
                this.af4(function (d) { return d.ah = _this.aan; });
                break;
            case "AngleAxisTitleAngle":
                this.af3(function (d) { return d.angle = _this.acd; });
                break;
            case "ValueAxisTitleAngle":
                this.af8(function (d) { return d.angle = _this.acy; });
                break;
            case "AngleAxisTitleAlignment":
                this.af3(function (d) { return d.horizontalAlignment = _this.agd; });
                break;
            case "ValueAxisTitleAlignment":
                this.af8(function (d) { return d.verticalAlignment = _this.ahg; });
                break;
            case "AngleAxisTitle":
                this.afz(function (d) { return d.g8 = _this.aeb; });
                break;
            case "ValueAxisTitle":
                this.af5(function (d) { return d.g8 = _this.afh; }, false);
                break;
            case "AngleAxisMajorStroke":
                this.af0(function (d) { return d.jz = _this.agy; }, a);
                break;
            case "ValueAxisMajorStroke":
                this.af4(function (d) { return d.jz = _this.ag5; });
                break;
            case "AngleAxisMajorStrokeThickness":
                this.af0(function (d) { return d.et = _this.ab8; }, a);
                break;
            case "ValueAxisMajorStrokeThickness":
                this.af4(function (d) { return d.et = _this.act; });
                break;
            case "AngleAxisMinorStroke":
                this.afz(function (d) { return d.j0 = _this.agz; });
                break;
            case "ValueAxisMinorStroke":
                this.af4(function (d) { return d.j0 = _this.ag6; });
                break;
            case "AngleAxisMinorStrokeThickness":
                this.afz(function (d) { return d.ew = _this.ab9; });
                break;
            case "ValueAxisMinorStrokeThickness":
                this.af4(function (d) { return d.ew = _this.acu; });
                break;
            case "AngleAxisTickLength":
                this.afz(function (d) { return d.fj = _this.acb; });
                break;
            case "ValueAxisTickLength":
                this.af4(function (d) { return d.fj = _this.acw; });
                break;
            case "AngleAxisTickStroke":
                this.afz(function (d) { return d.j3 = _this.ag2; });
                break;
            case "ValueAxisTickStroke":
                this.af4(function (d) { return d.j3 = _this.ag9; });
                break;
            case "AngleAxisTickStrokeThickness":
                this.afz(function (d) { return d.fk = _this.acc; });
                break;
            case "ValueAxisTickStrokeThickness":
                this.af4(function (d) { return d.fk = _this.acx; });
                break;
            case "AngleAxisStroke":
                this.afz(function (d) { return d.j2 = _this.ag1; });
                break;
            case "ValueAxisStroke":
                this.af4(function (d) { return d.j2 = _this.ag8; });
                break;
            case "AngleAxisStrokeThickness":
                this.afz(function (d) { return d.fi = _this.aca; });
                break;
            case "ValueAxisStrokeThickness":
                this.af4(function (d) { return d.fi = _this.acv; });
                break;
            case "AngleAxisExtent":
                this.af1(function (d) { return d.extent = _this.ab2; });
                break;
            case "ValueAxisExtent":
                this.af6(function (d) { return d.extent = _this.acn; });
                break;
            case "AngleAxisStrip":
                this.afz(function (d) { return d.j1 = _this.ag0; });
                break;
            case "ValueAxisStrip":
                this.af4(function (d) { return d.j1 = _this.ag7; });
                break;
            case "AngleAxisInverted":
                this.afz(function (d) { return d.ch = _this.aa2; });
                break;
            case "ValueAxisInverted":
                this.af4(function (d) { return d.ch = _this.aa3; });
                break;
            case "ValueAxisLabelLocation":
                this.af7();
                break;
            case "AngleAxisLabelLocation":
                this.af2();
                break;
        }
    };
    RadialBaseChart.prototype.af7 = function () {
        var a = this.aax(this.aaz);
        if (a == 2 || a == 7) {
            this.age = 2;
        }
        else {
            this.age = 0;
        }
        this.af6(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.af2 = function () {
        var a = this.aaw(this.aap);
        if (a == 1 || a == 5) {
            this.ahe = 0;
        }
        else {
            this.ahe = 2;
        }
        this.af1(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.aax = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.cb == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    RadialBaseChart.prototype.aaw = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "ac6", {
        get: function () {
            return this.ac4;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.ac4 = a;
                this.wd("AngleAxisLabel", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac7", {
        get: function () {
            return this.ac5;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.ac5 = a;
                this.wd("ValueAxisLabel", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agy", {
        get: function () {
            return this.agi;
        },
        set: function (a) {
            var b = this.agy;
            if (a != b) {
                this.agi = a;
                this.wd("AngleAxisMajorStroke", b, this.agy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag5", {
        get: function () {
            return this.agp;
        },
        set: function (a) {
            var b = this.ag5;
            if (a != b) {
                this.agp = a;
                this.wd("ValueAxisMajorStroke", b, this.ag5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab8", {
        get: function () {
            return this.aba;
        },
        set: function (a) {
            var b = this.ab8;
            if (a != b) {
                this.aba = a;
                this.wd("AngleAxisMajorStrokeThickness", b, this.ab8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "act", {
        get: function () {
            return this.abr;
        },
        set: function (a) {
            var b = this.act;
            if (a != b) {
                this.abr = a;
                this.wd("ValueAxisMajorStrokeThickness", b, this.act);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab9", {
        get: function () {
            return this.abb;
        },
        set: function (a) {
            var b = this.ab9;
            if (a != b) {
                this.abb = a;
                this.wd("AngleAxisMinorStrokeThickness", b, this.ab9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acu", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.abs = a;
                this.wd("ValueAxisMinorStrokeThickness", b, this.acu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag0", {
        get: function () {
            return this.agk;
        },
        set: function (a) {
            var b = this.ag0;
            if (a != b) {
                this.agk = a;
                this.wd("AngleAxisStrip", b, this.ag0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag7", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.ag7;
            if (a != b) {
                this.agr = a;
                this.wd("ValueAxisStrip", b, this.ag7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag1", {
        get: function () {
            return this.agl;
        },
        set: function (a) {
            var b = this.ag1;
            if (a != b) {
                this.agl = a;
                this.wd("AngleAxisStroke", b, this.ag1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag8", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.ag8;
            if (a != b) {
                this.ags = a;
                this.wd("ValueAxisStroke", b, this.ag8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aca", {
        get: function () {
            return this.abc;
        },
        set: function (a) {
            var b = this.aca;
            if (a != b) {
                this.abc = a;
                this.wd("AngleAxisStrokeThickness", b, this.aca);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acv", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.abt = a;
                this.wd("ValueAxisStrokeThickness", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acb", {
        get: function () {
            return this.abd;
        },
        set: function (a) {
            var b = this.acb;
            if (a != b) {
                this.abd = a;
                this.wd("AngleAxisTickLength", b, this.acb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acw", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.abu = a;
                this.wd("ValueAxisTickLength", b, this.acw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag2", {
        get: function () {
            return this.agm;
        },
        set: function (a) {
            var b = this.ag2;
            if (a != b) {
                this.agm = a;
                this.wd("AngleAxisTickStroke", b, this.ag2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag9", {
        get: function () {
            return this.agt;
        },
        set: function (a) {
            var b = this.ag9;
            if (a != b) {
                this.agt = a;
                this.wd("ValueAxisTickStroke", b, this.ag9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acc", {
        get: function () {
            return this.abe;
        },
        set: function (a) {
            var b = this.acc;
            if (a != b) {
                this.abe = a;
                this.wd("AngleAxisTickStrokeThickness", b, this.acc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acx", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.acx;
            if (a != b) {
                this.abv = a;
                this.wd("ValueAxisTickStrokeThickness", b, this.acx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aeb", {
        get: function () {
            return this.ada;
        },
        set: function (a) {
            var b = this.aeb;
            if (a != b) {
                this.ada = a;
                this.wd("AngleAxisTitle", b, this.aeb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afh", {
        get: function () {
            return this.ade;
        },
        set: function (a) {
            var b = this.afh;
            if (a != b) {
                this.ade = a;
                this.wd("ValueAxisTitle", b, this.afh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agz", {
        get: function () {
            return this.agj;
        },
        set: function (a) {
            var b = this.agz;
            if (a != b) {
                this.agj = a;
                this.wd("AngleAxisMinorStroke", b, this.agz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ag6", {
        get: function () {
            return this.agq;
        },
        set: function (a) {
            var b = this.ag6;
            if (a != b) {
                this.agq = a;
                this.wd("ValueAxisMinorStroke", b, this.ag6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab3", {
        get: function () {
            return this.aa5;
        },
        set: function (a) {
            var b = this.ab3;
            if (a != b) {
                this.aa5 = a;
                this.wd("AngleAxisLabelAngle", b, this.ab3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aco", {
        get: function () {
            return this.abm;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.abm = a;
                this.wd("ValueAxisLabelAngle", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab2", {
        get: function () {
            return this.aa4;
        },
        set: function (a) {
            var b = this.ab2;
            if (a != b) {
                this.aa4 = a;
                this.wd("AngleAxisExtent", b, this.ab2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acn", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.abl = a;
                this.wd("ValueAxisExtent", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acd", {
        get: function () {
            return this.abf;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.abf = a;
                this.wd("AngleAxisTitleAngle", b, this.acd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acy", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.acy;
            if (a != b) {
                this.abw = a;
                this.wd("ValueAxisTitleAngle", b, this.acy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa2", {
        get: function () {
            return this.aa0;
        },
        set: function (a) {
            var b = this.aa2;
            if (a != b) {
                this.aa0 = a;
                this.wd("AngleAxisInverted", b, this.aa2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa3", {
        get: function () {
            return this.aa1;
        },
        set: function (a) {
            var b = this.aa3;
            if (a != b) {
                this.aa1 = a;
                this.wd("ValueAxisInverted", b, this.aa3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agd", {
        get: function () {
            return this.aga;
        },
        set: function (a) {
            var b = this.agd;
            if (a != b) {
                this.aga = a;
                this.wd("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agd));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahg", {
        get: function () {
            return this.ahd;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.ahd = a;
                this.wd("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahg));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "agc", {
        get: function () {
            return this.af9;
        },
        set: function (a) {
            var b = this.agc;
            if (a != b) {
                this.af9 = a;
                this.wd("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.agc));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_age = function () {
        return this.agb;
    };
    RadialBaseChart.prototype.set_age = function (a) {
        var b = this.age;
        if (a != b) {
            this.agb = a;
            this.wd("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.age));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "age", {
        get: function () {
            return this.get_age();
        },
        set: function (a) {
            this.set_age(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahe", {
        get: function () {
            return this.ahb;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.ahb = a;
                this.wd("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahe));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahf", {
        get: function () {
            return this.ahc;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.ahc = a;
                this.wd("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ahf));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahj", {
        get: function () {
            return this.ahh;
        },
        set: function (a) {
            var b = this.ahj;
            if (a != b) {
                this.ahh = a;
                this.wd("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahj));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ahk", {
        get: function () {
            return this.ahi;
        },
        set: function (a) {
            var b = this.ahk;
            if (a != b) {
                this.ahi = a;
                this.wd("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ahk));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aaz = function () {
        return this.aay;
    };
    RadialBaseChart.prototype.set_aaz = function (a) {
        var b = this.aaz;
        if (a != b) {
            this.aay = a;
            this.wd("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.aaz));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aaz", {
        get: function () {
            return this.get_aaz();
        },
        set: function (a) {
            this.set_aaz(a);
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aap = function () {
        return this.aao;
    };
    RadialBaseChart.prototype.set_aap = function (a) {
        var b = this.aap;
        if (a != b) {
            this.aao = a;
            this.wd("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.aap));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aap", {
        get: function () {
            return this.get_aap();
        },
        set: function (a) {
            this.set_aap(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adn", {
        get: function () {
            return this.ac8;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.ac8 = a;
                this.wd("AngleAxisLabelFormat", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aam", {
        get: function () {
            return this.aak;
        },
        set: function (a) {
            var b = this.aak;
            if (a != b) {
                this.aak = a;
                this.wd("AngleAxisLabelFormatSpecifiers", b, this.aak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aet", {
        get: function () {
            return this.adc;
        },
        set: function (a) {
            var b = this.adc;
            if (a != b) {
                this.adc = a;
                this.wd("ValueAxisLabelFormat", b, this.adc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aan", {
        get: function () {
            return this.aal;
        },
        set: function (a) {
            var b = this.aal;
            if (a != b) {
                this.aal = a;
                this.wd("ValueAxisLabelFormatSpecifiers", b, this.aal);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.$t = markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
}(DomainChart));
export { RadialBaseChart };
