/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, enumGetBox, EnumUtil, Array_$type, runOn, delegateCombine, typeCast, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { DependencyProperty } from "igniteui-react-core";
import { RadialLabelMode_$type } from "igniteui-react-core";
import { CategoryCollisionMode_$type } from "./CategoryCollisionMode";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { BindingFormatter } from "igniteui-react-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { RadialFrame } from "./RadialFrame";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { ProportionalRadialLabelContext } from "./ProportionalRadialLabelContext";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-react-core";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.c9.ie;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.ca;
        var c = this.a.b9;
        var d = this.a.getEffectiveViewport();
        var e = this.a.c9.y4;
        if (b.isEmpty || c.isEmpty || e == null || this.a.c9.dp == null || this.a.c9.dp.count == 0) {
            this.b = 0;
            return;
        }
        var f = Math.floor(e.m9(c, d, b));
        var g = Math.ceil(e.m8(c, d, b));
        if (e.ch) {
            g = Math.ceil(e.m9(c, d, b));
            f = Math.floor(e.m8(c, d, b));
        }
        if (g < f) {
            g = e.lj + g;
        }
        var h = this.a.c9.za;
        var i = h != null ? h.n7 : 0.75;
        var j = Math.min(c.width, c.height) * 0.5 * (i) * 2 * Math.PI;
        var k = Math.floor((g - f + 1) * a / j);
        this.b = truncate(Math.max(1, k));
        this.c = truncate(Math.max(0, Math.floor(f / this.b) - 1));
        this.d = truncate(Math.ceil(g / this.b));
        if (e.cl) {
            this.b = 1;
            this.c = truncate(Math.max(0, Math.floor(f / this.b) - 1));
            this.d = truncate(Math.ceil(g / this.b));
        }
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.zj = null;
        _this.zq = false;
        _this.zp = false;
        _this.zn = null;
        _this.zo = null;
        _this.assigningRadialStyle = null;
        _this.assigningRadialMarkerStyle = null;
        _this.yx = null;
        _this.y1 = null;
        _this.yy = null;
        _this.y0 = null;
        _this.yz = null;
        _this.zf = new RadialFrame(4);
        _this.zg = new RadialFrame(4);
        _this.zd = new RadialFrame(4);
        _this.zb = null;
        _this.y9 = null;
        _this.y9 = new CategoryTransitionSourceFramePreparer();
        _this.zj = new RadialSeriesRenderManager();
        return _this;
    }
    RadialBase.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.zc = a;
    };
    RadialBase.prototype.abb = function () {
        if (this.dd.g) {
            this.dd.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.y4;
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.a0 = function () {
        return this.y4;
    };
    RadialBase.prototype.ys = function (a, b) {
        return null;
    };
    RadialBase.prototype.pu = function (a) {
        var b = this.y4;
        if (b.n6(a)) {
            if (this.fj) {
                this.ba.a$x(this, a, this.y4.lk - 1);
            }
            return;
        }
        _super.prototype.pu.call(this, a);
    };
    RadialBase.prototype.eg = function (a) {
        if (this.y4 != null && this.y4.cl && this.y4.hasOthersCategory) {
            if (this.y4.n6(a)) {
                return true;
            }
        }
        return _super.prototype.eg.call(this, a);
    };
    RadialBase.prototype.ps = function (a) {
        var b = this.y4;
        if (b.n6(a)) {
            if (this.fj) {
                this.ba.a$an(this, a, this.dp.count - 1);
            }
            return;
        }
        _super.prototype.ps.call(this, a);
    };
    RadialBase.prototype.ed = function (a, b, c, d, e) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var f = this.y4;
        var g = new ScalerParams(1, this.dc.wh, this.wx, f.ch);
        g.c = this.getEffectiveViewport1(this.cw);
        var h = this.za;
        var i = new ScalerParams(1, this.dc.wh, this.wx, h.ch);
        i.c = this.getEffectiveViewport1(this.cw);
        var j = this.z8;
        a.clear();
        this.xb.cw(function (k) {
            if (k._visibility == 0) {
                var l = new SeriesPointOfInterest();
                var m = k.n;
                var n = k.o;
                if (m < _this.wx.left || m > _this.wx.right || n < _this.wx.top || n > _this.wx.bottom) {
                    return;
                }
                var o = null;
                if (k.content != null) {
                    o = k.content.item;
                }
                var p = void 0;
                var q = void 0;
                var r = _this.zb.h(m, n, _this.cw.ca, _this.cw.b9, _this.cw.getEffectiveViewport(), p, q);
                p = r.p5;
                q = r.p6;
                l.d = p;
                l.e = q;
                var s = l.e;
                var t = k.ak;
                l.f = _this.aa8(s, o, t, d, j, c, b, false);
                l.b = k.content;
                l.g = _this.vl;
                l.c = k.ak;
                if (_this.ha) {
                    l.g = _this.vs(k.ak);
                }
                l.a = _this.ar(k.ak, k.al);
                a.add(l);
            }
        });
        return true;
    };
    RadialBase.prototype.kt = function (a, b) {
        var c = null;
        if (this.dp != null) {
            if (a >= 0 && a < this.dp.count) {
                c = this.dp.item(a);
            }
            if (this.y4 != null && this.y4.cl && a == this.y4.othersIndex) {
                c = this.y4.oj(false);
            }
        }
        var d = NaN;
        if (c != null) {
            d = this.jd(c);
        }
        var e = this.aa8(d, c, a, this.z7 >= 0 ? this.z7 : 5, this.z8, false, false, b);
        if (e != null) {
            return e;
        }
        return _super.prototype.kt.call(this, a, b);
    };
    RadialBase.prototype.aa8 = function (a, b, c, d, e, f, g, h) {
        var i = null;
        var j = this.y4.n6(b);
        var k = this.zh;
        if (h) {
            k = this.zi;
        }
        if (k == 0) {
            if (h) {
                k = 5;
            }
            else {
                k = 6;
            }
        }
        if ((h && ((this.yy != null) || (j && this.yz != null))) || (!h && ((this.y1 != null) || (j && this.y0 != null)))) {
            var l_1 = this.z4(a, b, c, d, f);
            var m_1 = this.z5(a, b, c, e, f);
            var n_1 = this.aap(c);
            var o = ((function () {
                var $ret = new ProportionalRadialLabelContext();
                $ret.value = l_1;
                $ret.percent = m_1;
                $ret.label = n_1;
                $ret.item = b;
                return $ret;
            })());
            var p = null;
            if (j) {
                if (h) {
                    p = this.yz;
                }
                else {
                    p = this.y0;
                }
                if (p == null) {
                    if (h) {
                        p = this.yy;
                    }
                    else {
                        p = this.y1;
                    }
                }
            }
            else {
                if (h) {
                    p = this.yy;
                }
                else {
                    p = this.y1;
                }
            }
            i = p.i(o);
        }
        else if (k != 1) {
            switch (k) {
                case 2:
                    i = this.aaq(a, b, c, d, f);
                    break;
                case 3:
                    i = this.aar(a, b, c, e, f);
                    break;
                case 4:
                    {
                        var q = this.aaq(a, b, c, d, f);
                        var r = this.aar(a, b, c, e, f);
                        i = q + this.aag + r;
                    }
                    break;
                case 5:
                    i = this.aap(c);
                    break;
                case 6:
                    {
                        var s = this.aaq(a, b, c, d, f);
                        var t = this.aap(c);
                        i = t + this.aag + s;
                    }
                    break;
                case 7:
                    {
                        var u = this.aar(a, b, c, e, f);
                        var v = this.aap(c);
                        i = v + this.aag + u;
                    }
                    break;
                case 8:
                    {
                        var w = this.aaq(a, b, c, d, f);
                        var x = this.aar(a, b, c, e, f);
                        var y = this.aap(c);
                        i = y + this.aag + w + this.aag + x;
                    }
                    break;
            }
        }
        else {
            if (g) {
                i = this.aaq(a, b, c, d, f);
            }
            else {
                i = this.aap(c);
            }
        }
        return i;
    };
    RadialBase.prototype.aap = function (a) {
        var b = this.y4;
        var c = this.au(true);
        if (this.y4 != null && this.y4.cl && this.y4.hasOthersCategory && a == this.y4.othersIndex) {
            if (this.yx != null) {
                c = this.yx;
            }
        }
        if (c != null) {
            var d = _super.prototype.kt.call(this, a, false);
            if (d != null) {
                return c.i(d);
            }
            else {
                return null;
            }
        }
        else {
            return b.gf(a);
        }
    };
    RadialBase.prototype.aaq = function (a, b, c, d, e) {
        var f = a;
        f = this.aac(c, f);
        if (e) {
            return this.aae(f, d);
        }
        else {
            a = this.jd(b);
            if (!isNaN_(a)) {
                return this.aae(a, d);
            }
            else {
                return this.aae(f, d);
            }
        }
    };
    RadialBase.prototype.z4 = function (a, b, c, d, e) {
        var f = a;
        f = this.aac(c, f);
        if (e) {
            return f;
        }
        else {
            a = this.jd(b);
            if (!isNaN_(a)) {
                return a;
            }
            else {
                return f;
            }
        }
    };
    RadialBase.prototype.aar = function (a, b, c, d, e) {
        if (this.y4 == null || !this.y4.cl) {
            return this.aaq(a, b, c, d, e);
        }
        var f = this.y4.od(c);
        if (e) {
            return this.aae(f, d) + "%";
        }
        else {
            a = this.y4.od(c);
            if (!isNaN_(a)) {
                return this.aae(a, d) + "%";
            }
            else {
                return this.aae(f, d) + "%";
            }
        }
    };
    RadialBase.prototype.z5 = function (a, b, c, d, e) {
        if (this.y4 == null || !this.y4.cl) {
            return this.z4(a, b, c, d, e);
        }
        var f = this.y4.od(c);
        if (e) {
            return f;
        }
        else {
            a = this.y4.od(c);
            if (!isNaN_(a)) {
                return a;
            }
            else {
                return f;
            }
        }
    };
    RadialBase.prototype.aac = function (a, b) {
        return b;
    };
    RadialBase.prototype.aae = function (a, b) {
        var c;
        if (b >= 0) {
            c = round10N(a, b);
        }
        else {
            c = a;
        }
        var d = this.au(false);
        if (d != null) {
            var e = d;
            return e.i(c);
        }
        else {
            return c.toString();
        }
    };
    RadialBase.prototype.get_fu = function () {
        return true;
    };
    RadialBase.prototype.get_ff = function () {
        return true;
    };
    RadialBase.prototype.zk = function (a, b, c) {
        var d = new HighlightingInfo();
        d.i = this;
        d.g = 0;
        d.f = this.dp.count - 1;
        d.c = true;
        if (c != null && c.g == d.g && c.f == d.f) {
            return c;
        }
        return d;
    };
    RadialBase.prototype.z1 = function () {
        return false;
    };
    RadialBase.prototype.hu = function () {
        var a = _super.prototype.hu.call(this);
        if (this.z1()) {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "DashArray";
                $ret.p = true;
                $ret.x = ((function () {
                    var $ret = new DoubleCollection();
                    $ret.add(5);
                    $ret.add(5);
                    return $ret;
                })());
                $ret.q = true;
                return $ret;
            })());
            a.add(b);
        }
        if (!this.z1()) {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.r4));
            a.add(c);
        }
        if (!this.z1()) {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.r4));
            a.add(d);
        }
        var e = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(e);
        var f = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(f);
        return a;
    };
    RadialBase.prototype.kw = function () {
        if (this.d4()) {
            return this.bo.zg;
        }
        else {
            return this.bo.zd;
        }
    };
    RadialBase.prototype.zl = function (a, b, c) {
        if (this.dp == null) {
            return null;
        }
        var d = this.zc.da.c;
        var e = this.zc.da.d;
        var f = this.zc.da.b;
        var g = this.ze();
        var h = this.dp.count;
        var i = this.y4;
        var j = -1;
        var k = -1;
        var l = this.j4(b);
        if (isNaN_(b.x) || isNaN_(b.y)) {
            if (a != null && this.dp != null) {
                if (this.y4.n6(a)) {
                    l = this.y4.othersIndex;
                }
                else {
                    l = this.dp.indexOf(a);
                }
            }
        }
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.g == j && c.f == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.i = this;
        m.g = j;
        m.f = k;
        return m;
    };
    RadialBase.prototype.zm = function (a, b, c) {
        if (this.dp == null) {
            return null;
        }
        var d = this.zc.da.c;
        var e = this.zc.da.d;
        var f = this.zc.da.b;
        var g = this.ze();
        var h = this.dp.count;
        var i = this.y4;
        var j = -1;
        var k = -1;
        var l = this.j4(b);
        if (isNaN_(b.x) || isNaN_(b.y)) {
            if (a != null && this.dp != null) {
                if (this.y4.n6(a)) {
                    l = this.y4.othersIndex;
                }
                else {
                    l = this.dp.indexOf(a);
                }
            }
        }
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.g == j && c.f == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.d = true;
        m.i = this;
        m.g = j;
        m.f = k;
        return m;
    };
    RadialBase.prototype.dh = function (a, b, c) {
        if (this.ef && this.f0(this.by) && !c) {
            var d = this.zl(a, b, this.zn);
            this.zn = d;
            return d;
        }
        else {
            var e = this.zk(a, b, this.zn);
            this.zn = e;
            return e;
        }
    };
    RadialBase.prototype.di = function (a, b, c) {
        if (this.f0(this.by) && !c) {
            var d = this.zm(a, b, this.zo);
            this.zo = d;
            return d;
        }
        else {
            var e = this.zk(a, b, this.zo);
            e.d = true;
            this.zo = e;
            return e;
        }
    };
    RadialBase.prototype.z0 = function () {
        return (this.assigningRadialStyle != null && this.zq) || this.d3 || (this.by != 1) || (this.cq != 1) || (this.cp != 1);
    };
    RadialBase.prototype.zz = function () {
        return (this.assigningRadialMarkerStyle != null && this.zp) || this.d3 || (this.by != 1) || (this.cq != 1) || (this.cp != 1);
    };
    RadialBase.prototype.abe = function (a) {
        if (this.assigningRadialStyle != null && this.zq) {
            this.assigningRadialStyle(this, a);
        }
    };
    RadialBase.prototype.abd = function (a) {
        if (this.assigningRadialMarkerStyle != null && this.zp) {
            this.assigningRadialMarkerStyle(this, a);
        }
    };
    RadialBase.prototype.z9 = function (a) {
        return a.da.b;
    };
    RadialBase.prototype.aaa = function (a) {
        return a.da.c;
    };
    RadialBase.prototype.ai = function () {
        return [this.y4, this.za];
    };
    RadialBase.prototype.sv = function (a, b) {
        this.zc.da.e(this.ie);
        this.ru(false);
    };
    RadialBase.prototype.su = function (a, b) {
        if (this.g2 && this.jr < 0.05 && (this.dc == null || !this.dc.fn())) {
            this.g3 = true;
            this.g6 = false;
            this.gl = false;
        }
        this.zc.da.e(this.ie);
        this.ru(false);
    };
    RadialBase.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case RadialBase.$$p[6]:
                this.ru(false);
                break;
            case RadialBase.$$p[14]:
                this.pg();
                this.ru(false);
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.y4 != null) {
                        this.y4.b0(this);
                    }
                    if (this.za != null) {
                        this.za.b0(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.y4 != null) {
                        this.y4.ct(this);
                    }
                    if (this.za != null) {
                        this.za.ct(this);
                    }
                }
                this.zc.da.e(this.ie);
                this.ru(false);
                break;
            case RadialBase.$$p[0]:
                if (this.y4 != null && this.za != null) {
                    this.zb = new RadialAxes(this.za, this.y4);
                }
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.zc.da.e(this.ie);
                this.ru(false);
                break;
            case RadialBase.$$p[22]:
                if (this.y4 != null && this.za != null) {
                    this.zb = new RadialAxes(this.za, this.y4);
                }
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.zc.da.e(this.ie);
                if (this.za == null || !this.za.c1()) {
                    this.ru(false);
                }
                break;
            case RadialBase.$$p[3]:
            case RadialBase.$$p[4]:
                if (this.aai != null) {
                    this.yx = new BindingFormatter();
                    this.yx.j = this.aai;
                    this.yx.d = this.yr;
                }
                else {
                    this.yx = null;
                }
                break;
            case RadialBase.$$p[19]:
            case RadialBase.$$p[20]:
                if (this.aa5 != null) {
                    this.y1 = new BindingFormatter();
                    this.y1.j = this.aa5;
                    this.y1.d = this.yw;
                }
                else {
                    this.y1 = null;
                }
                break;
            case RadialBase.$$p[12]:
            case RadialBase.$$p[13]:
                if (this.aav != null) {
                    this.yy = new BindingFormatter();
                    this.yy.j = this.aav;
                    this.yy.d = this.yt;
                }
                else {
                    this.yy = null;
                }
                break;
            case RadialBase.$$p[17]:
            case RadialBase.$$p[18]:
                if (this.aa5 != null) {
                    this.y0 = new BindingFormatter();
                    this.y0.j = this.aa2;
                    this.y0.d = this.yv;
                }
                else {
                    this.y0 = null;
                }
                break;
            case RadialBase.$$p[15]:
            case RadialBase.$$p[16]:
                if (this.aav != null) {
                    this.yz = new BindingFormatter();
                    this.yz.j = this.aaz;
                    this.yz.d = this.yu;
                }
                else {
                    this.yz = null;
                }
                break;
            case "SyncLink":
                if (this.c4 != null && this.dc != null) {
                    this.zc.da.e(this.ie);
                    this.ru(false);
                }
                break;
            case "TransitionProgress":
                this.zg.c(this.jr, this.zf, this.zd);
                if (this.d7(this.cw)) {
                    return;
                }
                if (this.jr == 1) {
                    this.zd.y();
                    this.abf(this.zd, this.zc);
                    if (this.g2) {
                        this.g2 = false;
                        this.o8();
                        this.dd.r = truncate(this.ja());
                        this.dd.b = this.de;
                    }
                    if (this.g5) {
                        this.g5 = false;
                        this.o8();
                        this.dd.r = truncate(this.ja());
                        this.dd.b = this.de;
                        this.q2();
                    }
                    this.qq();
                }
                else {
                    this.abf(this.zg, this.zc);
                }
                if (this.dc != null) {
                    this.dc.qx(this);
                }
                break;
            case RadialBase.$$p[8]:
                this.ru(false);
                this.qn();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.zc.da.e(this.ie);
                }
                break;
            case RadialBase.$$p[10]:
                this.zq = this.zy();
                this.ru(false);
                break;
            case RadialBase.$$p[9]:
                this.zp = this.zx();
                this.ru(false);
                break;
        }
    };
    RadialBase.prototype.zy = function () {
        return this.zv;
    };
    RadialBase.prototype.zx = function () {
        return this.zu;
    };
    RadialBase.prototype.zs = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.zr = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.ko = function (a) {
        var b = this.j4(a);
        var c = false;
        if (this.y4 != null && this.y4.cl) {
            var d = this.y4;
            var e = d.hasOthersCategory && b == this.y4.lj - 1;
            c = e;
        }
        if (c) {
            return this.y4.oj(true);
        }
        return b >= 0 && this.dp != null && b < this.dp.count ? this.dp.item(b) : null;
    };
    RadialBase.prototype.z2 = function (a) {
        var b = this.cw.ca;
        var c = this.cw.b9;
        var d = this.cw.getEffectiveViewport();
        if (this.y4 != null && !b.isEmpty && !c.isEmpty && this.zb != null) {
            var e = this.zb.c(a, b, c, d);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            return e;
        }
        return NaN;
    };
    RadialBase.prototype.is = function (a) {
        var b = this.cw.ca;
        var c = this.cw.b9;
        var d = this.getEffectiveViewport1(this.cw);
        var e = -1;
        if (this.y4 != null && !b.isEmpty && !c.isEmpty && this.zb != null) {
            var f = this.zb.c(a, b, c, d);
            if (f < 0) {
                f += Math.PI * 2;
            }
            if (f > Math.PI * 2) {
                f -= Math.PI * 2;
            }
            var g = this.y4.getUnscaledAngle(f);
            if (this.y4.categoryMode != 0) {
                g -= 0.5;
            }
            e = g;
        }
        return e;
    };
    RadialBase.prototype.z3 = function (a, b, c, d) {
        return this.y4.m7(a, b, c, d);
    };
    RadialBase.prototype.j4 = function (a) {
        var b = truncate(Math.round(this.is(a)));
        var c = false;
        if (this.y4 != null && this.y4.cl) {
            var d = this.y4;
            var e = d.hasOthersCategory && b == this.y4.lj - 1;
            c = e;
        }
        if (c) {
            var f = this.y4;
            return this.y4.lj - 1;
        }
        if (this.dp != null && b == this.dp.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.ge = function (a) {
        return false;
    };
    RadialBase.prototype.ze = function () {
        var a = this.zd;
        if (this.d4()) {
            if (this.dd.g) {
                this.dd.t();
            }
            a = this.zg;
        }
        return a;
    };
    RadialBase.prototype.qd = function () {
        _super.prototype.qd.call(this);
        if (this.y4 != null) {
            this.y4.ib(false);
        }
        if (this.za != null) {
            this.za.ib(false);
        }
    };
    RadialBase.prototype.hf = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.hf.call(this, a, b, c) || !c.r() || b.isEmpty || a.isEmpty || this.y4 == null || this.y4.itemsSource == null || this.za == null || this.zb == null || this.dp == null || this.y4.bi == null || this.za.bi == null || this.za.l4 == this.za.l3) {
            e.da.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.y7 = function () {
        return 1;
    };
    RadialBase.prototype.z6 = function () {
        return Math.max(0, 0.5 * this.za.n6);
    };
    RadialBase.prototype.go = function () {
        return this.zw;
    };
    RadialBase.prototype.gp = function () {
        return true;
    };
    RadialBase.prototype.rv = function (a) {
        _super.prototype.rv.call(this, a);
        this.zc.da.e(this.ie);
        if (this.d7(this.cw)) {
            this.zd.ab();
            this.zg.ab();
            this.zf.ab();
            return;
        }
        if (this.gs) {
            if (this.d4()) {
                if (this.dd.g) {
                    this.dd.t();
                }
                this.abf(this.zg, this.zc);
            }
            else {
                this.abf(this.zd, this.zc);
            }
            return;
        }
        if (this.gg(a)) {
            var b = this.zf;
            if (this.d4()) {
                if (this.dd.g) {
                    this.dd.t();
                }
                this.zf = this.zg;
                this.zg = b;
            }
            else {
                this.zf = this.zd;
                this.zd = b;
            }
            var c = false;
            this.abc(this.zd, this.zc);
            if (this.g4) {
                this.dd.w();
                this.dd.r = truncate(this.jb());
                this.dd.b = this.df != null ? this.df : this.de;
                if (this.g5) {
                    var d = this.zg;
                    this.zg = this.zf;
                    this.zf = d;
                    c = true;
                }
                this.y9.x(this, this.zf, this.zd, this.isVertical, this.y4, this.za, this.y8, this.y7(), this.c6, this.c5(), runOn(this, this.z6), this.zc.b9);
                if (this.g5) {
                    var e = this.zg;
                    this.zg = this.zf;
                    this.zf = e;
                }
                this.g5 = false;
            }
            if (this.g7) {
                this.dd.w();
                this.dd.r = truncate(this.jc());
                this.dd.b = this.dg != null ? this.dg : this.de;
                if (this.g2) {
                    var f = this.zg;
                    this.zg = this.zf;
                    this.zf = f;
                    c = true;
                }
                this.y9.x(this, this.zf, this.zd, this.isVertical, this.y4, this.za, this.y8, this.y7(), this.c6, this.c5(), runOn(this, this.z6), this.zc.b9);
                var g = this.zd;
                this.zd = this.zf;
                this.zf = g;
                if (this.g2) {
                    var h = this.zg;
                    this.zg = this.zf;
                    this.zf = h;
                }
                this.g2 = false;
            }
            this.eb = false;
            if (!c) {
                this.o3();
            }
            this.sb();
            if (this.g4) {
                this.g3 = false;
                this.g2 = true;
            }
            if (this.g7) {
                this.g6 = false;
                this.g5 = true;
            }
        }
        else {
            this.abc(this.zd, this.zc);
            this.abf(this.zd, this.zc);
        }
    };
    RadialBase.prototype.aab = function () {
        var e_1, _a;
        if (this.bo != null) {
            var a = this.bo;
            return a.aab();
        }
        var b = 0;
        try {
            for (var _b = __values(fromEnum(this.dc.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c == this || this.bo == c) {
                    return b;
                }
                var d = typeCast(RadialBase.$, c);
                if (d != null && d.y4 == this.y4 && d.preferredCategoryMode(d.y4) == 2) {
                    b++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.p6(a, c, b);
        return c.toArray();
    };
    RadialBase.prototype.p6 = function (a, b, c) {
        var _this = this;
        var d = this.cw.ca;
        var e = this.cw.b9;
        var f = this.cw.getEffectiveViewport();
        var g, h;
        var i = this.zb.f(this.dc.wm(a), d, e, f, g, h);
        g = i.p4;
        h = i.p5;
        if (g == -1 || h == -1) {
            return;
        }
        var j = h - g + 1;
        if (g > h) {
            j = this.y4.lk - g + h + 1;
        }
        if (j > 0 && (c == 7 || c == 6)) {
            b.add(((function () {
                var $ret = new ChartSelection();
                $ret.series = _this;
                return $ret;
            })()));
            return;
        }
        var _loop_1 = function (k) {
            var l = (k + g) % (this_1.y4.lk);
            if (c == 2 || c == 1) {
                b.add(((function () {
                    var $ret = new ChartSelection();
                    $ret.item = _this.y4.kv.item(l);
                    return $ret;
                })()));
            }
            else {
                b.add(((function () {
                    var $ret = new ChartSelection();
                    $ret.item = _this.y4.kv.item(l);
                    $ret.series = _this;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var k = 0; k < j; k++) {
            _loop_1(k);
        }
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:y4:abg', [CategoryAngleAxis.$, null], 'AutoCalloutLabelPrecision:z7:abh', [1, -1], 'AutoCalloutLabelValueSeparator:aag:abi', [2, " - "], 'AutoCalloutOthersLabelFormat:aai:abj', [2, null], 'AutoCalloutOthersLabelFormatSpecifiers:yr:abk', [Array_$type, null], 'AutoCalloutPercentagePrecision:z8:abl', [1, 2], 'AutoCalloutRadialLabelMode:zh:abm', [RadialLabelMode_$type, enumGetBox(RadialLabelMode_$type, 0)], 'CategoryCollisionMode:y5:abn', [CategoryCollisionMode_$type, enumGetBox(CategoryCollisionMode_$type, 1)], 'ClipSeriesToBounds:zt:abo', [0, false], 'IsCustomRadialMarkerStyleAllowed:zu:abp', [0, false], 'IsCustomRadialStyleAllowed:zv:abq', [0, false], 'IsTransitionInEnabled:zw:abr', [0, false], 'LegendProportionalRadialLabelFormat:aav:abs', [2, null], 'LegendProportionalRadialLabelFormatSpecifiers:yt:abt', [Array_$type, null], 'LegendRadialLabelMode:zi:abu', [RadialLabelMode_$type, enumGetBox(RadialLabelMode_$type, 0)], 'OthersLegendProportionalRadialLabelFormat:aaz:abv', [2, null], 'OthersLegendProportionalRadialLabelFormatSpecifiers:yu:abw', [Array_$type, null], 'OthersProportionalRadialLabelFormat:aa2:abx', [2, null], 'OthersProportionalRadialLabelFormatSpecifiers:yv:aby', [Array_$type, null], 'ProportionalRadialLabelFormat:aa5:abz', [2, null], 'ProportionalRadialLabelFormatSpecifiers:yw:ab0', [Array_$type, null], 'TransitionInMode:y8:ab1', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'ValueAxis:za:ab2', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.c9 = null;
        _this.db = null;
        _this.dc = 0;
        _this.dd = null;
        _this.c9 = a;
        _this.db = new Pool$1(Marker.$);
        _this.c0(_this.db);
        return _this;
    }
    RadialBaseView.prototype.cw = function (a) {
        this.db.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
