/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { runOn, typeCast, EnumUtil, markType, markDep } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
/**
 * @hidden
 */
var VerticalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAnchoredCategorySeries, _super);
    function VerticalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aci = null;
        return _this;
    }
    VerticalAnchoredCategorySeries.prototype.cl = function () {
        if (this.xAxis != null && this.xAxis.ch) {
            return 4;
        }
        return 3;
    };
    VerticalAnchoredCategorySeries.prototype.cm = function () {
        return 1;
    };
    VerticalAnchoredCategorySeries.prototype.o4 = function () {
        _super.prototype.o4.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "acj", {
        get: function () {
            var _this = this;
            if (this.aci == null) {
                this.aci = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.ds.n; });
            }
            return this.aci;
        },
        enumerable: false,
        configurable: true
    });
    VerticalAnchoredCategorySeries.prototype.get_isVertical = function () {
        return true;
    };
    VerticalAnchoredCategorySeries.prototype.yx = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.ze = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.y4.r(this.yx(), this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
    };
    VerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        return this.yAxis.getCategorySize(this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
    };
    VerticalAnchoredCategorySeries.prototype.j9 = function (a, b) {
        return this.ka(a, b, this.yx(), runOn(this, this.zy), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.kb = function (a, b) {
        return this.kc(a, b, this.yx(), runOn(this, this.zy), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.iq = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ir(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.zy));
    };
    VerticalAnchoredCategorySeries.prototype.az = function (a) {
        if (a.isEmpty && this.dc != null) {
            a = this.dc.wh;
        }
        if (this.valueColumn == null) {
            return null;
        }
        var b = this.wo(this.cw);
        var c = this.yx();
        var d = new ScalerParams(0, a, this.dc.wz, c.ch, this.getEffectiveViewport());
        var e = (c.eo(b.top, d));
        var f = (c.eo(b.bottom, d));
        if (!c.ch) {
            var g = e;
            e = f;
            f = g;
        }
        e -= this.abf;
        f += this.abf;
        var h = null;
        if (c.cn) {
            h = c;
            e = h.i$f(e);
            f = h.i$f(f);
        }
        else {
            e = Math.floor(e);
            f = Math.ceil(f);
        }
        if (isNaN_(e) || isNaN_(f)) {
            return null;
        }
        e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
        f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
        var i = 1.7976931348623157E+308;
        var j = -1.7976931348623157E+308;
        if (truncate(e) <= truncate(f)) {
            for (var k = truncate(e); k <= truncate(f); k++) {
                var l = k;
                if (h != null) {
                    l = h.i$b._inner[k];
                }
                var m = this.valueColumn.item(l);
                if (this.valueColumn.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                i = Math.min(i, m);
                j = Math.max(j, m);
            }
        }
        var n = new AxisRange(i, j);
        n = this.ax(n, this.ze(), a);
        return n;
    };
    VerticalAnchoredCategorySeries.prototype.b3 = function () {
        if (this.b4 == 0) {
            return 1;
        }
        else {
            return _super.prototype.b3.call(this);
        }
    };
    VerticalAnchoredCategorySeries.prototype.wu = function (a) {
        if (!this.hasMarkers || !this.xl()) {
            return Rect.empty;
        }
        return this.acj.e$b(this, this.yz.p, a, runOn(this, this.acr));
    };
    VerticalAnchoredCategorySeries.prototype.acr = function (a) {
        return this.aaz.ds(a);
    };
    VerticalAnchoredCategorySeries.prototype.gx = function (a, b) {
        if (this.gw(a, b)) {
            return true;
        }
        if (this.xm(a, b)) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.i6 = function (a, b, c) {
        if (this.dc == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.cw);
        var e = this.yx();
        var f = new ScalerParams(0, this.dc.wh, this.cw.b9, e.ch, d);
        var g = this.y4.r(e, this.dc.wh, this.cw.b9, d);
        return this.i8(this.valueColumn, a, e, f, g, runOn(this, this.zy), b, c);
    };
    VerticalAnchoredCategorySeries.prototype.wh = function (a, b, c) {
        var d = this.yx();
        return this.wj(a, b, c, this.y4.r(d, this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw)), this.ze(), d, null, null, null);
    };
    VerticalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.abv = function (a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.abw = function (a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.zu = function () {
        return this.xAxis != null && this.xAxis.c1();
    };
    VerticalAnchoredCategorySeries.prototype.yr = function (a, b) {
        return this.aaw(a, b, this.yAxis);
    };
    VerticalAnchoredCategorySeries.prototype.is = function (a) {
        return this.acj.e$a(this, a);
    };
    VerticalAnchoredCategorySeries.prototype.zy = function (a) {
        return this.iu(a, this.yx());
    };
    VerticalAnchoredCategorySeries.prototype.j4 = function (a) {
        return truncate(Math.round(this.is(a)));
    };
    VerticalAnchoredCategorySeries.prototype.ko = function (a) {
        var b = this.j4(a);
        return b >= 0 && this.dp != null && b < this.dp.count ? this.dp.item(b) : null;
    };
    VerticalAnchoredCategorySeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.pe(typeCast(Axis.$, c));
                    this.rk(typeCast(Axis.$, d));
                    this.y8.c9.g(this.ie);
                    if (this.dc != null) {
                        this.dc.ob();
                    }
                    this.ru(false);
                    this.qn();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.pe(typeCast(Axis.$, c));
                    this.rk(typeCast(Axis.$, d));
                    this.y8.c9.g(this.ie);
                    this.zu();
                    this.ru(false);
                    this.qn();
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.aaz.dk = CategoryTrendLineManagerFactory.a(this.aaz.dk, this.yAxis, this.sz, this, this.ds);
                }
                break;
        }
    };
    VerticalAnchoredCategorySeries.prototype.acm = function (a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.acl = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.zv;
        },
        enumerable: false,
        configurable: true
    });
    VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    VerticalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::acp', [NumericXAxis.$, null], 'YAxis::acq', [CategoryYAxis.$, null]]);
    return VerticalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { VerticalAnchoredCategorySeries };
