import { __extends } from "tslib";
import { IgrDataAnnotationPointLayer } from "./igr-data-annotation-point-layer";
import { DataAnnotationBandLayer } from "./DataAnnotationBandLayer";
/**
 * Represents an annotation layer that renders bands (line with breadth) at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
 * AnnotationBreadthMemberPath
*/
var IgrDataAnnotationBandLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataAnnotationBandLayer, _super);
    function IgrDataAnnotationBandLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrDataAnnotationBandLayer.prototype.createImplementation = function () {
        return new DataAnnotationBandLayer();
    };
    Object.defineProperty(IgrDataAnnotationBandLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationBandLayer.prototype, "annotationBreadthMemberPath", {
        /**
         * Gets or sets name of data column with breath/size of shape annotations.
        */
        get: function () {
            return this.i.aii;
        },
        set: function (v) {
            this.i.aii = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrDataAnnotationBandLayer;
}(IgrDataAnnotationPointLayer));
export { IgrDataAnnotationBandLayer };
