import { __extends } from "tslib";
import { IgrDataAnnotationShapeLayer } from "./igr-data-annotation-shape-layer";
import { brushToString, stringToBrush } from "igniteui-react-core";
/**
 * Represents a base of annotation layers that render from start/end range
*/
var IgrDataAnnotationRangeLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataAnnotationRangeLayer, _super);
    function IgrDataAnnotationRangeLayer(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "startLabelTextColor", {
        /**
         * Gets or sets the text color used for displaying the start annotation label.
        */
        get: function () {
            return brushToString(this.i.af9);
        },
        set: function (v) {
            this.i.af9 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "startLabelBackground", {
        /**
         * Gets or sets the background used for displaying the start annotation label.
        */
        get: function () {
            return brushToString(this.i.af7);
        },
        set: function (v) {
            this.i.af7 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "startLabelBorderColor", {
        /**
         * Gets or sets the border color used for displaying Start annotation label.
        */
        get: function () {
            return brushToString(this.i.af8);
        },
        set: function (v) {
            this.i.af8 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "endLabelTextColor", {
        /**
         * Gets or sets the text color used for displaying the end annotation label.
        */
        get: function () {
            return brushToString(this.i.af6);
        },
        set: function (v) {
            this.i.af6 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "endLabelBackground", {
        /**
         * Gets or sets the background used for displaying the end annotation label.
        */
        get: function () {
            return brushToString(this.i.af4);
        },
        set: function (v) {
            this.i.af4 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "endLabelBorderColor", {
        /**
         * Gets or sets the border used for displaying the end annotation label.
        */
        get: function () {
            return brushToString(this.i.af5);
        },
        set: function (v) {
            this.i.af5 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "centerLabelTextColor", {
        /**
         * Gets or sets the text color used for displaying the center annotation label.
        */
        get: function () {
            return brushToString(this.i.af3);
        },
        set: function (v) {
            this.i.af3 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "centerLabelBackground", {
        /**
         * Gets or sets the background used for displaying the center annotation label.
        */
        get: function () {
            return brushToString(this.i.af1);
        },
        set: function (v) {
            this.i.af1 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationRangeLayer.prototype, "centerLabelBorderColor", {
        /**
         * Gets or sets the border color used for displaying the center annotation label.
        */
        get: function () {
            return brushToString(this.i.af2);
        },
        set: function (v) {
            this.i.af2 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrDataAnnotationRangeLayer;
}(IgrDataAnnotationShapeLayer));
export { IgrDataAnnotationRangeLayer };
