import { __extends } from "tslib";
import { IgrDataAnnotationShapeLayer } from "./igr-data-annotation-shape-layer";
import { DataAnnotationSliceLayer } from "./DataAnnotationSliceLayer";
/**
 * Represents an annotation layer that renders vertical or horizontal slices/lines at values mapped to AnnotationValueMemberPath property
 * horizontal slices/lines when TargetAxis is set to Y-axis
 * vertical slices/lines when TargetAxis is set to X-axis
*/
var IgrDataAnnotationSliceLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataAnnotationSliceLayer, _super);
    function IgrDataAnnotationSliceLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrDataAnnotationSliceLayer.prototype.createImplementation = function () {
        return new DataAnnotationSliceLayer();
    };
    Object.defineProperty(IgrDataAnnotationSliceLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationSliceLayer.prototype, "annotationValueMemberPath", {
        /**
         * Gets or sets name of data column with values used to position annotations.
        */
        get: function () {
            return this.i.afr;
        },
        set: function (v) {
            this.i.afr = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationSliceLayer.prototype, "annotationLabelMemberPath", {
        /**
         * Gets or sets mapping custom label on axis annotations.
        */
        get: function () {
            return this.i.afo;
        },
        set: function (v) {
            this.i.afo = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrDataAnnotationSliceLayer;
}(IgrDataAnnotationShapeLayer));
export { IgrDataAnnotationSliceLayer };
