import { __extends } from "tslib";
import { DataAnnotationDisplayMode_$type } from "./DataAnnotationDisplayMode";
import { IgrDataAnnotationRangeLayer } from "./igr-data-annotation-range-layer";
import { DataAnnotationStripLayer } from "./DataAnnotationStripLayer";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents an annotation layer that renders vertical or horizontal strips between values mapped to these properties:
 * StartValueMemberPath
 * EndValueMemberPath
*/
var IgrDataAnnotationStripLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataAnnotationStripLayer, _super);
    function IgrDataAnnotationStripLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrDataAnnotationStripLayer.prototype.createImplementation = function () {
        return new DataAnnotationStripLayer();
    };
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "startValueMemberPath", {
        /**
         * Gets or sets name of data column with positions for the start of annotations.
        */
        get: function () {
            return this.i.ag3;
        },
        set: function (v) {
            this.i.ag3 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "startLabelMemberPath", {
        /**
         * Gets or sets mapping custom label at the start of annotations.
        */
        get: function () {
            return this.i.ag0;
        },
        set: function (v) {
            this.i.ag0 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "startLabelDisplayMode", {
        /**
         * Gets or sets display mode of label in the start annotation.
        */
        get: function () {
            return this.i.agc;
        },
        set: function (v) {
            this.i.agc = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "endValueMemberPath", {
        /**
         * Gets or sets name of data column with positions for end of annotation.
        */
        get: function () {
            return this.i.agw;
        },
        set: function (v) {
            this.i.agw = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "endLabelMemberPath", {
        /**
         * Gets or sets mapping custom label at the end of annotations.
        */
        get: function () {
            return this.i.agt;
        },
        set: function (v) {
            this.i.agt = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "endLabelDisplayMode", {
        /**
         * Gets or sets display mode of label at the end annotation.
        */
        get: function () {
            return this.i.agb;
        },
        set: function (v) {
            this.i.agb = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "centerLabelMemberPath", {
        /**
         * Gets or sets mapping custom label between start and end of data annotations.
        */
        get: function () {
            return this.i.agp;
        },
        set: function (v) {
            this.i.agp = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataAnnotationStripLayer.prototype, "centerLabelDisplayMode", {
        /**
         * Gets or sets display mode of label in the center annotation.
        */
        get: function () {
            return this.i.aga;
        },
        set: function (v) {
            this.i.aga = ensureEnum(DataAnnotationDisplayMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrDataAnnotationStripLayer;
}(IgrDataAnnotationRangeLayer));
export { IgrDataAnnotationStripLayer };
