import { AnnotationAppearanceMode_$type } from "./AnnotationAppearanceMode";
import { OverlayTextLocation_$type } from "./OverlayTextLocation";
import { OverlayTextUpdatingEventArgs as OverlayTextUpdatingEventArgs_internal } from "./OverlayTextUpdatingEventArgs";
import { ensureEnum, ensureBool, brushToString, stringToBrush } from "igniteui-react-core";
/**
 * Represents an event arguments for styling Overlay Text
*/
var IgrOverlayTextUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrOverlayTextUpdatingEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrOverlayTextUpdatingEventArgs.prototype.createImplementation = function () {
        return new OverlayTextUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrOverlayTextUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrOverlayTextUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "dataIndex", {
        /**
         * Gets data index associated with the overlay text
        */
        get: function () {
            return this.i.dataIndex;
        },
        set: function (v) {
            this.i.dataIndex = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "horizontalMargin", {
        /**
         * Gets or sets Horizontal Margin for the overlay text
        */
        get: function () {
            return this.i.horizontalMargin;
        },
        set: function (v) {
            this.i.horizontalMargin = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "horizontalPadding", {
        /**
         * Gets or sets Horizontal Padding for the overlay text
        */
        get: function () {
            return this.i.horizontalPadding;
        },
        set: function (v) {
            this.i.horizontalPadding = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "verticalPadding", {
        /**
         * Gets or sets Vertical Padding for the overlay text
        */
        get: function () {
            return this.i.verticalPadding;
        },
        set: function (v) {
            this.i.verticalPadding = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "verticalMargin", {
        /**
         * Gets or sets Vertical Margin for the overlay text
        */
        get: function () {
            return this.i.verticalMargin;
        },
        set: function (v) {
            this.i.verticalMargin = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "borderRadius", {
        /**
         * Gets or sets boarder border radius of the overlay text
        */
        get: function () {
            return this.i.borderRadius;
        },
        set: function (v) {
            this.i.borderRadius = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "borderThickness", {
        /**
         * Gets or sets boarder thickness of the overlay text
        */
        get: function () {
            return this.i.borderThickness;
        },
        set: function (v) {
            this.i.borderThickness = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "borderShift", {
        /**
         * Gets or sets appearance shift of the overlay text border
        */
        get: function () {
            return this.i.borderShift;
        },
        set: function (v) {
            this.i.borderShift = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "backgroundShift", {
        /**
         * Gets or sets appearance shift of the overlay text background
        */
        get: function () {
            return this.i.backgroundShift;
        },
        set: function (v) {
            this.i.backgroundShift = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textColorShift", {
        /**
         * Gets or sets appearance shift of the overlay text color
        */
        get: function () {
            return this.i.textColorShift;
        },
        set: function (v) {
            this.i.textColorShift = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "borderMode", {
        /**
         * Gets or sets appearance mode of the overlay text border
        */
        get: function () {
            return this.i.borderMode;
        },
        set: function (v) {
            this.i.borderMode = ensureEnum(AnnotationAppearanceMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "backgroundMode", {
        /**
         * Gets or sets appearance mode of the overlay text background
        */
        get: function () {
            return this.i.backgroundMode;
        },
        set: function (v) {
            this.i.backgroundMode = ensureEnum(AnnotationAppearanceMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textColorMode", {
        /**
         * Gets or sets appearance mode of the overlay text color
        */
        get: function () {
            return this.i.textColorMode;
        },
        set: function (v) {
            this.i.textColorMode = ensureEnum(AnnotationAppearanceMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textContent", {
        /**
         * Gets or sets content of the overlay text
        */
        get: function () {
            return this.i.textContent;
        },
        set: function (v) {
            this.i.textContent = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textAngle", {
        /**
         * Gets or sets rotation angle of the overlay text
        */
        get: function () {
            return this.i.textAngle;
        },
        set: function (v) {
            this.i.textAngle = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textVisible", {
        /**
         * Gets or sets visibility of the overlay text
        */
        get: function () {
            return this.i.textVisible;
        },
        set: function (v) {
            this.i.textVisible = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textEmpty", {
        /**
         * Gets or sets visibility of the overlay text
        */
        get: function () {
            return this.i.textEmpty;
        },
        set: function (v) {
            this.i.textEmpty = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textLocation", {
        /**
         * Gets or sets location of the overlay text in relation to shape annotation
        */
        get: function () {
            return this.i.textLocation;
        },
        set: function (v) {
            this.i.textLocation = ensureEnum(OverlayTextLocation_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "textColor", {
        /**
         * Gets or sets color of the overlay text
        */
        get: function () {
            return brushToString(this.i.textColor);
        },
        set: function (v) {
            this.i.textColor = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "background", {
        /**
         * Gets or sets background of the overlay text
        */
        get: function () {
            return brushToString(this.i.background);
        },
        set: function (v) {
            this.i.background = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "borderStroke", {
        /**
         * Gets or sets border stroke of the overlay text
        */
        get: function () {
            return brushToString(this.i.borderStroke);
        },
        set: function (v) {
            this.i.borderStroke = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "shapeBrush", {
        /**
         * Gets or sets shape brush associated with the overlay text
        */
        get: function () {
            return brushToString(this.i.shapeBrush);
        },
        set: function (v) {
            this.i.shapeBrush = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOverlayTextUpdatingEventArgs.prototype, "shapeOutline", {
        /**
         * Gets or sets shape outline associated with the overlay text
        */
        get: function () {
            return brushToString(this.i.shapeOutline);
        },
        set: function (v) {
            this.i.shapeOutline = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrOverlayTextUpdatingEventArgs;
}());
export { IgrOverlayTextUpdatingEventArgs };
