import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private aa3;
    get aa4(): IAnchoredCategorySeriesInteractionManager;
    aaz: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    mg(): string;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    aba: boolean;
    constructor();
    abr: string;
    kr(a: any, b: string): any;
    mf(a: string): string;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private aa5;
    abj: string;
    abn: string;
    abp: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ace(): Brush;
    set ace(a: Brush);
    static readonly ab0: DependencyProperty;
    trendLineThickness: number;
    acg: PenLineCap;
    acf: DoubleCollection;
    trendLinePeriod: number;
    abe: number;
    ge(a: any): boolean;
    protected aaw(a: number, b: number, c: Axis): any[];
    protected rc(a: any, b: string, c: any, d: any): void;
    ay(a: Axis): AxisRange;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected zz(): number;
    abd(a: CategorySeriesView): number;
    abx(a: PointCollection, b: number, c: CategorySeriesView): void;
    aax(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    aay(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected gc(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private abt;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    o7(a: boolean, b: SeriesView): void;
    aam(a: CategoryFrame, b: CategorySeriesView): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    aa0: CategoryFrame;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abu(a: CategoryFrame, b: CategorySeriesView): void;
    protected sl(): void;
    ky(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected abh: string;
    protected abg: string;
    abstract abv(a: Axis): void;
    abstract abw(a: Axis): void;
    protected p1(a: any): void;
    aa1: CategorySeriesMarkerCollisionAvoidance;
    ko(a: Point): any;
    aa2: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    iz(): number;
    protected get_abf(): number;
    protected get abf(): number;
    az(a: Rect): AxisRange;
    private abz;
    private aa7;
    private abb;
    abc: number;
    private aby;
    i9(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wk(a: ValueLayerValueMode): Point;
    wl(a: number[]): Point;
    aai(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    aa9(a: number, b: number, c: number): boolean;
    aa8(a: number, b: number, c: number): boolean;
    aac(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    bd(): ITrendLineManager;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    di: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private dj;
    get dk(): ITrendLineManager;
    set dk(a: ITrendLineManager);
    get dl(): boolean;
    dq(): void;
    dn(): void;
    dm(): void;
    da(): CategoryBucketCalculator;
    dp(): void;
    dr(): void;
    ds(a: number): Rect;
    protected bi(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
