import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Type, Point } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { Axis } from "./Axis";
import { RadialFrame } from "./RadialFrame";
import { SeriesView } from "./SeriesView";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { AxisRange } from "./AxisRange";
import { IFastItemsSource } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { Clipper } from "igniteui-react-core";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { PointCollection } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
    static $t: Type;
    private f;
    constructor(a: AnchoredRadialSeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare abstract class AnchoredRadialSeries extends RadialBase {
    static $t: Type;
    protected ct(): SeriesView;
    o4(): void;
    mg(): string;
    kr(a: any, b: string): any;
    mf(a: string): string;
    jd(a: any): number;
    protected ku(a: number): any;
    q3(a: SeriesView): void;
    ab5: AnchoredRadialSeriesView;
    constructor();
    ab6: CategoryLineRasterizer;
    kb(a: Point, b: boolean): number;
    j9(a: Point, b: boolean): number;
    iq(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected acg: boolean;
    i6(a: Point, b: boolean, c: boolean): number;
    wh(a: Point, b: boolean, c: boolean): Point;
    ack: boolean;
    ac0: string;
    acs: string;
    protected gc(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private ac6;
    get acb(): IFastItemColumn$1<number>;
    set acb(a: IFastItemColumn$1<number>);
    private aca;
    acw: string;
    acy: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    ab9: TrendLineType;
    ado: Brush;
    get adn(): Brush;
    set adn(a: Brush);
    static readonly ada: DependencyProperty;
    acp: number;
    adq: PenLineCap;
    adp: DoubleCollection;
    acq: number;
    acr: number;
    ay(a: Axis): AxisRange;
    protected aac(a: number, b: any): any;
    protected dl(a: string): IFastItemColumn$1<number>;
    protected ac4(a: IFastItemsSource, b: IFastItemColumn$1<number>): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_ach(): boolean;
    protected get ach(): boolean;
    protected get_em(): boolean;
    protected get_f6(): boolean;
    protected acm(a: CategoryAngleAxis, b: Rect, c: Rect, d: Rect): number;
    protected acl(a: number, b: CategoryAngleAxis, c: Rect, d: Rect, e: Rect): number;
    ac5(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: CategoryCollisionMode): void;
    protected get_acj(): boolean;
    protected get acj(): boolean;
    protected get_acd(): boolean;
    protected get acd(): boolean;
    abc(a: RadialFrame, b: RadialBaseView): void;
    private acn;
    private aco;
    private aci;
    ab4(a: List$1<number[]>, b: number, c: SeriesView): Clipper;
    protected adr: Point;
    ac9(a: PointCollection, b: PointCollection, c: PointCollection, d: PointCollection, e: boolean): void;
    private acf;
    private ace;
    o7(a: boolean, b: SeriesView): void;
    abf(a: RadialFrame, b: RadialBaseView): void;
    protected ab3(a: number, b: number, c: Axis): any[];
    protected ac7(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected ac8(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    ac3(a: RadialBaseView, b: RadialFrame): void;
    private ac2;
    protected sl(): void;
    ky(a: any, b: Point): any;
    ge(a: any): boolean;
    ab8: RadialFrame;
    rw(a: Rect, b: RenderSurface): void;
    rx(): void;
    private ab7;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected p1(a: any): void;
    private acc;
    bd(): ITrendLineManager;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredRadialSeriesView extends RadialBaseView {
    static $t: Type;
    de: AnchoredRadialSeries;
    constructor(a: AnchoredRadialSeries);
    df: RadialTrendLineManager;
    dg(a: Rect, b: Rect, c: Rect, d: Rect): void;
    dh(): void;
    protected bi(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
