import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-react-core";
import { ISupportsSizeScale } from "./ISupportsSizeScale";
import { ISupportsFillScale } from "./ISupportsFillScale";
import { Rect } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { UIElement } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { Series } from "./Series";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { MarkerFillMode } from "./MarkerFillMode";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Marker } from "./Marker";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries, ISupportsSizeScale, ISupportsFillScale {
    static $t: Type;
    protected bk(): Series;
    protected get_ek(): boolean;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    acv: BubbleSeriesView;
    protected jm(): number;
    w6(): MarkerFillMode;
    constructor();
    private aem;
    private ael;
    isAttachedTo(a: IChartLegend): boolean;
    protected ej(): boolean;
    protected p4(a: (arg1: any) => void): void;
    get ac3(): IFastItemColumn$1<number>;
    protected get_isColoredItemwise(): boolean;
    ac9: List$1<UIElement>;
    private aek;
    get legendReady(): boolean;
    get minScaleText(): string;
    get maxScaleText(): string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    ady: string;
    kr(a: any, b: string): any;
    mf(a: string): string;
    get ac5(): IFastItemColumn$1<number>;
    set ac5(a: IFastItemColumn$1<number>);
    private ac0;
    acx: SizeScale;
    ado: string;
    private acz;
    get ac4(): IFastItemColumn$1<any>;
    set ac4(a: IFastItemColumn$1<any>);
    adj: string;
    acu: BrushScale;
    private acy;
    get ac1(): IFastItemColumn$1<number>;
    set ac1(a: IFastItemColumn$1<number>);
    ac6: boolean;
    ac7: boolean;
    add: number;
    adc: number;
    ac8: boolean;
    aa9(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    abk(a: ScatterFrame, b: ScatterBaseView): void;
    private ad3;
    static ada(a: number, b: number, c: number, d: number, e: number): number;
    static adb(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    protected zw(a: string, b: FastItemsSourceEventAction): boolean;
    private ad2;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    qf(): void;
    qm(): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    updateSizeScaleGlobals(): void;
    updateFillScaleGlobals(): void;
    act(a: SizeScale): ActualRange;
    acs(): ActualRange;
    acw: SizeScale;
    ad5(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    ad4(a: List$1<Marker>): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    private ac2;
    adu: string;
    adf: string;
    adw: string;
    adh: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    get actualMarkerBrush(): Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected dy: BubbleSeries;
    constructor(a: BubbleSeries);
    a4(): void;
    protected dc(): MarkerManagerBase;
    d0(): void;
    d1(): void;
    dz(): void;
    getDefaultTooltipTemplate(): string;
}
