import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Base, Type, Point } from "igniteui-react-core";
import { Series } from "./Series";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { LabelCollisionPlacementPositions } from "igniteui-react-core";
import { HighlightedValueLabelMode } from "igniteui-react-core";
import { AutoCalloutVisibilityMode } from "./AutoCalloutVisibilityMode";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CalloutCollisionMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { Size } from "igniteui-react-core";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    protected bk(): Series;
    protected get_eq(): boolean;
    constructor();
    private aea;
    private aej;
    private aeb;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gg(a: boolean): boolean;
    abi: boolean;
    private agc;
    ab6: number;
    ab4: number;
    ab7: number;
    ab5: number;
    private aa9;
    private aga;
    wy(): Size;
    private abv;
    private aeq;
    private aer;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    adp: string;
    kr(a: any, b: string): any;
    mf(a: string): string;
    get aa2(): IFastItemColumn$1<any>;
    set aa2(a: IFastItemColumn$1<any>);
    private aax;
    ad5: string;
    get aa3(): IFastItemColumn$1<any>;
    set aa3(a: IFastItemColumn$1<any>);
    private aay;
    ad8: string;
    get aa4(): IFastItemColumn$1<any>;
    set aa4(a: IFastItemColumn$1<any>);
    private aaz;
    adj: string;
    get aa1(): IFastItemColumn$1<any>;
    set aa1(a: IFastItemColumn$1<any>);
    private aaw;
    abk: boolean;
    adm: string;
    aab: any[];
    adb: string;
    get aa0(): IFastItemColumn$1<any>;
    set aa0(a: IFastItemColumn$1<any>);
    private aav;
    private abw;
    private abz;
    private aed;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    protected aal: CalloutLayerView;
    private ab0;
    ads: string;
    aas: Series;
    ac8: string;
    private aam;
    get aan(): CalloutPlacementPositionsCollection;
    set aan(a: CalloutPlacementPositionsCollection);
    aaa: LabelCollisionPlacementPositions[];
    abj: boolean;
    abp: boolean;
    abs: boolean;
    gv(a: Series): boolean;
    abo: boolean;
    abq: boolean;
    abr: boolean;
    abt: boolean;
    aar: HighlightedValueLabelMode;
    get aag(): AutoCalloutVisibilityMode;
    set aag(a: AutoCalloutVisibilityMode);
    get aaf(): AutoCalloutVisibilityMode;
    set aaf(a: AutoCalloutVisibilityMode);
    static readonly afd: DependencyProperty;
    ab3: number;
    abm: boolean;
    abl: boolean;
    acg: number;
    af6: Brush;
    af4: Brush;
    af2: Brush;
    af1: Brush;
    abn: boolean;
    ach: number;
    af5: Brush;
    af3: Brush;
    get agb(): Thickness;
    ab9: number;
    acb: number;
    aca: number;
    ab8: number;
    aai: CalloutCollisionMode;
    acc: number;
    acd: number;
    adv: string;
    private aat;
    get aau(): FontInfo;
    protected yw(a: Series, b: boolean): void;
    protected yy(a: Frame, b: SeriesView): void;
    private abx;
    private abu;
    private aa5;
    private af8;
    protected sv(a: Rect, b: Rect): void;
    protected su(a: Rect, b: Rect): void;
    private abc;
    private abe;
    private acf;
    private af7;
    get af9(): Rect;
    set af9(a: Rect);
    private abb;
    private aek;
    private adx;
    private aef;
    private aa6;
    private aci;
    private acj;
    private aa7;
    private aec;
    private aa8;
    private ace;
    private ab1;
    private ack;
    protected xn(a: Series): boolean;
    qr(): void;
    private abd;
    aei(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private aby;
    private ael;
    private abg;
    private abh;
    private ab2;
    private abf;
    protected b3(): SeriesHitTestMode;
    a2(a: Point, b: boolean): DataContext;
    gx(a: Point, b: boolean): boolean;
    protected aep(a: CalloutLayerFrame, b: boolean): void;
    protected y1(a: Frame, b: SeriesView): void;
    protected gb(): boolean;
    private aad;
    protected rc(a: any, b: string, c: any, d: any): void;
    private aah;
    private aac;
    private aeo;
    private aba;
    private aae;
    private aeg;
    ax(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    private aem;
    private aee;
    private aeh;
    aen(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected cn: CalloutLayer;
    private cs;
    a4(): void;
    private cp;
    private cv;
    private cx;
    private cw;
    cr: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    c6(a: Brush): Brush;
    protected bj(a: RenderingContext, b: boolean): void;
    protected cq(): FontInfo;
    ax(a: any): void;
    private ct;
    c8(a: TextBlock): Size;
    private cu;
    private co;
    c7(a: any, b: Thickness): Size;
    cz(a: CalloutView, b: number, c: number): void;
    c0(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    c1(a: Series, b: Brush): Brush;
    c4(): Brush;
    c2(): Brush;
    c5(a: Series, b: Brush): Brush;
    c3(a: Series, b: Brush): Brush;
    cy(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    y: Visibility;
    j(a: RenderingContext): void;
    private l;
    private t;
    private q;
    private s;
    get r(): Point;
    set r(a: Point);
    get p(): Brush;
    set p(a: Brush);
    get o(): Brush;
    set o(a: Brush);
    get n(): Brush;
    set n(a: Brush);
    get m(): Brush;
    set m(a: Brush);
    get e(): number;
    set e(a: number);
    private w;
    private v;
    get x(): Thickness;
    set x(a: Thickness);
    private c;
    get d(): number;
    set d(a: number);
    get h(): any;
    set h(a: any);
    f: number;
    g: number;
    u(): Size;
    private b;
    k(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    i(a: CalloutLayer, b: FontInfo, c: any): void;
}
