import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategoryMode } from "./CategoryMode";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-react-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { ValueCollisionMode } from "./ValueCollisionMode";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    i(a: Frame): PreparationParams;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    s(a: PreparationParams): number;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected get q(): List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    private aa;
    private ab;
    protected ac: IHasCategoryTrendline;
    protected ad: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    y4: CategoryFramePreparer;
    protected ct(): SeriesView;
    y8: CategorySeriesView;
    private zc;
    get zd(): ICategorySeriesInteractionManager;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    private z4;
    q3(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get categoryAxis(): CategoryAxisBase;
    yx(): CategoryAxisBase;
    ze(): NumericAxisBase;
    protected get_em(): boolean;
    protected get_f6(): boolean;
    protected get_e0(): boolean;
    constructor();
    ac(): void;
    zp: boolean;
    zo: boolean;
    yy: CategoryCollisionMode;
    protected zl: boolean;
    protected zk: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    zr(): boolean;
    protected zs(): boolean;
    protected aao(a: AssigningCategoryStyleEventArgs): void;
    protected aan(a: AssigningCategoryMarkerStyleEventArgs): void;
    yr(a: number, b: number): any[];
    o7(a: boolean, b: SeriesView): void;
    bs(): SeriesComponentsForView;
    qd(): void;
    zv: boolean;
    protected sv(a: Rect, b: Rect): void;
    za: CategoryTransitionInMode;
    zq: boolean;
    protected su(a: Rect, b: Rect): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    protected zn(): boolean;
    protected zm(): boolean;
    zy(a: Point): number;
    protected get_ft(): boolean;
    a0(): CategoryAxisBase;
    j6(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    ko(a: Point): any;
    j4(a: Point): number;
    is(a: Point): number;
    private zi;
    private zj;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    protected get_ff(): boolean;
    o5(): void;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    protected zx(): List$1<Marker>;
    protected zh(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zg(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zf(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    y1: CategoryFrame;
    y3: CategoryFrame;
    yz: CategoryFrame;
    y2: CategoryFrame;
    y0(): CategoryFrame;
    y7: CategorySeriesRenderManager;
    protected aak(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    aal(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    private zw;
    protected go(): boolean;
    protected gp(): boolean;
    protected y9(): CategoryTransitionInMode;
    zb: CategoryTransitionSourceFramePreparer;
    protected o8(): void;
    rv(a: boolean): void;
    protected c5(): TransitionInSpeedType;
    protected c8(): TransitionOutSpeedType;
    protected zz(): number;
    protected zt(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    kw(): any;
    z3(): number;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    aae(a: CategorySeriesView, b: CategoryFrame): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    aam(a: CategoryFrame, b: CategorySeriesView): void;
    z0(a: SeriesView): number;
    z1(a: SeriesView): number;
    z2(a: SeriesView): number;
    aad(a: SeriesView): void;
    rw(a: Rect, b: RenderSurface): void;
    rx(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract zu(): boolean;
    y5(a: CategorySeriesView): CategoryFramePreparer;
    aw(a: Axis): Axis;
    ai(): Axis[];
    static ys(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    aah(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: CategoryCollisionMode, e: ValueCollisionMode): void;
    aaj(a: List$1<ChartSelection>, b: number, c: number, d: SeriesSelectionBehavior): void;
    abstract aai(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    abstract aac(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    aaf(a: Rect, b: NumericAxisBase, c: boolean, d: Rect, e: number, f: number): {
        p4: number;
        p5: number;
    };
    aag(a: Rect, b: CategoryAxisBase, c: boolean, d: Rect, e: number, f: number): {
        p4: number;
        p5: number;
    };
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    db: CategorySeries;
    de: number;
    dd(a: CategoryFrame): boolean;
    dg(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    c9: CategoryBucketCalculator;
    da(): CategoryBucketCalculator;
    dc: Pool$1<Marker>;
    get shouldDisplayMarkers(): boolean;
    updateMarkerCount(a: number): void;
    cw(a: (arg1: Marker) => void): void;
    df(): void;
}
