import { Type } from "igniteui-react-core";
/**
 * Describes mode for displaying content of axis annotation
 */
export declare enum DataAnnotationDisplayMode {
    /**
     * Indicates a mode that automatically selects content dsiaplyed on axis, based on type of data annotation layer
     */
    Auto = 0,
    /**
     * Displays data value in axis annotation that represents a value mapped via ValueMemberPath
     */
    DataValue = 1,
    /**
     * Displays a label in axis annotation that represents a value mapped via LabelMemberPath
     */
    DataLabel = 2,
    /**
     * Displays axis value in axis annotation that is between axis minimum and maximum
     */
    AxisValue = 3,
    /**
     * Displays pixel value in axis annotation that is between start and end size of plot area
     */
    PixelValue = 4,
    /**
     * Displays window value in axis annotation in relative coordinates (0.0 - 1.0) to start and end size of plot area
     */
    WindowValue = 5,
    /**
     * Hides axis annotation
     */
    Hidden = 6
}
/**
 * @hidden
 */
export declare let DataAnnotationDisplayMode_$type: Type;
