import { DataAnnotationAxisLayer } from "./DataAnnotationAxisLayer";
import { OverlayTextLocation } from "./OverlayTextLocation";
import { Brush } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Type, Point } from "igniteui-react-core";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { FontInfo } from "igniteui-react-core";
import { OverlayTextUpdatingEventArgs } from "./OverlayTextUpdatingEventArgs";
import { DataAnnotationItem } from "./DataAnnotationItem";
import { DataAnnotationInfo } from "./DataAnnotationInfo";
import { DataAnnotationShapeLayerFrame } from "./DataAnnotationShapeLayerFrame";
import { Axis } from "./Axis";
import { Pool$1 } from "igniteui-react-core";
import { IFastItemColumnPropertyName } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { TextBlock } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class DataAnnotationShapeLayer extends DataAnnotationAxisLayer {
    static $t: Type;
    stylingOverlayText: (sender: any, args: OverlayTextUpdatingEventArgs) => void;
    stylingShapeAnnotation: (sender: any, args: DataAnnotationItem) => void;
    stylingAxisAnnotation: (sender: any, args: DataAnnotationInfo) => void;
    protected get_acu(): boolean;
    get acu(): boolean;
    acl: boolean;
    acp: boolean;
    acd: OverlayTextLocation;
    ac9: number;
    adb: number;
    ada: number;
    adc: number;
    ac3: number;
    afd: Brush;
    afb: Brush;
    afc: Brush;
    ac5: number;
    ac7: number;
    act: boolean;
    ad5: string;
    private acj;
    get ack(): IFastItemColumn$1<any>;
    set ack(a: IFastItemColumn$1<any>);
    adl: string;
    ac8: number;
    ab6: AnnotationAppearanceMode;
    acs: boolean;
    ac4: number;
    ab4: AnnotationAppearanceMode;
    acq: boolean;
    ac6: number;
    ab5: AnnotationAppearanceMode;
    acr: boolean;
    private ach;
    get aci(): FontInfo;
    set aci(a: FontInfo);
    protected rc(a: any, b: string, c: any, d: any): void;
    aco(a: string): boolean;
    protected dl(a: string): IFastItemColumn$1<number>;
    protected dn(a: string): IFastItemColumn$1<any>;
    aed(a: IFastItemColumnPropertyName): void;
    protected aeh(a: any, b: any): void;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    constructor();
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    protected acb: DataAnnotationShapeLayerView;
    aeg(): void;
    qr(): void;
    private acw;
    private acv;
    protected aee(): void;
    protected aef(a: number): void;
    protected ael(a: DataAnnotationShapeLayerFrame, b: boolean): void;
    private aek;
    acx: List$1<DataAnnotationItem>;
    protected yy(a: Frame, b: SeriesView): void;
    private aej;
    private aei;
    adi(a: Axis, b: number, c: number, d: number): string;
    adh(a: Axis, b: DataAnnotationInfo, c: boolean): string;
    protected y1(a: Frame, b: SeriesView): void;
    private aec;
    protected w7(): AnnotationAppearanceMode;
    protected xu(): number;
    protected xx(): number;
    protected xw(): number;
    protected y6(): void;
    protected x0(): number;
    private afe;
    protected zy(): DoubleCollection;
    adj(a: number, b: IFastItemColumn$1<any>): string;
    ac2(a: number, b: IFastItemColumn$1<number>): number;
    afg(a: number, b: IFastItemColumn$1<any>): Point;
    private afh;
    acy(a: number): number;
    acz(a: number): number;
    acn(a: number): boolean;
    private adf;
    private ab7;
    acm: boolean;
    ab8: Axis;
    ab9: Axis;
    acf: ScalerParams;
    acg: ScalerParams;
    aff(a: Point): Point;
    ac0(a: number): number;
    ac1(a: number): number;
    afi(a: Point): Point;
    add(a: number): number;
    ade(a: number): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class DataAnnotationShapeLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: DataAnnotationShapeLayer);
    protected cn: DataAnnotationShapeLayer;
    co: Pool$1<Path>;
    ct: List$1<Path>;
    cs: List$1<TextBlock>;
    cq: Pool$1<TextBlock>;
    cr: List$1<Rectangle>;
    cp: Pool$1<Rectangle>;
    a4(): void;
    cu(): void;
    c5(): TextBlock;
    c2(a: TextBlock): void;
    c1(a: TextBlock): void;
    c3(a: TextBlock): void;
    c7(): Rectangle;
    cz(a: Rectangle): void;
    cy(a: Rectangle): void;
    c0(a: Rectangle): void;
    private c6;
    private cv;
    private cx;
    private cw;
    c4(a: Path, b: number, c: number, d: number): void;
    protected bj(a: RenderingContext, b: boolean): void;
    ax(a: any): void;
}
