import { RadialBaseChart } from "./RadialBaseChart";
import { ProportionalCategoryAngleAxis } from "./ProportionalCategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { PropertyChangedEventArgs, Type } from "igniteui-react-core";
import { PieChartSweepDirection } from "./PieChartSweepDirection";
import { CalloutCollisionMode } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { LegendEmptyValuesMode } from "igniteui-react-core";
import { OthersCategoryType } from "igniteui-react-core";
import { AxisRangeBufferMode } from "./AxisRangeBufferMode";
import { RadialLabelMode } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { RadialBase } from "./RadialBase";
import { Series } from "./Series";
import { RadialPieSeries } from "./RadialPieSeries";
import { DataSeries } from "igniteui-react-core";
import { Axis } from "./Axis";
import { MarkerType } from "./MarkerType";
import { DataSeriesType } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { OthersCategoryContext } from "./OthersCategoryContext";
/**
 * @hidden
 */
export declare abstract class DataPieBaseChart extends RadialBaseChart {
    static $t: Type;
    constructor();
    protected hg(): boolean;
    protected ak3(a: (arg1: RadialBase) => void): void;
    protected ak4(a: (arg1: RadialBase, arg2: number) => void): void;
    protected ak1(a: (arg1: RadialPieSeries) => void): void;
    protected ak2(a: (arg1: RadialPieSeries, arg2: number) => void): void;
    protected xa(): void;
    protected c2(a: Series, b: number): MarkerType;
    protected w8(a: DataSeries): void;
    protected hc(a: DataSeries): boolean;
    protected xb(): void;
    private ah8;
    get angleAxis(): ProportionalCategoryAngleAxis;
    set angleAxis(a: ProportionalCategoryAngleAxis);
    private ah1;
    get valueAxis(): NumericRadiusAxis;
    set valueAxis(a: NumericRadiusAxis);
    protected get_aim(): boolean;
    protected get aim(): boolean;
    protected dc(a: DataSeries, b: DataSeriesType): Series;
    protected vn(a: Series, b: number): void;
    private aie;
    protected aaq(): Axis;
    protected aar(): Axis;
    protected ux(): void;
    protected ak5(a: any, b: PropertyChangedEventArgs): void;
    protected ak6(a: any, b: PropertyChangedEventArgs): void;
    protected ur(a: Series, b: number): void;
    protected afx(a: Axis): void;
    protected afv(a: Axis): void;
    protected vi(a: XamDataChart): void;
    protected wd(a: string, b: any, c: any): void;
    private ajl;
    get aki(): string;
    set aki(a: string);
    private aho;
    get ahs(): any[];
    set ahs(a: any[]);
    private ajh;
    get aj2(): string;
    set aj2(a: string);
    private ahm;
    get ahq(): any[];
    set ahq(a: any[]);
    private ajj;
    get akb(): string;
    set akb(a: string);
    private ahn;
    get ahr(): any[];
    set ahr(a: any[]);
    private ajg;
    get ajy(): string;
    set ajy(a: string);
    private ahl;
    get ahp(): any[];
    set ahp(a: any[]);
    private ais;
    get ai2(): number;
    set ai2(a: number);
    private ah6;
    get ah7(): PieChartSweepDirection;
    set ah7(a: PieChartSweepDirection);
    private ahv;
    get ahw(): CalloutCollisionMode;
    set ahw(a: CalloutCollisionMode);
    private ak8;
    get ala(): Brush;
    set ala(a: Brush);
    private ak7;
    get ak9(): Brush;
    set ak9(a: Brush);
    private ajm;
    get aky(): string;
    set aky(a: string);
    private ajf;
    get ajw(): string;
    set ajw(a: string);
    private ahz;
    get ah0(): LegendEmptyValuesMode;
    set ah0(a: LegendEmptyValuesMode);
    private ah4;
    get ah5(): OthersCategoryType;
    set ah5(a: OthersCategoryType);
    private ait;
    get ai3(): number;
    set ai3(a: number);
    private aji;
    get aj7(): string;
    set aj7(a: string);
    ah3(): OthersCategoryContext;
    private aje;
    get ajt(): string;
    set ajt(a: string);
    private aii;
    get aio(): boolean;
    set aio(a: boolean);
    private aht;
    get ahu(): AxisRangeBufferMode;
    set ahu(a: AxisRangeBufferMode);
    private aiq;
    get ai0(): number;
    set ai0(a: number);
    private air;
    get ai1(): number;
    set ai1(a: number);
    private aiw;
    get ai8(): number;
    set ai8(a: number);
    private aij;
    get aip(): boolean;
    set aip(a: boolean);
    private ajc;
    get ajd(): number;
    set ajd(a: number);
    private aiy;
    get aja(): number;
    set aja(a: number);
    private aix;
    get ai9(): number;
    set ai9(a: number);
    private aiz;
    get ajb(): number;
    set ajb(a: number);
    get ai7(): number;
    get ai6(): number;
    private aiu;
    get ai4(): number;
    set ai4(a: number);
    private aiv;
    get ai5(): number;
    set ai5(a: number);
    private ajk;
    get akg(): string;
    set akg(a: string);
    private aib;
    get aid(): RadialLabelMode;
    set aid(a: RadialLabelMode);
    private aia;
    get aic(): RadialLabelMode;
    set aic(a: RadialLabelMode);
    private aif;
    get aik(): boolean;
    set aik(a: boolean);
    private aih;
    get ain(): boolean;
    set ain(a: boolean);
    private ahx;
    get ahy(): CollisionAvoidanceType;
    set ahy(a: CollisionAvoidanceType);
    private aig;
    get ail(): boolean;
    set ail(a: boolean);
}
