import { Base, INotifyPropertyChanged, Type, IEnumerable, PropertyChangedEventArgs, Point } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { IDomainChartLike } from "./IDomainChartLike";
import { List$1 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-react-core";
import { DataSeriesType } from "igniteui-react-core";
import { IDataSeriesAdapterRule } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-react-core";
import { IDomainChartToolbarProvider } from "./IDomainChartToolbarProvider";
import { ToolCommand } from "igniteui-react-core";
import { DataToolTipLayerGroupingMode } from "igniteui-react-core";
import { DataTooltipGroupedPositionX } from "igniteui-react-core";
import { DataTooltipGroupedPositionY } from "igniteui-react-core";
import { DataAbbreviationMode } from "igniteui-react-core";
import { DataLegendValueMode } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DataLegendHeaderDateMode } from "igniteui-react-core";
import { DataLegendHeaderTimeMode } from "igniteui-react-core";
import { DataLegendSummaryType } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { DataLegendUnitsMode } from "igniteui-react-core";
import { DataLegendLabelMode } from "igniteui-react-core";
import { DomainType } from "./DomainType";
import { ChartSortDescriptionCollection } from "./ChartSortDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-react-core";
import { ChartSummaryDescriptionCollection } from "./ChartSummaryDescriptionCollection";
import { SeriesSelectionMode } from "./SeriesSelectionMode";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { ChartSelectedItemCollection } from "./ChartSelectedItemCollection";
import { FilterStringErrorsParsingEventArgs } from "./FilterStringErrorsParsingEventArgs";
import { BrushCollection } from "igniteui-react-core";
import { IChartLegend } from "igniteui-react-core";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { UnknownValuePlotting } from "igniteui-react-core";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { TrendLineType } from "igniteui-react-core";
import { TrendLineTypeCollection } from "./TrendLineTypeCollection";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { CalloutCollisionMode } from "igniteui-react-core";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { ValueModeCollection } from "./ValueModeCollection";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Series } from "./Series";
import { DataSeries } from "igniteui-react-core";
import { IDataLegend } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ObservableColorCollection } from "igniteui-react-core";
import { DataSeriesMarker } from "igniteui-react-core";
import { IDataLegendSeries } from "igniteui-react-core";
import { ToolActionInfo } from "igniteui-react-core";
import { IToolbarContextAccessor } from "igniteui-react-core";
import { ToolCommandExecutionState } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { DomainChartPlotAreaPointerEventArgs } from "./DomainChartPlotAreaPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesViewerSelectedSeriesItemsChangedEventArgs } from "./SeriesViewerSelectedSeriesItemsChangedEventArgs";
import { DataSourcePropertiesRequestedChangedEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged, IDataLegendTarget, IToolbarTarget, IDomainChartLike {
    static $t: Type;
    protected l4: any;
    provideContainer(a: any): void;
    destroy(): void;
    private vl;
    protected vm(): void;
    protected vi(a: XamDataChart): void;
    protected vf(): void;
    protected vo(a: Series, b: number): void;
    protected wh(a: string, b: any, c: any): void;
    private l1;
    get tooltipTemplate(): any;
    set tooltipTemplate(a: any);
    private hw;
    get tooltipTemplates(): List$1<any>;
    set tooltipTemplates(a: List$1<any>);
    private it;
    get j5(): number;
    set j5(a: number);
    private l0;
    private get toolTip();
    private set toolTip(value);
    private i6;
    get ki(): number;
    set ki(a: number);
    private i7;
    get kj(): number;
    set kj(a: number);
    private i8;
    get kk(): number;
    set kk(a: number);
    private i5;
    get kh(): number;
    set kh(a: number);
    private i1;
    get kd(): number;
    set kd(a: number);
    private i3;
    get kf(): number;
    set kf(a: number);
    private i2;
    get ke(): number;
    set ke(a: number);
    private i0;
    get kc(): number;
    set kc(a: number);
    private yj;
    get zk(): Brush;
    set zk(a: Brush);
    private yk;
    get zl(): Brush;
    set zl(a: Brush);
    private iq;
    protected get_j2(): number;
    protected set_j2(a: number): void;
    get j2(): number;
    set j2(a: number);
    private i9;
    get kl(): number;
    set kl(a: number);
    private iz;
    get kb(): number;
    set kb(a: number);
    private ia;
    get jo(): number;
    set jo(a: number);
    private lf;
    get lu(): number;
    set lu(a: number);
    private et;
    get eu(): (time: number) => number;
    set eu(a: (time: number) => number);
    private la;
    get lq(): number;
    set lq(a: number);
    private ld;
    get lt(): number;
    set lt(a: number);
    private k8;
    get lo(): number;
    set lo(a: number);
    protected vj(a: XamDataChart): void;
    protected vp(a: Series, b: number): void;
    protected vg(): void;
    private vq;
    kz: (arg1: HTMLElement) => any[];
    private xj;
    private l6;
    private hf;
    private k0;
    protected wi(a: string, b: any, c: any): void;
    private ck;
    get cl(): IDomainChartWidget;
    set cl(a: IDomainChartWidget);
    private m1;
    get s9(): string;
    set s9(a: string);
    private m3;
    get tk(): string;
    set tk(a: string);
    private eh;
    get dataChart(): XamDataChart;
    set dataChart(a: XamDataChart);
    bf: DataSeriesAdapterImplementation;
    get currentDataAdapter(): DataSeriesAdapterImplementation;
    private f1;
    private fj;
    sendCommandCompleted(a: ToolCommand): void;
    captureTargetImageToClipboard(a: (arg1: any, arg2: any) => void): void;
    private wa;
    bg: DataSeriesAdapterImplementation;
    private f5;
    private f4;
    get isDetached(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    protected vk(): void;
    private xh;
    private xg;
    private xi;
    bh(a: boolean): DataSeriesAdapterImplementation;
    protected abstract get h2(): List$1<DataSeriesType>;
    protected abstract get h1(): List$1<IDataSeriesAdapterRule>;
    protected h0: List$1<MarkerType>;
    protected ha(a: DataSeriesType): boolean;
    notifyResized(): void;
    vz(): void;
    u4(): void;
    vd(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    seriesDataChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected wv(a: string): void;
    protected abstract u5(a: (arg1: Axis) => void, b: boolean): void;
    protected u6(a: (arg1: Series) => void): void;
    protected u7(a: (arg1: Series, arg2: number) => void): void;
    protected vb(a: (arg1: Series) => void): void;
    protected vc(a: (arg1: Series, arg2: number) => void): void;
    protected u9(a: (arg1: Series) => void): void;
    protected va(a: (arg1: Series, arg2: number) => void): void;
    w7(): void;
    protected v1(a: (arg1: XamDataChart) => void): void;
    protected v2(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected v3(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected hc(a: DataSeries): boolean;
    protected g2(): boolean;
    private static readonly mf;
    private le;
    protected q0(a: DataSeries): string;
    private static me;
    protected q1(a: DataSeries, b: DataSeriesType): string;
    protected abstract be(a: DataSeries): DataSeriesType;
    protected abstract dc(a: DataSeries, b: DataSeriesType): Series;
    qz(): string;
    private g8;
    private g7;
    protected wk(): void;
    protected uv(): void;
    private xk;
    private uu;
    private hr;
    protected h6(a: DataSeries): IEnumerable;
    protected h7(a: DataSeries): IEnumerable;
    private u3;
    private gy;
    protected xa(): void;
    protected df(seriesType_: DataSeriesType): Series;
    private c6;
    private c8;
    private da;
    private db;
    private c7;
    private c9;
    private de;
    private dd;
    private cd;
    protected get ce(): IAnnotationLayerProxy;
    private get gx();
    protected g0(a: Series): boolean;
    private xl;
    protected g3(): boolean;
    protected g4(): boolean;
    protected get_g1(): boolean;
    protected get g1(): boolean;
    protected hy(a: string, b: boolean): List$1<Series>;
    private uo;
    private un;
    protected uw(a: Series, b: boolean): void;
    protected hg(): boolean;
    protected xf(a: Series, b: Series, c: DataSeries): void;
    protected abstract w9(a: DataSeries): void;
    protected abstract w8(a: DataSeries): void;
    protected xc(): void;
    v7(): void;
    private xd;
    protected xe(a: Series): void;
    protected abstract xb(): void;
    private v4;
    private v9;
    protected u0(): void;
    protected hm: boolean;
    protected u1(): void;
    protected zc(a: number): Brush;
    protected zf(a: number): Brush;
    protected zd(a: number): Brush;
    protected ze(a: number): Brush;
    protected zo(a: number): Color;
    protected fh(a: Color): ObservableColorCollection;
    protected aa(a: Color): BrushCollection;
    protected hv: List$1<Color>;
    protected get hx(): List$1<Color>;
    protected get_hk(): boolean;
    protected get hk(): boolean;
    l5(): any;
    vs(a: string, b: string): void;
    vt(a: string, b: string, c: Series): void;
    c0(a: DataSeriesMarker): MarkerType;
    private ch;
    private f7;
    attachDataLegend(a: IDataLegend): void;
    protected ut(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    protected uz(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    protected o(): IDataLegendSeries[];
    zoomIn(a: number): void;
    zoomOut(a: number): void;
    resetZoom(): void;
    protected get_hb(): boolean;
    get hb(): boolean;
    private ci;
    get cj(): IDomainChartToolbarProvider;
    private we;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private hs;
    provideContextAccessor(a: IToolbarContextAccessor): void;
    dismissContextAccessor(a: IToolbarContextAccessor): void;
    private vr;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private ht;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    notifySeriesDataChanged(): void;
    vy(source_: any, a: number, b: any, c: any): void;
    vu(source_: any): void;
    vv(source_: any, a: number, b: any): void;
    vw(source_: any, a: number, b: any): void;
    private by;
    get bz(): DataToolTipLayerGroupingMode;
    set bz(a: DataToolTipLayerGroupingMode);
    private ig;
    get jt(): number;
    set jt(a: number);
    private ih;
    get ju(): number;
    set ju(a: number);
    private id;
    get jr(): number;
    set jr(a: number);
    private ie;
    get js(): number;
    set js(a: number);
    private bu;
    get bv(): DataTooltipGroupedPositionX;
    set bv(a: DataTooltipGroupedPositionX);
    private bw;
    get bx(): DataTooltipGroupedPositionY;
    set bx(a: DataTooltipGroupedPositionY);
    private fx;
    get gt(): boolean;
    set gt(a: boolean);
    static readonly ph: string;
    get m(): string[];
    set m(a: string[]);
    private e;
    get j(): string[];
    set j(a: string[]);
    private b;
    get l(): string[];
    set l(a: string[]);
    private d;
    get i(): string[];
    set i(a: string[]);
    private a;
    get bd(): DataAbbreviationMode;
    set bd(a: DataAbbreviationMode);
    private bc;
    get lk(): number;
    set lk(a: number);
    private k4;
    get ll(): number;
    set ll(a: number);
    private k5;
    get bt(): DataLegendValueMode;
    set bt(a: DataLegendValueMode);
    private bs;
    get p9(): string;
    set p9(a: string);
    private mr;
    get gu(): boolean;
    set gu(a: boolean);
    private fy;
    get qf(): string;
    set qf(a: string);
    private ms;
    get n(): any[];
    set n(a: any[]);
    private f;
    get aae(): Thickness;
    set aae(a: Thickness);
    private z2;
    get gv(): boolean;
    set gv(a: boolean);
    private fz;
    get qo(): string;
    set qo(a: string);
    private mt;
    get gw(): boolean;
    set gw(a: boolean);
    private f0;
    get aaf(): Thickness;
    set aaf(a: Thickness);
    private z3;
    get y8(): Brush;
    set y8(a: Brush);
    private yc;
    private e5;
    get fg(): FontInfo;
    set fg(a: FontInfo);
    get oz(): string;
    set oz(a: string);
    private ml;
    get k(): any[];
    set k(a: any[]);
    private c;
    get ov(): string;
    set ov(a: string);
    private mk;
    get bj(): DataLegendHeaderDateMode;
    set bj(a: DataLegendHeaderDateMode);
    private bi;
    get bl(): DataLegendHeaderTimeMode;
    set bl(a: DataLegendHeaderTimeMode);
    private bk;
    get o4(): string;
    set o4(a: string);
    private mm;
    get y0(): Brush;
    set y0(a: Brush);
    private x4;
    get z8(): Thickness;
    set z8(a: Thickness);
    private zw;
    get z7(): Thickness;
    set z7(a: Thickness);
    private zv;
    get gs(): boolean;
    set gs(a: boolean);
    private fw;
    private ex;
    get e8(): FontInfo;
    set e8(a: FontInfo);
    get yz(): Brush;
    set yz(a: Brush);
    private x3;
    get z6(): Thickness;
    set z6(a: Thickness);
    private zu;
    get z5(): Thickness;
    set z5(a: Thickness);
    private zt;
    get gr(): boolean;
    set gr(a: boolean);
    private fv;
    private ew;
    get e7(): FontInfo;
    set e7(a: FontInfo);
    get y3(): Brush;
    set y3(a: Brush);
    private x7;
    private e0;
    get fb(): FontInfo;
    set fb(a: FontInfo);
    get bp(): DataLegendSummaryType;
    set bp(a: DataLegendSummaryType);
    private bo;
    get pn(): string;
    set pn(a: string);
    private mo;
    get aab(): Thickness;
    set aab(a: Thickness);
    private zz;
    get aaa(): Thickness;
    set aaa(a: Thickness);
    private zy;
    get y5(): Brush;
    set y5(a: Brush);
    private x9;
    private e2;
    get fd(): FontInfo;
    set fd(a: FontInfo);
    get pi(): string;
    set pi(a: string);
    private mn;
    get y2(): Brush;
    set y2(a: Brush);
    private x6;
    private ez;
    get fa(): FontInfo;
    set fa(a: FontInfo);
    get pt(): string;
    set pt(a: string);
    private mp;
    get y4(): Brush;
    set y4(a: Brush);
    private x8;
    private e1;
    get fc(): FontInfo;
    set fc(a: FontInfo);
    get z4(): Thickness;
    set z4(a: Thickness);
    private zs;
    get cs(): LegendItemBadgeShape;
    set cs(a: LegendItemBadgeShape);
    private cq;
    get br(): DataLegendUnitsMode;
    set br(a: DataLegendUnitsMode);
    private bq;
    get p3(): string;
    set p3(a: string);
    private mq;
    get y7(): Brush;
    set y7(a: Brush);
    private yb;
    get aad(): Thickness;
    set aad(a: Thickness);
    private z1;
    private e4;
    get ff(): FontInfo;
    set ff(a: FontInfo);
    get aac(): Thickness;
    set aac(a: Thickness);
    private z0;
    get y6(): Brush;
    set y6(a: Brush);
    private ya;
    private e3;
    get fe(): FontInfo;
    set fe(a: FontInfo);
    get bn(): DataLegendLabelMode;
    set bn(a: DataLegendLabelMode);
    private bm;
    get y1(): Brush;
    set y1(a: Brush);
    private x5;
    get z9(): Thickness;
    set z9(a: Thickness);
    private zx;
    private ey;
    get e9(): FontInfo;
    set e9(a: FontInfo);
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    wx(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    w5(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w1(a: Series, b: any, c: Point): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w2(a: Series, b: any, c: Point): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w3(a: Series, b: any, c: Point): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w0(a: Series, b: any, c: Point): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    w4(a: Series, b: any, c: Point): void;
    seriesClick: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    wy(a: Series, b: DomainChartSeriesPointerEventArgs): void;
    plotAreaPointerEnter: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wr(a: Point): void;
    plotAreaPointerLeave: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    ws(a: Point): void;
    plotAreaPointerMove: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wt(a: Point): void;
    plotAreaPointerDown: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wq(a: Point): void;
    plotAreaPointerUp: (sender: any, args: DomainChartPlotAreaPointerEventArgs) => void;
    wu(a: Point): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    wo(a: any, b: CalloutStyleUpdatingEventArgs): void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    wn(a: any, b: CalloutRenderStyleUpdatingEventArgs): void;
    selectedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    ww(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    focusedSeriesItemsChanged: (sender: any, e: SeriesViewerSelectedSeriesItemsChangedEventArgs) => void;
    wp(a: any, b: SeriesViewerSelectedSeriesItemsChangedEventArgs): void;
    private wz;
    private hz;
    wl(a: () => void): void;
    private fi;
    wm(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_hd(): boolean;
    protected get hd(): boolean;
    protected vh(a: XamDataChart, b: any): void;
    protected u8(): void;
    protected ae(a: BrushCollection): BrushCollection;
    protected zi(a: Brush): Brush;
    protected vn(a: Series, b: number): void;
    protected abstract ux(): void;
    protected get gk(): boolean;
    private fm;
    protected u2(): void;
    protected ve(): void;
    protected w6(a: XamDataChart): void;
    protected us(a: Series, b: number): void;
    protected abstract ur(a: Series, b: number): void;
    protected c2(a: Series, b: number): MarkerType;
    protected c1(a: Series): MarkerType;
    protected c3(a: Series): MarkerType;
    protected ma(): any;
    protected l9(): any;
    protected get_g5(): boolean;
    protected get g5(): boolean;
    protected h8(): IEnumerable;
    protected wd(a: string, b: any, c: any): void;
    private hq;
    private hu;
    private v6;
    private uq;
    private up;
    private wb;
    private wg;
    v5(a: any, b: DataSourcePropertiesRequestedChangedEventArgs): void;
    private xm;
    private wf;
    abstract get cb(): DomainType;
    private ax;
    private at;
    private as;
    private ej;
    private ek;
    private a5;
    private er;
    private es;
    private aw;
    private av;
    private au;
    private em;
    private el;
    private a4;
    get a3(): ChartSortDescriptionCollection;
    get az(): ChartSortDescriptionCollection;
    get ay(): ChartSortDescriptionCollection;
    get en(): FilterExpressionCollection;
    get eo(): FilterExpressionCollection;
    get a7(): ChartSummaryDescriptionCollection;
    private dw;
    get dy(): SeriesSelectionMode;
    set dy(a: SeriesSelectionMode);
    private dv;
    get dx(): SeriesSelectionMode;
    set dx(a: SeriesSelectionMode);
    private yi;
    get zj(): Brush;
    set zj(a: Brush);
    private yf;
    get zb(): Brush;
    set zb(a: Brush);
    private dt;
    get du(): SeriesSelectionBehavior;
    set du(a: SeriesSelectionBehavior);
    private an;
    get selectedSeriesItems(): ChartSelectedItemCollection;
    private am;
    get focusedSeriesItems(): ChartSelectedItemCollection;
    get a2(): ChartSortDescriptionCollection;
    get a1(): ChartSortDescriptionCollection;
    get a0(): ChartSortDescriptionCollection;
    get ep(): FilterExpressionCollection;
    get eq(): FilterExpressionCollection;
    get a6(): ChartSummaryDescriptionCollection;
    private my;
    get ru(): string;
    set ru(a: string);
    private mu;
    get q2(): string;
    set q2(a: string);
    private mw;
    get rq(): string;
    set rq(a: string);
    private mv;
    get ro(): string;
    set ro(a: string);
    private mx;
    get rs(): string;
    set rs(a: string);
    filterStringErrorsParsing: (sender: any, args: FilterStringErrorsParsingEventArgs) => void;
    private mz;
    get rw(): string;
    set rw(a: string);
    private lz;
    get itemsSource(): any;
    set itemsSource(a: any);
    private lx;
    get actualItemsSource(): any;
    set actualItemsSource(a: any);
    private ly;
    get highlightedItemsSource(): any;
    set highlightedItemsSource(a: any);
    private lw;
    get actualHighlightedItemsSource(): any;
    set actualHighlightedItemsSource(a: any);
    private h;
    get includedProperties(): string[];
    set includedProperties(a: string[]);
    private g;
    get excludedProperties(): string[];
    set excludedProperties(a: string[]);
    private r;
    get z(): BrushCollection;
    set z(a: BrushCollection);
    private u;
    get ad(): BrushCollection;
    set ad(a: BrushCollection);
    private p;
    get x(): BrushCollection;
    set x(a: BrushCollection);
    private q;
    get y(): BrushCollection;
    set y(a: BrushCollection);
    private cf;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    private f6;
    protected get_g6(): boolean;
    protected set_g6(a: boolean): void;
    get g6(): boolean;
    set g6(a: boolean);
    private f9;
    protected get_he(): boolean;
    protected set_he(a: boolean): void;
    get he(): boolean;
    set he(a: boolean);
    private gc;
    protected get_hi(): boolean;
    protected set_hi(a: boolean): void;
    get hi(): boolean;
    set hi(a: boolean);
    private ge;
    protected get_hl(): boolean;
    protected set_hl(a: boolean): void;
    get hl(): boolean;
    set hl(a: boolean);
    private dg;
    protected get_dh(): SeriesHighlightedValuesDisplayMode;
    protected set_dh(a: SeriesHighlightedValuesDisplayMode): void;
    get dh(): SeriesHighlightedValuesDisplayMode;
    set dh(a: SeriesHighlightedValuesDisplayMode);
    private f8;
    protected get_g9(): boolean;
    protected set_g9(a: boolean): void;
    get g9(): boolean;
    set g9(a: boolean);
    private aag;
    protected get_aai(): Visibility;
    protected set_aai(a: Visibility): void;
    get aai(): Visibility;
    set aai(a: Visibility);
    private aah;
    protected get_aaj(): Visibility;
    protected set_aaj(a: Visibility): void;
    get aaj(): Visibility;
    set aaj(a: Visibility);
    private zp;
    get zr(): Rect;
    set zr(a: Rect);
    get zq(): Rect;
    private m2;
    get td(): string;
    set td(a: string);
    private m0;
    get s2(): string;
    set s2(a: string);
    private xo;
    get xq(): HorizontalAlignment;
    set xq(a: HorizontalAlignment);
    private xn;
    get xp(): HorizontalAlignment;
    set xp(a: HorizontalAlignment);
    private ee;
    get ef(): UnknownValuePlotting;
    set ef(a: UnknownValuePlotting);
    private iy;
    protected get_ka(): number;
    protected set_ka(a: number): void;
    get ka(): number;
    set ka(a: number);
    private i4;
    get kg(): number;
    set kg(a: number);
    private dm;
    get dn(): SeriesOutlineMode;
    set dn(a: SeriesOutlineMode);
    private cy;
    get cz(): MarkerOutlineMode;
    set cz(a: MarkerOutlineMode);
    private cw;
    get cx(): MarkerFillMode;
    set cx(a: MarkerFillMode);
    private ir;
    get j3(): number;
    set j3(a: number);
    private is;
    get j4(): number;
    set j4(a: number);
    private c4;
    get c5(): MarkerTypeCollection;
    set c5(a: MarkerTypeCollection);
    private cu;
    get cv(): MarkerAutomaticBehavior;
    set cv(a: MarkerAutomaticBehavior);
    private s;
    get ab(): BrushCollection;
    set ab(a: BrushCollection);
    private t;
    get ac(): BrushCollection;
    set ac(a: BrushCollection);
    private lb;
    get lr(): number;
    set lr(a: number);
    private h9;
    get jn(): number;
    set jn(a: number);
    private fl;
    get gj(): boolean;
    set gj(a: boolean);
    private v;
    get af(): BrushCollection;
    set af(a: BrushCollection);
    private eb;
    get ec(): TrendLineType;
    set ec(a: TrendLineType);
    private ja;
    get km(): number;
    set km(a: number);
    private ed;
    get trendLineTypes(): TrendLineTypeCollection;
    set trendLineTypes(a: TrendLineTypeCollection);
    private gf;
    protected get_hn(): boolean;
    protected set_hn(a: boolean): void;
    get hn(): boolean;
    set hn(a: boolean);
    private fk;
    get gi(): boolean;
    set gi(a: boolean);
    private iv;
    get j7(): number;
    set j7(a: number);
    private ix;
    get j9(): number;
    set j9(a: number);
    private iw;
    get j8(): number;
    set j8(a: number);
    private iu;
    get j6(): number;
    set j6(a: number);
    protected wc(): void;
    private k9;
    get lp(): number;
    set lp(a: number);
    private k7;
    get ln(): number;
    set ln(a: number);
    private lc;
    get ls(): number;
    set ls(a: number);
    private a8;
    get a9(): ComputedPlotAreaMarginMode;
    set a9(a: ComputedPlotAreaMarginMode);
    protected ba(): ComputedPlotAreaMarginMode;
    private dp;
    get dq(): SeriesPlotAreaMarginHorizontalMode;
    set dq(a: SeriesPlotAreaMarginHorizontalMode);
    private dr;
    get ds(): SeriesPlotAreaMarginVerticalMode;
    set ds(a: SeriesPlotAreaMarginVerticalMode);
    private dk;
    get dl(): SeriesHighlightingMode;
    set dl(a: SeriesHighlightingMode);
    private di;
    get dj(): SeriesHighlightingBehavior;
    set dj(a: SeriesHighlightingBehavior);
    private cm;
    get cn(): LegendHighlightingMode;
    set cn(a: LegendHighlightingMode);
    private cr;
    get ct(): LegendItemBadgeShape;
    set ct(a: LegendItemBadgeShape);
    private co;
    get cp(): LegendItemBadgeMode;
    set cp(a: LegendItemBadgeMode);
    private lg;
    get lv(): number;
    set lv(a: number);
    private d9;
    get ea(): ToolTipType;
    set ea(a: ToolTipType);
    private bb;
    get crosshairsDisplayMode(): CrosshairsDisplayMode;
    set crosshairsDisplayMode(a: CrosshairsDisplayMode);
    private fu;
    get gq(): boolean;
    set gq(a: boolean);
    private x2;
    get yy(): Brush;
    set yy(a: Brush);
    private ic;
    get jq(): number;
    set jq(a: number);
    private x1;
    get yx(): Brush;
    set yx(a: Brush);
    private ft;
    get crosshairsAnnotationEnabled(): boolean;
    set crosshairsAnnotationEnabled(a: boolean);
    private xx;
    get yt(): Brush;
    set yt(a: Brush);
    private xz;
    get yv(): Brush;
    set yv(a: Brush);
    private xy;
    get yu(): Brush;
    set yu(a: Brush);
    private x0;
    get yw(): Brush;
    set yw(a: Brush);
    private k2;
    get li(): number;
    set li(a: number);
    private k3;
    get lj(): number;
    set lj(a: number);
    private gb;
    get shouldAvoidAxisAnnotationCollisions(): boolean;
    set shouldAvoidAxisAnnotationCollisions(a: boolean);
    private gd;
    get hj(): boolean;
    set hj(a: boolean);
    private f2;
    get finalValueAnnotationsVisible(): boolean;
    set finalValueAnnotationsVisible(a: boolean);
    private yd;
    get y9(): Brush;
    set y9(a: Brush);
    private ye;
    get za(): Brush;
    set za(a: Brush);
    private k6;
    get lm(): number;
    set lm(a: number);
    private fn;
    get autoCalloutsVisible(): boolean;
    set autoCalloutsVisible(a: boolean);
    private fs;
    get gp(): boolean;
    set gp(a: boolean);
    private fo;
    get gl(): boolean;
    set gl(a: boolean);
    private gg;
    get ho(): boolean;
    set ho(a: boolean);
    private ag;
    get ah(): CalloutCollisionMode;
    set ah(a: CalloutCollisionMode);
    private fq;
    get gn(): boolean;
    set gn(a: boolean);
    private fr;
    get go(): boolean;
    set go(a: boolean);
    private fp;
    get gm(): boolean;
    set gm(a: boolean);
    private ib;
    get jp(): number;
    set jp(a: number);
    private xr;
    get yn(): Brush;
    set yn(a: Brush);
    private xv;
    get yr(): Brush;
    set yr(a: Brush);
    private xw;
    get ys(): Brush;
    set ys(a: Brush);
    private xu;
    get yq(): Brush;
    set yq(a: Brush);
    private xs;
    get yo(): Brush;
    set yo(a: Brush);
    private xt;
    get yp(): Brush;
    set yp(a: Brush);
    private k1;
    get lh(): number;
    set lh(a: number);
    private h4;
    get calloutsItemsSource(): IEnumerable;
    set calloutsItemsSource(a: IEnumerable);
    private ai;
    get aj(): CalloutPlacementPositionsCollection;
    set aj(a: CalloutPlacementPositionsCollection);
    private mi;
    get nz(): string;
    set nz(a: string);
    private mj;
    get n1(): string;
    set n1(a: string);
    private mh;
    get nm(): string;
    set nm(a: string);
    private mg;
    get ni(): string;
    set ni(a: string);
    private ev;
    get e6(): FontInfo;
    set e6(a: FontInfo);
    private eg;
    get valueLines(): ValueModeCollection;
    set valueLines(a: ValueModeCollection);
    private w;
    get valueLinesBrushes(): BrushCollection;
    set valueLinesBrushes(a: BrushCollection);
    private jb;
    get kn(): number;
    set kn(a: number);
    private ga;
    protected get_hh(): boolean;
    protected set_hh(a: boolean): void;
    get hh(): boolean;
    set hh(a: boolean);
    get d3(): SeriesViewerScrollbarMode;
    set d3(a: SeriesViewerScrollbarMode);
    private d1;
    get d4(): SeriesViewerScrollbarMode;
    set d4(a: SeriesViewerScrollbarMode);
    private d2;
    get d0(): SeriesViewerHorizontalScrollbarPosition;
    set d0(a: SeriesViewerHorizontalScrollbarPosition);
    private dz;
    get d8(): SeriesViewerVerticalScrollbarPosition;
    set d8(a: SeriesViewerVerticalScrollbarPosition);
    private d7;
    get zg(): Brush;
    set zg(a: Brush);
    private yg;
    get zh(): Brush;
    set zh(a: Brush);
    private yh;
    get jz(): number;
    set jz(a: number);
    private im;
    get jy(): number;
    set jy(a: number);
    private il;
    get jv(): number;
    set jv(a: number);
    private ii;
    get jw(): number;
    set jw(a: number);
    private ij;
    get jx(): number;
    set jx(a: number);
    private ik;
    get j1(): number;
    set j1(a: number);
    private ip;
    get j0(): number;
    set j0(a: number);
    private io;
    get gz(): boolean;
    set gz(a: boolean);
    private f3;
    static readonly rj: string;
    get zm(): Brush;
    set zm(a: Brush);
    private yl;
    get zn(): Brush;
    set zn(a: Brush);
    private ym;
    get kr(): number;
    set kr(a: number);
    private jf;
    get kq(): number;
    set kq(a: number);
    private je;
    get ko(): number;
    set ko(a: number);
    private jc;
    get ku(): number;
    set ku(a: number);
    private ji;
    get kp(): number;
    set kp(a: number);
    private jd;
    get kt(): number;
    set kt(a: number);
    private jh;
    get ks(): number;
    set ks(a: number);
    private jg;
    get hp(): boolean;
    set hp(a: boolean);
    private gh;
    static readonly uc: string;
    get kw(): number;
    set kw(a: number);
    private jk;
    get kv(): number;
    set kv(a: number);
    private jj;
    get ky(): number;
    set ky(a: number);
    private jm;
    get kx(): number;
    set kx(a: number);
    private jl;
}
