import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { DomWrapper } from "igniteui-react-core";
import { EventArgs, IList, Type } from "igniteui-react-core";
import { IZoomSlider } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType } from "igniteui-react-core";
import { IDataSeriesAdapterRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { DomainType } from "./DomainType";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "igniteui-react-core";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { IChartLegend } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Axis } from "./Axis";
import { DataSeries } from "igniteui-react-core";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerType } from "./MarkerType";
import { IZoomableCategoryAxis } from "./IZoomableCategoryAxis";
import { TitleSettings } from "./TitleSettings";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType } from "igniteui-react-core";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
/**
 * @hidden
 */
export declare class FinancialChart extends XYChart {
    static $t: Type;
    protected wi(a: string, b: any, c: any): void;
    private apz;
    private apy;
    private apv;
    private ap8;
    private ajd;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: Event): void;
    private amb;
    private al9;
    private al6;
    private al8;
    private ama;
    private al7;
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private aqj;
    private aqx;
    private apf;
    private aqv;
    setGridRows(): void;
    protected vm(): void;
    private aqf;
    private aqg;
    private aqp;
    private ape;
    private ap5;
    protected vj(a: XamDataChart): void;
    private aq0;
    private aq3;
    private aq1;
    private aq2;
    aln(): number;
    vv(source_: any, a: number, b: any): void;
    vw(source_: any, a: number, b: any): void;
    vu(source_: any): void;
    vy(source_: any, a: number, b: any, c: any): void;
    protected vp(a: Series, b: number): void;
    private aij;
    private get aik();
    private set aik(value);
    private amt;
    get am0(): any;
    set am0(a: any);
    private amu;
    get am1(): any;
    set am1(a: any);
    private amq;
    get amx(): any;
    set amx(a: any);
    private amv;
    get am2(): any;
    set am2(a: any);
    private amw;
    get am3(): any;
    set am3(a: any);
    private amr;
    get amy(): any;
    set amy(a: any);
    private ams;
    get amz(): any;
    set amz(a: any);
    private aj1;
    get aj2(): IZoomSlider;
    set aj2(a: IZoomSlider);
    protected get_j2(): number;
    protected set_j2(a: number): void;
    protected get_g6(): boolean;
    protected set_g6(a: boolean): void;
    private alb;
    get als(): number;
    set als(a: number);
    constructor();
    protected aao(): Axis;
    protected aap(): Axis;
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    protected be(a: DataSeries): DataSeriesType;
    protected get_h2(): List$1<DataSeriesType>;
    protected get h2(): List$1<DataSeriesType>;
    protected get_h1(): List$1<IDataSeriesAdapterRule>;
    protected get h1(): List$1<IDataSeriesAdapterRule>;
    private ah6;
    private ajk;
    private ah5;
    protected ux(): void;
    protected ur(a: Series, b: number): void;
    protected c1(a: Series): MarkerType;
    protected w8(a: DataSeries): void;
    protected xb(): void;
    private aio;
    private ain;
    private aix;
    private aiq;
    private anc;
    private ah7;
    private ajl;
    private ajr;
    private ajs;
    private ajq;
    private ajt;
    private get aka();
    private ai7;
    private get ai8();
    private get akd();
    private ai5;
    private get ai6();
    private get akb();
    private ai9;
    private get aja();
    private get akc();
    private aje;
    private get ajf();
    protected dc(a: DataSeries, b: DataSeriesType): Series;
    protected xa(): void;
    protected af0(a: (arg1: Axis) => void, b: string): void;
    protected af5(a: (arg1: Axis) => void, b: boolean): void;
    protected ap7(a: (arg1: IZoomableCategoryAxis) => void): void;
    protected af3(a: (arg1: TitleSettings) => void): void;
    protected af8(a: (arg1: TitleSettings) => void): void;
    protected af6(a: (arg1: AxisLabelSettings) => void): void;
    protected af1(a: (arg1: AxisLabelSettings) => void): void;
    protected vi(a: XamDataChart): void;
    private static amo;
    private am4;
    private an7;
    private app;
    private apb;
    private apc;
    private aph;
    private apk;
    private api;
    private apj;
    private apl;
    private ami;
    protected u7(a: (arg1: Series, arg2: number) => void): void;
    private ajx;
    private get volumeChart();
    private set volumeChart(value);
    private aqa;
    private ake;
    private aki;
    private akf;
    private akh;
    private ap9;
    private aju;
    private ajw;
    private aqr;
    l5(): any;
    am9(): string;
    private ajv;
    private aqq;
    private akn;
    private aqo;
    protected vf(): void;
    protected get_hd(): boolean;
    protected get akt(): boolean;
    private aqw;
    private aqb;
    protected v3(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    private apn;
    private aqk;
    private get aks();
    private apo;
    private akj;
    private aqe;
    private aps;
    private apx;
    private apw;
    private apq;
    private apr;
    private ap1;
    private ap4;
    private ap2;
    private apd;
    private aqi;
    private aqu;
    private apt;
    private aqs;
    private akm;
    private ap0;
    private apm;
    private aqm;
    private aql;
    private aqd;
    private apu;
    private aku;
    private aqt;
    private apg;
    private aqn;
    protected xf(a: Series, b: Series, c: DataSeries): void;
    private anb;
    protected afv(a: Axis): void;
    protected afx(a: Axis): void;
    private ap3;
    protected vn(a: Series, b: number): void;
    protected vo(a: Series, b: number): void;
    protected wd(a: string, b: any, c: any): void;
    protected get_cb(): DomainType;
    get cb(): DomainType;
    private aj9;
    get akr(): boolean;
    set akr(a: boolean);
    private amh;
    get amp(): number;
    set amp(a: number);
    private ali;
    get al1(): number;
    set al1(a: number);
    private alk;
    get al3(): number;
    set al3(a: number);
    private alj;
    get al2(): number;
    set al2(a: number);
    private all;
    get al4(): number;
    set al4(a: number);
    get al0(): number;
    get alz(): number;
    private aip;
    get air(): FinancialChartVolumeType;
    set air(a: FinancialChartVolumeType);
    private ais;
    get ait(): FinancialChartXAxisMode;
    set ait(a: FinancialChartXAxisMode);
    private ald;
    get alu(): number;
    set alu(a: number);
    private alg;
    get alx(): number;
    set alx(a: number);
    private ale;
    get alv(): number;
    set alv(a: number);
    private alf;
    get alw(): number;
    set alw(a: number);
    private alh;
    get aly(): number;
    set aly(a: number);
    private aiu;
    get aiv(): FinancialChartYAxisMode;
    set aiv(a: FinancialChartYAxisMode);
    private aj4;
    get akk(): boolean;
    set akk(a: boolean);
    private ail;
    get aim(): FinancialChartType;
    set aim(a: FinancialChartType);
    protected get_age(): HorizontalAlignment;
    protected set_age(a: HorizontalAlignment): void;
    private aj5;
    get akl(): boolean;
    set akl(a: boolean);
    private aiz;
    get ai0(): FinancialIndicatorTypeCollection;
    set ai0(a: FinancialIndicatorTypeCollection);
    private ai1;
    get ai2(): FinancialOverlayTypeCollection;
    set ai2(a: FinancialOverlayTypeCollection);
    private akw;
    private get indicatorCharts();
    private set indicatorCharts(value);
    private aj7;
    get akp(): boolean;
    set akp(a: boolean);
    protected get_ka(): number;
    protected set_ka(a: number): void;
    private static readonly aok;
    private aj6;
    get ako(): boolean;
    set ako(a: boolean);
    private static readonly aov;
    private aj8;
    get akq(): boolean;
    set akq(a: boolean);
    private ajy;
    get zoomSliderChart(): XamDataChart;
    set zoomSliderChart(a: XamDataChart);
    private ajj;
    private get zoomSliderAxis();
    private set zoomSliderAxis(value);
    private ah4;
    private get zoomSliderXAxis();
    private set zoomSliderXAxis(value);
    private aiw;
    get aiy(): FinancialChartZoomSliderType;
    set aiy(a: FinancialChartZoomSliderType);
    private ahn;
    get ahv(): BrushCollection;
    set ahv(a: BrushCollection);
    private aho;
    get ahw(): BrushCollection;
    set ahw(a: BrushCollection);
    private ahp;
    get ahx(): BrushCollection;
    set ahx(a: BrushCollection);
    private ahq;
    get ahy(): BrushCollection;
    set ahy(a: BrushCollection);
    private ahs;
    get ah0(): BrushCollection;
    set ah0(a: BrushCollection);
    private ahr;
    get ahz(): BrushCollection;
    set ahz(a: BrushCollection);
    private ahm;
    get ahu(): BrushCollection;
    set ahu(a: BrushCollection);
    private ahl;
    get aht(): BrushCollection;
    set aht(a: BrushCollection);
    private alc;
    get alt(): number;
    set alt(a: number);
    private ala;
    get alr(): number;
    set alr(a: number);
    private ak9;
    get alq(): number;
    set alq(a: number);
    private ak8;
    get alp(): number;
    set alp(a: number);
    private ajb;
    get ajc(): IndicatorDisplayTypeCollection;
    set ajc(a: IndicatorDisplayTypeCollection);
    private amd;
    get amk(): number;
    set amk(a: number);
    private ak7;
    get alo(): number;
    set alo(a: number);
    private amg;
    get amn(): number;
    set amn(a: number);
    private ame;
    get aml(): number;
    set aml(a: number);
    private amc;
    get amj(): number;
    set amj(a: number);
    private amf;
    get amm(): number;
    set amm(a: number);
    private aig;
    get aii(): FinancialChartRangeSelectorOptionCollection;
    set aii(a: FinancialChartRangeSelectorOptionCollection);
    aih: FinancialChartRangeSelectorOptionCollection;
    private aic;
    get customIndicatorNames(): CustomIndicatorNameCollection;
    set customIndicatorNames(a: CustomIndicatorNameCollection);
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_he(): boolean;
    protected set_he(a: boolean): void;
    private aqy;
    get aqz(): Brush;
    set aqz(a: Brush);
    private alm;
    get al5(): number;
    set al5(a: number);
    private aj3;
    get akg(): boolean;
    set akg(a: boolean);
    private ai3;
    get ai4(): IChartLegend;
    set ai4(a: IChartLegend);
    private ah3;
    private get xAxis();
    private set xAxis(value);
    private aji;
    private get yAxis();
    private set yAxis(value);
    private ajh;
    private get volumeAxis();
    private set volumeAxis(value);
    private ah2;
    private get volumeXAxis();
    private set volumeXAxis(value);
    private ajg;
    private get indicatorAxis();
    private set indicatorAxis(value);
    private ah1;
    private get indicatorXAxis();
    private set indicatorXAxis(value);
    private akv;
    private get aky();
    private set aky(value);
    private akx;
    private get ak0();
    private set ak0(value);
    private ak4;
    get ak6(): Date;
    set ak6(a: Date);
    private ak3;
    get ak5(): Date;
    set ak5(a: Date);
    private ak1;
    get xAxisBreaks(): ObservableCollection$1<any>;
}
/**
 * @hidden
 */
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    static $t: Type;
    bg(a: DomWrapper): void;
    bl(a: Event): void;
    private o;
    constructor(a: FinancialChart, b: any);
    private r;
    get s(): FinancialChartRangeSelector;
    set s(a: FinancialChartRangeSelector);
    private z;
    get aa(): FinancialChartTypePicker;
    set aa(a: FinancialChartTypePicker);
    private p;
    get q(): FinancialChartIndicatorMenu;
    set q(a: FinancialChartIndicatorMenu);
    private bm;
    private bh;
    private bi;
    private bj;
    w: FinancialChartToolbarViewModel;
    v(): FinancialChartToolbarContext;
    l(a: any): void;
    private bk;
    private aq;
    get au(): Date;
    set au(a: Date);
    private ap;
    get at(): Date;
    set at(a: Date);
    private ao;
    get as(): Date;
    set as(a: Date);
    private an;
    get ar(): Date;
    set ar(a: Date);
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bn(): void;
    private x;
    get y(): FinancialChartType;
    set y(a: FinancialChartType);
    private ah;
    get ai(): TrendLineType;
    set ai(a: TrendLineType);
    private ab;
    get ac(): FinancialChartVolumeType;
    set ac(a: FinancialChartVolumeType);
    private ad;
    get ae(): FinancialIndicatorTypeCollection;
    set ae(a: FinancialIndicatorTypeCollection);
    private af;
    get ag(): FinancialOverlayTypeCollection;
    set ag(a: FinancialOverlayTypeCollection);
    static am(a: IList, b: IList): boolean;
    aj(): FinancialChartToolbarVisualData;
    private t;
    get u(): FinancialChartRangeSelectorOptionCollection;
    set u(a: FinancialChartRangeSelectorOptionCollection);
    private ak;
    get al(): boolean;
    set al(a: boolean);
}
/**
 * @hidden
 */
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    static $t: Type;
    private static x;
    q: FinancialChartRangeSelectorViewModel;
    get v(): Date;
    set v(a: Date);
    get u(): Date;
    set u(a: Date);
    get t(): Date;
    set t(a: Date);
    get s(): Date;
    set s(a: Date);
    ab(): void;
    constructor(a: any);
    l(a: any): void;
    private z;
    rangeChanged: (sender: any, e: EventArgs) => void;
    r(): FinancialChartRangeSelectorVisualData;
    get o(): FinancialChartRangeSelectorOptionCollection;
    set o(a: FinancialChartRangeSelectorOptionCollection);
    private aa;
    private p;
}
