import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private aae;
    private aac;
    private aad;
    private aab;
    private aaf;
    kw(): any;
    q3(a: SeriesView): void;
    xs: FinancialSeriesView;
    protected get_e8(): boolean;
    ai(): Axis[];
    kr(a: any, b: string): any;
    mf(a: string): string;
    protected zb(): number;
    private y9;
    aj(a: Point): Point[][];
    al(a: Point): Point[][];
    constructor();
    aa1: Brush;
    v1(): Brush;
    v2(): Brush;
    o4(): void;
    protected get_em(): boolean;
    protected get_f6(): boolean;
    xb: CategoryAxisBase;
    xu: NumericYAxis;
    z1: string;
    get x7(): IFastItemColumn$1<number>;
    set x7(a: IFastItemColumn$1<number>);
    private x2;
    zs: string;
    get x5(): IFastItemColumn$1<number>;
    set x5(a: IFastItemColumn$1<number>);
    private x0;
    zx: string;
    get x6(): IFastItemColumn$1<number>;
    set x6(a: IFastItemColumn$1<number>);
    private x1;
    zf: string;
    get x4(): IFastItemColumn$1<number>;
    set x4(a: IFastItemColumn$1<number>);
    private xz;
    z5: string;
    get x9(): IFastItemColumn$1<number>;
    set x9(a: IFastItemColumn$1<number>);
    private x3;
    zo: string;
    zk: string;
    zm: string;
    zi: string;
    zq: string;
    protected gc(): boolean;
    yh: boolean;
    protected yc: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    yj(): boolean;
    protected aai(a: AssigningCategoryStyleEventArgs): void;
    protected xk: CategorySeriesRenderManager;
    protected aag(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    y1(a: Point): number;
    kb(a: Point, b: boolean): number;
    j9(a: Point, b: boolean): number;
    iq(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    wh(a: Point, b: boolean, c: boolean): Point;
    i6(a: Point, b: boolean, c: boolean): number;
    i2(a: Point, b: boolean, c: boolean): number;
    i4(a: Point, b: boolean, c: boolean): number;
    y3(a: Point, b: boolean, c: boolean): number;
    y4(a: Point, b: boolean, c: boolean): number;
    y5(a: Point, b: boolean, c: boolean): number;
    wd(a: Point, b: boolean, c: boolean): Point;
    wf(a: Point, b: boolean, c: boolean): Point;
    aa3(a: Point, b: boolean, c: boolean): Point;
    aa2(a: Point, b: boolean, c: boolean): Point;
    aa4(a: Point, b: boolean, c: boolean): Point;
    qd(): void;
    protected sv(a: Rect, b: Rect): void;
    protected su(a: Rect, b: Rect): void;
    protected ym: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected yn: Dictionary$2<string, string>;
    private x8;
    private aaa;
    private yb;
    protected rc(a: any, b: string, c: any, d: any): void;
    ye(a: any): boolean;
    yd(a: any): boolean;
    protected w4(a: number, b: number, c: Axis): any[];
    protected y8(a: SeriesView): number;
    protected za(a: SeriesView): number;
    w3(a: number, b: number): any[];
    private xy;
    protected get_ff(): boolean;
    o5(): void;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    zc(a: Point): number;
    protected xx(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected xw(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected yf(): boolean;
    is(a: Point): number;
    j4(a: Point): number;
    protected get_ft(): boolean;
    a0(): CategoryAxisBase;
    j6(a: Point): number;
    ko(a: Point): any;
    xf: CategoryFrame;
    xh: CategoryFrame;
    xd: CategoryFrame;
    xe(): CategoryFrame;
    protected y2(a: Rect, b: Rect, c: Rect): number;
    xm: CategoryTransitionInMode;
    yi: boolean;
    protected go(): boolean;
    protected xl(): CategoryTransitionInMode;
    protected c5(): TransitionInSpeedType;
    protected c8(): TransitionOutSpeedType;
    aaj(a: CategoryFrame, b: FinancialSeriesView): void;
    aah(a: CategoryFrame, b: FinancialSeriesView): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    xn: CategoryTransitionSourceFramePreparer;
    y6(a: FinancialSeriesView): number;
    protected o8(): void;
    rv(a: boolean): void;
    protected gp(): boolean;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected yk(a: IList$1<string>): boolean;
    get yl(): boolean;
    protected yg(): boolean;
    protected z9(a: FinancialEventArgs): void;
    protected get yt(): IEnumerable$1<number>;
    private _yq;
    private yq;
    protected get ys(): IEnumerable$1<number>;
    private _yp;
    private yp;
    protected get yr(): IEnumerable$1<number>;
    private _yo;
    private yo;
    yv(a: IList$1<number>): IList$1<number>;
    private ya;
    protected yu(): IList$1<string>;
    private yz;
    getOpenColumnAsArray(): number[];
    private yx;
    getHighColumnAsArray(): number[];
    private yy;
    getLowColumnAsArray(): number[];
    private yw;
    getCloseColumnAsArray(): number[];
    private y0;
    getVolumeColumnAsArray(): number[];
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected xo(a: number, b: number): FinancialCalculationDataSource;
    y7(a: number): number;
    protected xp(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private xg;
    rw(a: Rect, b: RenderSurface): void;
    rx(): void;
    private xc;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aw(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private xi;
    get xj(): CategoryMode;
    set xj(a: CategoryMode);
    protected get_fn(): boolean;
    r7(a: Brush, b: Brush): void;
    private aak;
    private xt;
    private xv;
    kq(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    cf: FinancialSeries;
    cd: FinancialBucketCalculator;
    ch: number;
    cg(a: CategoryFrame): boolean;
    ci(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract ce(): FinancialBucketCalculator;
    a4(): void;
    getDefaultTooltipTemplate(): string;
    protected an(): void;
}
