import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Clipper } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class FinancialIndicator extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_e9(): boolean;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    aa6: FinancialIndicatorView;
    constructor();
    abj(a: boolean): void;
    protected abb(a: Point, b: Point, c: boolean): boolean;
    protected b3(): SeriesHitTestMode;
    ws(a: Point): Rect;
    gx(a: Point, b: boolean): boolean;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aa8: IndicatorDisplayType;
    protected get_aa7(): IndicatorDisplayType;
    get aa7(): IndicatorDisplayType;
    abe: number;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get abw(): Brush;
    set abw(a: Brush);
    static readonly abm: DependencyProperty;
    trendLineThickness: number;
    aby: PenLineCap;
    abx: DoubleCollection;
    trendLinePeriod: number;
    protected abg(): number;
    abf: number;
    private _indicatorColumn;
    get indicatorColumn(): List$1<number>;
    set indicatorColumn(a: List$1<number>);
    protected aa5: AxisRange;
    protected abstract aa9(a: number, b: number): boolean;
    protected abstract abc(a: number, b: number): IList$1<string>;
    protected rc(a: any, b: string, c: any, d: any): void;
    i6(a: Point, b: boolean, c: boolean): number;
    kb(a: Point, b: boolean): number;
    j9(a: Point, b: boolean): number;
    protected get_he(): boolean;
    private aba;
    private abl;
    ay(a: Axis): AxisRange;
    ge(a: any): boolean;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    aah(a: CategoryFrame, b: FinancialSeriesView): void;
    o7(a: boolean, b: SeriesView): void;
    protected xl(): CategoryTransitionInMode;
    aaj(a: CategoryFrame, b: FinancialSeriesView): void;
    protected sl(): void;
    protected abk(): void;
    protected p1(a: any): void;
    protected bf(a: LegendItemBadgeShape): LegendItemBadgeShape;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: FinancialIndicatorView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorView extends FinancialSeriesView {
    static $t: Type;
    cj: FinancialIndicator;
    constructor(a: FinancialIndicator);
    protected ce(): FinancialBucketCalculator;
    a4(): void;
    private readonly cm;
    private cw;
    private cp;
    da: Path;
    c6: Path;
    db: Path;
    c7: Path;
    dc: Path;
    c8: Path;
    c9: Path;
    c5: Path;
    private ck;
    get cl(): ITrendLineManager;
    set cl(a: ITrendLineManager);
    get cn(): boolean;
    co(a: boolean): void;
    cu(): void;
    cs(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: Clipper): void;
    cq(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number, f: Clipper): void;
    cr(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number): void;
    cv(): void;
    private c2;
    private c4;
    private c3;
    private c1;
    private cy;
    private c0;
    private cz;
    private cx;
    protected bq(): void;
    protected bj(a: RenderingContext, b: boolean): void;
    protected bi(a: RenderingContext, b: boolean): void;
    ax(a: any): void;
    ct(): void;
}
