import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PriceDisplayType } from "./PriceDisplayType";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { Series } from "./Series";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { List$1 } from "igniteui-react-core";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Pool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { GeometryGroup } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { NumericAxisBase } from "./NumericAxisBase";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected bk(): Series;
    protected get_fb(): boolean;
    protected jl(): number;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    aa7: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get acq(): Brush;
    set acq(a: Brush);
    static readonly ab7: DependencyProperty;
    trendLineThickness: number;
    act: PenLineCap;
    acs: DoubleCollection;
    trendLinePeriod: number;
    abe: number;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aa8: PriceDisplayType;
    aa6: CategoryCollisionMode;
    protected b3(): SeriesHitTestMode;
    ws(a: Point): Rect;
    private aa5;
    ao(a: Point): Rect[];
    gx(a: Point, b: boolean): boolean;
    protected g0(a: Point, b: boolean): boolean;
    protected rc(a: any, b: string, c: any, d: any): void;
    private ab6;
    ay(a: Axis): AxisRange;
    az(a: Rect): AxisRange;
    iz(): number;
    ge(a: any): boolean;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    aah(a: CategoryFrame, b: FinancialSeriesView): void;
    o7(a: boolean, b: SeriesView): void;
    protected su(a: Rect, b: Rect): void;
    w0(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected get_ef(): boolean;
    aaj(a: CategoryFrame, b: FinancialSeriesView): void;
    ix(): number;
    private ab4;
    private abc;
    private ab3;
    ky(a: any, b: Point): any;
    protected sl(): void;
    protected p1(a: any): void;
    acr: Brush;
    v2(): Brush;
    r7(a: Brush, b: Brush): void;
    protected bf(a: LegendItemBadgeShape): LegendItemBadgeShape;
    abp: string;
    abl: string;
    abg: string;
    abu: string;
    abr: string;
    abn: string;
    abi: string;
    abw: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private aa9;
    private aba;
    abb: number;
    private ab5;
    aq(a: ValueLayerValueMode): number[];
    wk(a: ValueLayerValueMode): Point;
    wl(a: number[]): Point;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    ab0(a: Rect, b: CategoryAxisBase, c: boolean, d: Rect, e: number, f: number): {
        p4: number;
        p5: number;
    };
    abz(a: Rect, b: NumericAxisBase, c: boolean, d: Rect, e: number, f: number): {
        p4: number;
        p5: number;
    };
    aby(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    ab2(a: List$1<ChartSelection>, b: number, c: number, d: SeriesSelectionBehavior): void;
    ab1(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    bd(): ITrendLineManager;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    static $t: Type;
    protected cj: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    cm: Pool$1<Path>;
    c4(): Path;
    protected cp: List$1<Path>;
    cu(a: Path): void;
    cw(a: Path): void;
    cv(a: Path): void;
    protected ce(): FinancialBucketCalculator;
    a4(): void;
    private c3;
    private c2;
    private ck;
    get cl(): ITrendLineManager;
    set cl(a: ITrendLineManager);
    get cn(): boolean;
    cx(): void;
    cr(): void;
    cq(): void;
    c0(): GeometryGroup;
    cz(): GeometryGroup;
    cy(): void;
    protected bp(): void;
    protected bq(): void;
    protected ak(a: number): any;
    private c1;
    protected aj(a: number): any;
    protected bj(a: RenderingContext, b: boolean): void;
    protected bi(a: RenderingContext, b: boolean): void;
    ax(a: any): void;
    cs(): void;
    co: boolean;
    ct(): void;
}
