import { Type } from "igniteui-react-core";
/**
 * Describes location of the overlay text in relation to underlying shape.
 */
export declare enum OverlayTextLocation {
    /**
     * Let the chart automatically decide which overlay text location to use based on type of annotation layer
     */
    Auto = 0,
    /**
     * Positions the overlay text inside middle center of underlying shape.
     */
    InsideMiddleCenter = 1,
    /**
     * Positions the overlay text inside middle left of underlying shape.
     */
    InsideMiddleLeft = 2,
    /**
     * Positions the overlay text inside middle right of underlying shape.
     */
    InsideMiddleRight = 3,
    /**
     * Positions the overlay text inside top left of underlying shape.
     */
    InsideTopLeft = 4,
    /**
     * Positions the overlay text inside top center of underlying shape.
     */
    InsideTopCenter = 5,
    /**
     * Positions the overlay text inside top right of underlying shape.
     */
    InsideTopRight = 6,
    /**
     * Positions the overlay text inside bottom left of underlying shape.
     */
    InsideBottomLeft = 7,
    /**
     * Positions the overlay text inside bottom center of underlying shape.
     */
    InsideBottomCenter = 8,
    /**
     * Positions the overlay text inside bottom right of underlying shape.
     */
    InsideBottomRight = 9,
    /**
     * Positions the overlay text outside top left of underlying shape.
     */
    OutsideTopLeft = 10,
    /**
     * Positions the overlay text outside top center of underlying shape.
     */
    OutsideTopCenter = 11,
    /**
     * Positions the overlay text outside top right of underlying shape.
     */
    OutsideTopRight = 12,
    /**
     * Positions the overlay text outside middle left of underlying shape.
     */
    OutsideMiddleLeft = 13,
    /**
     * Positions the overlay text outside middle right of underlying shape.
     */
    OutsideMiddleRight = 14,
    /**
     * Positions the overlay text outside bottom left of underlying shape.
     */
    OutsideBottomLeft = 15,
    /**
     * Positions the overlay text outside bottom center of underlying shape.
     */
    OutsideBottomCenter = 16,
    /**
     * Positions the overlay text outside bottom right of underlying shape.
     */
    OutsideBottomRight = 17,
    /**
     * Hides the overlay text
     */
    Hidden = 18
}
/**
 * @hidden
 */
export declare let OverlayTextLocation_$type: Type;
