import { MarkerSeries } from "./MarkerSeries";
import { Point, Type } from "igniteui-react-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { HighlightingInfo } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Axis } from "./Axis";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { AxisRange } from "./AxisRange";
import { OwnedPoint } from "./OwnedPoint";
import { HashPool$2 } from "igniteui-react-core";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { AssigningPolarStyleEventArgs } from "./AssigningPolarStyleEventArgs";
import { AssigningPolarMarkerStyleEventArgs } from "./AssigningPolarMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class PolarBase extends MarkerSeries {
    static $t: Type;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    y2: PolarBaseView;
    private y3;
    o4(): void;
    protected get_fq(): boolean;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    constructor();
    private abb;
    private abd;
    private yu;
    y1: PolarAxisInfoCache;
    private ack;
    private acj;
    private aci;
    zf: SeriesRenderer$2<PolarFrame, PolarBaseView>;
    aao: string;
    aa6: string;
    aat: string;
    aar: string;
    protected gc(): boolean;
    protected z3(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private abf;
    private abe;
    protected get zo(): IFastItemColumn$1<number>;
    protected set zo(a: IFastItemColumn$1<number>);
    private zm;
    protected get zp(): IFastItemColumn$1<number>;
    protected set zp(a: IFastItemColumn$1<number>);
    private zn;
    yy: NumericAngleAxis;
    yz: NumericRadiusAxis;
    z4: boolean;
    aae: number;
    zg: TrendLineType;
    acd: Brush;
    get acc(): Brush;
    set acc(a: Brush);
    static readonly abn: DependencyProperty;
    aac: number;
    acf: PenLineCap;
    ace: DoubleCollection;
    aaf: number;
    aag: number;
    zu: boolean;
    y7: PolarFrame;
    y9: PolarFrame;
    y5: PolarFrame;
    y6(): PolarFrame;
    y0: PolarAxes;
    qd(): void;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected su(a: Rect, b: Rect): void;
    protected sv(a: Rect, b: Rect): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    rv(a: boolean): void;
    private ach;
    ay(a: Axis): AxisRange;
    ge(a: any): boolean;
    ko(a: Point): any;
    j4(a: Point): number;
    is(a: Point): number;
    protected z8(a: Point): number;
    protected z7(a: Point): number;
    private zv;
    private z5;
    private aab;
    protected aaa(a: Point): number;
    protected z9(a: Point): number;
    wh(a: Point, b: boolean, c: boolean): Point;
    ai(): Axis[];
    kr(a: any, b: string): any;
    mf(a: string): string;
    protected rc(a: any, b: string, c: any, d: any): void;
    private zb;
    get zc(): ScatterItemSearchMode;
    set zc(a: ScatterItemSearchMode);
    protected zd(): ScatterItemSearchMode;
    protected get_zy(): boolean;
    protected get zy(): boolean;
    protected z0(): boolean;
    protected zz(): boolean;
    ze: ScatterItemSearchMode;
    aad: number;
    zt(a: any): boolean;
    zs(a: any): boolean;
    o7(a: boolean, b: SeriesView): void;
    private yv;
    aba(a: PolarFrame, b: number, c: Rect, d: Rect): void;
    abi(a: PolarFrame, b: PolarBaseView): void;
    zx: boolean;
    zw: boolean;
    protected zr: boolean;
    protected zq: boolean;
    protected get_ff(): boolean;
    private zk;
    private zl;
    protected zi(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zj(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zh(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningPolarStyle: (sender: any, args: AssigningPolarStyleEventArgs) => void;
    assigningPolarMarkerStyle: (sender: any, args: AssigningPolarMarkerStyleEventArgs) => void;
    protected z2(): boolean;
    protected z1(): boolean;
    abm(a: PolarFrame, b: PolarBaseView): void;
    ys(a: number, b: number): any[];
    protected yt(a: number, b: number): any[];
    protected za: PolarSeriesRenderManager;
    abc(a: PolarBaseView, b: PolarFrame): void;
    protected abh(a: number, b: number, c: boolean): void;
    protected abg(a: number, b: number, c: boolean): void;
    protected abk(a: AssigningPolarStyleEventArgs): void;
    protected abj(a: AssigningPolarMarkerStyleEventArgs): void;
    private aa9;
    protected sl(): void;
    y8: PolarFrame;
    rw(a: Rect, b: RenderSurface): void;
    rx(): void;
    private y4;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abl(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    yr(a: HashPool$2<any, Marker>, b: Rect, c: Rect): Point[];
    z6(a: HashPool$2<any, Marker>): List$1<number>;
    acg(a: number): Point;
    protected p1(a: any): void;
    aa2: string;
    aak: string;
    aa4: string;
    aam: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    bd(): ITrendLineManager;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PolarSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningPolarMarkerStyleEventArgs;
    ax: AssigningPolarStyleEventArgs;
    ay(a: PolarBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class PolarBaseView extends MarkerSeriesView {
    static $t: Type;
    protected dc: PolarBase;
    db: MarkerManagerBase;
    constructor(a: PolarBase);
    dd: PolarTrendLineManager;
    a4(): void;
    dh(a: (arg1: Marker) => void): void;
    protected da(): MarkerManagerBase;
    protected di(a: IDictionary$2<any, OwnedPoint>): void;
    protected c9(): Point[];
    protected df(): List$1<number>;
    dg(a: Rect, b: Rect, c: Rect, d: Rect): void;
    dj(): void;
    de: HashPool$2<any, Marker>;
    cw(a: (arg1: Marker) => void): void;
    protected bi(a: RenderingContext, b: boolean): void;
    protected dk(): Rect;
    getDefaultTooltipTemplate(): string;
}
