import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { RadialLabelMode } from "igniteui-react-core";
import { CategoryCollisionMode } from "./CategoryCollisionMode";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { RadialFrame } from "./RadialFrame";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { AssigningRadialStyleEventArgs } from "./AssigningRadialStyleEventArgs";
import { AssigningRadialMarkerStyleEventArgs } from "./AssigningRadialMarkerStyleEventArgs";
import { RadialAxes } from "./RadialAxes";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { Pool$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class RadialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: RadialBaseView;
    constructor(a: RadialBaseView);
    c: number;
    d: number;
    b: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RadialBase extends MarkerSeries implements IHasCategoryModePreference {
    static $t: Type;
    q3(a: SeriesView): void;
    zc: RadialBaseView;
    constructor();
    private abb;
    get categoryAxis(): CategoryAxisBase;
    a0(): CategoryAxisBase;
    ys(a: number, b: number): any[];
    z7: number;
    z8: number;
    aag: string;
    zi: RadialLabelMode;
    y5: CategoryCollisionMode;
    zh: RadialLabelMode;
    aai: string;
    yr: any[];
    aa5: string;
    yw: any[];
    aav: string;
    yt: any[];
    aa2: string;
    yv: any[];
    aaz: string;
    yu: any[];
    protected zj: RadialSeriesRenderManager;
    pu(a: any): void;
    eg(a: any): boolean;
    ps(a: any): void;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    protected kt(a: number, b: boolean): any;
    protected aa8(a: any, b: any, c: number, d: number, e: number, f: boolean, g: boolean, h: boolean): string;
    private aap;
    private aaq;
    private z4;
    private aar;
    private z5;
    protected aac(a: number, b: any): any;
    private aae;
    protected get_fu(): boolean;
    zv: boolean;
    zu: boolean;
    y8: CategoryTransitionInMode;
    zw: boolean;
    protected zq: boolean;
    protected zp: boolean;
    protected get_ff(): boolean;
    private zn;
    private zo;
    protected zk(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected z1(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    kw(): any;
    protected zl(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zm(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningRadialStyle: (sender: any, args: AssigningRadialStyleEventArgs) => void;
    assigningRadialMarkerStyle: (sender: any, args: AssigningRadialMarkerStyleEventArgs) => void;
    protected z0(): boolean;
    protected zz(): boolean;
    protected abe(a: AssigningRadialStyleEventArgs): void;
    protected abd(a: AssigningRadialMarkerStyleEventArgs): void;
    z9(a: SeriesView): number;
    aaa(a: SeriesView): number;
    y4: CategoryAngleAxis;
    za: NumericRadiusAxis;
    ai(): Axis[];
    zt: boolean;
    protected sv(a: Rect, b: Rect): void;
    protected su(a: Rect, b: Rect): void;
    abstract preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private yx;
    private y1;
    private yy;
    private y0;
    private yz;
    protected rc(a: any, b: string, c: any, d: any): void;
    protected zy(): boolean;
    protected zx(): boolean;
    zs(a: any): boolean;
    zr(a: any): boolean;
    ko(a: Point): any;
    z2(a: Point): number;
    is(a: Point): number;
    z3(a: number, b: Rect, c: Rect, d: Rect): number;
    j4(a: Point): number;
    ge(a: any): boolean;
    zf: RadialFrame;
    zg: RadialFrame;
    zd: RadialFrame;
    ze(): RadialFrame;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    abstract abc(a: RadialFrame, b: RadialBaseView): void;
    abstract abf(a: RadialFrame, b: RadialBaseView): void;
    zb: RadialAxes;
    qd(): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    y9: CategoryTransitionSourceFramePreparer;
    protected y7(): CategoryTransitionInMode;
    protected z6(): number;
    protected go(): boolean;
    protected gp(): boolean;
    rv(a: boolean): void;
    aab(): number;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialBaseView extends MarkerSeriesView {
    static $t: Type;
    da: RadialBucketCalculator;
    c9: RadialBase;
    constructor(a: RadialBase);
    db: Pool$1<Marker>;
    cw(a: (arg1: Marker) => void): void;
    dc: number;
    dd: Point;
}
