import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { MarkerCollisionMode } from "./MarkerCollisionMode";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected ct(): SeriesView;
    o4(): void;
    q3(a: SeriesView): void;
    y2: ScatterBaseView;
    protected get_fx(): boolean;
    ai(): Axis[];
    kr(a: any, b: string): any;
    mf(a: string): string;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    protected b3(): SeriesHitTestMode;
    wu(a: Point): Rect;
    gx(a: Point, b: boolean): boolean;
    constructor();
    y1: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    aay: string;
    get zm(): IFastItemColumn$1<number>;
    set zm(a: IFastItemColumn$1<number>);
    private zk;
    aa6: string;
    get zn(): IFastItemColumn$1<number>;
    set zn(a: IFastItemColumn$1<number>);
    private zl;
    aai: string;
    aak: string;
    protected gc(): boolean;
    protected z1(): boolean;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private abd;
    private abe;
    aau: string;
    aa2: string;
    aaw: string;
    aa4: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get acn(): Brush;
    set acn(a: Brush);
    static readonly aby: DependencyProperty;
    trendLineThickness: number;
    acp: PenLineCap;
    aco: DoubleCollection;
    trendLinePeriod: number;
    yy: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    aaf: number;
    aae: number;
    zd: ScatterItemSearchMode;
    aad: number;
    qd(): void;
    y3: ScatterErrorBarSettings;
    protected rc(a: any, b: string, c: any, d: any): void;
    protected zy(): boolean;
    protected zx(): boolean;
    zs(a: any): boolean;
    zr(a: any): boolean;
    private abw;
    private acq;
    private acr;
    private aa8;
    protected zw(a: string, b: FastItemsSourceEventAction): boolean;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    abn(a: ScatterFrame): void;
    abo(a: ScatterFrame, b: Clipper): void;
    ay(a: Axis): AxisRange;
    ko(a: Point): any;
    private za;
    get zb(): ScatterItemSearchMode;
    set zb(a: ScatterItemSearchMode);
    protected zc(): ScatterItemSearchMode;
    j4(a: Point): number;
    is(a: Point): number;
    protected z9(a: Point): number;
    private yr;
    private ys;
    protected z8(a: Point): number;
    private abb;
    protected get_zv(): boolean;
    protected get zv(): boolean;
    private aac;
    protected aab(a: Point): number;
    protected z7(a: Point): number;
    protected aaa(a: Point): number;
    wh(a: Point, b: boolean, c: boolean): Point;
    ge(a: any): boolean;
    protected su(a: Rect, b: Rect): void;
    protected sv(a: Rect, b: Rect): void;
    y7: ScatterFrame;
    y9: ScatterFrame;
    y5: ScatterFrame;
    y6(): ScatterFrame;
    aa9(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    abk(a: ScatterFrame, b: ScatterBaseView): void;
    o7(a: boolean, b: SeriesView): void;
    zu: boolean;
    zt: boolean;
    protected zq: boolean;
    protected zp: boolean;
    protected get_ff(): boolean;
    private zi;
    private zj;
    protected zg(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected zh(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    w0(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected zf(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected z0(): boolean;
    protected zz(): boolean;
    abv(a: ScatterFrame, b: ScatterBaseView): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    abc(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior, d: MarkerCollisionMode, e: IFastItemColumn$1<number>): void;
    yu(a: number, b: number): any[];
    protected yv(a: number, b: number): any[];
    protected ze: ScatterSeriesRenderManager;
    aba(a: ScatterBaseView, b: ScatterFrame): void;
    protected abg(a: number, b: number, c: boolean): void;
    protected abf(a: number, b: number, c: boolean): void;
    protected abq(a: AssigningScatterStyleEventArgs): void;
    protected abp(a: AssigningScatterMarkerStyleEventArgs): void;
    abi(a: ScatterFrame, b: ScatterBaseView): void;
    abl(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    abj(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    abh(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    abm(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    abs(a: ScatterFrame, b: ScatterBaseView): void;
    private abt;
    private abu;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    rv(a: boolean): void;
    protected sl(): void;
    y8: ScatterFrame;
    rw(a: Rect, b: RenderSurface): void;
    rx(): void;
    private y4;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    abr(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    yt(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    z2(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected p1(a: any): void;
    iz(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private zo;
    private z3;
    private z4;
    z5: number;
    z6: number;
    private abx;
    i9(a: ValueLayerValueMode, b: Axis): number;
    aq(a: ValueLayerValueMode): number[];
    wl(a: number[]): Point;
    wk(a: ValueLayerValueMode): Point;
    bd(): ITrendLineManager;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    dd: MarkerManagerBase;
    protected db: Point[];
    protected de: ScatterBase;
    protected dj: List$1<number>;
    constructor(a: ScatterBase);
    private dv;
    private dw;
    df: ScatterTrendLineManager;
    a4(): void;
    private du;
    dx(a: Marker): Size;
    protected dc(): MarkerManagerBase;
    protected ds(a: IDictionary$2<any, OwnedPoint>): void;
    di(): List$1<Marker>;
    da(): Point[];
    protected c9(): Point[];
    protected dh(): List$1<number>;
    dk(): void;
    dq(a: PathGeometry): void;
    dl(): void;
    dr(a: PathGeometry): void;
    dt(): void;
    dg: HashPool$2<any, Marker>;
    cw(a: (arg1: Marker) => void): void;
    dn(a: (arg1: Marker) => void): void;
    dp(): void;
    protected bi(a: RenderingContext, b: boolean): void;
    dm(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
