import { EventArgs, Base, Type, Point, IList$1, IEnumerable, IEnumerator$1, IEnumerator, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategorySeries } from "./CategorySeries";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { NumericAxisBase } from "./NumericAxisBase";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { Rect } from "igniteui-react-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { SeriesViewer } from "./SeriesViewer";
import { PointCollection } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IChartLegend } from "igniteui-react-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { RenderSurface } from "./RenderSurface";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Path } from "igniteui-react-core";
import { CategoryMode } from "./CategoryMode";
import { DependencyObject } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { IScaler } from "./IScaler";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { AnchoredCategoryBucketCalculator } from "./AnchoredCategoryBucketCalculator";
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { ICategoryScaler } from "./ICategoryScaler";
import { IBucketizer } from "./IBucketizer";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { IBarSeries } from "./IBarSeries";
import { Color } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-react-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { DomRenderer } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ValuesHolder } from "./ValuesHolder";
import { PreparationParams } from "./PreparationParams";
import { RenderingContext } from "igniteui-react-core";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Canvas } from "igniteui-react-core";
import { Panel } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class StackedSeriesCreatedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: StackedFragmentSeries);
    c: StackedFragmentSeries;
    get brush(): Brush;
    set brush(a: Brush);
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(a: Visibility);
    get outline(): Brush;
    set outline(a: Brush);
    get dashArray(): DoubleCollection;
    set dashArray(a: DoubleCollection);
    get dashCap(): PenLineCap;
    set dashCap(a: PenLineCap);
    get index(): number;
    get thickness(): number;
    set thickness(a: number);
    get title(): any;
    set title(a: any);
    get transitionDuration(): number;
    set transitionDuration(a: number);
    get transitionEasingFunction(): (time: number) => number;
    set transitionEasingFunction(a: (time: number) => number);
    get markerBrush(): Brush;
    set markerBrush(a: Brush);
    get markerOutline(): Brush;
    set markerOutline(a: Brush);
    get markerStyle(): Style;
    set markerStyle(a: Style);
    get markerTemplate(): DataTemplate;
    set markerTemplate(a: DataTemplate);
    get markerType(): MarkerType;
    set markerType(a: MarkerType);
    get markerThickness(): number;
    set markerThickness(a: number);
    get lineCap(): PenLineCap;
    set lineCap(a: PenLineCap);
}
/**
 * @hidden
 */
export declare abstract class FragmentBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    private ___neverPassByValue;
    constructor();
    ac1: CategoryLineRasterizer;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    private ac3;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_e7(): boolean;
    protected get_isFragment(): boolean;
    ne(): string;
    j3(): number;
    protected qc(a: Series): void;
    j8(): number;
    resolveLegendIndex(): number;
    bq(): Series;
    yx(): CategoryAxisBase;
    ac0(): CategoryFramePreparer;
    ze(): NumericAxisBase;
    ac6(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    aam(a: CategoryFrame, b: CategorySeriesView): void;
    wh(a: Point, b: boolean, c: boolean): Point;
    ai(): Axis[];
    private ac7;
    ac9(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    abd(a: CategorySeriesView): number;
    ay(a: Axis): AxisRange;
    ac8(): number;
    ada(a: IChartLegend): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    rw(a: Rect, b: RenderSurface): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragment extends FragmentBase {
    static $t: Type;
    protected bk(): Series;
    constructor();
    protected ct(): SeriesView;
    adb: AreaFragmentView;
    q3(a: SeriesView): void;
    protected get_ex(): boolean;
    protected get_ew(): boolean;
    protected y9(): CategoryTransitionInMode;
    protected add(a: Point, b: boolean): boolean;
    gx(a: Point, b: boolean): boolean;
    private adc;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    o7(a: boolean, b: SeriesView): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    sh(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class ColumnFragment extends FragmentBase {
    static $t: Type;
    protected bk(): Series;
    protected get_e1(): boolean;
    protected get_fm(): boolean;
    protected jl(): number;
    protected y9(): CategoryTransitionInMode;
    constructor();
    protected ct(): SeriesView;
    adc: ColumnFragmentView;
    q3(a: SeriesView): void;
    adf: number;
    adg: number;
    get fragmentXAxis(): CategoryAxisBase;
    get fragmentYAxis(): NumericAxisBase;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    yx(): CategoryAxisBase;
    ze(): NumericAxisBase;
    protected get_ef(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    o7(a: boolean, b: SeriesView): void;
    ay(a: Axis): AxisRange;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    hc(): boolean;
    z0(a: SeriesView): number;
    z1(a: SeriesView): number;
    z2(a: SeriesView): number;
    ws(a: Point): Rect;
    gx(a: Point, b: boolean): boolean;
    protected g0(a: Point, b: boolean): boolean;
    protected adl(a: Rect, b: number): Rect;
    ky(a: any, b: Point): any;
    ko(a: Point): any;
    j6(a: Point): number;
    j4(a: Point): number;
    ac6(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    private ade;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aam(a: CategoryFrame, b: CategorySeriesView): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BarFragment extends ColumnFragment {
    static $t: Type;
    constructor();
    protected get_ez(): boolean;
    protected get_fm(): boolean;
    protected get_e1(): boolean;
    protected y9(): CategoryTransitionInMode;
    get barFragmentXAxis(): NumericXAxis;
    get barFragmentYAxis(): CategoryYAxis;
    yx(): CategoryAxisBase;
    protected get_isVertical(): boolean;
    is(a: Point): number;
    ze(): NumericAxisBase;
    protected adl(a: Rect, b: number): Rect;
    ws(a: Point): Rect;
    gx(a: Point, b: boolean): boolean;
    ac6(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    ko(a: Point): any;
    j6(a: Point): number;
    abd(a: CategorySeriesView): number;
    protected rc(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class LineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class SplineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class StackedBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedBarBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    g(a: number): void;
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedColumnBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class FragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: FragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare class LineFragment extends FragmentBase {
    static $t: Type;
    protected bk(): Series;
    protected get_fl(): boolean;
    protected zt(): boolean;
    constructor();
    protected ct(): SeriesView;
    adb: LineFragmentView;
    q3(a: SeriesView): void;
    protected add(a: Point, b: boolean): boolean;
    protected get_ex(): boolean;
    gx(a: Point, b: boolean): boolean;
    private adc;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    o7(a: boolean, b: SeriesView): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class SplineFragmentBase extends SplineSeriesBase {
    static $t: Type;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    adk: CategoryLineRasterizer;
    constructor();
    private adm;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected qc(a: Series): void;
    protected get_e7(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_isFragment(): boolean;
    ne(): string;
    wh(a: Point, b: boolean, c: boolean): Point;
    ai(): Axis[];
    private ado;
    j3(): number;
    resolveLegendIndex(): number;
    j8(): number;
    bq(): Series;
    ac6(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    ay(a: Axis): AxisRange;
    adp(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericYAxis, f: CategorySeriesView): void;
    aam(a: CategoryFrame, b: CategorySeriesView): void;
    ac0(a: CategorySeriesView): number[][];
    ac1(a: CategorySeriesView): number[][];
    adf(a: CategorySeriesView): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineAreaFragment extends SplineFragmentBase {
    static $t: Type;
    protected bk(): Series;
    constructor();
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    private adq;
    ac(): void;
    protected get_ex(): boolean;
    protected get_ew(): boolean;
    protected get_f1(): boolean;
    protected y9(): CategoryTransitionInMode;
    protected ads(a: Point, b: boolean): boolean;
    gx(a: Point, b: boolean): boolean;
    private adr;
    adu: PointCollection;
    o7(a: boolean, b: SeriesView): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    rw(a: Rect, b: RenderSurface): void;
    adt(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    abd(a: CategorySeriesView): number;
    sh(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragment extends SplineFragmentBase {
    static $t: Type;
    protected bk(): Series;
    protected get_f1(): boolean;
    protected zt(): boolean;
    constructor();
    protected ct(): SeriesView;
    adq: SplineFragmentView;
    q3(a: SeriesView): void;
    protected ads(a: Point, b: boolean): boolean;
    protected get_ex(): boolean;
    gx(a: Point, b: boolean): boolean;
    private adr;
    o7(a: boolean, b: SeriesView): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: SplineFragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare abstract class StackedSeriesBase extends CategorySeries implements IIsCategoryBased {
    static $t: Type;
    constructor();
    qi(): void;
    protected get_ff(): boolean;
    getHostReferenceValue(): number;
    protected ct(): SeriesView;
    aa6: StackedSeriesView;
    q3(a: SeriesView): void;
    q4(a: Rect, b: Rect): void;
    private _series;
    get series(): StackedSeriesCollection;
    set series(a: StackedSeriesCollection);
    kd(): number;
    p5(a: (arg1: Series) => boolean): void;
    aa7: boolean;
    aa9: boolean;
    protected get_isStacked(): boolean;
    seriesCreated: (sender: any, e: StackedSeriesCreatedEventArgs) => void;
    abx: Visibility;
    abg: number;
    abf: number;
    aaw: number[];
    aax: number[];
    private aa4;
    get aa5(): StackedSeriesManager;
    set aa5(a: StackedSeriesManager);
    aa1: StackedSeriesCollection;
    get aa0(): StackedSeriesCollection;
    private abm;
    private abs;
    private abr;
    sa(a: Point): void;
    y5(a: CategorySeriesView): CategoryFramePreparer;
    aam(a: CategoryFrame, b: CategorySeriesView): void;
    rv(a: boolean): void;
    protected get_gu(): boolean;
    o7(a: boolean, b: SeriesView): void;
    abn(): void;
    abt(): void;
    protected get_aa8(): boolean;
    get aa8(): boolean;
    ge(a: any): boolean;
    ay(a: Axis): AxisRange;
    xl(): boolean;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    aaz(): CategorySeriesView;
    abc(): number;
    abd(): number;
    abi(a: StackedFragmentSeries): number;
    abh(a: Point): number;
    aba(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    private abb;
    abo(): void;
    aap(a: CategoryFrame, b: CategorySeriesView): void;
    abq(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Rect): AxisRange;
    rz(): void;
    protected abp(): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    protected go(): boolean;
    protected get_e7(): boolean;
    rw(a: Rect, b: RenderSurface): void;
    aay: CategoryFrame;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aai(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    abe(a: number, b: number): number;
    aac(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    kn(): any;
    get mayContainUnknowns(): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: CategoryAxisBase;
    protected get_em(): boolean;
    protected get_f6(): boolean;
    o4(): void;
    cl(): SeriesPlotAreaMarginHorizontalMode;
    cm(): SeriesPlotAreaMarginVerticalMode;
    yAxis: NumericYAxis;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ai(): Axis[];
    zu(): boolean;
    sh(): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    ab1(a: any): boolean;
    ab0(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bk(): Series;
    protected get_ew(): boolean;
    constructor();
    ac(): void;
    protected ct(): SeriesView;
    ab6: StackedAreaSeriesView;
    q3(a: SeriesView): void;
    ay(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class VerticalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    yx(): CategoryAxisBase;
    ze(): NumericAxisBase;
    o4(): void;
    cl(): SeriesPlotAreaMarginHorizontalMode;
    cm(): SeriesPlotAreaMarginVerticalMode;
    az(a: Rect): AxisRange;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_isVertical(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    zu(): boolean;
    protected rc(a: any, b: string, c: any, d: any): void;
    ab1(a: any): boolean;
    ab0(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedBarSeries extends VerticalStackedSeriesBase implements IBarSeries {
    static $t: Type;
    protected bk(): Series;
    protected get_ez(): boolean;
    protected get_fm(): boolean;
    protected jl(): number;
    constructor();
    ac(): void;
    protected ct(): SeriesView;
    ab6: StackedBarSeriesView;
    q3(a: SeriesView): void;
    ab7: number;
    ab8: number;
    aaz(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    z3(): number;
    abc(): number;
    abd(): number;
    ay(a: Axis): AxisRange;
    ge(a: any): boolean;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    protected pd(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    j4(a: Point): number;
    ko(a: Point): any;
    abt(): void;
    abh(a: Point): number;
    aba(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    ix(): number;
    abq(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    getPreferredCategoryMode(): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedColumnSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bk(): Series;
    protected get_e1(): boolean;
    protected get_fm(): boolean;
    protected jl(): number;
    constructor();
    protected ct(): SeriesView;
    ab6: StackedColumnSeriesView;
    q3(a: SeriesView): void;
    ab7: number;
    ab8: number;
    aaz(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ay(a: Axis): AxisRange;
    ix(): number;
    abq(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    protected rc(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bk(): Series;
    ab7: boolean;
    protected jl(): number;
    protected get_ew(): boolean;
    protected get_f1(): boolean;
    constructor();
    ac(): void;
    protected ct(): SeriesView;
    ab6: StackedSplineAreaSeriesView;
    q3(a: SeriesView): void;
    ay(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected rc(a: any, b: string, c: any, d: any): void;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected bk(): Series;
    ab7: boolean;
    protected get_f1(): boolean;
    protected jl(): number;
    constructor();
    ac(): void;
    protected ct(): SeriesView;
    ab6: StackedSplineSeriesView;
    q3(a: SeriesView): void;
    ay(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    ak(a: Rect, b: SeriesSelectionBehavior): ChartSelection[];
    p6(a: Rect, b: List$1<ChartSelection>, c: SeriesSelectionBehavior): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedFragmentSeries extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    itemsSource: IEnumerable;
    highlightedItemsSource: IEnumerable;
    kz: Brush;
    ku: Brush;
    k8: DoubleCollection;
    k7: DoubleCollection;
    lb: PenLineCap;
    k9: PenLineCap;
    au: boolean;
    al: boolean;
    b1: number;
    bi: number;
    k6: Color;
    k5: Color;
    a4: boolean;
    ar: boolean;
    b2: number;
    bj: number;
    b3: number;
    bk: number;
    lc: PenLineCap;
    la: PenLineCap;
    av: boolean;
    am: boolean;
    hq: DataTemplate;
    hn: DataTemplate;
    hr: DataTemplate;
    ho: DataTemplate;
    lu: Visibility;
    ls: Visibility;
    r: LegendItemBadgeShape;
    p: LegendItemBadgeMode;
    q: LegendItemBadgeShape;
    o: LegendItemBadgeMode;
    k0: Brush;
    kv: Brush;
    k1: Brush;
    kw: Brush;
    lr: Style;
    lq: Style;
    hs: DataTemplate;
    hp: DataTemplate;
    x: MarkerType;
    w: MarkerType;
    t: MarkerFillMode;
    s: MarkerFillMode;
    v: MarkerOutlineMode;
    u: MarkerOutlineMode;
    e0: string;
    by: number;
    bf: number;
    k2: Brush;
    kx: Brush;
    k3: Brush;
    ky: Brush;
    bm: number;
    bb: number;
    bw: number;
    bd: number;
    ab: SeriesOutlineMode;
    aa: SeriesOutlineMode;
    bv: number;
    bc: number;
    z: SeriesHighlightedValuesDisplayMode;
    bz: number;
    bg: number;
    an: boolean;
    aw: boolean;
    b0: number;
    bh: number;
    b4: number;
    bl: number;
    bx: number;
    be: number;
    cj: any;
    ck: any;
    cf: any;
    ai: (time: number) => number;
    cd: number;
    ce: number;
    aj: (time: number) => number;
    n: CategoryTransitionInMode;
    ax: boolean;
    ae: TransitionInSpeedType;
    ao: boolean;
    b7: number;
    m: CategoryTransitionInMode;
    ad: TransitionInSpeedType;
    ah: (time: number) => number;
    ag: (time: number) => number;
    b6: number;
    a3: boolean;
    aq: boolean;
    a2: boolean;
    ap: boolean;
    ft: string;
    fp: string;
    fr: string;
    d0: string;
    d2: string;
    cg(a: number, b: number): any;
    eb(): string;
    d9: string;
    ed: string;
    cp: string;
    cr: string;
    lv: Visibility;
    lt: Visibility;
    private _parentSeries;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    cc: number;
    af: SeriesViewer;
    ak: IFastItemColumn$1<number>;
    private _visualSeriesLink;
    get visualSeriesLink(): AnchoredCategorySeries;
    set visualSeriesLink(a: AnchoredCategorySeries);
    a7: List$1<number>;
    a8: List$1<number>;
    a6: List$1<number[]>;
    az: boolean;
    b8(a: Point): number;
    ch(a: Point): any;
    cb(a: Point, b: boolean): number;
    ca(a: Point, b: boolean): number;
    bt(a: Point, b: boolean, c: boolean): number;
    li(a: Point, b: boolean, c: boolean): Point;
    lm(a: Point): Rect;
    j(a: Point): Rect[];
    ln(a: Point): Rect;
    k(a: Point): Rect[];
    lo(a: Point): Rect;
    lp(a: Point): Rect;
    bp(a: Point, b: boolean, c: boolean): number;
    le(a: Point, b: boolean, c: boolean): Point;
    br(a: Point, b: boolean, c: boolean): number;
    lg(a: Point, b: boolean, c: boolean): Point;
    lj(a: Point, b: boolean, c: boolean): Point;
    bu(a: Point, b: boolean, c: boolean): number;
    lf(a: Point, b: boolean, c: boolean): Point;
    bq(a: Point, b: boolean, c: boolean): number;
    lh(a: Point, b: boolean, c: boolean): Point;
    bs(a: Point, b: boolean, c: boolean): number;
    b9(a: Point): number;
    bo(): number;
    bn(a: Point): number;
    ci(a: Point): any;
    as(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    lk(a: Point): Point;
    ld(a: Point): Point;
    a0(a: any): boolean;
    ll(): Rect;
    fx(): void;
    f2(a: Point): void;
    a1(a: Point, b: boolean): boolean;
    fw(a: Point): void;
    b5: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    k4: Brush;
    hm(): void;
    gu(): void;
    gw(): void;
    f4(): void;
    f5(): void;
    gb(): void;
    ga(): void;
    g0(): void;
    gq(): void;
    f6(): void;
    gc(): void;
    g3(): void;
    g4(): void;
    hi(): void;
    g5(): void;
    g6(): void;
    gd(): void;
    gj(): void;
    gk(): void;
    gl(): void;
    gi(): void;
    gh(): void;
    go(): void;
    gr(): void;
    gt(): void;
    gx(): void;
    gy(): void;
    gz(): void;
    gg(): void;
    f9(): void;
    f3(): void;
    ge(): void;
    g1(): void;
    g2(): void;
    gm(): void;
    g7(): void;
    gn(): void;
    gv(): void;
    g9(): void;
    hb(): void;
    ha(): void;
    hd(): void;
    he(): void;
    hf(): void;
    gf(): void;
    hc(): void;
    hh(): void;
    g8(): void;
    gp(): void;
    gs(): void;
    hg(): void;
    hk(): void;
    hj(): void;
    f7(): void;
    f8(): void;
    hl(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected f0(a: string, b: any, c: any): void;
    private a5;
    private at;
    private ay;
    protected fy(a: any, b: string, c: any, d: any): void;
    f1(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSeriesCollection extends ObservableCollection$1<StackedFragmentSeries> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesFramePreparer extends CategoryFramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    j(a: PreparationParams): ValuesHolder;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    dt: AreaFragment;
    a4(): void;
    constructor(a: AreaFragment);
    dz: Path;
    d1: Path;
    d0: Path;
    d2: Path;
    dv: Path;
    dx: Path;
    dw: Path;
    dy: Path;
    du(): void;
    da(): CategoryBucketCalculator;
    protected bp(): void;
    protected bq(): void;
    protected bj(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    ax(a: any): void;
}
/**
 * @hidden
 */
export declare class ColumnFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    dt: ColumnFragment;
    a4(): void;
    constructor(a: ColumnFragment);
    protected dx: List$1<Rectangle>;
    du: Pool$1<Rectangle>;
    dv: List$1<number>;
    dw: List$1<number>;
    private d3;
    private dy;
    private d0;
    private dz;
    protected bs(a: any, b: number): void;
    d1(a: Rectangle, b: number, c: number): void;
    protected bt(a: any, b: number): void;
    protected ak(a: number): any;
    private d2;
    protected aj(a: number): any;
    protected bj(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    ax(a: any): void;
    getDefaultTooltipTemplate(): string;
}
/**
 * @hidden
 */
export declare class LineFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    dt: LineFragment;
    constructor(a: LineFragment);
    dz: Path;
    dy: Path;
    d0: Path;
    dw: Path;
    dv: Path;
    dx: Path;
    du(): void;
    da(): CategoryBucketCalculator;
    protected bp(): void;
    protected bq(): void;
    protected bj(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    ax(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineAreaFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    private dv;
    a4(): void;
    constructor(a: SplineAreaFragment);
    d1: Path;
    d3: Path;
    d2: Path;
    d4: Path;
    dx: Path;
    dz: Path;
    dy: Path;
    d0: Path;
    dw(): void;
    protected bp(): void;
    protected bq(): void;
    protected bj(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    ax(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    dv: SplineFragment;
    constructor(a: SplineFragment);
    da(): CategoryBucketCalculator;
    d1: Path;
    d0: Path;
    d2: Path;
    dy: Path;
    dx: Path;
    dz: Path;
    dw(): void;
    protected bp(): void;
    protected bq(): void;
    protected bj(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    ax(a: any): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesView extends CategorySeriesView {
    static $t: Type;
    di: StackedSeriesBase;
    private readonly dj;
    get dk(): Canvas;
    private readonly dl;
    get dm(): Panel;
    constructor(a: StackedSeriesBase);
    da(): CategoryBucketCalculator;
    a1(): void;
    a3(a: RenderingContext, b: RenderingContext): void;
    protected an(): void;
}
/**
 * @hidden
 */
export declare class StackedBarSeriesView extends StackedSeriesView {
    static $t: Type;
    dn: StackedBarSeries;
    constructor(a: StackedBarSeries);
    da(): CategoryBucketCalculator;
    a4(): void;
}
/**
 * @hidden
 */
export declare class StackedColumnSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedColumnSeries);
    da(): CategoryBucketCalculator;
    a4(): void;
}
/**
 * @hidden
 */
export declare class StackedAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedAreaSeries);
    a4(): void;
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineAreaSeries);
    a4(): void;
    dn(): number;
}
/**
 * @hidden
 */
export declare class StackedSplineSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineSeries);
    a4(): void;
    dn(): number;
}
/**
 * @hidden
 */
export declare class StackedSeriesManager extends Base {
    static $t: Type;
    constructor(a: StackedSeriesBase);
    b: StackedSeriesBase;
    f: ObservableCollection$1<AnchoredCategorySeries>;
    c: StackedSeriesCollection;
    e: ObservableCollection$1<AnchoredCategorySeries>;
    d: ObservableCollection$1<AnchoredCategorySeries>;
    l: Canvas;
    m: Panel;
    a(a: StackedFragmentSeries): AnchoredCategorySeries;
    k(): void;
    private j;
    i(a: boolean): void;
    private h;
    g(): void;
}
