import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { YAxisLabelLocation } from "./YAxisLabelLocation";
import { XAxisLabelLocation } from "./XAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected vm(): void;
    protected wh(a: string, b: any, c: any): void;
    private aaq;
    get aas(): (item: any) => string;
    set aas(a: (item: any) => string);
    private aar;
    get aat(): (item: any) => string;
    set aat(a: (item: any) => string);
    private aa7;
    get ab9(): number;
    set ab9(a: number);
    private aa9;
    get acb(): number;
    set acb(a: number);
    private aa8;
    get aca(): number;
    set aca(a: number);
    private aa6;
    get ab8(): number;
    set ab8(a: number);
    private abo;
    get acq(): number;
    set acq(a: number);
    private abq;
    get acs(): number;
    set acs(a: number);
    private abp;
    get acr(): number;
    set acr(a: number);
    private abn;
    get acp(): number;
    set acp(a: number);
    private agh;
    get agx(): Brush;
    set agx(a: Brush);
    private ago;
    get ag4(): Brush;
    set ag4(a: Brush);
    private agf;
    get agv(): Brush;
    set agv(a: Brush);
    private agg;
    get agw(): Brush;
    set agw(a: Brush);
    private abi;
    get ack(): number;
    set ack(a: number);
    private abz;
    get ac1(): number;
    set ac1(a: number);
    private abh;
    get acj(): number;
    set acj(a: number);
    private aby;
    get ac0(): number;
    set ac0(a: number);
    private abk;
    get acm(): number;
    set acm(a: number);
    private ab1;
    get ac3(): number;
    set ac3(a: number);
    private abj;
    get acl(): number;
    set acl(a: number);
    private ab0;
    get ac2(): number;
    set ac2(a: number);
    private abg;
    get aci(): number;
    set aci(a: number);
    private abx;
    get acz(): number;
    set acz(a: number);
    private agn;
    get ag3(): Brush;
    set ag3(a: Brush);
    private agu;
    get aha(): Brush;
    set aha(a: Brush);
    protected wi(a: string, b: any, c: any): void;
    private ac9;
    get adx(): string;
    set adx(a: string);
    private add;
    get ae2(): string;
    set ae2(a: string);
    private adb;
    get ael(): string;
    set ael(a: string);
    private adf;
    get afq(): string;
    set afq(a: string);
    private afw;
    private afy;
    protected w9(a: DataSeries): void;
    protected abstract aao(): Axis;
    protected abstract aap(): Axis;
    protected afz(a: (arg1: Axis) => void): void;
    protected af0(a: (arg1: Axis) => void, b: string): void;
    protected af5(a: (arg1: Axis) => void, b: boolean): void;
    protected af4(a: (arg1: Axis) => void): void;
    protected u5(a: (arg1: Axis) => void, b: boolean): void;
    protected af3(a: (arg1: TitleSettings) => void): void;
    protected af8(a: (arg1: TitleSettings) => void): void;
    protected af6(a: (arg1: AxisLabelSettings) => void): void;
    protected af1(a: (arg1: AxisLabelSettings) => void): void;
    ab2(a: number): number;
    ab4(a: number): number;
    ab3(a: number): number;
    ab5(a: number): number;
    protected w6(a: XamDataChart): void;
    static adi(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected vh(a: XamDataChart, b: any): void;
    protected afv(a: Axis): void;
    protected afx(a: Axis): void;
    protected ve(): void;
    protected aft(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected afu(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected wd(a: string, b: any, c: any): void;
    af7(): void;
    af2(): void;
    aav(a: YAxisLabelLocation): AxisLabelsLocation;
    aau(a: XAxisLabelLocation): AxisLabelsLocation;
    private ac4;
    get ac6(): any;
    set ac6(a: any);
    private ac5;
    get ac7(): any;
    set ac7(a: any);
    private agi;
    get agy(): Brush;
    set agy(a: Brush);
    private agp;
    get ag5(): Brush;
    set ag5(a: Brush);
    private aba;
    get acc(): number;
    set acc(a: number);
    private abr;
    get act(): number;
    set act(a: number);
    private abb;
    get acd(): number;
    set acd(a: number);
    private abs;
    get acu(): number;
    set acu(a: number);
    private agk;
    get ag0(): Brush;
    set ag0(a: Brush);
    private agr;
    get ag7(): Brush;
    set ag7(a: Brush);
    private agl;
    get ag1(): Brush;
    set ag1(a: Brush);
    private ags;
    get ag8(): Brush;
    set ag8(a: Brush);
    private abc;
    get ace(): number;
    set ace(a: number);
    private abt;
    get acv(): number;
    set acv(a: number);
    private abd;
    get acf(): number;
    set acf(a: number);
    private abu;
    get acw(): number;
    set acw(a: number);
    private agm;
    get ag2(): Brush;
    set ag2(a: Brush);
    private agt;
    get ag9(): Brush;
    set ag9(a: Brush);
    private abe;
    get acg(): number;
    set acg(a: number);
    private abv;
    get acx(): number;
    set acx(a: number);
    private ada;
    get aec(): string;
    set aec(a: string);
    private ade;
    get afh(): string;
    set afh(a: string);
    private agj;
    get agz(): Brush;
    set agz(a: Brush);
    private agq;
    get ag6(): Brush;
    set ag6(a: Brush);
    private aa5;
    get ab7(): number;
    set ab7(a: number);
    private abm;
    get aco(): number;
    set aco(a: number);
    private aa4;
    get ab6(): number;
    set ab6(a: number);
    private abl;
    get acn(): number;
    set acn(a: number);
    private abf;
    get ach(): number;
    set ach(a: number);
    private abw;
    get acy(): number;
    set acy(a: number);
    private aa0;
    get aa2(): boolean;
    set aa2(a: boolean);
    private aa1;
    get aa3(): boolean;
    set aa3(a: boolean);
    private aga;
    get agd(): HorizontalAlignment;
    set agd(a: HorizontalAlignment);
    private ahd;
    get ahg(): VerticalAlignment;
    set ahg(a: VerticalAlignment);
    private af9;
    get agc(): HorizontalAlignment;
    set agc(a: HorizontalAlignment);
    private agb;
    protected get_age(): HorizontalAlignment;
    protected set_age(a: HorizontalAlignment): void;
    get age(): HorizontalAlignment;
    set age(a: HorizontalAlignment);
    private ahb;
    get ahe(): VerticalAlignment;
    set ahe(a: VerticalAlignment);
    private ahc;
    get ahf(): VerticalAlignment;
    set ahf(a: VerticalAlignment);
    private ahh;
    get ahj(): Visibility;
    set ahj(a: Visibility);
    private ahi;
    get ahk(): Visibility;
    set ahk(a: Visibility);
    private aay;
    protected get_aaz(): YAxisLabelLocation;
    protected set_aaz(a: YAxisLabelLocation): void;
    get aaz(): YAxisLabelLocation;
    set aaz(a: YAxisLabelLocation);
    private aaw;
    protected get_aax(): XAxisLabelLocation;
    protected set_aax(a: XAxisLabelLocation): void;
    get aax(): XAxisLabelLocation;
    set aax(a: XAxisLabelLocation);
    private ac8;
    get ado(): string;
    set ado(a: string);
    private aak;
    get aam(): any[];
    set aam(a: any[]);
    private adc;
    get aet(): string;
    set aet(a: string);
    private aal;
    get aan(): any[];
    set aan(a: any[]);
}
