import { IgrDataAnnotationPointLayer, IIgrDataAnnotationPointLayerProps } from "./igr-data-annotation-point-layer";
import { DataAnnotationBandLayer } from "./DataAnnotationBandLayer";
/**
 * Represents an annotation layer that renders bands (line with breadth) at locations of x/y values mapped to these properties:
 * StartValueXMemberPath
 * StartValueYMemberPath
 * EndValueXMemberPath
 * EndValueYMemberPath
 * AnnotationBreadthMemberPath
*/
export declare class IgrDataAnnotationBandLayer extends IgrDataAnnotationPointLayer<IIgrDataAnnotationBandLayerProps> {
    protected createImplementation(): DataAnnotationBandLayer;
    /**
                                 * @hidden
                                 */
    get i(): DataAnnotationBandLayer;
    constructor(props: IIgrDataAnnotationBandLayerProps);
    /**
     * Gets or sets name of data column with breath/size of shape annotations.
    */
    get annotationBreadthMemberPath(): string;
    set annotationBreadthMemberPath(v: string);
}
export interface IIgrDataAnnotationBandLayerProps extends IIgrDataAnnotationPointLayerProps {
    /**
     * Gets or sets name of data column with breath/size of shape annotations.
    */
    annotationBreadthMemberPath?: string;
}
