import { IgrDataAnnotationShapeLayer, IIgrDataAnnotationShapeLayerProps } from "./igr-data-annotation-shape-layer";
import { DataAnnotationRangeLayer } from "./DataAnnotationRangeLayer";
/**
 * Represents a base of annotation layers that render from start/end range
*/
export declare abstract class IgrDataAnnotationRangeLayer<P extends IIgrDataAnnotationRangeLayerProps = IIgrDataAnnotationRangeLayerProps> extends IgrDataAnnotationShapeLayer<P> {
    /**
                                 * @hidden
                                 */
    get i(): DataAnnotationRangeLayer;
    constructor(props: P);
    /**
     * Gets or sets the text color used for displaying the start annotation label.
    */
    get startLabelTextColor(): string;
    set startLabelTextColor(v: string);
    /**
     * Gets or sets the background used for displaying the start annotation label.
    */
    get startLabelBackground(): string;
    set startLabelBackground(v: string);
    /**
     * Gets or sets the border color used for displaying Start annotation label.
    */
    get startLabelBorderColor(): string;
    set startLabelBorderColor(v: string);
    /**
     * Gets or sets the text color used for displaying the end annotation label.
    */
    get endLabelTextColor(): string;
    set endLabelTextColor(v: string);
    /**
     * Gets or sets the background used for displaying the end annotation label.
    */
    get endLabelBackground(): string;
    set endLabelBackground(v: string);
    /**
     * Gets or sets the border used for displaying the end annotation label.
    */
    get endLabelBorderColor(): string;
    set endLabelBorderColor(v: string);
    /**
     * Gets or sets the text color used for displaying the center annotation label.
    */
    get centerLabelTextColor(): string;
    set centerLabelTextColor(v: string);
    /**
     * Gets or sets the background used for displaying the center annotation label.
    */
    get centerLabelBackground(): string;
    set centerLabelBackground(v: string);
    /**
     * Gets or sets the border color used for displaying the center annotation label.
    */
    get centerLabelBorderColor(): string;
    set centerLabelBorderColor(v: string);
}
export interface IIgrDataAnnotationRangeLayerProps extends IIgrDataAnnotationShapeLayerProps {
    /**
     * Gets or sets the text color used for displaying the start annotation label.
    */
    startLabelTextColor?: string;
    /**
     * Gets or sets the background used for displaying the start annotation label.
    */
    startLabelBackground?: string;
    /**
     * Gets or sets the border color used for displaying Start annotation label.
    */
    startLabelBorderColor?: string;
    /**
     * Gets or sets the text color used for displaying the end annotation label.
    */
    endLabelTextColor?: string;
    /**
     * Gets or sets the background used for displaying the end annotation label.
    */
    endLabelBackground?: string;
    /**
     * Gets or sets the border used for displaying the end annotation label.
    */
    endLabelBorderColor?: string;
    /**
     * Gets or sets the text color used for displaying the center annotation label.
    */
    centerLabelTextColor?: string;
    /**
     * Gets or sets the background used for displaying the center annotation label.
    */
    centerLabelBackground?: string;
    /**
     * Gets or sets the border color used for displaying the center annotation label.
    */
    centerLabelBorderColor?: string;
}
