import { IgrDataAnnotationShapeLayer, IIgrDataAnnotationShapeLayerProps } from "./igr-data-annotation-shape-layer";
import { DataAnnotationSliceLayer } from "./DataAnnotationSliceLayer";
/**
 * Represents an annotation layer that renders vertical or horizontal slices/lines at values mapped to AnnotationValueMemberPath property
 * horizontal slices/lines when TargetAxis is set to Y-axis
 * vertical slices/lines when TargetAxis is set to X-axis
*/
export declare class IgrDataAnnotationSliceLayer extends IgrDataAnnotationShapeLayer<IIgrDataAnnotationSliceLayerProps> {
    protected createImplementation(): DataAnnotationSliceLayer;
    /**
                                 * @hidden
                                 */
    get i(): DataAnnotationSliceLayer;
    constructor(props: IIgrDataAnnotationSliceLayerProps);
    /**
     * Gets or sets name of data column with values used to position annotations.
    */
    get annotationValueMemberPath(): string;
    set annotationValueMemberPath(v: string);
    /**
     * Gets or sets mapping custom label on axis annotations.
    */
    get annotationLabelMemberPath(): string;
    set annotationLabelMemberPath(v: string);
}
export interface IIgrDataAnnotationSliceLayerProps extends IIgrDataAnnotationShapeLayerProps {
    /**
     * Gets or sets name of data column with values used to position annotations.
    */
    annotationValueMemberPath?: string;
    /**
     * Gets or sets mapping custom label on axis annotations.
    */
    annotationLabelMemberPath?: string;
}
