import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { OverlayTextLocation } from "./OverlayTextLocation";
import { OverlayTextUpdatingEventArgs as OverlayTextUpdatingEventArgs_internal } from "./OverlayTextUpdatingEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents an event arguments for styling Overlay Text
*/
export declare class IgrOverlayTextUpdatingEventArgs {
    protected createImplementation(): OverlayTextUpdatingEventArgs_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): OverlayTextUpdatingEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets data index associated with the overlay text
    */
    get dataIndex(): number;
    set dataIndex(v: number);
    /**
     * Gets or sets Horizontal Margin for the overlay text
    */
    get horizontalMargin(): number;
    set horizontalMargin(v: number);
    /**
     * Gets or sets Horizontal Padding for the overlay text
    */
    get horizontalPadding(): number;
    set horizontalPadding(v: number);
    /**
     * Gets or sets Vertical Padding for the overlay text
    */
    get verticalPadding(): number;
    set verticalPadding(v: number);
    /**
     * Gets or sets Vertical Margin for the overlay text
    */
    get verticalMargin(): number;
    set verticalMargin(v: number);
    /**
     * Gets or sets boarder border radius of the overlay text
    */
    get borderRadius(): number;
    set borderRadius(v: number);
    /**
     * Gets or sets boarder thickness of the overlay text
    */
    get borderThickness(): number;
    set borderThickness(v: number);
    /**
     * Gets or sets appearance shift of the overlay text border
    */
    get borderShift(): number;
    set borderShift(v: number);
    /**
     * Gets or sets appearance shift of the overlay text background
    */
    get backgroundShift(): number;
    set backgroundShift(v: number);
    /**
     * Gets or sets appearance shift of the overlay text color
    */
    get textColorShift(): number;
    set textColorShift(v: number);
    /**
     * Gets or sets appearance mode of the overlay text border
    */
    get borderMode(): AnnotationAppearanceMode;
    set borderMode(v: AnnotationAppearanceMode);
    /**
     * Gets or sets appearance mode of the overlay text background
    */
    get backgroundMode(): AnnotationAppearanceMode;
    set backgroundMode(v: AnnotationAppearanceMode);
    /**
     * Gets or sets appearance mode of the overlay text color
    */
    get textColorMode(): AnnotationAppearanceMode;
    set textColorMode(v: AnnotationAppearanceMode);
    /**
     * Gets or sets content of the overlay text
    */
    get textContent(): string;
    set textContent(v: string);
    /**
     * Gets or sets rotation angle of the overlay text
    */
    get textAngle(): number;
    set textAngle(v: number);
    /**
     * Gets or sets visibility of the overlay text
    */
    get textVisible(): boolean;
    set textVisible(v: boolean);
    /**
     * Gets or sets visibility of the overlay text
    */
    get textEmpty(): boolean;
    set textEmpty(v: boolean);
    /**
     * Gets or sets location of the overlay text in relation to shape annotation
    */
    get textLocation(): OverlayTextLocation;
    set textLocation(v: OverlayTextLocation);
    /**
     * Gets or sets color of the overlay text
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets background of the overlay text
    */
    get background(): string;
    set background(v: string);
    /**
     * Gets or sets border stroke of the overlay text
    */
    get borderStroke(): string;
    set borderStroke(v: string);
    /**
     * Gets or sets shape brush associated with the overlay text
    */
    get shapeBrush(): string;
    set shapeBrush(v: string);
    /**
     * Gets or sets shape outline associated with the overlay text
    */
    get shapeOutline(): string;
    set shapeOutline(v: string);
}
